#ifndef BITSLIDER_H
#define BITSLIDER_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Author	:	Jackey
//	Date	:	2004.02.19
//	File	:	BitSlider.h
//	Home	:	http://www.kuihua.net/
//	Contains:	Define the CBitSlider class...
//	History	:
//		1.0	:	2004.02.19 - First Version...
//	Mailto	:	Omega@Kuihua.net (Bug Report or Comments)
////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "BitWnd.h"

class CBitItem;

class CBitSlider : public CSliderCtrl
{
public:
	CBitSlider();
	virtual ~CBitSlider();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
protected:
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	DECLARE_MESSAGE_MAP()
public:
	void			SetPos(int nPos);
	void			SetLeftOffset(int nOffset)		{ m_nOffset = nOffset; }
	void			SetTopOffset(int nOffset)		{ m_nOffset = nOffset; }
	void			SetFlipCursor(HCURSOR hCursor)	{ m_hHand = hCursor; m_Thumb.SetFlipCursor(hCursor); }

	void			BuildBackItem(UINT nNormalRes, UINT nActiveRes);
	void			BuildThumbItem(UINT nThumbRes, int cx, int cy);

	void			BuildBackItem(CBitItem * lpNBit, CBitItem * lpABit);
	void			BuildThumbItem(CBitItem * lpBit);

	void			DestroyBackItem();
	void			SetMessage(int position, CString firstMessage, CString secondMessage);
private:
	void			UpdateToolTips();
	void			DrawSlider(CDC * pDC, BOOL bPaint);
	void			GetNewThumbRect(CRect & rcThumb);
private:
	CBitWnd			m_Thumb;
	CBitItem	*	m_lpActive;
	CBitItem	*	m_lpNormal;
	HCURSOR			m_hHand;
	int				m_position;
	CString			m_firstMessage;
	CString			m_secondMessage;

	BOOL			m_bAllocFlag;
	int				m_nOffset;

	CToolTipCtrl	m_ctlTips;
};

#endif