///////////////////////////////////////////////////////////////////////////////
//
// ButtonXP.cpp : implementation file
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ButtonXP.h"
#include "Draw.h"
#include "aeroglss.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


////////////////////////////////////////////////////////////////////////////////
CButtonXP::CButtonXP()
{
}

////////////////////////////////////////////////////////////////////////////////
CButtonXP::~CButtonXP()
{
}

////////////////////////////////////////////////////////////////////////////////
void CButtonXP::PreSubclassWindow()
{
    m_MouseMgr.Init(m_hWnd);
}

////////////////////////////////////////////////////////////////////////////////
void CButtonXP::OnPaint()
{
    CButton::OnPaint();
    CDwmApiImpl dwmApi;
    if ((dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled()) || !CMenuXP::GetXPLookNFeel(GetParent()))
        return;

    CRect rcItem;
    GetClientRect(rcItem);

    CBufferDC cDC(::GetDC(m_hWnd), rcItem);

    CFontDC font(cDC, DEFAULT_GUI_FONT);
    CPenDC pen(cDC);
    CBrushDC brush(cDC);

    UINT state = GetState();

    if (!::IsWindowEnabled(m_hWnd) || (!m_MouseMgr.MouseOver() && !(state & 0x0004)))
    {
        if ((state & 0x0008) || LOWORD(::SendMessage(::GetParent(m_hWnd), DM_GETDEFID, 0, 0)) == GetDlgCtrlID())
            pen.Color(::GetSysColor(COLOR_3DDKSHADOW));
        else
            pen.Color(::GetSysColor(COLOR_3DSHADOW));
        brush.Color(HLS_TRANSFORM(::GetSysColor(COLOR_3DFACE), +15, 0));
    }
    else
    {
        COLORREF crBorder = ::GetSysColor(COLOR_HIGHLIGHT);

        pen.Color(crBorder);

        if ((state & 0x0004))
        {
            brush.Color(HLS_TRANSFORM(crBorder, +50, -50));
            cDC.SetTextColor(RGB(240, 240, 240));
        }
        else
        {
            brush.Color(HLS_TRANSFORM(crBorder, +80, -66));
            cDC.SetTextColor(::GetSysColor(COLOR_BTNTEXT));
        }
    }
    // Disabled
    if (!::IsWindowEnabled(m_hWnd))
        cDC.SetTextColor(::GetSysColor(COLOR_GRAYTEXT));
    else if ((state & 0x0004))
        cDC.SetTextColor(RGB(240, 240, 240));
    else if (m_MouseMgr.MouseOver())
        cDC.SetTextColor(0);
    else
        cDC.SetTextColor(::GetSysColor(COLOR_BTNTEXT));
    cDC.Rectangle(rcItem);
    cDC.SetBkMode(TRANSPARENT);
    if (GetIcon() != NULL)
    {
        cDC.DrawIcon(-8, -8, GetIcon());
    }
    else
    {
        CString str;
        GetWindowText(str);
        cDC.DrawText(str, rcItem, DT_SINGLELINE | DT_CENTER | DT_VCENTER);
    }
    if ((state & 0x0008))
    {
        rcItem.DeflateRect(2, 2);
        cDC.DrawFocusRect(rcItem);
    }
}

////////////////////////////////////////////////////////////////////////////////
BEGIN_MESSAGE_MAP(CButtonXP, CButton)
  ON_WM_MOUSEMOVE()
  ON_WM_MOUSEOUT()
  ON_WM_PAINT()
END_MESSAGE_MAP()

////////////////////////////////////////////////////////////////////////////////
void CButtonXP::OnMouseMove(UINT nFlags, CPoint point)
{
    Default();
    m_MouseMgr.OnMouseMove();
}

///////////////////////////////////////////////////////////////////////////////
void CButtonXP::OnMouseOut()
{
    m_MouseMgr.OnMouseOut();
}
