// Helper.cpp: implementation of the Helper class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MainHelper.h"
#include <assert.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HMODULE helperMod = NULL;

Helper::Helper()
{
}

/*
 * get name of configuration file
 */
void Helper::config_get_filename(TCHAR* buffer, int size)
{
    TCHAR* p;

    assert(buffer);

    memset(buffer, 0, size);

    GetModuleFileName(NULL, buffer, size);
    p = buffer + _tcslen(buffer);

    while (p >= buffer && *p != '.')
        p--;

    _tcscpy(p, _T(".ini"));
}

void Helper::translate(UINT ressources, CString& buf, UINT i, UINT j)
{
    CString oldValue = buf;
    CString key = _T("");
    CString tmp;
    TCHAR cbuf[256];
    TCHAR path[MAX_PATH];
    CString name = _T("");
    GetModuleFileName(helperMod, path, MAX_PATH);
    for (int ii = _tcslen(path) - 1; ii > 0; ii--)
    {
        if (path[ii] == '.')
        {
            path[ii] = '\0';break;
        }
    }
    _tcscat(path, _T(".ini"));

    key.Format(_T("%d"), ressources);
    if (j != 0xFFFFFFFF)
        key.Format(_T("%dI%dJ%d"), ressources, i, j);
    int translate = GetPrivateProfileInt(_T("Preferences"), _T("MakeTranslation"), TRUE, path);

    CString langFile = _T("");
    GetPrivateProfileString(_T("Preferences"), _T("Language"), _T(""), cbuf, 256, path);
    langFile.Format(_T("%s"), cbuf);
    CString langFilePath = _T("");

    if (langFile.GetLength() != 0)
    {
        name.Format(_T("%s"), path);
        name = name.Left(name.ReverseFind('.'));
        langFilePath.Format(_T("%s_%s.ini"), name, langFile);
    }

    if (translate == TRUE && langFile.GetLength() != 0)
        tmp = key + _T(" ") + oldValue;
    else
        tmp = oldValue;
    ::GetPrivateProfileString(_T("Translation"), key, tmp, cbuf, 256, langFilePath);
    if (tmp.Find(cbuf) == 0)
    {
        oldValue.Replace(_T("\n"), _T("\\n"));
        oldValue.Replace(_T("\t"), _T("\\t"));
        ::WritePrivateProfileString(_T("Translation"), key, oldValue, langFilePath);
    }

    buf.Format(_T("%s"), cbuf);
    buf.Replace(_T("\\n"), _T("\n"));
    buf.Replace(_T("\\t"), _T("\t"));
    buf.TrimRight();
}

void Helper::translateDlgItemText(CWnd* wnd, UINT itemID)
{
    CString buf = _T("");

    wnd->GetDlgItemText(itemID, buf);
    translate(itemID, buf);
    wnd->SetDlgItemText(itemID, buf);
}

void Helper::translateMenu(CMenu* firstMenu, UINT firstMenuID)
{
    UINT i, j;
    CObArray listMenu;
    listMenu.Add(firstMenu);
    for (j = 0; j < (UINT)listMenu.GetSize(); j++)
    {
        CMenu* menu = (CMenu*)listMenu[j];
        for (i = 0; i < menu->GetMenuItemCount(); i++)
        {
            UINT menuID = menu->GetMenuItemID(i);
            CString buf;
            if (menuID != 0)
            {
                menu->GetMenuString(i, buf, MF_BYPOSITION);
                if (menuID == 0xFFFFFFFF)
                {
                    CMenu* tmp = menu->GetSubMenu(i);
                    listMenu.Add(tmp);
                    translate(firstMenuID, buf, i, j);
                    HMENU tmpHMENU = tmp->GetSafeHmenu();
                    menu->RemoveMenu(i, MF_BYPOSITION);
                    menu->InsertMenu(i, MF_BYPOSITION | MF_POPUP, (UINT)tmpHMENU, buf);
                    //menu->GetSubMenu(i)->Attach(tmpHMENU);
                    //menu->ModifyMenu(i, MF_BYPOSITION, i, buf);
                }
                else
                {
                    translate(menuID, buf);
                    menu->ModifyMenu(menuID, MF_BYCOMMAND, menuID, buf);
                }
            }
        }
    }
}

void Helper::translateWindowText(CWnd* wnd, UINT windowID)
{
    CString buf = _T("");
    wnd->GetWindowText(buf);
    translate(windowID, buf);
    wnd->SetWindowText(buf);
}

CString Helper::translateWindowTextString(CWnd* wnd, UINT windowID)
{
    CString buf = _T("");
    wnd->GetWindowText(buf);
    translate(windowID, buf);
    return buf;
}

CString Helper::MyLoadString(UINT id)
{
    CString buf = _T("");
    TCHAR cbuf[256];
    LoadString(helperMod, id, cbuf, 256);
    buf.Format(_T("%s"), cbuf);
    translate(id, buf);
    return buf;
}

CString Helper::ConvertColorHexa(COLORREF color)
{
    CString tmp;
    tmp.Format(_T("0x%02X%02X%02X"), GetBValue(color), GetGValue(color), GetRValue(color));
    return tmp;
}