// ----------------------------------------------------------------------------
// Generated by InterfaceFactory [Wed May 07 00:55:56 2003]
//
// File        : api_application.h
// Class       : api_application
// class layer : Dispatchable Interface
// ----------------------------------------------------------------------------

#ifndef __API_APPLICATION_H
#define __API_APPLICATION_H

#include <bfc/dispatch.h>
#include <bfc/platform/guid.h>
#include "api_messageprocessor.h"

class String;
class StringW;

// ----------------------------------------------------------------------------

class NOVTABLE api_application : public Dispatchable
{
protected:
    api_application()
    {
    }
    ~api_application()
    {
    }
public:
    const wchar_t* main_getAppName(); // returns (e.g.) "Winamp"
    const wchar_t* main_getVersionString(); // returns (e.g.) "Winamp 5.12"
    const wchar_t* main_getVersionNumString();  // returns (e.g.) "5.12"
    unsigned int main_getBuildNumber(); // returns (e.g.) 666
    GUID main_getGUID();
    HANDLE main_getMainThreadHandle();
    HINSTANCE main_gethInstance();
    const wchar_t* main_getCommandLine();
    void main_shutdown(int deferred = TRUE);
    void main_cancelShutdown();
    int main_isShuttingDown();
    const wchar_t* path_getAppPath();
    const wchar_t* path_getUserSettingsPath();
    int app_getInitCount();
    intptr_t app_messageLoopStep();
    void app_addMessageProcessor(api_messageprocessor* processor);
    void app_removeMessageProcessor(api_messageprocessor* processor);
    void app_addModelessDialog(HWND hwnd);
    void app_removeModelessDialog(HWND hwnd);

protected:
    enum
    {
        API_APPLICATION_MAIN_GETAPPNAME             = 10,
        API_APPLICATION_MAIN_GETVERSIONSTRING       = 20,
        API_APPLICATION_MAIN_GETVERSIONSTRING2      = 21,
        API_APPLICATION_MAIN_GETBUILDNUMBER         = 30,
        API_APPLICATION_MAIN_GETGUID                = 40,
        API_APPLICATION_MAIN_GETMAINTHREADHANDLE    = 50,
        API_APPLICATION_MAIN_GETHINSTANCE           = 60,
        API_APPLICATION_MAIN_GETCOMMANDLINE         = 70,
        API_APPLICATION_MAIN_SHUTDOWN               = 80,
        API_APPLICATION_MAIN_CANCELSHUTDOWN         = 90,
        API_APPLICATION_MAIN_ISSHUTTINGDOWN         = 100,
        API_APPLICATION_PATH_GETAPPPATH             = 110,
        API_APPLICATION_PATH_GETUSERSETTINGSPATH    = 120,
        API_APPLICATION_APP_GETINITCOUNT            = 130,
        API_APPLICATION_APP_MESSAGELOOPSTEP         = 140,
        API_APPLICATION_APP_ADDMESSAGEPROCESSOR     = 150,
        API_APPLICATION_APP_REMOVEMESSAGEPROCESSOR  = 160,
        API_APPLICATION_APP_ADDMODELESSDIALOG       = 170,
        API_APPLICATION_APP_REMOVEMODELESSDIALOG    = 180,
    };
};

// ----------------------------------------------------------------------------

inline const wchar_t* api_application::main_getAppName()
{
    const wchar_t* __retval = _call(API_APPLICATION_MAIN_GETAPPNAME, (const wchar_t*)0);
    return __retval;
}

inline const wchar_t* api_application::main_getVersionString()
{
    const wchar_t* __retval = _call(API_APPLICATION_MAIN_GETVERSIONSTRING, (const wchar_t*)0);
    return __retval;
}

inline const wchar_t* api_application::main_getVersionNumString()
{
    return _call(API_APPLICATION_MAIN_GETVERSIONSTRING2, (const wchar_t*)0);
}

inline unsigned int api_application::main_getBuildNumber()
{
    return _call(API_APPLICATION_MAIN_GETBUILDNUMBER, 0);
}

inline GUID api_application::main_getGUID()
{
    GUID __retval = _call(API_APPLICATION_MAIN_GETGUID, INVALID_GUID);
    return __retval;
}

inline HANDLE api_application::main_getMainThreadHandle()
{
    HANDLE __retval = _call(API_APPLICATION_MAIN_GETMAINTHREADHANDLE, (HANDLE)NULL);
    return __retval;
}

inline HINSTANCE api_application::main_gethInstance()
{
    HINSTANCE __retval = _call(API_APPLICATION_MAIN_GETHINSTANCE, (HINSTANCE)NULL);
    return __retval;
}

inline const wchar_t* api_application::main_getCommandLine()
{
    const wchar_t* __retval = _call(API_APPLICATION_MAIN_GETCOMMANDLINE, (const wchar_t*)0);
    return __retval;
}

inline void api_application::main_shutdown(int deferred)
{
    _voidcall(API_APPLICATION_MAIN_SHUTDOWN, deferred);
}

inline void api_application::main_cancelShutdown()
{
    _voidcall(API_APPLICATION_MAIN_CANCELSHUTDOWN);
}

inline int api_application::main_isShuttingDown()
{
    int __retval = _call(API_APPLICATION_MAIN_ISSHUTTINGDOWN, (int)0);
    return __retval;
}

inline const wchar_t* api_application::path_getAppPath()
{
    const wchar_t* __retval = _call(API_APPLICATION_PATH_GETAPPPATH, (const wchar_t*)0);
    return __retval;
}

inline const wchar_t* api_application::path_getUserSettingsPath()
{
    return _call(API_APPLICATION_PATH_GETUSERSETTINGSPATH, (const wchar_t*)0);
}

inline int api_application::app_getInitCount()
{
    int __retval = _call(API_APPLICATION_APP_GETINITCOUNT, 0);
    return __retval;
}

inline intptr_t api_application::app_messageLoopStep()
{
    return _call(API_APPLICATION_APP_MESSAGELOOPSTEP, (intptr_t)1);
}

inline void api_application::app_addMessageProcessor(api_messageprocessor* processor)
{
    _voidcall(API_APPLICATION_APP_ADDMESSAGEPROCESSOR, processor);
}

inline void api_application::app_removeMessageProcessor(api_messageprocessor* processor)
{
    _voidcall(API_APPLICATION_APP_REMOVEMESSAGEPROCESSOR, processor);
}

inline void api_application::app_addModelessDialog(HWND hwnd)
{
    _voidcall(API_APPLICATION_APP_ADDMODELESSDIALOG, hwnd);
}

inline void api_application::app_removeModelessDialog(HWND hwnd)
{
    _voidcall(API_APPLICATION_APP_REMOVEMODELESSDIALOG, hwnd);
}

// ----------------------------------------------------------------------------


// {23B96771-09D7-46d3-9AE2-20DCEA6C86EA}
static const GUID applicationApiServiceGuid =
{
    0x23b96771, 0x9d7, 0x46d3, { 0x9a, 0xe2, 0x20, 0xdc, 0xea, 0x6c, 0x86, 0xea }
};

extern api_application* applicationApi;
//extern StringW g_resourcepath;

#endif // __API_APPLICATION_H
