#ifndef GDIPLUS_H
#define GDIPLUS_H

#include "gdiplusH.h"
using namespace Gdiplus;

typedef Status (WINAPI *GDI_PLUS_STARTUP)(OUT ULONG_PTR* token, const GdiplusStartupInput* input, OUT GdiplusStartupOutput* output);
typedef VOID (WINAPI *GDI_PLUS_SHUTDOWN)(ULONG_PTR token);
typedef void* (WINAPI *GDIP_ALLOC)(size_t size);
typedef void (WINAPI *GDIP_FREE)(void* ptr);

//----------------------------------------------------------------------------
// GraphicsPath APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreatePath)(GpFillMode brushMode, GpPath** path);
typedef GpStatus (WINAPI *pGdipCreatePath2)(GDIPCONST GpPointF* points, GDIPCONST BYTE* types, INT count, GpFillMode fillMode, GpPath** path);
typedef GpStatus (WINAPI *pGdipCreatePath2I)(GDIPCONST GpPoint* points, GDIPCONST BYTE* types, INT count, GpFillMode fillMode, GpPath** path);
typedef GpStatus (WINAPI *pGdipClonePath)(GpPath* path, GpPath** clonePath);
typedef GpStatus (WINAPI *pGdipDeletePath)(GpPath* path);
typedef GpStatus (WINAPI *pGdipResetPath)(GpPath* path);
typedef GpStatus (WINAPI *pGdipGetPointCount)(GpPath* path, INT* count);
typedef GpStatus (WINAPI *pGdipGetPathTypes)(GpPath* path, BYTE* types, INT count);
typedef GpStatus (WINAPI *pGdipGetPathPoints)(GpPath* path, GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipGetPathPointsI)(GpPath* path, GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipGetPathFillMode)(GpPath* path, GpFillMode* fillmode);
typedef GpStatus (WINAPI *pGdipSetPathFillMode)(GpPath* path, GpFillMode fillmode);
typedef GpStatus (WINAPI *pGdipGetPathData)(GpPath* path, GpPathData* pathData);
typedef GpStatus (WINAPI *pGdipStartPathFigure)(GpPath* path);
typedef GpStatus (WINAPI *pGdipClosePathFigure)(GpPath* path);
typedef GpStatus (WINAPI *pGdipClosePathFigures)(GpPath* path);
typedef GpStatus (WINAPI *pGdipSetPathMarker)(GpPath* path);
typedef GpStatus (WINAPI *pGdipClearPathMarkers)(GpPath* path);
typedef GpStatus (WINAPI *pGdipReversePath)(GpPath* path);
typedef GpStatus (WINAPI *pGdipGetPathLastPoint)(GpPath* path, GpPointF* lastPoint);
typedef GpStatus (WINAPI *pGdipAddPathLine)(GpPath* path, REAL x1, REAL y1, REAL x2, REAL y2);
typedef GpStatus (WINAPI *pGdipAddPathLine2)(GpPath* path, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipAddPathArc)(GpPath* path, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
typedef GpStatus (WINAPI *pGdipAddPathBezier)(GpPath* path, REAL x1, REAL y1, REAL x2, REAL y2, REAL x3, REAL y3, REAL x4, REAL y4);
typedef GpStatus (WINAPI *pGdipAddPathBeziers)(GpPath* path, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipAddPathCurve)(GpPath* path, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipAddPathCurve2)(GpPath* path, GDIPCONST GpPointF* points, INT count, REAL tension);
typedef GpStatus (WINAPI *pGdipAddPathCurve3)(GpPath* path, GDIPCONST GpPointF* points, INT count, INT offset, INT numberOfSegments, REAL tension);
typedef GpStatus (WINAPI *pGdipAddPathClosedCurve)(GpPath* path, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipAddPathClosedCurve2)(GpPath* path, GDIPCONST GpPointF* points, INT count, REAL tension);
typedef GpStatus (WINAPI *pGdipAddPathRectangle)(GpPath* path, REAL x, REAL y, REAL width, REAL height);
typedef GpStatus (WINAPI *pGdipAddPathRectangles)(GpPath* path, GDIPCONST GpRectF* rects, INT count);
typedef GpStatus (WINAPI *pGdipAddPathEllipse)(GpPath* path, REAL x, REAL y, REAL width, REAL height);
typedef GpStatus (WINAPI *pGdipAddPathPie)(GpPath* path, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
typedef GpStatus (WINAPI *pGdipAddPathPolygon)(GpPath* path, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipAddPathPath)(GpPath* path, GDIPCONST GpPath* addingPath, BOOL connect);
typedef GpStatus (WINAPI *pGdipAddPathString)(GpPath* path, GDIPCONST WCHAR* string, INT length, GDIPCONST GpFontFamily* family, INT style, REAL emSize, GDIPCONST RectF* layoutRect, GDIPCONST GpStringFormat* format);
typedef GpStatus (WINAPI *pGdipAddPathStringI)(GpPath* path, GDIPCONST WCHAR* string, INT length, GDIPCONST GpFontFamily* family, INT style, REAL emSize, GDIPCONST Rect* layoutRect, GDIPCONST GpStringFormat* format);
typedef GpStatus (WINAPI *pGdipAddPathLineI)(GpPath* path, INT x1, INT y1, INT x2, INT y2);
typedef GpStatus (WINAPI *pGdipAddPathLine2I)(GpPath* path, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipAddPathArcI)(GpPath* path, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
typedef GpStatus (WINAPI *pGdipAddPathBezierI)(GpPath* path, INT x1, INT y1, INT x2, INT y2, INT x3, INT y3, INT x4, INT y4);
typedef GpStatus (WINAPI *pGdipAddPathBeziersI)(GpPath* path, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipAddPathCurveI)(GpPath* path, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipAddPathCurve2I)(GpPath* path, GDIPCONST GpPoint* points, INT count, REAL tension);
typedef GpStatus (WINAPI *pGdipAddPathCurve3I)(GpPath* path, GDIPCONST GpPoint* points, INT count, INT offset, INT numberOfSegments, REAL tension);
typedef GpStatus (WINAPI *pGdipAddPathClosedCurveI)(GpPath* path, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipAddPathClosedCurve2I)(GpPath* path, GDIPCONST GpPoint* points, INT count, REAL tension);
typedef GpStatus (WINAPI *pGdipAddPathRectangleI)(GpPath* path, INT x, INT y, INT width, INT height);
typedef GpStatus (WINAPI *pGdipAddPathRectanglesI)(GpPath* path, GDIPCONST GpRect* rects, INT count);
typedef GpStatus (WINAPI *pGdipAddPathEllipseI)(GpPath* path, INT x, INT y, INT width, INT height);
typedef GpStatus (WINAPI *pGdipAddPathPieI)(GpPath* path, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
typedef GpStatus (WINAPI *pGdipAddPathPolygonI)(GpPath* path, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipFlattenPath)(GpPath* path, GpMatrix* matrix, REAL flatness);
typedef GpStatus (WINAPI *pGdipWindingModeOutline)(GpPath* path, GpMatrix* matrix, REAL flatness);
typedef GpStatus (WINAPI *pGdipWidenPath)(GpPath* nativePath, GpPen* pen, GpMatrix* matrix, REAL flatness);
typedef GpStatus (WINAPI *pGdipWarpPath)(GpPath* path, GpMatrix* matrix, GDIPCONST GpPointF* points, INT count, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, WarpMode warpMode, REAL flatness);
typedef GpStatus (WINAPI *pGdipTransformPath)(GpPath* path, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipGetPathWorldBounds)(GpPath* path, GpRectF* bounds, GDIPCONST GpMatrix* matrix, GDIPCONST GpPen* pen);
typedef GpStatus (WINAPI *pGdipGetPathWorldBoundsI)(GpPath* path, GpRect* bounds, GDIPCONST GpMatrix* matrix, GDIPCONST GpPen* pen);
typedef GpStatus (WINAPI *pGdipIsVisiblePathPoint)(GpPath* path, REAL x, REAL y, GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsVisiblePathPointI)(GpPath* path, INT x, INT y, GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsOutlineVisiblePathPoint)(GpPath* path, REAL x, REAL y, GpPen* pen, GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsOutlineVisiblePathPointI)(GpPath* path, INT x, INT y, GpPen* pen, GpGraphics* graphics, BOOL* result);

//----------------------------------------------------------------------------
// PathIterator APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreatePathIter)(GpPathIterator** iterator, GpPath* path);
typedef GpStatus (WINAPI *pGdipDeletePathIter)(GpPathIterator* iterator);
typedef GpStatus (WINAPI *pGdipPathIterNextSubpath)(GpPathIterator* iterator, INT* resultCount, INT* startIndex, INT* endIndex, BOOL* isClosed);
typedef GpStatus (WINAPI *pGdipPathIterNextSubpathPath)(GpPathIterator* iterator, INT* resultCount, GpPath* path, BOOL* isClosed);
typedef GpStatus (WINAPI *pGdipPathIterNextPathType)(GpPathIterator* iterator, INT* resultCount, BYTE* pathType, INT* startIndex, INT* endIndex);
typedef GpStatus (WINAPI *pGdipPathIterNextMarker)(GpPathIterator* iterator, INT* resultCount, INT* startIndex, INT* endIndex);
typedef GpStatus (WINAPI *pGdipPathIterNextMarkerPath)(GpPathIterator* iterator, INT* resultCount, GpPath* path);
typedef GpStatus (WINAPI *pGdipPathIterGetCount)(GpPathIterator* iterator, INT* count);
typedef GpStatus (WINAPI *pGdipPathIterGetSubpathCount)(GpPathIterator* iterator, INT* count);
typedef GpStatus (WINAPI *pGdipPathIterIsValid)(GpPathIterator* iterator, BOOL* valid);
typedef GpStatus (WINAPI *pGdipPathIterHasCurve)(GpPathIterator* iterator, BOOL* hasCurve);
typedef GpStatus (WINAPI *pGdipPathIterRewind)(GpPathIterator* iterator);
typedef GpStatus (WINAPI *pGdipPathIterEnumerate)(GpPathIterator* iterator, INT* resultCount, GpPointF* points, BYTE* types, INT count);
typedef GpStatus (WINAPI *pGdipPathIterCopyData)(GpPathIterator* iterator, INT* resultCount, GpPointF* points, BYTE* types, INT startIndex, INT endIndex);

//----------------------------------------------------------------------------
// Matrix APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateMatrix)(GpMatrix** matrix);
typedef GpStatus (WINAPI *pGdipCreateMatrix2)(REAL m11, REAL m12, REAL m21, REAL m22, REAL dx, REAL dy, GpMatrix** matrix);
typedef GpStatus (WINAPI *pGdipCreateMatrix3)(GDIPCONST GpRectF* rect, GDIPCONST GpPointF* dstplg, GpMatrix** matrix);
typedef GpStatus (WINAPI *pGdipCreateMatrix3I)(GDIPCONST GpRect* rect, GDIPCONST GpPoint* dstplg, GpMatrix** matrix);
typedef GpStatus (WINAPI *pGdipCloneMatrix)(GpMatrix* matrix, GpMatrix** cloneMatrix);
typedef GpStatus (WINAPI *pGdipDeleteMatrix)(GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipSetMatrixElements)(GpMatrix* matrix, REAL m11, REAL m12, REAL m21, REAL m22, REAL dx, REAL dy);
typedef GpStatus (WINAPI *pGdipMultiplyMatrix)(GpMatrix* matrix, GpMatrix* matrix2, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipTranslateMatrix)(GpMatrix* matrix, REAL offsetX, REAL offsetY, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipScaleMatrix)(GpMatrix* matrix, REAL scaleX, REAL scaleY, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipRotateMatrix)(GpMatrix* matrix, REAL angle, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipShearMatrix)(GpMatrix* matrix, REAL shearX, REAL shearY, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipInvertMatrix)(GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipTransformMatrixPoints)(GpMatrix* matrix, GpPointF* pts, INT count);
typedef GpStatus (WINAPI *pGdipTransformMatrixPointsI)(GpMatrix* matrix, GpPoint* pts, INT count);
typedef GpStatus (WINAPI *pGdipVectorTransformMatrixPoints)(GpMatrix* matrix, GpPointF* pts, INT count);
typedef GpStatus (WINAPI *pGdipVectorTransformMatrixPointsI)(GpMatrix* matrix, GpPoint* pts, INT count);
typedef GpStatus (WINAPI *pGdipGetMatrixElements)(GDIPCONST GpMatrix* matrix, REAL* matrixOut);
typedef GpStatus (WINAPI *pGdipIsMatrixInvertible)(GDIPCONST GpMatrix* matrix, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsMatrixIdentity)(GDIPCONST GpMatrix* matrix, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsMatrixEqual)(GDIPCONST GpMatrix* matrix, GDIPCONST GpMatrix* matrix2, BOOL* result);

//----------------------------------------------------------------------------
// Region APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateRegion)(GpRegion** region);
typedef GpStatus (WINAPI *pGdipCreateRegionRect)(GDIPCONST GpRectF* rect, GpRegion** region);
typedef GpStatus (WINAPI *pGdipCreateRegionRectI)(GDIPCONST GpRect* rect, GpRegion** region);
typedef GpStatus (WINAPI *pGdipCreateRegionPath)(GpPath* path, GpRegion** region);
typedef GpStatus (WINAPI *pGdipCreateRegionRgnData)(GDIPCONST BYTE* regionData, INT size, GpRegion** region);
typedef GpStatus (WINAPI *pGdipCreateRegionHrgn)(HRGN hRgn, GpRegion** region);
typedef GpStatus (WINAPI *pGdipCloneRegion)(GpRegion* region, GpRegion** cloneRegion);
typedef GpStatus (WINAPI *pGdipDeleteRegion)(GpRegion* region);
typedef GpStatus (WINAPI *pGdipSetInfinite)(GpRegion* region);
typedef GpStatus (WINAPI *pGdipSetEmpty)(GpRegion* region);
typedef GpStatus (WINAPI *pGdipCombineRegionRect)(GpRegion* region, GDIPCONST GpRectF* rect, CombineMode combineMode);
typedef GpStatus (WINAPI *pGdipCombineRegionRectI)(GpRegion* region, GDIPCONST GpRect* rect, CombineMode combineMode);
typedef GpStatus (WINAPI *pGdipCombineRegionPath)(GpRegion* region, GpPath* path, CombineMode combineMode);
typedef GpStatus (WINAPI *pGdipCombineRegionRegion)(GpRegion* region, GpRegion* region2, CombineMode combineMode);
typedef GpStatus (WINAPI *pGdipTranslateRegion)(GpRegion* region, REAL dx, REAL dy);
typedef GpStatus (WINAPI *pGdipTranslateRegionI)(GpRegion* region, INT dx, INT dy);
typedef GpStatus (WINAPI *pGdipTransformRegion)(GpRegion* region, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipGetRegionBounds)(GpRegion* region, GpGraphics* graphics, GpRectF* rect);
typedef GpStatus (WINAPI *pGdipGetRegionBoundsI)(GpRegion* region, GpGraphics* graphics, GpRect* rect);
typedef GpStatus (WINAPI *pGdipGetRegionHRgn)(GpRegion* region, GpGraphics* graphics, HRGN* hRgn);
typedef GpStatus (WINAPI *pGdipIsEmptyRegion)(GpRegion* region, GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsInfiniteRegion)(GpRegion* region, GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsEqualRegion)(GpRegion* region, GpRegion* region2, GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipGetRegionDataSize)(GpRegion* region, UINT* bufferSize);
typedef GpStatus (WINAPI *pGdipGetRegionData)(GpRegion* region, BYTE* buffer, UINT bufferSize, UINT* sizeFilled);
typedef GpStatus (WINAPI *pGdipIsVisibleRegionPoint)(GpRegion* region, REAL x, REAL y, GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsVisibleRegionPointI)(GpRegion* region, INT x, INT y, GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsVisibleRegionRect)(GpRegion* region, REAL x, REAL y, REAL width, REAL height, GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsVisibleRegionRectI)(GpRegion* region, INT x, INT y, INT width, INT height, GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipGetRegionScansCount)(GpRegion* region, UINT* count, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipGetRegionScans)(GpRegion* region, GpRectF* rects, INT* count, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipGetRegionScansI)(GpRegion* region, GpRect* rects, INT* count, GpMatrix* matrix);

//----------------------------------------------------------------------------
// Brush APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCloneBrush)(GpBrush* brush, GpBrush** cloneBrush);
typedef GpStatus (WINAPI *pGdipDeleteBrush)(GpBrush* brush);
typedef GpStatus (WINAPI *pGdipGetBrushType)(GpBrush* brush, GpBrushType* type);

//----------------------------------------------------------------------------
// HatchBrush APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateHatchBrush)(GpHatchStyle hatchstyle, ARGB forecol, ARGB backcol, GpHatch** brush);
typedef GpStatus (WINAPI *pGdipGetHatchStyle)(GpHatch* brush, GpHatchStyle* hatchstyle);
typedef GpStatus (WINAPI *pGdipGetHatchForegroundColor)(GpHatch* brush, ARGB* forecol);
typedef GpStatus (WINAPI *pGdipGetHatchBackgroundColor)(GpHatch* brush, ARGB* backcol);

//----------------------------------------------------------------------------
// TextureBrush APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateTexture)(GpImage* image, GpWrapMode wrapmode, GpTexture** texture);
typedef GpStatus (WINAPI *pGdipCreateTexture2)(GpImage* image, GpWrapMode wrapmode, REAL x, REAL y, REAL width, REAL height, GpTexture** texture);
typedef GpStatus (WINAPI *pGdipCreateTextureIA)(GpImage* image, GDIPCONST GpImageAttributes* imageAttributes, REAL x, REAL y, REAL width, REAL height, GpTexture** texture);
typedef GpStatus (WINAPI *pGdipCreateTexture2I)(GpImage* image, GpWrapMode wrapmode, INT x, INT y, INT width, INT height, GpTexture** texture);
typedef GpStatus (WINAPI *pGdipCreateTextureIAI)(GpImage* image, GDIPCONST GpImageAttributes* imageAttributes, INT x, INT y, INT width, INT height, GpTexture** texture);
typedef GpStatus (WINAPI *pGdipGetTextureTransform)(GpTexture* brush, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipSetTextureTransform)(GpTexture* brush, GDIPCONST GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipResetTextureTransform)(GpTexture* brush);
typedef GpStatus (WINAPI *pGdipMultiplyTextureTransform)(GpTexture* brush, GDIPCONST GpMatrix* matrix, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipTranslateTextureTransform)(GpTexture* brush, REAL dx, REAL dy, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipScaleTextureTransform)(GpTexture* brush, REAL sx, REAL sy, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipRotateTextureTransform)(GpTexture* brush, REAL angle, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipSetTextureWrapMode)(GpTexture* brush, GpWrapMode wrapmode);
typedef GpStatus (WINAPI *pGdipGetTextureWrapMode)(GpTexture* brush, GpWrapMode* wrapmode);
typedef GpStatus (WINAPI *pGdipGetTextureImage)(GpTexture* brush, GpImage** image);

//----------------------------------------------------------------------------
// SolidBrush APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateSolidFill)(ARGB color, GpSolidFill** brush);
typedef GpStatus (WINAPI *pGdipSetSolidFillColor)(GpSolidFill* brush, ARGB color);
typedef GpStatus (WINAPI *pGdipGetSolidFillColor)(GpSolidFill* brush, ARGB* color);

//----------------------------------------------------------------------------
// LineBrush APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateLineBrush)(GDIPCONST GpPointF* point1, GDIPCONST GpPointF* point2, ARGB color1, ARGB color2, GpWrapMode wrapMode, GpLineGradient** lineGradient);
typedef GpStatus (WINAPI *pGdipCreateLineBrushI)(GDIPCONST GpPoint* point1, GDIPCONST GpPoint* point2, ARGB color1, ARGB color2, GpWrapMode wrapMode, GpLineGradient** lineGradient);
typedef GpStatus (WINAPI *pGdipCreateLineBrushFromRect)(GDIPCONST GpRectF* rect, ARGB color1, ARGB color2, LinearGradientMode mode, GpWrapMode wrapMode, GpLineGradient** lineGradient);
typedef GpStatus (WINAPI *pGdipCreateLineBrushFromRectI)(GDIPCONST GpRect* rect, ARGB color1, ARGB color2, LinearGradientMode mode, GpWrapMode wrapMode, GpLineGradient** lineGradient);
typedef GpStatus (WINAPI *pGdipCreateLineBrushFromRectWithAngle)(GDIPCONST GpRectF* rect, ARGB color1, ARGB color2, REAL angle, BOOL isAngleScalable, GpWrapMode wrapMode, GpLineGradient** lineGradient);
typedef GpStatus (WINAPI *pGdipCreateLineBrushFromRectWithAngleI)(GDIPCONST GpRect* rect, ARGB color1, ARGB color2, REAL angle, BOOL isAngleScalable, GpWrapMode wrapMode, GpLineGradient** lineGradient);
typedef GpStatus (WINAPI *pGdipSetLineColors)(GpLineGradient* brush, ARGB color1, ARGB color2);
typedef GpStatus (WINAPI *pGdipGetLineColors)(GpLineGradient* brush, ARGB* colors);
typedef GpStatus (WINAPI *pGdipGetLineRect)(GpLineGradient* brush, GpRectF* rect);
typedef GpStatus (WINAPI *pGdipGetLineRectI)(GpLineGradient* brush, GpRect* rect);
typedef GpStatus (WINAPI *pGdipSetLineGammaCorrection)(GpLineGradient* brush, BOOL useGammaCorrection);
typedef GpStatus (WINAPI *pGdipGetLineGammaCorrection)(GpLineGradient* brush, BOOL* useGammaCorrection);
typedef GpStatus (WINAPI *pGdipGetLineBlendCount)(GpLineGradient* brush, INT* count);
typedef GpStatus (WINAPI *pGdipGetLineBlend)(GpLineGradient* brush, REAL* blend, REAL* positions, INT count);
typedef GpStatus (WINAPI *pGdipSetLineBlend)(GpLineGradient* brush, GDIPCONST REAL* blend, GDIPCONST REAL* positions, INT count);
typedef GpStatus (WINAPI *pGdipGetLinePresetBlendCount)(GpLineGradient* brush, INT* count);
typedef GpStatus (WINAPI *pGdipGetLinePresetBlend)(GpLineGradient* brush, ARGB* blend, REAL* positions, INT count);
typedef GpStatus (WINAPI *pGdipSetLinePresetBlend)(GpLineGradient* brush, GDIPCONST ARGB* blend, GDIPCONST REAL* positions, INT count);
typedef GpStatus (WINAPI *pGdipSetLineSigmaBlend)(GpLineGradient* brush, REAL focus, REAL scale);
typedef GpStatus (WINAPI *pGdipSetLineLinearBlend)(GpLineGradient* brush, REAL focus, REAL scale);
typedef GpStatus (WINAPI *pGdipSetLineWrapMode)(GpLineGradient* brush, GpWrapMode wrapmode);
typedef GpStatus (WINAPI *pGdipGetLineWrapMode)(GpLineGradient* brush, GpWrapMode* wrapmode);
typedef GpStatus (WINAPI *pGdipGetLineTransform)(GpLineGradient* brush, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipSetLineTransform)(GpLineGradient* brush, GDIPCONST GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipResetLineTransform)(GpLineGradient* brush);
typedef GpStatus (WINAPI *pGdipMultiplyLineTransform)(GpLineGradient* brush, GDIPCONST GpMatrix* matrix, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipTranslateLineTransform)(GpLineGradient* brush, REAL dx, REAL dy, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipScaleLineTransform)(GpLineGradient* brush, REAL sx, REAL sy, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipRotateLineTransform)(GpLineGradient* brush, REAL angle, GpMatrixOrder order);

//----------------------------------------------------------------------------
// PathGradientBrush APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreatePathGradient)(GDIPCONST GpPointF* points, INT count, GpWrapMode wrapMode, GpPathGradient** polyGradient);
typedef GpStatus (WINAPI *pGdipCreatePathGradientI)(GDIPCONST GpPoint* points, INT count, GpWrapMode wrapMode, GpPathGradient** polyGradient);
typedef GpStatus (WINAPI *pGdipCreatePathGradientFromPath)(GDIPCONST GpPath* path, GpPathGradient** polyGradient);
typedef GpStatus (WINAPI *pGdipGetPathGradientCenterColor)(GpPathGradient* brush, ARGB* colors);
typedef GpStatus (WINAPI *pGdipSetPathGradientCenterColor)(GpPathGradient* brush, ARGB colors);
typedef GpStatus (WINAPI *pGdipGetPathGradientSurroundColorsWithCount)(GpPathGradient* brush, ARGB* color, INT* count);
typedef GpStatus (WINAPI *pGdipSetPathGradientSurroundColorsWithCount)(GpPathGradient* brush, GDIPCONST ARGB* color, INT* count);
typedef GpStatus (WINAPI *pGdipGetPathGradientPath)(GpPathGradient* brush, GpPath* path);
typedef GpStatus (WINAPI *pGdipSetPathGradientPath)(GpPathGradient* brush, GDIPCONST GpPath* path);
typedef GpStatus (WINAPI *pGdipGetPathGradientCenterPoint)(GpPathGradient* brush, GpPointF* points);
typedef GpStatus (WINAPI *pGdipGetPathGradientCenterPointI)(GpPathGradient* brush, GpPoint* points);
typedef GpStatus (WINAPI *pGdipSetPathGradientCenterPoint)(GpPathGradient* brush, GDIPCONST GpPointF* points);
typedef GpStatus (WINAPI *pGdipSetPathGradientCenterPointI)(GpPathGradient* brush, GDIPCONST GpPoint* points);
typedef GpStatus (WINAPI *pGdipGetPathGradientRect)(GpPathGradient* brush, GpRectF* rect);
typedef GpStatus (WINAPI *pGdipGetPathGradientRectI)(GpPathGradient* brush, GpRect* rect);
typedef GpStatus (WINAPI *pGdipGetPathGradientPointCount)(GpPathGradient* brush, INT* count);
typedef GpStatus (WINAPI *pGdipGetPathGradientSurroundColorCount)(GpPathGradient* brush, INT* count);
typedef GpStatus (WINAPI *pGdipSetPathGradientGammaCorrection)(GpPathGradient* brush, BOOL useGammaCorrection);
typedef GpStatus (WINAPI *pGdipGetPathGradientGammaCorrection)(GpPathGradient* brush, BOOL* useGammaCorrection);
typedef GpStatus (WINAPI *pGdipGetPathGradientBlendCount)(GpPathGradient* brush, INT* count);
typedef GpStatus (WINAPI *pGdipGetPathGradientBlend)(GpPathGradient* brush, REAL* blend, REAL* positions, INT count);
typedef GpStatus (WINAPI *pGdipSetPathGradientBlend)(GpPathGradient* brush, GDIPCONST REAL* blend, GDIPCONST REAL* positions, INT count);
typedef GpStatus (WINAPI *pGdipGetPathGradientPresetBlendCount)(GpPathGradient* brush, INT* count);
typedef GpStatus (WINAPI *pGdipGetPathGradientPresetBlend)(GpPathGradient* brush, ARGB* blend, REAL* positions, INT count);
typedef GpStatus (WINAPI *pGdipSetPathGradientPresetBlend)(GpPathGradient* brush, GDIPCONST ARGB* blend, GDIPCONST REAL* positions, INT count);
typedef GpStatus (WINAPI *pGdipSetPathGradientSigmaBlend)(GpPathGradient* brush, REAL focus, REAL scale);
typedef GpStatus (WINAPI *pGdipSetPathGradientLinearBlend)(GpPathGradient* brush, REAL focus, REAL scale);
typedef GpStatus (WINAPI *pGdipGetPathGradientWrapMode)(GpPathGradient* brush, GpWrapMode* wrapmode);
typedef GpStatus (WINAPI *pGdipSetPathGradientWrapMode)(GpPathGradient* brush, GpWrapMode wrapmode);
typedef GpStatus (WINAPI *pGdipGetPathGradientTransform)(GpPathGradient* brush, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipSetPathGradientTransform)(GpPathGradient* brush, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipResetPathGradientTransform)(GpPathGradient* brush);
typedef GpStatus (WINAPI *pGdipMultiplyPathGradientTransform)(GpPathGradient* brush, GDIPCONST GpMatrix* matrix, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipTranslatePathGradientTransform)(GpPathGradient* brush, REAL dx, REAL dy, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipScalePathGradientTransform)(GpPathGradient* brush, REAL sx, REAL sy, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipRotatePathGradientTransform)(GpPathGradient* brush, REAL angle, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipGetPathGradientFocusScales)(GpPathGradient* brush, REAL* xScale, REAL* yScale);
typedef GpStatus (WINAPI *pGdipSetPathGradientFocusScales)(GpPathGradient* brush, REAL xScale, REAL yScale);

//----------------------------------------------------------------------------
// Pen APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreatePen1)(ARGB color, REAL width, GpUnit unit, GpPen** pen);
typedef GpStatus (WINAPI *pGdipCreatePen2)(GpBrush* brush, REAL width, GpUnit unit, GpPen** pen);
typedef GpStatus (WINAPI *pGdipClonePen)(GpPen* pen, GpPen** clonepen);
typedef GpStatus (WINAPI *pGdipDeletePen)(GpPen* pen);
typedef GpStatus (WINAPI *pGdipSetPenWidth)(GpPen* pen, REAL width);
typedef GpStatus (WINAPI *pGdipGetPenWidth)(GpPen* pen, REAL* width);
typedef GpStatus (WINAPI *pGdipSetPenUnit)(GpPen* pen, GpUnit unit);
typedef GpStatus (WINAPI *pGdipGetPenUnit)(GpPen* pen, GpUnit* unit);
typedef GpStatus (WINAPI *pGdipSetPenLineCap197819)(GpPen* pen, GpLineCap startCap, GpLineCap endCap, GpDashCap dashCap);
typedef GpStatus (WINAPI *pGdipSetPenStartCap)(GpPen* pen, GpLineCap startCap);
typedef GpStatus (WINAPI *pGdipSetPenEndCap)(GpPen* pen, GpLineCap endCap);
typedef GpStatus (WINAPI *pGdipSetPenDashCap197819)(GpPen* pen, GpDashCap dashCap);
typedef GpStatus (WINAPI *pGdipGetPenStartCap)(GpPen* pen, GpLineCap* startCap);
typedef GpStatus (WINAPI *pGdipGetPenEndCap)(GpPen* pen, GpLineCap* endCap);
typedef GpStatus (WINAPI *pGdipGetPenDashCap197819)(GpPen* pen, GpDashCap* dashCap);
typedef GpStatus (WINAPI *pGdipSetPenLineJoin)(GpPen* pen, GpLineJoin lineJoin);
typedef GpStatus (WINAPI *pGdipGetPenLineJoin)(GpPen* pen, GpLineJoin* lineJoin);
typedef GpStatus (WINAPI *pGdipSetPenCustomStartCap)(GpPen* pen, GpCustomLineCap* customCap);
typedef GpStatus (WINAPI *pGdipGetPenCustomStartCap)(GpPen* pen, GpCustomLineCap** customCap);
typedef GpStatus (WINAPI *pGdipSetPenCustomEndCap)(GpPen* pen, GpCustomLineCap* customCap);
typedef GpStatus (WINAPI *pGdipGetPenCustomEndCap)(GpPen* pen, GpCustomLineCap** customCap);
typedef GpStatus (WINAPI *pGdipSetPenMiterLimit)(GpPen* pen, REAL miterLimit);
typedef GpStatus (WINAPI *pGdipGetPenMiterLimit)(GpPen* pen, REAL* miterLimit);
typedef GpStatus (WINAPI *pGdipSetPenMode)(GpPen* pen, GpPenAlignment penMode);
typedef GpStatus (WINAPI *pGdipGetPenMode)(GpPen* pen, GpPenAlignment* penMode);
typedef GpStatus (WINAPI *pGdipSetPenTransform)(GpPen* pen, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipGetPenTransform)(GpPen* pen, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipResetPenTransform)(GpPen* pen);
typedef GpStatus (WINAPI *pGdipMultiplyPenTransform)(GpPen* pen, GDIPCONST GpMatrix* matrix, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipTranslatePenTransform)(GpPen* pen, REAL dx, REAL dy, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipScalePenTransform)(GpPen* pen, REAL sx, REAL sy, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipRotatePenTransform)(GpPen* pen, REAL angle, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipSetPenColor)(GpPen* pen, ARGB argb);
typedef GpStatus (WINAPI *pGdipGetPenColor)(GpPen* pen, ARGB* argb);
typedef GpStatus (WINAPI *pGdipSetPenBrushFill)(GpPen* pen, GpBrush* brush);
typedef GpStatus (WINAPI *pGdipGetPenBrushFill)(GpPen* pen, GpBrush** brush);
typedef GpStatus (WINAPI *pGdipGetPenFillType)(GpPen* pen, GpPenType* type);
typedef GpStatus (WINAPI *pGdipGetPenDashStyle)(GpPen* pen, GpDashStyle* dashstyle);
typedef GpStatus (WINAPI *pGdipSetPenDashStyle)(GpPen* pen, GpDashStyle dashstyle);
typedef GpStatus (WINAPI *pGdipGetPenDashOffset)(GpPen* pen, REAL* offset);
typedef GpStatus (WINAPI *pGdipSetPenDashOffset)(GpPen* pen, REAL offset);
typedef GpStatus (WINAPI *pGdipGetPenDashCount)(GpPen* pen, INT* count);
typedef GpStatus (WINAPI *pGdipSetPenDashArray)(GpPen* pen, GDIPCONST REAL* dash, INT count);
typedef GpStatus (WINAPI *pGdipGetPenDashArray)(GpPen* pen, REAL* dash, INT count);
typedef GpStatus (WINAPI *pGdipGetPenCompoundCount)(GpPen* pen, INT* count);
typedef GpStatus (WINAPI *pGdipSetPenCompoundArray)(GpPen* pen, GDIPCONST REAL* dash, INT count);
typedef GpStatus (WINAPI *pGdipGetPenCompoundArray)(GpPen* pen, REAL* dash, INT count);

//----------------------------------------------------------------------------
// CustomLineCap APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateCustomLineCap)(GpPath* fillPath, GpPath* strokePath, GpLineCap baseCap, REAL baseInset, GpCustomLineCap** customCap);
typedef GpStatus (WINAPI *pGdipDeleteCustomLineCap)(GpCustomLineCap* customCap);
typedef GpStatus (WINAPI *pGdipCloneCustomLineCap)(GpCustomLineCap* customCap, GpCustomLineCap** clonedCap);
typedef GpStatus (WINAPI *pGdipGetCustomLineCapType)(GpCustomLineCap* customCap, CustomLineCapType* capType);
typedef GpStatus (WINAPI *pGdipSetCustomLineCapStrokeCaps)(GpCustomLineCap* customCap, GpLineCap startCap, GpLineCap endCap);
typedef GpStatus (WINAPI *pGdipGetCustomLineCapStrokeCaps)(GpCustomLineCap* customCap, GpLineCap* startCap, GpLineCap* endCap);
typedef GpStatus (WINAPI *pGdipSetCustomLineCapStrokeJoin)(GpCustomLineCap* customCap, GpLineJoin lineJoin);
typedef GpStatus (WINAPI *pGdipGetCustomLineCapStrokeJoin)(GpCustomLineCap* customCap, GpLineJoin* lineJoin);
typedef GpStatus (WINAPI *pGdipSetCustomLineCapBaseCap)(GpCustomLineCap* customCap, GpLineCap baseCap);
typedef GpStatus (WINAPI *pGdipGetCustomLineCapBaseCap)(GpCustomLineCap* customCap, GpLineCap* baseCap);
typedef GpStatus (WINAPI *pGdipSetCustomLineCapBaseInset)(GpCustomLineCap* customCap, REAL inset);
typedef GpStatus (WINAPI *pGdipGetCustomLineCapBaseInset)(GpCustomLineCap* customCap, REAL* inset);
typedef GpStatus (WINAPI *pGdipSetCustomLineCapWidthScale)(GpCustomLineCap* customCap, REAL widthScale);
typedef GpStatus (WINAPI *pGdipGetCustomLineCapWidthScale)(GpCustomLineCap* customCap, REAL* widthScale);

//----------------------------------------------------------------------------
// AdjustableArrowCap APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateAdjustableArrowCap)(REAL height, REAL width, BOOL isFilled, GpAdjustableArrowCap** cap);
typedef GpStatus (WINAPI *pGdipSetAdjustableArrowCapHeight)(GpAdjustableArrowCap* cap, REAL height);
typedef GpStatus (WINAPI *pGdipGetAdjustableArrowCapHeight)(GpAdjustableArrowCap* cap, REAL* height);
typedef GpStatus (WINAPI *pGdipSetAdjustableArrowCapWidth)(GpAdjustableArrowCap* cap, REAL width);
typedef GpStatus (WINAPI *pGdipGetAdjustableArrowCapWidth)(GpAdjustableArrowCap* cap, REAL* width);
typedef GpStatus (WINAPI *pGdipSetAdjustableArrowCapMiddleInset)(GpAdjustableArrowCap* cap, REAL middleInset);
typedef GpStatus (WINAPI *pGdipGetAdjustableArrowCapMiddleInset)(GpAdjustableArrowCap* cap, REAL* middleInset);
typedef GpStatus (WINAPI *pGdipSetAdjustableArrowCapFillState)(GpAdjustableArrowCap* cap, BOOL fillState);
typedef GpStatus (WINAPI *pGdipGetAdjustableArrowCapFillState)(GpAdjustableArrowCap* cap, BOOL* fillState);

//----------------------------------------------------------------------------
// Image APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipLoadImageFromStream)(IStream* stream, GpImage** image);
typedef GpStatus (WINAPI *pGdipLoadImageFromFile)(GDIPCONST WCHAR* filename, GpImage** image);
typedef GpStatus (WINAPI *pGdipLoadImageFromStreamICM)(IStream* stream, GpImage** image);
typedef GpStatus (WINAPI *pGdipLoadImageFromFileICM)(GDIPCONST WCHAR* filename, GpImage** image);
typedef GpStatus (WINAPI *pGdipCloneImage)(GpImage* image, GpImage** cloneImage);
typedef GpStatus (WINAPI *pGdipDisposeImage)(GpImage* image);
typedef GpStatus (WINAPI *pGdipSaveImageToFile)(GpImage* image, GDIPCONST WCHAR* filename, GDIPCONST CLSID* clsidEncoder, GDIPCONST EncoderParameters* encoderParams);
typedef GpStatus (WINAPI *pGdipSaveImageToStream)(GpImage* image, IStream* stream, GDIPCONST CLSID* clsidEncoder, GDIPCONST EncoderParameters* encoderParams);
typedef GpStatus (WINAPI *pGdipSaveAdd)(GpImage* image, GDIPCONST EncoderParameters* encoderParams);
typedef GpStatus (WINAPI *pGdipSaveAddImage)(GpImage* image, GpImage* newImage, GDIPCONST EncoderParameters* encoderParams);
typedef GpStatus (WINAPI *pGdipGetImageGraphicsContext)(GpImage* image, GpGraphics** graphics);
typedef GpStatus (WINAPI *pGdipGetImageBounds)(GpImage* image, GpRectF* srcRect, GpUnit* srcUnit);
typedef GpStatus (WINAPI *pGdipGetImageDimension)(GpImage* image, REAL* width, REAL* height);
typedef GpStatus (WINAPI *pGdipGetImageType)(GpImage* image, ImageType* type);
typedef GpStatus (WINAPI *pGdipGetImageWidth)(GpImage* image, UINT* width);
typedef GpStatus (WINAPI *pGdipGetImageHeight)(GpImage* image, UINT* height);
typedef GpStatus (WINAPI *pGdipGetImageHorizontalResolution)(GpImage* image, REAL* resolution);
typedef GpStatus (WINAPI *pGdipGetImageVerticalResolution)(GpImage* image, REAL* resolution);
typedef GpStatus (WINAPI *pGdipGetImageFlags)(GpImage* image, UINT* flags);
typedef GpStatus (WINAPI *pGdipGetImageRawFormat)(GpImage* image, GUID* format);
typedef GpStatus (WINAPI *pGdipGetImagePixelFormat)(GpImage* image, PixelFormat* format);
typedef GpStatus (WINAPI *pGdipGetImageThumbnail)(GpImage* image, UINT thumbWidth, UINT thumbHeight, GpImage** thumbImage, GetThumbnailImageAbort callback, VOID* callbackData);
typedef GpStatus (WINAPI *pGdipGetEncoderParameterListSize)(GpImage* image, GDIPCONST CLSID* clsidEncoder, UINT* size);
typedef GpStatus (WINAPI *pGdipGetEncoderParameterList)(GpImage* image, GDIPCONST CLSID* clsidEncoder, UINT size, EncoderParameters* buffer);
typedef GpStatus (WINAPI *pGdipImageGetFrameDimensionsCount)(GpImage* image, UINT* count);
typedef GpStatus (WINAPI *pGdipImageGetFrameDimensionsList)(GpImage* image, GUID* dimensionIDs, UINT count);
typedef GpStatus (WINAPI *pGdipImageGetFrameCount)(GpImage* image, GDIPCONST GUID* dimensionID, UINT* count);
typedef GpStatus (WINAPI *pGdipImageSelectActiveFrame)(GpImage* image, GDIPCONST GUID* dimensionID, UINT frameIndex);
typedef GpStatus (WINAPI *pGdipImageRotateFlip)(GpImage* image, RotateFlipType rfType);
typedef GpStatus (WINAPI *pGdipGetImagePalette)(GpImage* image, ColorPalette* palette, INT size);
typedef GpStatus (WINAPI *pGdipSetImagePalette)(GpImage* image, GDIPCONST ColorPalette* palette);
typedef GpStatus (WINAPI *pGdipGetImagePaletteSize)(GpImage* image, INT* size);
typedef GpStatus (WINAPI *pGdipGetPropertyCount)(GpImage* image, UINT* numOfProperty);
typedef GpStatus (WINAPI *pGdipGetPropertyIdList)(GpImage* image, UINT numOfProperty, PROPID* list);
typedef GpStatus (WINAPI *pGdipGetPropertyItemSize)(GpImage* image, PROPID propId, UINT* size);
typedef GpStatus (WINAPI *pGdipGetPropertyItem)(GpImage* image, PROPID propId, UINT propSize, PropertyItem* buffer);
typedef GpStatus (WINAPI *pGdipGetPropertySize)(GpImage* image, UINT* totalBufferSize, UINT* numProperties);
typedef GpStatus (WINAPI *pGdipGetAllPropertyItems)(GpImage* image, UINT totalBufferSize, UINT numProperties, PropertyItem* allItems);
typedef GpStatus (WINAPI *pGdipRemovePropertyItem)(GpImage* image, PROPID propId);
typedef GpStatus (WINAPI *pGdipSetPropertyItem)(GpImage* image, GDIPCONST PropertyItem* item);
typedef GpStatus (WINAPI *pGdipImageForceValidation)(GpImage* image);

//----------------------------------------------------------------------------
// Bitmap APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateBitmapFromStream)(IStream* stream, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCreateBitmapFromFile)(GDIPCONST WCHAR* filename, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCreateBitmapFromStreamICM)(IStream* stream, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCreateBitmapFromFileICM)(GDIPCONST WCHAR* filename, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCreateBitmapFromScan0)(INT width, INT height, INT stride, PixelFormat format, BYTE* scan0, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCreateBitmapFromGraphics)(INT width, INT height, GpGraphics* target, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCreateBitmapFromDirectDrawSurface)(IDirectDrawSurface7* surface, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCreateBitmapFromGdiDib)(GDIPCONST BITMAPINFO* gdiBitmapInfo, VOID* gdiBitmapData, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCreateBitmapFromHBITMAP)(HBITMAP hbm, HPALETTE hpal, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCreateHBITMAPFromBitmap)(GpBitmap* bitmap, HBITMAP* hbmReturn, ARGB background);
typedef GpStatus (WINAPI *pGdipCreateBitmapFromHICON)(HICON hicon, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCreateHICONFromBitmap)(GpBitmap* bitmap, HICON* hbmReturn);
typedef GpStatus (WINAPI *pGdipCreateBitmapFromResource)(HINSTANCE hInstance, GDIPCONST WCHAR* lpBitmapName, GpBitmap** bitmap);
typedef GpStatus (WINAPI *pGdipCloneBitmapArea)(REAL x, REAL y, REAL width, REAL height, PixelFormat format, GpBitmap* srcBitmap, GpBitmap** dstBitmap);
typedef GpStatus (WINAPI *pGdipCloneBitmapAreaI)(INT x, INT y, INT width, INT height, PixelFormat format, GpBitmap* srcBitmap, GpBitmap** dstBitmap);
typedef GpStatus (WINAPI *pGdipBitmapLockBits)(GpBitmap* bitmap, GDIPCONST GpRect* rect, UINT flags, PixelFormat format, BitmapData* lockedBitmapData);
typedef GpStatus (WINAPI *pGdipBitmapUnlockBits)(GpBitmap* bitmap, BitmapData* lockedBitmapData);
typedef GpStatus (WINAPI *pGdipBitmapGetPixel)(GpBitmap* bitmap, INT x, INT y, ARGB* color);
typedef GpStatus (WINAPI *pGdipBitmapSetPixel)(GpBitmap* bitmap, INT x, INT y, ARGB color);
typedef GpStatus (WINAPI *pGdipBitmapSetResolution)(GpBitmap* bitmap, REAL xdpi, REAL ydpi);

//----------------------------------------------------------------------------
// ImageAttributes APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateImageAttributes)(GpImageAttributes** imageattr);
typedef GpStatus (WINAPI *pGdipCloneImageAttributes)(GDIPCONST GpImageAttributes* imageattr, GpImageAttributes** cloneImageattr);
typedef GpStatus (WINAPI *pGdipDisposeImageAttributes)(GpImageAttributes* imageattr);
typedef GpStatus (WINAPI *pGdipSetImageAttributesToIdentity)(GpImageAttributes* imageattr, ColorAdjustType type);
typedef GpStatus (WINAPI *pGdipResetImageAttributes)(GpImageAttributes* imageattr, ColorAdjustType type);
typedef GpStatus (WINAPI *pGdipSetImageAttributesColorMatrix)(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, GDIPCONST ColorMatrix* colorMatrix, GDIPCONST ColorMatrix* grayMatrix, ColorMatrixFlags flags);
typedef GpStatus (WINAPI *pGdipSetImageAttributesThreshold)(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, REAL threshold);
typedef GpStatus (WINAPI *pGdipSetImageAttributesGamma)(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, REAL gamma);
typedef GpStatus (WINAPI *pGdipSetImageAttributesNoOp)(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag);
typedef GpStatus (WINAPI *pGdipSetImageAttributesColorKeys)(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, ARGB colorLow, ARGB colorHigh);
typedef GpStatus (WINAPI *pGdipSetImageAttributesOutputChannel)(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, ColorChannelFlags channelFlags);
typedef GpStatus (WINAPI *pGdipSetImageAttributesOutputChannelColorProfile)(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, GDIPCONST  WCHAR* colorProfileFilename);
typedef GpStatus (WINAPI *pGdipSetImageAttributesRemapTable)(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, UINT mapSize, GDIPCONST ColorMap* map);
typedef GpStatus (WINAPI *pGdipSetImageAttributesWrapMode)(GpImageAttributes* imageAttr, WrapMode wrap, ARGB argb, BOOL clamp);
typedef GpStatus (WINAPI *pGdipSetImageAttributesICMMode)(GpImageAttributes* imageAttr, BOOL on);
typedef GpStatus (WINAPI *pGdipGetImageAttributesAdjustedPalette)(GpImageAttributes* imageAttr, ColorPalette* colorPalette, ColorAdjustType colorAdjustType);

//----------------------------------------------------------------------------
// Graphics APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipFlush)(GpGraphics* graphics, GpFlushIntention intention);
typedef GpStatus (WINAPI *pGdipCreateFromHDC)(HDC hdc, GpGraphics** graphics);
typedef GpStatus (WINAPI *pGdipCreateFromHDC2)(HDC hdc, HANDLE hDevice, GpGraphics** graphics);
typedef GpStatus (WINAPI *pGdipCreateFromHWND)(HWND hwnd, GpGraphics** graphics);
typedef GpStatus (WINAPI *pGdipCreateFromHWNDICM)(HWND hwnd, GpGraphics** graphics);
typedef GpStatus (WINAPI *pGdipDeleteGraphics)(GpGraphics* graphics);
typedef GpStatus (WINAPI *pGdipGetDC)(GpGraphics* graphics, HDC* hdc);
typedef GpStatus (WINAPI *pGdipReleaseDC)(GpGraphics* graphics, HDC hdc);
typedef GpStatus (WINAPI *pGdipSetCompositingMode)(GpGraphics* graphics, CompositingMode compositingMode);
typedef GpStatus (WINAPI *pGdipGetCompositingMode)(GpGraphics* graphics, CompositingMode* compositingMode);
typedef GpStatus (WINAPI *pGdipSetRenderingOrigin)(GpGraphics* graphics, INT x, INT y);
typedef GpStatus (WINAPI *pGdipGetRenderingOrigin)(GpGraphics* graphics, INT* x, INT* y);
typedef GpStatus (WINAPI *pGdipSetCompositingQuality)(GpGraphics* graphics, CompositingQuality compositingQuality);
typedef GpStatus (WINAPI *pGdipGetCompositingQuality)(GpGraphics* graphics, CompositingQuality* compositingQuality);
typedef GpStatus (WINAPI *pGdipSetSmoothingMode)(GpGraphics* graphics, SmoothingMode smoothingMode);
typedef GpStatus (WINAPI *pGdipGetSmoothingMode)(GpGraphics* graphics, SmoothingMode* smoothingMode);
typedef GpStatus (WINAPI *pGdipSetPixelOffsetMode)(GpGraphics* graphics, PixelOffsetMode pixelOffsetMode);
typedef GpStatus (WINAPI *pGdipGetPixelOffsetMode)(GpGraphics* graphics, PixelOffsetMode* pixelOffsetMode);
typedef GpStatus (WINAPI *pGdipSetTextRenderingHint)(GpGraphics* graphics, TextRenderingHint mode);
typedef GpStatus (WINAPI *pGdipGetTextRenderingHint)(GpGraphics* graphics, TextRenderingHint* mode);
typedef GpStatus (WINAPI *pGdipSetTextContrast)(GpGraphics* graphics, UINT contrast);
typedef GpStatus (WINAPI *pGdipGetTextContrast)(GpGraphics* graphics, UINT* contrast);
typedef GpStatus (WINAPI *pGdipSetInterpolationMode)(GpGraphics* graphics, InterpolationMode interpolationMode);
typedef GpStatus (WINAPI *pGdipGetInterpolationMode)(GpGraphics* graphics, InterpolationMode* interpolationMode);
typedef GpStatus (WINAPI *pGdipSetWorldTransform)(GpGraphics* graphics, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipResetWorldTransform)(GpGraphics* graphics);
typedef GpStatus (WINAPI *pGdipMultiplyWorldTransform)(GpGraphics* graphics, GDIPCONST GpMatrix* matrix, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipTranslateWorldTransform)(GpGraphics* graphics, REAL dx, REAL dy, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipScaleWorldTransform)(GpGraphics* graphics, REAL sx, REAL sy, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipRotateWorldTransform)(GpGraphics* graphics, REAL angle, GpMatrixOrder order);
typedef GpStatus (WINAPI *pGdipGetWorldTransform)(GpGraphics* graphics, GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipResetPageTransform)(GpGraphics* graphics);
typedef GpStatus (WINAPI *pGdipGetPageUnit)(GpGraphics* graphics, GpUnit* unit);
typedef GpStatus (WINAPI *pGdipGetPageScale)(GpGraphics* graphics, REAL* scale);
typedef GpStatus (WINAPI *pGdipSetPageUnit)(GpGraphics* graphics, GpUnit unit);
typedef GpStatus (WINAPI *pGdipSetPageScale)(GpGraphics* graphics, REAL scale);
typedef GpStatus (WINAPI *pGdipGetDpiX)(GpGraphics* graphics, REAL* dpi);
typedef GpStatus (WINAPI *pGdipGetDpiY)(GpGraphics* graphics, REAL* dpi);
typedef GpStatus (WINAPI *pGdipTransformPoints)(GpGraphics* graphics, GpCoordinateSpace destSpace, GpCoordinateSpace srcSpace, GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipTransformPointsI)(GpGraphics* graphics, GpCoordinateSpace destSpace, GpCoordinateSpace srcSpace, GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipGetNearestColor)(GpGraphics* graphics, ARGB* argb);

// Creates the Win9x Halftone Palette(even on NT) with correct Desktop colors
typedef HPALETTE (WINAPI *pGdipCreateHalftonePalette)();
typedef GpStatus (WINAPI *pGdipDrawLine)(GpGraphics* graphics, GpPen* pen, REAL x1, REAL y1, REAL x2, REAL y2);
typedef GpStatus (WINAPI *pGdipDrawLineI)(GpGraphics* graphics, GpPen* pen, INT x1, INT y1, INT x2, INT y2);
typedef GpStatus (WINAPI *pGdipDrawLines)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipDrawLinesI)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipDrawArc)(GpGraphics* graphics, GpPen* pen, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
typedef GpStatus (WINAPI *pGdipDrawArcI)(GpGraphics* graphics, GpPen* pen, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
typedef GpStatus (WINAPI *pGdipDrawBezier)(GpGraphics* graphics, GpPen* pen, REAL x1, REAL y1, REAL x2, REAL y2, REAL x3, REAL y3, REAL x4, REAL y4);
typedef GpStatus (WINAPI *pGdipDrawBezierI)(GpGraphics* graphics, GpPen* pen, INT x1, INT y1, INT x2, INT y2, INT x3, INT y3, INT x4, INT y4);
typedef GpStatus (WINAPI *pGdipDrawBeziers)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipDrawBeziersI)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipDrawRectangle)(GpGraphics* graphics, GpPen* pen, REAL x, REAL y, REAL width, REAL height);
typedef GpStatus (WINAPI *pGdipDrawRectangleI)(GpGraphics* graphics, GpPen* pen, INT x, INT y, INT width, INT height);
typedef GpStatus (WINAPI *pGdipDrawRectangles)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpRectF* rects, INT count);
typedef GpStatus (WINAPI *pGdipDrawRectanglesI)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpRect* rects, INT count);
typedef GpStatus (WINAPI *pGdipDrawEllipse)(GpGraphics* graphics, GpPen* pen, REAL x, REAL y, REAL width, REAL height);
typedef GpStatus (WINAPI *pGdipDrawEllipseI)(GpGraphics* graphics, GpPen* pen, INT x, INT y, INT width, INT height);
typedef GpStatus (WINAPI *pGdipDrawPie)(GpGraphics* graphics, GpPen* pen, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
typedef GpStatus (WINAPI *pGdipDrawPieI)(GpGraphics* graphics, GpPen* pen, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
typedef GpStatus (WINAPI *pGdipDrawPolygon)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipDrawPolygonI)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipDrawPath)(GpGraphics* graphics, GpPen* pen, GpPath* path);
typedef GpStatus (WINAPI *pGdipDrawCurve)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipDrawCurveI)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipDrawCurve2)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count, REAL tension);
typedef GpStatus (WINAPI *pGdipDrawCurve2I)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count, REAL tension);
typedef GpStatus (WINAPI *pGdipDrawCurve3)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count, INT offset, INT numberOfSegments, REAL tension);
typedef GpStatus (WINAPI *pGdipDrawCurve3I)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count, INT offset, INT numberOfSegments, REAL tension);
typedef GpStatus (WINAPI *pGdipDrawClosedCurve)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipDrawClosedCurveI)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipDrawClosedCurve2)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count, REAL tension);
typedef GpStatus (WINAPI *pGdipDrawClosedCurve2I)(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count, REAL tension);
typedef GpStatus (WINAPI *pGdipGraphicsClear)(GpGraphics* graphics, ARGB color);
typedef GpStatus (WINAPI *pGdipFillRectangle)(GpGraphics* graphics, GpBrush* brush, REAL x, REAL y, REAL width, REAL height);
typedef GpStatus (WINAPI *pGdipFillRectangleI)(GpGraphics* graphics, GpBrush* brush, INT x, INT y, INT width, INT height);
typedef GpStatus (WINAPI *pGdipFillRectangles)(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpRectF* rects, INT count);
typedef GpStatus (WINAPI *pGdipFillRectanglesI)(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpRect* rects, INT count);
typedef GpStatus (WINAPI *pGdipFillPolygon)(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPointF* points, INT count, GpFillMode fillMode);
typedef GpStatus (WINAPI *pGdipFillPolygonI)(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPoint* points, INT count, GpFillMode fillMode);
typedef GpStatus (WINAPI *pGdipFillPolygon2)(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipFillPolygon2I)(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipFillEllipse)(GpGraphics* graphics, GpBrush* brush, REAL x, REAL y, REAL width, REAL height);
typedef GpStatus (WINAPI *pGdipFillEllipseI)(GpGraphics* graphics, GpBrush* brush, INT x, INT y, INT width, INT height);
typedef GpStatus (WINAPI *pGdipFillPie)(GpGraphics* graphics, GpBrush* brush, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
typedef GpStatus (WINAPI *pGdipFillPieI)(GpGraphics* graphics, GpBrush* brush, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
typedef GpStatus (WINAPI *pGdipFillPath)(GpGraphics* graphics, GpBrush* brush, GpPath* path);
typedef GpStatus (WINAPI *pGdipFillClosedCurve)(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPointF* points, INT count);
typedef GpStatus (WINAPI *pGdipFillClosedCurveI)(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPoint* points, INT count);
typedef GpStatus (WINAPI *pGdipFillClosedCurve2)(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPointF* points, INT count, REAL tension, GpFillMode fillMode);
typedef GpStatus (WINAPI *pGdipFillClosedCurve2I)(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPoint* points, INT count, REAL tension, GpFillMode fillMode);
typedef GpStatus (WINAPI *pGdipFillRegion)(GpGraphics* graphics, GpBrush* brush, GpRegion* region);
typedef GpStatus (WINAPI *pGdipDrawImage)(GpGraphics* graphics, GpImage* image, REAL x, REAL y);
typedef GpStatus (WINAPI *pGdipDrawImageI)(GpGraphics* graphics, GpImage* image, INT x, INT y);
typedef GpStatus (WINAPI *pGdipDrawImageRect)(GpGraphics* graphics, GpImage* image, REAL x, REAL y, REAL width, REAL height);
typedef GpStatus (WINAPI *pGdipDrawImageRectI)(GpGraphics* graphics, GpImage* image, INT x, INT y, INT width, INT height);
typedef GpStatus (WINAPI *pGdipDrawImagePoints)(GpGraphics* graphics, GpImage* image, GDIPCONST GpPointF* dstpoints, INT count);
typedef GpStatus (WINAPI *pGdipDrawImagePointsI)(GpGraphics* graphics, GpImage* image, GDIPCONST GpPoint* dstpoints, INT count);
typedef GpStatus (WINAPI *pGdipDrawImagePointRect)(GpGraphics* graphics, GpImage* image, REAL x, REAL y, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, GpUnit srcUnit);
typedef GpStatus (WINAPI *pGdipDrawImagePointRectI)(GpGraphics* graphics, GpImage* image, INT x, INT y, INT srcx, INT srcy, INT srcwidth, INT srcheight, GpUnit srcUnit);
typedef GpStatus (WINAPI *pGdipDrawImageRectRect)(GpGraphics* graphics, GpImage* image, REAL dstx, REAL dsty, REAL dstwidth, REAL dstheight, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, GpUnit srcUnit, GDIPCONST GpImageAttributes* imageAttributes, DrawImageAbort callback, VOID* callbackData);
typedef GpStatus (WINAPI *pGdipDrawImageRectRectI)(GpGraphics* graphics, GpImage* image, INT dstx, INT dsty, INT dstwidth, INT dstheight, INT srcx, INT srcy, INT srcwidth, INT srcheight, GpUnit srcUnit, GDIPCONST GpImageAttributes* imageAttributes, DrawImageAbort callback, VOID* callbackData);
typedef GpStatus (WINAPI *pGdipDrawImagePointsRect)(GpGraphics* graphics, GpImage* image, GDIPCONST GpPointF* points, INT count, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, GpUnit srcUnit, GDIPCONST GpImageAttributes* imageAttributes, DrawImageAbort callback, VOID* callbackData);
typedef GpStatus (WINAPI *pGdipDrawImagePointsRectI)(GpGraphics* graphics, GpImage* image, GDIPCONST GpPoint* points, INT count, INT srcx, INT srcy, INT srcwidth, INT srcheight, GpUnit srcUnit, GDIPCONST GpImageAttributes* imageAttributes, DrawImageAbort callback, VOID* callbackData);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileDestPoint)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST PointF& destPoint, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileDestPointI)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Point& destPoint, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileDestRect)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST RectF& destRect, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileDestRectI)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Rect& destRect, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileDestPoints)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST PointF* destPoints, INT count, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileDestPointsI)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Point* destPoints, INT count, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileSrcRectDestPoint)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST PointF& destPoint, GDIPCONST RectF& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileSrcRectDestPointI)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Point& destPoint, GDIPCONST Rect& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileSrcRectDestRect)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST RectF& destRect, GDIPCONST RectF& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileSrcRectDestRectI)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Rect& destRect, GDIPCONST Rect& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileSrcRectDestPoints)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST PointF* destPoints, INT count, GDIPCONST RectF& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipEnumerateMetafileSrcRectDestPointsI)(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Point* destPoints, INT count, GDIPCONST Rect& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
typedef GpStatus (WINAPI *pGdipPlayMetafileRecord)(GDIPCONST GpMetafile* metafile, EmfPlusRecordType recordType, UINT flags, UINT dataSize, GDIPCONST BYTE* data);
typedef GpStatus (WINAPI *pGdipSetClipGraphics)(GpGraphics* graphics, GpGraphics* srcgraphics, CombineMode combineMode);
typedef GpStatus (WINAPI *pGdipSetClipRect)(GpGraphics* graphics, REAL x, REAL y, REAL width, REAL height, CombineMode combineMode);
typedef GpStatus (WINAPI *pGdipSetClipRectI)(GpGraphics* graphics, INT x, INT y, INT width, INT height, CombineMode combineMode);
typedef GpStatus (WINAPI *pGdipSetClipPath)(GpGraphics* graphics, GpPath* path, CombineMode combineMode);
typedef GpStatus (WINAPI *pGdipSetClipRegion)(GpGraphics* graphics, GpRegion* region, CombineMode combineMode);
typedef GpStatus (WINAPI *pGdipSetClipHrgn)(GpGraphics* graphics, HRGN hRgn, CombineMode combineMode);
typedef GpStatus (WINAPI *pGdipResetClip)(GpGraphics* graphics);
typedef GpStatus (WINAPI *pGdipTranslateClip)(GpGraphics* graphics, REAL dx, REAL dy);
typedef GpStatus (WINAPI *pGdipTranslateClipI)(GpGraphics* graphics, INT dx, INT dy);
typedef GpStatus (WINAPI *pGdipGetClip)(GpGraphics* graphics, GpRegion* region);
typedef GpStatus (WINAPI *pGdipGetClipBounds)(GpGraphics* graphics, GpRectF* rect);
typedef GpStatus (WINAPI *pGdipGetClipBoundsI)(GpGraphics* graphics, GpRect* rect);
typedef GpStatus (WINAPI *pGdipIsClipEmpty)(GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipGetVisibleClipBounds)(GpGraphics* graphics, GpRectF* rect);
typedef GpStatus (WINAPI *pGdipGetVisibleClipBoundsI)(GpGraphics* graphics, GpRect* rect);
typedef GpStatus (WINAPI *pGdipIsVisibleClipEmpty)(GpGraphics* graphics, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsVisiblePoint)(GpGraphics* graphics, REAL x, REAL y, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsVisiblePointI)(GpGraphics* graphics, INT x, INT y, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsVisibleRect)(GpGraphics* graphics, REAL x, REAL y, REAL width, REAL height, BOOL* result);
typedef GpStatus (WINAPI *pGdipIsVisibleRectI)(GpGraphics* graphics, INT x, INT y, INT width, INT height, BOOL* result);
typedef GpStatus (WINAPI *pGdipSaveGraphics)(GpGraphics* graphics, GraphicsState* state);
typedef GpStatus (WINAPI *pGdipRestoreGraphics)(GpGraphics* graphics, GraphicsState state);
typedef GpStatus (WINAPI *pGdipBeginContainer)(GpGraphics* graphics, GDIPCONST GpRectF* dstrect, GDIPCONST GpRectF* srcrect, GpUnit unit, GraphicsContainer* state);
typedef GpStatus (WINAPI *pGdipBeginContainerI)(GpGraphics* graphics, GDIPCONST GpRect* dstrect, GDIPCONST GpRect* srcrect, GpUnit unit, GraphicsContainer* state);
typedef GpStatus (WINAPI *pGdipBeginContainer2)(GpGraphics* graphics, GraphicsContainer* state);
typedef GpStatus (WINAPI *pGdipEndContainer)(GpGraphics* graphics, GraphicsContainer state);
typedef GpStatus (WINAPI *pGdipGetMetafileHeaderFromWmf)(HMETAFILE hWmf, GDIPCONST WmfPlaceableFileHeader* wmfPlaceableFileHeader, MetafileHeader* header);
typedef GpStatus (WINAPI *pGdipGetMetafileHeaderFromEmf)(HENHMETAFILE hEmf, MetafileHeader* header);
typedef GpStatus (WINAPI *pGdipGetMetafileHeaderFromFile)(GDIPCONST WCHAR* filename, MetafileHeader* header);
typedef GpStatus (WINAPI *pGdipGetMetafileHeaderFromStream)(IStream* stream, MetafileHeader* header);
typedef GpStatus (WINAPI *pGdipGetMetafileHeaderFromMetafile)(GpMetafile* metafile, MetafileHeader* header);
typedef GpStatus (WINAPI *pGdipGetHemfFromMetafile)(GpMetafile* metafile, HENHMETAFILE* hEmf);
typedef GpStatus (WINAPI *pGdipCreateStreamOnFile)(GDIPCONST WCHAR* filename, UINT access, IStream** stream);
typedef GpStatus (WINAPI *pGdipCreateMetafileFromWmf)(HMETAFILE hWmf, BOOL deleteWmf, GDIPCONST WmfPlaceableFileHeader* wmfPlaceableFileHeader, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipCreateMetafileFromEmf)(HENHMETAFILE hEmf, BOOL deleteEmf, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipCreateMetafileFromFile)(GDIPCONST WCHAR* file, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipCreateMetafileFromWmfFile)(GDIPCONST WCHAR* file, GDIPCONST WmfPlaceableFileHeader* wmfPlaceableFileHeader, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipCreateMetafileFromStream)(IStream* stream, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipRecordMetafile)(HDC referenceHdc, EmfType type, GDIPCONST GpRectF* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipRecordMetafileI)(HDC referenceHdc, EmfType type, GDIPCONST GpRect* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipRecordMetafileFileName)(GDIPCONST WCHAR* fileName, HDC referenceHdc, EmfType type, GDIPCONST GpRectF* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipRecordMetafileFileNameI)(GDIPCONST WCHAR* fileName, HDC referenceHdc, EmfType type, GDIPCONST GpRect* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipRecordMetafileStream)(IStream* stream, HDC referenceHdc, EmfType type, GDIPCONST GpRectF* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipRecordMetafileStreamI)(IStream* stream, HDC referenceHdc, EmfType type, GDIPCONST GpRect* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
typedef GpStatus (WINAPI *pGdipSetMetafileDownLevelRasterizationLimit)(GpMetafile* metafile, UINT metafileRasterizationLimitDpi);
typedef GpStatus (WINAPI *pGdipGetMetafileDownLevelRasterizationLimit)(GDIPCONST GpMetafile* metafile, UINT* metafileRasterizationLimitDpi);
typedef GpStatus (WINAPI *pGdipGetImageDecodersSize)(UINT* numDecoders, UINT* size);
typedef GpStatus (WINAPI *pGdipGetImageDecoders)(UINT numDecoders, UINT size, ImageCodecInfo* decoders);
typedef GpStatus (WINAPI *pGdipGetImageEncodersSize)(UINT* numEncoders, UINT* size);
typedef GpStatus (WINAPI *pGdipGetImageEncoders)(UINT numEncoders, UINT size, ImageCodecInfo* encoders);
typedef GpStatus (WINAPI *pGdipComment)(GpGraphics* graphics, UINT sizeData, GDIPCONST BYTE* data);

//----------------------------------------------------------------------------
// FontFamily APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateFontFamilyFromName)(GDIPCONST WCHAR* name, GpFontCollection* fontCollection, GpFontFamily** FontFamily);
typedef GpStatus (WINAPI *pGdipDeleteFontFamily)(GpFontFamily* FontFamily);
typedef GpStatus (WINAPI *pGdipCloneFontFamily)(GpFontFamily* FontFamily, GpFontFamily** clonedFontFamily);
typedef GpStatus (WINAPI *pGdipGetGenericFontFamilySansSerif)(GpFontFamily** nativeFamily);
typedef GpStatus (WINAPI *pGdipGetGenericFontFamilySerif)(GpFontFamily** nativeFamily);
typedef GpStatus (WINAPI *pGdipGetGenericFontFamilyMonospace)(GpFontFamily** nativeFamily);
typedef GpStatus (WINAPI *pGdipGetFamilyName)(GDIPCONST GpFontFamily* family, WCHAR name[LF_FACESIZE], LANGID language);
typedef GpStatus (WINAPI *pGdipIsStyleAvailable)(GDIPCONST GpFontFamily* family, INT style, BOOL* IsStyleAvailable);
typedef GpStatus (WINAPI *pGdipFontCollectionEnumerable)(GpFontCollection* fontCollection, GpGraphics* graphics, INT* numFound);
typedef GpStatus (WINAPI *pGdipFontCollectionEnumerate)(GpFontCollection* fontCollection, INT numSought, GpFontFamily* gpfamilies[], INT* numFound, GpGraphics* graphics);
typedef GpStatus (WINAPI *pGdipGetEmHeight)(GDIPCONST GpFontFamily* family, INT style, UINT16* EmHeight);
typedef GpStatus (WINAPI *pGdipGetCellAscent)(GDIPCONST GpFontFamily* family, INT style, UINT16* CellAscent);
typedef GpStatus (WINAPI *pGdipGetCellDescent)(GDIPCONST GpFontFamily* family, INT style, UINT16* CellDescent);
typedef GpStatus (WINAPI *pGdipGetLineSpacing)(GDIPCONST GpFontFamily* family, INT style, UINT16* LineSpacing);

//----------------------------------------------------------------------------
// Font APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateFontFromDC)(HDC hdc, GpFont** font);
typedef GpStatus (WINAPI *pGdipCreateFontFromLogfontA)(HDC hdc, GDIPCONST LOGFONTA* logfont, GpFont** font);
typedef GpStatus (WINAPI *pGdipCreateFontFromLogfontW)(HDC hdc, GDIPCONST LOGFONTW* logfont, GpFont** font);
typedef GpStatus (WINAPI *pGdipCreateFont)(GDIPCONST GpFontFamily* fontFamily, REAL emSize, INT style, Unit unit, GpFont** font);
typedef GpStatus (WINAPI *pGdipCloneFont)(GpFont* font, GpFont** cloneFont);
typedef GpStatus (WINAPI *pGdipDeleteFont)(GpFont* font);
typedef GpStatus (WINAPI *pGdipGetFamily)(GpFont* font, GpFontFamily** family);
typedef GpStatus (WINAPI *pGdipGetFontStyle)(GpFont* font, INT* style);
typedef GpStatus (WINAPI *pGdipGetFontSize)(GpFont* font, REAL* size);
typedef GpStatus (WINAPI *pGdipGetFontUnit)(GpFont* font, Unit* unit);
typedef GpStatus (WINAPI *pGdipGetFontHeight)(GDIPCONST GpFont* font, GDIPCONST GpGraphics* graphics, REAL* height);
typedef GpStatus (WINAPI *pGdipGetFontHeightGivenDPI)(GDIPCONST GpFont* font, REAL dpi, REAL* height);
typedef GpStatus (WINAPI *pGdipGetLogFontA)(GpFont* font, GpGraphics* graphics, LOGFONTA* logfontA);
typedef GpStatus (WINAPI *pGdipGetLogFontW)(GpFont* font, GpGraphics* graphics, LOGFONTW* logfontW);
typedef GpStatus (WINAPI *pGdipNewInstalledFontCollection)(GpFontCollection** fontCollection);
typedef GpStatus (WINAPI *pGdipNewPrivateFontCollection)(GpFontCollection** fontCollection);
typedef GpStatus (WINAPI *pGdipDeletePrivateFontCollection)(GpFontCollection** fontCollection);
typedef GpStatus (WINAPI *pGdipGetFontCollectionFamilyCount)(GpFontCollection* fontCollection, INT* numFound);
typedef GpStatus (WINAPI *pGdipGetFontCollectionFamilyList)(GpFontCollection* fontCollection, INT numSought, GpFontFamily* gpfamilies[], INT* numFound);
typedef GpStatus (WINAPI *pGdipPrivateAddFontFile)(GpFontCollection* fontCollection, GDIPCONST WCHAR* filename);
typedef GpStatus (WINAPI *pGdipPrivateAddMemoryFont)(GpFontCollection* fontCollection, GDIPCONST void* memory, INT length);

//----------------------------------------------------------------------------
// Text APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipDrawString)(GpGraphics* graphics, GDIPCONST WCHAR* string, INT length, GDIPCONST GpFont* font, GDIPCONST RectF* layoutRect, GDIPCONST GpStringFormat* stringFormat, GDIPCONST GpBrush* brush);
typedef GpStatus (WINAPI *pGdipMeasureString)(GpGraphics* graphics, GDIPCONST WCHAR* string, INT length, GDIPCONST GpFont* font, GDIPCONST RectF* layoutRect, GDIPCONST GpStringFormat* stringFormat, RectF* boundingBox, INT* codepointsFitted, INT* linesFilled);
typedef GpStatus (WINAPI *pGdipMeasureCharacterRanges)(GpGraphics* graphics, GDIPCONST WCHAR* string, INT length, GDIPCONST GpFont* font, GDIPCONST RectF& layoutRect, GDIPCONST GpStringFormat* stringFormat, INT regionCount, GpRegion** regions);
typedef GpStatus (WINAPI *pGdipDrawDriverString)(GpGraphics* graphics, GDIPCONST UINT16* text, INT length, GDIPCONST GpFont* font, GDIPCONST GpBrush* brush, GDIPCONST PointF* positions, INT flags, GDIPCONST GpMatrix* matrix);
typedef GpStatus (WINAPI *pGdipMeasureDriverString)(GpGraphics* graphics, GDIPCONST UINT16* text, INT length, GDIPCONST GpFont* font, GDIPCONST PointF* positions, INT flags, GDIPCONST GpMatrix* matrix, RectF* boundingBox);

//----------------------------------------------------------------------------
// String format APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateStringFormat)(INT formatAttributes, LANGID language, GpStringFormat** format);
typedef GpStatus (WINAPI *pGdipStringFormatGetGenericDefault)(GpStringFormat** format);
typedef GpStatus (WINAPI *pGdipStringFormatGetGenericTypographic)(GpStringFormat** format);
typedef GpStatus (WINAPI *pGdipDeleteStringFormat)(GpStringFormat* format);
typedef GpStatus (WINAPI *pGdipCloneStringFormat)(GDIPCONST GpStringFormat* format, GpStringFormat** newFormat);
typedef GpStatus (WINAPI *pGdipSetStringFormatFlags)(GpStringFormat* format, INT flags);
typedef GpStatus (WINAPI *pGdipGetStringFormatFlags)(GDIPCONST GpStringFormat* format, INT* flags);
typedef GpStatus (WINAPI *pGdipSetStringFormatAlign)(GpStringFormat* format, StringAlignment align);
typedef GpStatus (WINAPI *pGdipGetStringFormatAlign)(GDIPCONST GpStringFormat* format, StringAlignment* align);
typedef GpStatus (WINAPI *pGdipSetStringFormatLineAlign)(GpStringFormat* format, StringAlignment align);
typedef GpStatus (WINAPI *pGdipGetStringFormatLineAlign)(GDIPCONST GpStringFormat* format, StringAlignment* align);
typedef GpStatus (WINAPI *pGdipSetStringFormatTrimming)(GpStringFormat* format, StringTrimming trimming);
typedef GpStatus (WINAPI *pGdipGetStringFormatTrimming)(GDIPCONST GpStringFormat* format, StringTrimming* trimming);
typedef GpStatus (WINAPI *pGdipSetStringFormatHotkeyPrefix)(GpStringFormat* format, INT hotkeyPrefix);
typedef GpStatus (WINAPI *pGdipGetStringFormatHotkeyPrefix)(GDIPCONST GpStringFormat* format, INT* hotkeyPrefix);
typedef GpStatus (WINAPI *pGdipSetStringFormatTabStops)(GpStringFormat* format, REAL firstTabOffset, INT count, GDIPCONST REAL* tabStops);
typedef GpStatus (WINAPI *pGdipGetStringFormatTabStops)(GDIPCONST GpStringFormat* format, INT count, REAL* firstTabOffset, REAL* tabStops);
typedef GpStatus (WINAPI *pGdipGetStringFormatTabStopCount)(GDIPCONST GpStringFormat* format, INT* count);
typedef GpStatus (WINAPI *pGdipSetStringFormatDigitSubstitution)(GpStringFormat* format, LANGID language, StringDigitSubstitute substitute);
typedef GpStatus (WINAPI *pGdipGetStringFormatDigitSubstitution)(GDIPCONST GpStringFormat* format, LANGID* language, StringDigitSubstitute* substitute);
typedef GpStatus (WINAPI *pGdipGetStringFormatMeasurableCharacterRangeCount)(GDIPCONST GpStringFormat* format, INT* count);
typedef GpStatus (WINAPI *pGdipSetStringFormatMeasurableCharacterRanges)(GpStringFormat* format, INT rangeCount, GDIPCONST CharacterRange* ranges);

//----------------------------------------------------------------------------
// Cached Bitmap APIs
//----------------------------------------------------------------------------
typedef GpStatus (WINAPI *pGdipCreateCachedBitmap)(GpBitmap* bitmap, GpGraphics* graphics, GpCachedBitmap** cachedBitmap);
typedef GpStatus (WINAPI *pGdipDeleteCachedBitmap)(GpCachedBitmap* cachedBitmap);
typedef GpStatus (WINAPI *pGdipDrawCachedBitmap)(GpGraphics* graphics, GpCachedBitmap* cachedBitmap, INT x, INT y);
typedef UINT (WINAPI *pGdipEmfToWmfBits)(HENHMETAFILE hemf, UINT cbData16, LPBYTE pData16, INT iMapMode, INT eFlags);

class GdiplusWrapper
{
private:
    HINSTANCE m_hGdiplusLib;
    Status m_GdiPlusStatus;
public:
    GdiplusWrapper();
    ~GdiplusWrapper();
    BOOL Initialize();
    BOOL IsLoaded();
    BOOL IsInitialized();
    Status WINAPI GdiplusStartup(OUT ULONG_PTR* token, const GdiplusStartupInput* input, OUT GdiplusStartupOutput* output);
    VOID WINAPI GdiplusShutdown(ULONG_PTR token);
    void* WINAPI GdipAlloc(size_t size);
    void WINAPI GdipFree(void* ptr);

    //----------------------------------------------------------------------------
    // GraphicsPath APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreatePath(GpFillMode brushMode, GpPath** path);
    GpStatus WINAPI GdipCreatePath2(GDIPCONST GpPointF* points, GDIPCONST BYTE* types, INT count, GpFillMode fillMode, GpPath** path);
    GpStatus WINAPI GdipCreatePath2I(GDIPCONST GpPoint* points, GDIPCONST BYTE* types, INT count, GpFillMode fillMode, GpPath** path);
    GpStatus WINAPI GdipClonePath(GpPath* path, GpPath** clonePath);
    GpStatus WINAPI GdipDeletePath(GpPath* path);
    GpStatus WINAPI GdipResetPath(GpPath* path);
    GpStatus WINAPI GdipGetPointCount(GpPath* path, INT* count);
    GpStatus WINAPI GdipGetPathTypes(GpPath* path, BYTE* types, INT count);
    GpStatus WINAPI GdipGetPathPoints(GpPath* path, GpPointF* points, INT count);
    GpStatus WINAPI GdipGetPathPointsI(GpPath* path, GpPoint* points, INT count);
    GpStatus WINAPI GdipGetPathFillMode(GpPath* path, GpFillMode* fillmode);
    GpStatus WINAPI GdipSetPathFillMode(GpPath* path, GpFillMode fillmode);
    GpStatus WINAPI GdipGetPathData(GpPath* path, GpPathData* pathData);
    GpStatus WINAPI GdipStartPathFigure(GpPath* path);
    GpStatus WINAPI GdipClosePathFigure(GpPath* path);
    GpStatus WINAPI GdipClosePathFigures(GpPath* path);
    GpStatus WINAPI GdipSetPathMarker(GpPath* path);
    GpStatus WINAPI GdipClearPathMarkers(GpPath* path);
    GpStatus WINAPI GdipReversePath(GpPath* path);
    GpStatus WINAPI GdipGetPathLastPoint(GpPath* path, GpPointF* lastPoint);
    GpStatus WINAPI GdipAddPathLine(GpPath* path, REAL x1, REAL y1, REAL x2, REAL y2);
    GpStatus WINAPI GdipAddPathLine2(GpPath* path, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipAddPathArc(GpPath* path, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
    GpStatus WINAPI GdipAddPathBezier(GpPath* path, REAL x1, REAL y1, REAL x2, REAL y2, REAL x3, REAL y3, REAL x4, REAL y4);
    GpStatus WINAPI GdipAddPathBeziers(GpPath* path, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipAddPathCurve(GpPath* path, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipAddPathCurve2(GpPath* path, GDIPCONST GpPointF* points, INT count, REAL tension);
    GpStatus WINAPI GdipAddPathCurve3(GpPath* path, GDIPCONST GpPointF* points, INT count, INT offset, INT numberOfSegments, REAL tension);
    GpStatus WINAPI GdipAddPathClosedCurve(GpPath* path, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipAddPathClosedCurve2(GpPath* path, GDIPCONST GpPointF* points, INT count, REAL tension);
    GpStatus WINAPI GdipAddPathRectangle(GpPath* path, REAL x, REAL y, REAL width, REAL height);
    GpStatus WINAPI GdipAddPathRectangles(GpPath* path, GDIPCONST GpRectF* rects, INT count);
    GpStatus WINAPI GdipAddPathEllipse(GpPath* path, REAL x, REAL y, REAL width, REAL height);
    GpStatus WINAPI GdipAddPathPie(GpPath* path, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
    GpStatus WINAPI GdipAddPathPolygon(GpPath* path, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipAddPathPath(GpPath* path, GDIPCONST GpPath* addingPath, BOOL connect);
    GpStatus WINAPI GdipAddPathString(GpPath* path, GDIPCONST WCHAR* string, INT length, GDIPCONST GpFontFamily* family, INT style, REAL emSize, GDIPCONST RectF* layoutRect, GDIPCONST GpStringFormat* format);
    GpStatus WINAPI GdipAddPathStringI(GpPath* path, GDIPCONST WCHAR* string, INT length, GDIPCONST GpFontFamily* family, INT style, REAL emSize, GDIPCONST Rect* layoutRect, GDIPCONST GpStringFormat* format);
    GpStatus WINAPI GdipAddPathLineI(GpPath* path, INT x1, INT y1, INT x2, INT y2);
    GpStatus WINAPI GdipAddPathLine2I(GpPath* path, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipAddPathArcI(GpPath* path, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
    GpStatus WINAPI GdipAddPathBezierI(GpPath* path, INT x1, INT y1, INT x2, INT y2, INT x3, INT y3, INT x4, INT y4);
    GpStatus WINAPI GdipAddPathBeziersI(GpPath* path, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipAddPathCurveI(GpPath* path, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipAddPathCurve2I(GpPath* path, GDIPCONST GpPoint* points, INT count, REAL tension);
    GpStatus WINAPI GdipAddPathCurve3I(GpPath* path, GDIPCONST GpPoint* points, INT count, INT offset, INT numberOfSegments, REAL tension);
    GpStatus WINAPI GdipAddPathClosedCurveI(GpPath* path, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipAddPathClosedCurve2I(GpPath* path, GDIPCONST GpPoint* points, INT count, REAL tension);
    GpStatus WINAPI GdipAddPathRectangleI(GpPath* path, INT x, INT y, INT width, INT height);
    GpStatus WINAPI GdipAddPathRectanglesI(GpPath* path, GDIPCONST GpRect* rects, INT count);
    GpStatus WINAPI GdipAddPathEllipseI(GpPath* path, INT x, INT y, INT width, INT height);
    GpStatus WINAPI GdipAddPathPieI(GpPath* path, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
    GpStatus WINAPI GdipAddPathPolygonI(GpPath* path, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipFlattenPath(GpPath* path, GpMatrix* matrix, REAL flatness);
    GpStatus WINAPI GdipWindingModeOutline(GpPath* path, GpMatrix* matrix, REAL flatness);
    GpStatus WINAPI GdipWidenPath(GpPath* nativePath, GpPen* pen, GpMatrix* matrix, REAL flatness);
    GpStatus WINAPI GdipWarpPath(GpPath* path, GpMatrix* matrix, GDIPCONST GpPointF* points, INT count, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, WarpMode warpMode, REAL flatness);
    GpStatus WINAPI GdipTransformPath(GpPath* path, GpMatrix* matrix);
    GpStatus WINAPI GdipGetPathWorldBounds(GpPath* path, GpRectF* bounds, GDIPCONST GpMatrix* matrix, GDIPCONST GpPen* pen);
    GpStatus WINAPI GdipGetPathWorldBoundsI(GpPath* path, GpRect* bounds, GDIPCONST GpMatrix* matrix, GDIPCONST GpPen* pen);
    GpStatus WINAPI GdipIsVisiblePathPoint(GpPath* path, REAL x, REAL y, GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipIsVisiblePathPointI(GpPath* path, INT x, INT y, GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipIsOutlineVisiblePathPoint(GpPath* path, REAL x, REAL y, GpPen* pen, GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipIsOutlineVisiblePathPointI(GpPath* path, INT x, INT y, GpPen* pen, GpGraphics* graphics, BOOL* result);

    //----------------------------------------------------------------------------
    // PathIterator APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreatePathIter(GpPathIterator** iterator, GpPath* path);
    GpStatus WINAPI GdipDeletePathIter(GpPathIterator* iterator);
    GpStatus WINAPI GdipPathIterNextSubpath(GpPathIterator* iterator, INT* resultCount, INT* startIndex, INT* endIndex, BOOL* isClosed);
    GpStatus WINAPI GdipPathIterNextSubpathPath(GpPathIterator* iterator, INT* resultCount, GpPath* path, BOOL* isClosed);
    GpStatus WINAPI GdipPathIterNextPathType(GpPathIterator* iterator, INT* resultCount, BYTE* pathType, INT* startIndex, INT* endIndex);
    GpStatus WINAPI GdipPathIterNextMarker(GpPathIterator* iterator, INT* resultCount, INT* startIndex, INT* endIndex);
    GpStatus WINAPI GdipPathIterNextMarkerPath(GpPathIterator* iterator, INT* resultCount, GpPath* path);
    GpStatus WINAPI GdipPathIterGetCount(GpPathIterator* iterator, INT* count);
    GpStatus WINAPI GdipPathIterGetSubpathCount(GpPathIterator* iterator, INT* count);
    GpStatus WINAPI GdipPathIterIsValid(GpPathIterator* iterator, BOOL* valid);
    GpStatus WINAPI GdipPathIterHasCurve(GpPathIterator* iterator, BOOL* hasCurve);
    GpStatus WINAPI GdipPathIterRewind(GpPathIterator* iterator);
    GpStatus WINAPI GdipPathIterEnumerate(GpPathIterator* iterator, INT* resultCount, GpPointF* points, BYTE* types, INT count);
    GpStatus WINAPI GdipPathIterCopyData(GpPathIterator* iterator, INT* resultCount, GpPointF* points, BYTE* types, INT startIndex, INT endIndex);

    //----------------------------------------------------------------------------
    // Matrix APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateMatrix(GpMatrix** matrix);
    GpStatus WINAPI GdipCreateMatrix2(REAL m11, REAL m12, REAL m21, REAL m22, REAL dx, REAL dy, GpMatrix** matrix);
    GpStatus WINAPI GdipCreateMatrix3(GDIPCONST GpRectF* rect, GDIPCONST GpPointF* dstplg, GpMatrix** matrix);
    GpStatus WINAPI GdipCreateMatrix3I(GDIPCONST GpRect* rect, GDIPCONST GpPoint* dstplg, GpMatrix** matrix);
    GpStatus WINAPI GdipCloneMatrix(GpMatrix* matrix, GpMatrix** cloneMatrix);
    GpStatus WINAPI GdipDeleteMatrix(GpMatrix* matrix);
    GpStatus WINAPI GdipSetMatrixElements(GpMatrix* matrix, REAL m11, REAL m12, REAL m21, REAL m22, REAL dx, REAL dy);
    GpStatus WINAPI GdipMultiplyMatrix(GpMatrix* matrix, GpMatrix* matrix2, GpMatrixOrder order);
    GpStatus WINAPI GdipTranslateMatrix(GpMatrix* matrix, REAL offsetX, REAL offsetY, GpMatrixOrder order);
    GpStatus WINAPI GdipScaleMatrix(GpMatrix* matrix, REAL scaleX, REAL scaleY, GpMatrixOrder order);
    GpStatus WINAPI GdipRotateMatrix(GpMatrix* matrix, REAL angle, GpMatrixOrder order);
    GpStatus WINAPI GdipShearMatrix(GpMatrix* matrix, REAL shearX, REAL shearY, GpMatrixOrder order);
    GpStatus WINAPI GdipInvertMatrix(GpMatrix* matrix);
    GpStatus WINAPI GdipTransformMatrixPoints(GpMatrix* matrix, GpPointF* pts, INT count);
    GpStatus WINAPI GdipTransformMatrixPointsI(GpMatrix* matrix, GpPoint* pts, INT count);
    GpStatus WINAPI GdipVectorTransformMatrixPoints(GpMatrix* matrix, GpPointF* pts, INT count);
    GpStatus WINAPI GdipVectorTransformMatrixPointsI(GpMatrix* matrix, GpPoint* pts, INT count);
    GpStatus WINAPI GdipGetMatrixElements(GDIPCONST GpMatrix* matrix, REAL* matrixOut);
    GpStatus WINAPI GdipIsMatrixInvertible(GDIPCONST GpMatrix* matrix, BOOL* result);
    GpStatus WINAPI GdipIsMatrixIdentity(GDIPCONST GpMatrix* matrix, BOOL* result);
    GpStatus WINAPI GdipIsMatrixEqual(GDIPCONST GpMatrix* matrix, GDIPCONST GpMatrix* matrix2, BOOL* result);

    //----------------------------------------------------------------------------
    // Region APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateRegion(GpRegion** region);
    GpStatus WINAPI GdipCreateRegionRect(GDIPCONST GpRectF* rect, GpRegion** region);
    GpStatus WINAPI GdipCreateRegionRectI(GDIPCONST GpRect* rect, GpRegion** region);
    GpStatus WINAPI GdipCreateRegionPath(GpPath* path, GpRegion** region);
    GpStatus WINAPI GdipCreateRegionRgnData(GDIPCONST BYTE* regionData, INT size, GpRegion** region);
    GpStatus WINAPI GdipCreateRegionHrgn(HRGN hRgn, GpRegion** region);
    GpStatus WINAPI GdipCloneRegion(GpRegion* region, GpRegion** cloneRegion);
    GpStatus WINAPI GdipDeleteRegion(GpRegion* region);
    GpStatus WINAPI GdipSetInfinite(GpRegion* region);
    GpStatus WINAPI GdipSetEmpty(GpRegion* region);
    GpStatus WINAPI GdipCombineRegionRect(GpRegion* region, GDIPCONST GpRectF* rect, CombineMode combineMode);
    GpStatus WINAPI GdipCombineRegionRectI(GpRegion* region, GDIPCONST GpRect* rect, CombineMode combineMode);
    GpStatus WINAPI GdipCombineRegionPath(GpRegion* region, GpPath* path, CombineMode combineMode);
    GpStatus WINAPI GdipCombineRegionRegion(GpRegion* region, GpRegion* region2, CombineMode combineMode);
    GpStatus WINAPI GdipTranslateRegion(GpRegion* region, REAL dx, REAL dy);
    GpStatus WINAPI GdipTranslateRegionI(GpRegion* region, INT dx, INT dy);
    GpStatus WINAPI GdipTransformRegion(GpRegion* region, GpMatrix* matrix);
    GpStatus WINAPI GdipGetRegionBounds(GpRegion* region, GpGraphics* graphics, GpRectF* rect);
    GpStatus WINAPI GdipGetRegionBoundsI(GpRegion* region, GpGraphics* graphics, GpRect* rect);
    GpStatus WINAPI GdipGetRegionHRgn(GpRegion* region, GpGraphics* graphics, HRGN* hRgn);
    GpStatus WINAPI GdipIsEmptyRegion(GpRegion* region, GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipIsInfiniteRegion(GpRegion* region, GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipIsEqualRegion(GpRegion* region, GpRegion* region2, GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipGetRegionDataSize(GpRegion* region, UINT* bufferSize);
    GpStatus WINAPI GdipGetRegionData(GpRegion* region, BYTE* buffer, UINT bufferSize, UINT* sizeFilled);
    GpStatus WINAPI GdipIsVisibleRegionPoint(GpRegion* region, REAL x, REAL y, GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipIsVisibleRegionPointI(GpRegion* region, INT x, INT y, GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipIsVisibleRegionRect(GpRegion* region, REAL x, REAL y, REAL width, REAL height, GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipIsVisibleRegionRectI(GpRegion* region, INT x, INT y, INT width, INT height, GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipGetRegionScansCount(GpRegion* region, UINT* count, GpMatrix* matrix);
    GpStatus WINAPI GdipGetRegionScans(GpRegion* region, GpRectF* rects, INT* count, GpMatrix* matrix);
    GpStatus WINAPI GdipGetRegionScansI(GpRegion* region, GpRect* rects, INT* count, GpMatrix* matrix);

    //----------------------------------------------------------------------------
    // Brush APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCloneBrush(GpBrush* brush, GpBrush** cloneBrush);
    GpStatus WINAPI GdipDeleteBrush(GpBrush* brush);
    GpStatus WINAPI GdipGetBrushType(GpBrush* brush, GpBrushType* type);

    //----------------------------------------------------------------------------
    // HatchBrush APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateHatchBrush(GpHatchStyle hatchstyle, ARGB forecol, ARGB backcol, GpHatch** brush);
    GpStatus WINAPI GdipGetHatchStyle(GpHatch* brush, GpHatchStyle* hatchstyle);
    GpStatus WINAPI GdipGetHatchForegroundColor(GpHatch* brush, ARGB* forecol);
    GpStatus WINAPI GdipGetHatchBackgroundColor(GpHatch* brush, ARGB* backcol);

    //----------------------------------------------------------------------------
    // TextureBrush APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateTexture(GpImage* image, GpWrapMode wrapmode, GpTexture** texture);
    GpStatus WINAPI GdipCreateTexture2(GpImage* image, GpWrapMode wrapmode, REAL x, REAL y, REAL width, REAL height, GpTexture** texture);
    GpStatus WINAPI GdipCreateTextureIA(GpImage* image, GDIPCONST GpImageAttributes* imageAttributes, REAL x, REAL y, REAL width, REAL height, GpTexture** texture);
    GpStatus WINAPI GdipCreateTexture2I(GpImage* image, GpWrapMode wrapmode, INT x, INT y, INT width, INT height, GpTexture** texture);
    GpStatus WINAPI GdipCreateTextureIAI(GpImage* image, GDIPCONST GpImageAttributes* imageAttributes, INT x, INT y, INT width, INT height, GpTexture** texture);
    GpStatus WINAPI GdipGetTextureTransform(GpTexture* brush, GpMatrix* matrix);
    GpStatus WINAPI GdipSetTextureTransform(GpTexture* brush, GDIPCONST GpMatrix* matrix);
    GpStatus WINAPI GdipResetTextureTransform(GpTexture* brush);
    GpStatus WINAPI GdipMultiplyTextureTransform(GpTexture* brush, GDIPCONST GpMatrix* matrix, GpMatrixOrder order);
    GpStatus WINAPI GdipTranslateTextureTransform(GpTexture* brush, REAL dx, REAL dy, GpMatrixOrder order);
    GpStatus WINAPI GdipScaleTextureTransform(GpTexture* brush, REAL sx, REAL sy, GpMatrixOrder order);
    GpStatus WINAPI GdipRotateTextureTransform(GpTexture* brush, REAL angle, GpMatrixOrder order);
    GpStatus WINAPI GdipSetTextureWrapMode(GpTexture* brush, GpWrapMode wrapmode);
    GpStatus WINAPI GdipGetTextureWrapMode(GpTexture* brush, GpWrapMode* wrapmode);
    GpStatus WINAPI GdipGetTextureImage(GpTexture* brush, GpImage** image);

    //----------------------------------------------------------------------------
    // SolidBrush APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateSolidFill(ARGB color, GpSolidFill** brush);
    GpStatus WINAPI GdipSetSolidFillColor(GpSolidFill* brush, ARGB color);
    GpStatus WINAPI GdipGetSolidFillColor(GpSolidFill* brush, ARGB* color);

    //----------------------------------------------------------------------------
    // LineBrush APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateLineBrush(GDIPCONST GpPointF* point1, GDIPCONST GpPointF* point2, ARGB color1, ARGB color2, GpWrapMode wrapMode, GpLineGradient** lineGradient);
    GpStatus WINAPI GdipCreateLineBrushI(GDIPCONST GpPoint* point1, GDIPCONST GpPoint* point2, ARGB color1, ARGB color2, GpWrapMode wrapMode, GpLineGradient** lineGradient);
    GpStatus WINAPI GdipCreateLineBrushFromRect(GDIPCONST GpRectF* rect, ARGB color1, ARGB color2, LinearGradientMode mode, GpWrapMode wrapMode, GpLineGradient** lineGradient);
    GpStatus WINAPI GdipCreateLineBrushFromRectI(GDIPCONST GpRect* rect, ARGB color1, ARGB color2, LinearGradientMode mode, GpWrapMode wrapMode, GpLineGradient** lineGradient);
    GpStatus WINAPI GdipCreateLineBrushFromRectWithAngle(GDIPCONST GpRectF* rect, ARGB color1, ARGB color2, REAL angle, BOOL isAngleScalable, GpWrapMode wrapMode, GpLineGradient** lineGradient);
    GpStatus WINAPI GdipCreateLineBrushFromRectWithAngleI(GDIPCONST GpRect* rect, ARGB color1, ARGB color2, REAL angle, BOOL isAngleScalable, GpWrapMode wrapMode, GpLineGradient** lineGradient);
    GpStatus WINAPI GdipSetLineColors(GpLineGradient* brush, ARGB color1, ARGB color2);
    GpStatus WINAPI GdipGetLineColors(GpLineGradient* brush, ARGB* colors);
    GpStatus WINAPI GdipGetLineRect(GpLineGradient* brush, GpRectF* rect);
    GpStatus WINAPI GdipGetLineRectI(GpLineGradient* brush, GpRect* rect);
    GpStatus WINAPI GdipSetLineGammaCorrection(GpLineGradient* brush, BOOL useGammaCorrection);
    GpStatus WINAPI GdipGetLineGammaCorrection(GpLineGradient* brush, BOOL* useGammaCorrection);
    GpStatus WINAPI GdipGetLineBlendCount(GpLineGradient* brush, INT* count);
    GpStatus WINAPI GdipGetLineBlend(GpLineGradient* brush, REAL* blend, REAL* positions, INT count);
    GpStatus WINAPI GdipSetLineBlend(GpLineGradient* brush, GDIPCONST REAL* blend, GDIPCONST REAL* positions, INT count);
    GpStatus WINAPI GdipGetLinePresetBlendCount(GpLineGradient* brush, INT* count);
    GpStatus WINAPI GdipGetLinePresetBlend(GpLineGradient* brush, ARGB* blend, REAL* positions, INT count);
    GpStatus WINAPI GdipSetLinePresetBlend(GpLineGradient* brush, GDIPCONST ARGB* blend, GDIPCONST REAL* positions, INT count);
    GpStatus WINAPI GdipSetLineSigmaBlend(GpLineGradient* brush, REAL focus, REAL scale);
    GpStatus WINAPI GdipSetLineLinearBlend(GpLineGradient* brush, REAL focus, REAL scale);
    GpStatus WINAPI GdipSetLineWrapMode(GpLineGradient* brush, GpWrapMode wrapmode);
    GpStatus WINAPI GdipGetLineWrapMode(GpLineGradient* brush, GpWrapMode* wrapmode);
    GpStatus WINAPI GdipGetLineTransform(GpLineGradient* brush, GpMatrix* matrix);
    GpStatus WINAPI GdipSetLineTransform(GpLineGradient* brush, GDIPCONST GpMatrix* matrix);
    GpStatus WINAPI GdipResetLineTransform(GpLineGradient* brush);
    GpStatus WINAPI GdipMultiplyLineTransform(GpLineGradient* brush, GDIPCONST GpMatrix* matrix, GpMatrixOrder order);
    GpStatus WINAPI GdipTranslateLineTransform(GpLineGradient* brush, REAL dx, REAL dy, GpMatrixOrder order);
    GpStatus WINAPI GdipScaleLineTransform(GpLineGradient* brush, REAL sx, REAL sy, GpMatrixOrder order);
    GpStatus WINAPI GdipRotateLineTransform(GpLineGradient* brush, REAL angle, GpMatrixOrder order);

    //----------------------------------------------------------------------------
    // PathGradientBrush APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreatePathGradient(GDIPCONST GpPointF* points, INT count, GpWrapMode wrapMode, GpPathGradient** polyGradient);
    GpStatus WINAPI GdipCreatePathGradientI(GDIPCONST GpPoint* points, INT count, GpWrapMode wrapMode, GpPathGradient** polyGradient);
    GpStatus WINAPI GdipCreatePathGradientFromPath(GDIPCONST GpPath* path, GpPathGradient** polyGradient);
    GpStatus WINAPI GdipGetPathGradientCenterColor(GpPathGradient* brush, ARGB* colors);
    GpStatus WINAPI GdipSetPathGradientCenterColor(GpPathGradient* brush, ARGB colors);
    GpStatus WINAPI GdipGetPathGradientSurroundColorsWithCount(GpPathGradient* brush, ARGB* color, INT* count);
    GpStatus WINAPI GdipSetPathGradientSurroundColorsWithCount(GpPathGradient* brush, GDIPCONST ARGB* color, INT* count);
    GpStatus WINAPI GdipGetPathGradientPath(GpPathGradient* brush, GpPath* path);
    GpStatus WINAPI GdipSetPathGradientPath(GpPathGradient* brush, GDIPCONST GpPath* path);
    GpStatus WINAPI GdipGetPathGradientCenterPoint(GpPathGradient* brush, GpPointF* points);
    GpStatus WINAPI GdipGetPathGradientCenterPointI(GpPathGradient* brush, GpPoint* points);
    GpStatus WINAPI GdipSetPathGradientCenterPoint(GpPathGradient* brush, GDIPCONST GpPointF* points);
    GpStatus WINAPI GdipSetPathGradientCenterPointI(GpPathGradient* brush, GDIPCONST GpPoint* points);
    GpStatus WINAPI GdipGetPathGradientRect(GpPathGradient* brush, GpRectF* rect);
    GpStatus WINAPI GdipGetPathGradientRectI(GpPathGradient* brush, GpRect* rect);
    GpStatus WINAPI GdipGetPathGradientPointCount(GpPathGradient* brush, INT* count);
    GpStatus WINAPI GdipGetPathGradientSurroundColorCount(GpPathGradient* brush, INT* count);
    GpStatus WINAPI GdipSetPathGradientGammaCorrection(GpPathGradient* brush, BOOL useGammaCorrection);
    GpStatus WINAPI GdipGetPathGradientGammaCorrection(GpPathGradient* brush, BOOL* useGammaCorrection);
    GpStatus WINAPI GdipGetPathGradientBlendCount(GpPathGradient* brush, INT* count);
    GpStatus WINAPI GdipGetPathGradientBlend(GpPathGradient* brush, REAL* blend, REAL* positions, INT count);
    GpStatus WINAPI GdipSetPathGradientBlend(GpPathGradient* brush, GDIPCONST REAL* blend, GDIPCONST REAL* positions, INT count);
    GpStatus WINAPI GdipGetPathGradientPresetBlendCount(GpPathGradient* brush, INT* count);
    GpStatus WINAPI GdipGetPathGradientPresetBlend(GpPathGradient* brush, ARGB* blend, REAL* positions, INT count);
    GpStatus WINAPI GdipSetPathGradientPresetBlend(GpPathGradient* brush, GDIPCONST ARGB* blend, GDIPCONST REAL* positions, INT count);
    GpStatus WINAPI GdipSetPathGradientSigmaBlend(GpPathGradient* brush, REAL focus, REAL scale);
    GpStatus WINAPI GdipSetPathGradientLinearBlend(GpPathGradient* brush, REAL focus, REAL scale);
    GpStatus WINAPI GdipGetPathGradientWrapMode(GpPathGradient* brush, GpWrapMode* wrapmode);
    GpStatus WINAPI GdipSetPathGradientWrapMode(GpPathGradient* brush, GpWrapMode wrapmode);
    GpStatus WINAPI GdipGetPathGradientTransform(GpPathGradient* brush, GpMatrix* matrix);
    GpStatus WINAPI GdipSetPathGradientTransform(GpPathGradient* brush, GpMatrix* matrix);
    GpStatus WINAPI GdipResetPathGradientTransform(GpPathGradient* brush);
    GpStatus WINAPI GdipMultiplyPathGradientTransform(GpPathGradient* brush, GDIPCONST GpMatrix* matrix, GpMatrixOrder order);
    GpStatus WINAPI GdipTranslatePathGradientTransform(GpPathGradient* brush, REAL dx, REAL dy, GpMatrixOrder order);
    GpStatus WINAPI GdipScalePathGradientTransform(GpPathGradient* brush, REAL sx, REAL sy, GpMatrixOrder order);
    GpStatus WINAPI GdipRotatePathGradientTransform(GpPathGradient* brush, REAL angle, GpMatrixOrder order);
    GpStatus WINAPI GdipGetPathGradientFocusScales(GpPathGradient* brush, REAL* xScale, REAL* yScale);
    GpStatus WINAPI GdipSetPathGradientFocusScales(GpPathGradient* brush, REAL xScale, REAL yScale);

    //----------------------------------------------------------------------------
    // Pen APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreatePen1(ARGB color, REAL width, GpUnit unit, GpPen** pen);
    GpStatus WINAPI GdipCreatePen2(GpBrush* brush, REAL width, GpUnit unit, GpPen** pen);
    GpStatus WINAPI GdipClonePen(GpPen* pen, GpPen** clonepen);
    GpStatus WINAPI GdipDeletePen(GpPen* pen);
    GpStatus WINAPI GdipSetPenWidth(GpPen* pen, REAL width);
    GpStatus WINAPI GdipGetPenWidth(GpPen* pen, REAL* width);
    GpStatus WINAPI GdipSetPenUnit(GpPen* pen, GpUnit unit);
    GpStatus WINAPI GdipGetPenUnit(GpPen* pen, GpUnit* unit);
    GpStatus WINAPI GdipSetPenLineCap197819(GpPen* pen, GpLineCap startCap, GpLineCap endCap, GpDashCap dashCap);
    GpStatus WINAPI GdipSetPenStartCap(GpPen* pen, GpLineCap startCap);
    GpStatus WINAPI GdipSetPenEndCap(GpPen* pen, GpLineCap endCap);
    GpStatus WINAPI GdipSetPenDashCap197819(GpPen* pen, GpDashCap dashCap);
    GpStatus WINAPI GdipGetPenStartCap(GpPen* pen, GpLineCap* startCap);
    GpStatus WINAPI GdipGetPenEndCap(GpPen* pen, GpLineCap* endCap);
    GpStatus WINAPI GdipGetPenDashCap197819(GpPen* pen, GpDashCap* dashCap);
    GpStatus WINAPI GdipSetPenLineJoin(GpPen* pen, GpLineJoin lineJoin);
    GpStatus WINAPI GdipGetPenLineJoin(GpPen* pen, GpLineJoin* lineJoin);
    GpStatus WINAPI GdipSetPenCustomStartCap(GpPen* pen, GpCustomLineCap* customCap);
    GpStatus WINAPI GdipGetPenCustomStartCap(GpPen* pen, GpCustomLineCap** customCap);
    GpStatus WINAPI GdipSetPenCustomEndCap(GpPen* pen, GpCustomLineCap* customCap);
    GpStatus WINAPI GdipGetPenCustomEndCap(GpPen* pen, GpCustomLineCap** customCap);
    GpStatus WINAPI GdipSetPenMiterLimit(GpPen* pen, REAL miterLimit);
    GpStatus WINAPI GdipGetPenMiterLimit(GpPen* pen, REAL* miterLimit);
    GpStatus WINAPI GdipSetPenMode(GpPen* pen, GpPenAlignment penMode);
    GpStatus WINAPI GdipGetPenMode(GpPen* pen, GpPenAlignment* penMode);
    GpStatus WINAPI GdipSetPenTransform(GpPen* pen, GpMatrix* matrix);
    GpStatus WINAPI GdipGetPenTransform(GpPen* pen, GpMatrix* matrix);
    GpStatus WINAPI GdipResetPenTransform(GpPen* pen);
    GpStatus WINAPI GdipMultiplyPenTransform(GpPen* pen, GDIPCONST GpMatrix* matrix, GpMatrixOrder order);
    GpStatus WINAPI GdipTranslatePenTransform(GpPen* pen, REAL dx, REAL dy, GpMatrixOrder order);
    GpStatus WINAPI GdipScalePenTransform(GpPen* pen, REAL sx, REAL sy, GpMatrixOrder order);
    GpStatus WINAPI GdipRotatePenTransform(GpPen* pen, REAL angle, GpMatrixOrder order);
    GpStatus WINAPI GdipSetPenColor(GpPen* pen, ARGB argb);
    GpStatus WINAPI GdipGetPenColor(GpPen* pen, ARGB* argb);
    GpStatus WINAPI GdipSetPenBrushFill(GpPen* pen, GpBrush* brush);
    GpStatus WINAPI GdipGetPenBrushFill(GpPen* pen, GpBrush** brush);
    GpStatus WINAPI GdipGetPenFillType(GpPen* pen, GpPenType* type);
    GpStatus WINAPI GdipGetPenDashStyle(GpPen* pen, GpDashStyle* dashstyle);
    GpStatus WINAPI GdipSetPenDashStyle(GpPen* pen, GpDashStyle dashstyle);
    GpStatus WINAPI GdipGetPenDashOffset(GpPen* pen, REAL* offset);
    GpStatus WINAPI GdipSetPenDashOffset(GpPen* pen, REAL offset);
    GpStatus WINAPI GdipGetPenDashCount(GpPen* pen, INT* count);
    GpStatus WINAPI GdipSetPenDashArray(GpPen* pen, GDIPCONST REAL* dash, INT count);
    GpStatus WINAPI GdipGetPenDashArray(GpPen* pen, REAL* dash, INT count);
    GpStatus WINAPI GdipGetPenCompoundCount(GpPen* pen, INT* count);
    GpStatus WINAPI GdipSetPenCompoundArray(GpPen* pen, GDIPCONST REAL* dash, INT count);
    GpStatus WINAPI GdipGetPenCompoundArray(GpPen* pen, REAL* dash, INT count);

    //----------------------------------------------------------------------------
    // CustomLineCap APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateCustomLineCap(GpPath* fillPath, GpPath* strokePath, GpLineCap baseCap, REAL baseInset, GpCustomLineCap** customCap);
    GpStatus WINAPI GdipDeleteCustomLineCap(GpCustomLineCap* customCap);
    GpStatus WINAPI GdipCloneCustomLineCap(GpCustomLineCap* customCap, GpCustomLineCap** clonedCap);
    GpStatus WINAPI GdipGetCustomLineCapType(GpCustomLineCap* customCap, CustomLineCapType* capType);
    GpStatus WINAPI GdipSetCustomLineCapStrokeCaps(GpCustomLineCap* customCap, GpLineCap startCap, GpLineCap endCap);
    GpStatus WINAPI GdipGetCustomLineCapStrokeCaps(GpCustomLineCap* customCap, GpLineCap* startCap, GpLineCap* endCap);
    GpStatus WINAPI GdipSetCustomLineCapStrokeJoin(GpCustomLineCap* customCap, GpLineJoin lineJoin);
    GpStatus WINAPI GdipGetCustomLineCapStrokeJoin(GpCustomLineCap* customCap, GpLineJoin* lineJoin);
    GpStatus WINAPI GdipSetCustomLineCapBaseCap(GpCustomLineCap* customCap, GpLineCap baseCap);
    GpStatus WINAPI GdipGetCustomLineCapBaseCap(GpCustomLineCap* customCap, GpLineCap* baseCap);
    GpStatus WINAPI GdipSetCustomLineCapBaseInset(GpCustomLineCap* customCap, REAL inset);
    GpStatus WINAPI GdipGetCustomLineCapBaseInset(GpCustomLineCap* customCap, REAL* inset);
    GpStatus WINAPI GdipSetCustomLineCapWidthScale(GpCustomLineCap* customCap, REAL widthScale);
    GpStatus WINAPI GdipGetCustomLineCapWidthScale(GpCustomLineCap* customCap, REAL* widthScale);

    //----------------------------------------------------------------------------
    // AdjustableArrowCap APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateAdjustableArrowCap(REAL height, REAL width, BOOL isFilled, GpAdjustableArrowCap** cap);
    GpStatus WINAPI GdipSetAdjustableArrowCapHeight(GpAdjustableArrowCap* cap, REAL height);
    GpStatus WINAPI GdipGetAdjustableArrowCapHeight(GpAdjustableArrowCap* cap, REAL* height);
    GpStatus WINAPI GdipSetAdjustableArrowCapWidth(GpAdjustableArrowCap* cap, REAL width);
    GpStatus WINAPI GdipGetAdjustableArrowCapWidth(GpAdjustableArrowCap* cap, REAL* width);
    GpStatus WINAPI GdipSetAdjustableArrowCapMiddleInset(GpAdjustableArrowCap* cap, REAL middleInset);
    GpStatus WINAPI GdipGetAdjustableArrowCapMiddleInset(GpAdjustableArrowCap* cap, REAL* middleInset);
    GpStatus WINAPI GdipSetAdjustableArrowCapFillState(GpAdjustableArrowCap* cap, BOOL fillState);
    GpStatus WINAPI GdipGetAdjustableArrowCapFillState(GpAdjustableArrowCap* cap, BOOL* fillState);

    //----------------------------------------------------------------------------
    // Image APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipLoadImageFromStream(IStream* stream, GpImage** image);
    GpStatus WINAPI GdipLoadImageFromFile(GDIPCONST WCHAR* filename, GpImage** image);
    GpStatus WINAPI GdipLoadImageFromStreamICM(IStream* stream, GpImage** image);
    GpStatus WINAPI GdipLoadImageFromFileICM(GDIPCONST WCHAR* filename, GpImage** image);
    GpStatus WINAPI GdipCloneImage(GpImage* image, GpImage** cloneImage);
    GpStatus WINAPI GdipDisposeImage(GpImage* image);
    GpStatus WINAPI GdipSaveImageToFile(GpImage* image, GDIPCONST WCHAR* filename, GDIPCONST CLSID* clsidEncoder, GDIPCONST EncoderParameters* encoderParams);
    GpStatus WINAPI GdipSaveImageToStream(GpImage* image, IStream* stream, GDIPCONST CLSID* clsidEncoder, GDIPCONST EncoderParameters* encoderParams);
    GpStatus WINAPI GdipSaveAdd(GpImage* image, GDIPCONST EncoderParameters* encoderParams);
    GpStatus WINAPI GdipSaveAddImage(GpImage* image, GpImage* newImage, GDIPCONST EncoderParameters* encoderParams);
    GpStatus WINAPI GdipGetImageGraphicsContext(GpImage* image, GpGraphics** graphics);
    GpStatus WINAPI GdipGetImageBounds(GpImage* image, GpRectF* srcRect, GpUnit* srcUnit);
    GpStatus WINAPI GdipGetImageDimension(GpImage* image, REAL* width, REAL* height);
    GpStatus WINAPI GdipGetImageType(GpImage* image, ImageType* type);
    GpStatus WINAPI GdipGetImageWidth(GpImage* image, UINT* width);
    GpStatus WINAPI GdipGetImageHeight(GpImage* image, UINT* height);
    GpStatus WINAPI GdipGetImageHorizontalResolution(GpImage* image, REAL* resolution);
    GpStatus WINAPI GdipGetImageVerticalResolution(GpImage* image, REAL* resolution);
    GpStatus WINAPI GdipGetImageFlags(GpImage* image, UINT* flags);
    GpStatus WINAPI GdipGetImageRawFormat(GpImage* image, GUID* format);
    GpStatus WINAPI GdipGetImagePixelFormat(GpImage* image, PixelFormat* format);
    GpStatus WINAPI GdipGetImageThumbnail(GpImage* image, UINT thumbWidth, UINT thumbHeight, GpImage** thumbImage, GetThumbnailImageAbort callback, VOID* callbackData);
    GpStatus WINAPI GdipGetEncoderParameterListSize(GpImage* image, GDIPCONST CLSID* clsidEncoder, UINT* size);
    GpStatus WINAPI GdipGetEncoderParameterList(GpImage* image, GDIPCONST CLSID* clsidEncoder, UINT size, EncoderParameters* buffer);
    GpStatus WINAPI GdipImageGetFrameDimensionsCount(GpImage* image, UINT* count);
    GpStatus WINAPI GdipImageGetFrameDimensionsList(GpImage* image, GUID* dimensionIDs, UINT count);
    GpStatus WINAPI GdipImageGetFrameCount(GpImage* image, GDIPCONST GUID* dimensionID, UINT* count);
    GpStatus WINAPI GdipImageSelectActiveFrame(GpImage* image, GDIPCONST GUID* dimensionID, UINT frameIndex);
    GpStatus WINAPI GdipImageRotateFlip(GpImage* image, RotateFlipType rfType);
    GpStatus WINAPI GdipGetImagePalette(GpImage* image, ColorPalette* palette, INT size);
    GpStatus WINAPI GdipSetImagePalette(GpImage* image, GDIPCONST ColorPalette* palette);
    GpStatus WINAPI GdipGetImagePaletteSize(GpImage* image, INT* size);
    GpStatus WINAPI GdipGetPropertyCount(GpImage* image, UINT* numOfProperty);
    GpStatus WINAPI GdipGetPropertyIdList(GpImage* image, UINT numOfProperty, PROPID* list);
    GpStatus WINAPI GdipGetPropertyItemSize(GpImage* image, PROPID propId, UINT* size);
    GpStatus WINAPI GdipGetPropertyItem(GpImage* image, PROPID propId, UINT propSize, PropertyItem* buffer);
    GpStatus WINAPI GdipGetPropertySize(GpImage* image, UINT* totalBufferSize, UINT* numProperties);
    GpStatus WINAPI GdipGetAllPropertyItems(GpImage* image, UINT totalBufferSize, UINT numProperties, PropertyItem* allItems);
    GpStatus WINAPI GdipRemovePropertyItem(GpImage* image, PROPID propId);
    GpStatus WINAPI GdipSetPropertyItem(GpImage* image, GDIPCONST PropertyItem* item);
    GpStatus WINAPI GdipImageForceValidation(GpImage* image);

    //----------------------------------------------------------------------------
    // Bitmap APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateBitmapFromStream(IStream* stream, GpBitmap** bitmap);
    GpStatus WINAPI GdipCreateBitmapFromFile(GDIPCONST WCHAR* filename, GpBitmap** bitmap);
    GpStatus WINAPI GdipCreateBitmapFromStreamICM(IStream* stream, GpBitmap** bitmap);
    GpStatus WINAPI GdipCreateBitmapFromFileICM(GDIPCONST WCHAR* filename, GpBitmap** bitmap);
    GpStatus WINAPI GdipCreateBitmapFromScan0(INT width, INT height, INT stride, PixelFormat format, BYTE* scan0, GpBitmap** bitmap);
    GpStatus WINAPI GdipCreateBitmapFromGraphics(INT width, INT height, GpGraphics* target, GpBitmap** bitmap);
    GpStatus WINAPI GdipCreateBitmapFromDirectDrawSurface(IDirectDrawSurface7* surface, GpBitmap** bitmap);
    GpStatus WINAPI GdipCreateBitmapFromGdiDib(GDIPCONST BITMAPINFO* gdiBitmapInfo, VOID* gdiBitmapData, GpBitmap** bitmap);
    GpStatus WINAPI GdipCreateBitmapFromHBITMAP(HBITMAP hbm, HPALETTE hpal, GpBitmap** bitmap);
    GpStatus WINAPI GdipCreateHBITMAPFromBitmap(GpBitmap* bitmap, HBITMAP* hbmReturn, ARGB background);
    GpStatus WINAPI GdipCreateBitmapFromHICON(HICON hicon, GpBitmap** bitmap);
    GpStatus WINAPI GdipCreateHICONFromBitmap(GpBitmap* bitmap, HICON* hbmReturn);
    GpStatus WINAPI GdipCreateBitmapFromResource(HINSTANCE hInstance, GDIPCONST WCHAR* lpBitmapName, GpBitmap** bitmap);
    GpStatus WINAPI GdipCloneBitmapArea(REAL x, REAL y, REAL width, REAL height, PixelFormat format, GpBitmap* srcBitmap, GpBitmap** dstBitmap);
    GpStatus WINAPI GdipCloneBitmapAreaI(INT x, INT y, INT width, INT height, PixelFormat format, GpBitmap* srcBitmap, GpBitmap** dstBitmap);
    GpStatus WINAPI GdipBitmapLockBits(GpBitmap* bitmap, GDIPCONST GpRect* rect, UINT flags, PixelFormat format, BitmapData* lockedBitmapData);
    GpStatus WINAPI GdipBitmapUnlockBits(GpBitmap* bitmap, BitmapData* lockedBitmapData);
    GpStatus WINAPI GdipBitmapGetPixel(GpBitmap* bitmap, INT x, INT y, ARGB* color);
    GpStatus WINAPI GdipBitmapSetPixel(GpBitmap* bitmap, INT x, INT y, ARGB color);
    GpStatus WINAPI GdipBitmapSetResolution(GpBitmap* bitmap, REAL xdpi, REAL ydpi);

    //----------------------------------------------------------------------------
    // ImageAttributes APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateImageAttributes(GpImageAttributes** imageattr);
    GpStatus WINAPI GdipCloneImageAttributes(GDIPCONST GpImageAttributes* imageattr, GpImageAttributes** cloneImageattr);
    GpStatus WINAPI GdipDisposeImageAttributes(GpImageAttributes* imageattr);
    GpStatus WINAPI GdipSetImageAttributesToIdentity(GpImageAttributes* imageattr, ColorAdjustType type);
    GpStatus WINAPI GdipResetImageAttributes(GpImageAttributes* imageattr, ColorAdjustType type);
    GpStatus WINAPI GdipSetImageAttributesColorMatrix(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, GDIPCONST ColorMatrix* colorMatrix, GDIPCONST ColorMatrix* grayMatrix, ColorMatrixFlags flags);
    GpStatus WINAPI GdipSetImageAttributesThreshold(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, REAL threshold);
    GpStatus WINAPI GdipSetImageAttributesGamma(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, REAL gamma);
    GpStatus WINAPI GdipSetImageAttributesNoOp(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag);
    GpStatus WINAPI GdipSetImageAttributesColorKeys(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, ARGB colorLow, ARGB colorHigh);
    GpStatus WINAPI GdipSetImageAttributesOutputChannel(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, ColorChannelFlags channelFlags);
    GpStatus WINAPI GdipSetImageAttributesOutputChannelColorProfile(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, GDIPCONST  WCHAR* colorProfileFilename);
    GpStatus WINAPI GdipSetImageAttributesRemapTable(GpImageAttributes* imageattr, ColorAdjustType type, BOOL enableFlag, UINT mapSize, GDIPCONST ColorMap* map);
    GpStatus WINAPI GdipSetImageAttributesWrapMode(GpImageAttributes* imageAttr, WrapMode wrap, ARGB argb, BOOL clamp);
    GpStatus WINAPI GdipSetImageAttributesICMMode(GpImageAttributes* imageAttr, BOOL on);
    GpStatus WINAPI GdipGetImageAttributesAdjustedPalette(GpImageAttributes* imageAttr, ColorPalette* colorPalette, ColorAdjustType colorAdjustType);

    //----------------------------------------------------------------------------
    // Graphics APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipFlush(GpGraphics* graphics, GpFlushIntention intention);
    GpStatus WINAPI GdipCreateFromHDC(HDC hdc, GpGraphics** graphics);
    GpStatus WINAPI GdipCreateFromHDC2(HDC hdc, HANDLE hDevice, GpGraphics** graphics);
    GpStatus WINAPI GdipCreateFromHWND(HWND hwnd, GpGraphics** graphics);
    GpStatus WINAPI GdipCreateFromHWNDICM(HWND hwnd, GpGraphics** graphics);
    GpStatus WINAPI GdipDeleteGraphics(GpGraphics* graphics);
    GpStatus WINAPI GdipGetDC(GpGraphics* graphics, HDC* hdc);
    GpStatus WINAPI GdipReleaseDC(GpGraphics* graphics, HDC hdc);
    GpStatus WINAPI GdipSetCompositingMode(GpGraphics* graphics, CompositingMode compositingMode);
    GpStatus WINAPI GdipGetCompositingMode(GpGraphics* graphics, CompositingMode* compositingMode);
    GpStatus WINAPI GdipSetRenderingOrigin(GpGraphics* graphics, INT x, INT y);
    GpStatus WINAPI GdipGetRenderingOrigin(GpGraphics* graphics, INT* x, INT* y);
    GpStatus WINAPI GdipSetCompositingQuality(GpGraphics* graphics, CompositingQuality compositingQuality);
    GpStatus WINAPI GdipGetCompositingQuality(GpGraphics* graphics, CompositingQuality* compositingQuality);
    GpStatus WINAPI GdipSetSmoothingMode(GpGraphics* graphics, SmoothingMode smoothingMode);
    GpStatus WINAPI GdipGetSmoothingMode(GpGraphics* graphics, SmoothingMode* smoothingMode);
    GpStatus WINAPI GdipSetPixelOffsetMode(GpGraphics* graphics, PixelOffsetMode pixelOffsetMode);
    GpStatus WINAPI GdipGetPixelOffsetMode(GpGraphics* graphics, PixelOffsetMode* pixelOffsetMode);
    GpStatus WINAPI GdipSetTextRenderingHint(GpGraphics* graphics, TextRenderingHint mode);
    GpStatus WINAPI GdipGetTextRenderingHint(GpGraphics* graphics, TextRenderingHint* mode);
    GpStatus WINAPI GdipSetTextContrast(GpGraphics* graphics, UINT contrast);
    GpStatus WINAPI GdipGetTextContrast(GpGraphics* graphics, UINT* contrast);
    GpStatus WINAPI GdipSetInterpolationMode(GpGraphics* graphics, InterpolationMode interpolationMode);
    GpStatus WINAPI GdipGetInterpolationMode(GpGraphics* graphics, InterpolationMode* interpolationMode);
    GpStatus WINAPI GdipSetWorldTransform(GpGraphics* graphics, GpMatrix* matrix);
    GpStatus WINAPI GdipResetWorldTransform(GpGraphics* graphics);
    GpStatus WINAPI GdipMultiplyWorldTransform(GpGraphics* graphics, GDIPCONST GpMatrix* matrix, GpMatrixOrder order);
    GpStatus WINAPI GdipTranslateWorldTransform(GpGraphics* graphics, REAL dx, REAL dy, GpMatrixOrder order);
    GpStatus WINAPI GdipScaleWorldTransform(GpGraphics* graphics, REAL sx, REAL sy, GpMatrixOrder order);
    GpStatus WINAPI GdipRotateWorldTransform(GpGraphics* graphics, REAL angle, GpMatrixOrder order);
    GpStatus WINAPI GdipGetWorldTransform(GpGraphics* graphics, GpMatrix* matrix);
    GpStatus WINAPI GdipResetPageTransform(GpGraphics* graphics);
    GpStatus WINAPI GdipGetPageUnit(GpGraphics* graphics, GpUnit* unit);
    GpStatus WINAPI GdipGetPageScale(GpGraphics* graphics, REAL* scale);
    GpStatus WINAPI GdipSetPageUnit(GpGraphics* graphics, GpUnit unit);
    GpStatus WINAPI GdipSetPageScale(GpGraphics* graphics, REAL scale);
    GpStatus WINAPI GdipGetDpiX(GpGraphics* graphics, REAL* dpi);
    GpStatus WINAPI GdipGetDpiY(GpGraphics* graphics, REAL* dpi);
    GpStatus WINAPI GdipTransformPoints(GpGraphics* graphics, GpCoordinateSpace destSpace, GpCoordinateSpace srcSpace, GpPointF* points, INT count);
    GpStatus WINAPI GdipTransformPointsI(GpGraphics* graphics, GpCoordinateSpace destSpace, GpCoordinateSpace srcSpace, GpPoint* points, INT count);
    GpStatus WINAPI GdipGetNearestColor(GpGraphics* graphics, ARGB* argb);

    // Creates the Win9x Halftone Palette (even on NT) with correct Desktop colors
    HPALETTE WINAPI GdipCreateHalftonePalette();
    GpStatus WINAPI GdipDrawLine(GpGraphics* graphics, GpPen* pen, REAL x1, REAL y1, REAL x2, REAL y2);
    GpStatus WINAPI GdipDrawLineI(GpGraphics* graphics, GpPen* pen, INT x1, INT y1, INT x2, INT y2);
    GpStatus WINAPI GdipDrawLines(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipDrawLinesI(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipDrawArc(GpGraphics* graphics, GpPen* pen, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
    GpStatus WINAPI GdipDrawArcI(GpGraphics* graphics, GpPen* pen, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
    GpStatus WINAPI GdipDrawBezier(GpGraphics* graphics, GpPen* pen, REAL x1, REAL y1, REAL x2, REAL y2, REAL x3, REAL y3, REAL x4, REAL y4);
    GpStatus WINAPI GdipDrawBezierI(GpGraphics* graphics, GpPen* pen, INT x1, INT y1, INT x2, INT y2, INT x3, INT y3, INT x4, INT y4);
    GpStatus WINAPI GdipDrawBeziers(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipDrawBeziersI(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipDrawRectangle(GpGraphics* graphics, GpPen* pen, REAL x, REAL y, REAL width, REAL height);
    GpStatus WINAPI GdipDrawRectangleI(GpGraphics* graphics, GpPen* pen, INT x, INT y, INT width, INT height);
    GpStatus WINAPI GdipDrawRectangles(GpGraphics* graphics, GpPen* pen, GDIPCONST GpRectF* rects, INT count);
    GpStatus WINAPI GdipDrawRectanglesI(GpGraphics* graphics, GpPen* pen, GDIPCONST GpRect* rects, INT count);
    GpStatus WINAPI GdipDrawEllipse(GpGraphics* graphics, GpPen* pen, REAL x, REAL y, REAL width, REAL height);
    GpStatus WINAPI GdipDrawEllipseI(GpGraphics* graphics, GpPen* pen, INT x, INT y, INT width, INT height);
    GpStatus WINAPI GdipDrawPie(GpGraphics* graphics, GpPen* pen, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
    GpStatus WINAPI GdipDrawPieI(GpGraphics* graphics, GpPen* pen, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
    GpStatus WINAPI GdipDrawPolygon(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipDrawPolygonI(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipDrawPath(GpGraphics* graphics, GpPen* pen, GpPath* path);
    GpStatus WINAPI GdipDrawCurve(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipDrawCurveI(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipDrawCurve2(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count, REAL tension);
    GpStatus WINAPI GdipDrawCurve2I(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count, REAL tension);
    GpStatus WINAPI GdipDrawCurve3(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count, INT offset, INT numberOfSegments, REAL tension);
    GpStatus WINAPI GdipDrawCurve3I(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count, INT offset, INT numberOfSegments, REAL tension);
    GpStatus WINAPI GdipDrawClosedCurve(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipDrawClosedCurveI(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipDrawClosedCurve2(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPointF* points, INT count, REAL tension);
    GpStatus WINAPI GdipDrawClosedCurve2I(GpGraphics* graphics, GpPen* pen, GDIPCONST GpPoint* points, INT count, REAL tension);
    GpStatus WINAPI GdipGraphicsClear(GpGraphics* graphics, ARGB color);
    GpStatus WINAPI GdipFillRectangle(GpGraphics* graphics, GpBrush* brush, REAL x, REAL y, REAL width, REAL height);
    GpStatus WINAPI GdipFillRectangleI(GpGraphics* graphics, GpBrush* brush, INT x, INT y, INT width, INT height);
    GpStatus WINAPI GdipFillRectangles(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpRectF* rects, INT count);
    GpStatus WINAPI GdipFillRectanglesI(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpRect* rects, INT count);
    GpStatus WINAPI GdipFillPolygon(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPointF* points, INT count, GpFillMode fillMode);
    GpStatus WINAPI GdipFillPolygonI(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPoint* points, INT count, GpFillMode fillMode);
    GpStatus WINAPI GdipFillPolygon2(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipFillPolygon2I(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipFillEllipse(GpGraphics* graphics, GpBrush* brush, REAL x, REAL y, REAL width, REAL height);
    GpStatus WINAPI GdipFillEllipseI(GpGraphics* graphics, GpBrush* brush, INT x, INT y, INT width, INT height);
    GpStatus WINAPI GdipFillPie(GpGraphics* graphics, GpBrush* brush, REAL x, REAL y, REAL width, REAL height, REAL startAngle, REAL sweepAngle);
    GpStatus WINAPI GdipFillPieI(GpGraphics* graphics, GpBrush* brush, INT x, INT y, INT width, INT height, REAL startAngle, REAL sweepAngle);
    GpStatus WINAPI GdipFillPath(GpGraphics* graphics, GpBrush* brush, GpPath* path);
    GpStatus WINAPI GdipFillClosedCurve(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPointF* points, INT count);
    GpStatus WINAPI GdipFillClosedCurveI(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPoint* points, INT count);
    GpStatus WINAPI GdipFillClosedCurve2(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPointF* points, INT count, REAL tension, GpFillMode fillMode);
    GpStatus WINAPI GdipFillClosedCurve2I(GpGraphics* graphics, GpBrush* brush, GDIPCONST GpPoint* points, INT count, REAL tension, GpFillMode fillMode);
    GpStatus WINAPI GdipFillRegion(GpGraphics* graphics, GpBrush* brush, GpRegion* region);
    GpStatus WINAPI GdipDrawImage(GpGraphics* graphics, GpImage* image, REAL x, REAL y);
    GpStatus WINAPI GdipDrawImageI(GpGraphics* graphics, GpImage* image, INT x, INT y);
    GpStatus WINAPI GdipDrawImageRect(GpGraphics* graphics, GpImage* image, REAL x, REAL y, REAL width, REAL height);
    GpStatus WINAPI GdipDrawImageRectI(GpGraphics* graphics, GpImage* image, INT x, INT y, INT width, INT height);
    GpStatus WINAPI GdipDrawImagePoints(GpGraphics* graphics, GpImage* image, GDIPCONST GpPointF* dstpoints, INT count);
    GpStatus WINAPI GdipDrawImagePointsI(GpGraphics* graphics, GpImage* image, GDIPCONST GpPoint* dstpoints, INT count);
    GpStatus WINAPI GdipDrawImagePointRect(GpGraphics* graphics, GpImage* image, REAL x, REAL y, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, GpUnit srcUnit);
    GpStatus WINAPI GdipDrawImagePointRectI(GpGraphics* graphics, GpImage* image, INT x, INT y, INT srcx, INT srcy, INT srcwidth, INT srcheight, GpUnit srcUnit);
    GpStatus WINAPI GdipDrawImageRectRect(GpGraphics* graphics, GpImage* image, REAL dstx, REAL dsty, REAL dstwidth, REAL dstheight, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, GpUnit srcUnit, GDIPCONST GpImageAttributes* imageAttributes, DrawImageAbort callback, VOID* callbackData);
    GpStatus WINAPI GdipDrawImageRectRectI(GpGraphics* graphics, GpImage* image, INT dstx, INT dsty, INT dstwidth, INT dstheight, INT srcx, INT srcy, INT srcwidth, INT srcheight, GpUnit srcUnit, GDIPCONST GpImageAttributes* imageAttributes, DrawImageAbort callback, VOID* callbackData);
    GpStatus WINAPI GdipDrawImagePointsRect(GpGraphics* graphics, GpImage* image, GDIPCONST GpPointF* points, INT count, REAL srcx, REAL srcy, REAL srcwidth, REAL srcheight, GpUnit srcUnit, GDIPCONST GpImageAttributes* imageAttributes, DrawImageAbort callback, VOID* callbackData);
    GpStatus WINAPI GdipDrawImagePointsRectI(GpGraphics* graphics, GpImage* image, GDIPCONST GpPoint* points, INT count, INT srcx, INT srcy, INT srcwidth, INT srcheight, GpUnit srcUnit, GDIPCONST GpImageAttributes* imageAttributes, DrawImageAbort callback, VOID* callbackData);
    GpStatus WINAPI GdipEnumerateMetafileDestPoint(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST PointF& destPoint, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileDestPointI(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Point& destPoint, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileDestRect(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST RectF& destRect, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileDestRectI(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Rect& destRect, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileDestPoints(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST PointF* destPoints, INT count, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileDestPointsI(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Point* destPoints, INT count, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileSrcRectDestPoint(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST PointF& destPoint, GDIPCONST RectF& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileSrcRectDestPointI(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Point& destPoint, GDIPCONST Rect& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileSrcRectDestRect(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST RectF& destRect, GDIPCONST RectF& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileSrcRectDestRectI(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Rect& destRect, GDIPCONST Rect& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileSrcRectDestPoints(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST PointF* destPoints, INT count, GDIPCONST RectF& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipEnumerateMetafileSrcRectDestPointsI(GpGraphics* graphics, GDIPCONST GpMetafile* metafile, GDIPCONST Point* destPoints, INT count, GDIPCONST Rect& srcRect, Unit srcUnit, EnumerateMetafileProc callback, VOID* callbackData, GDIPCONST GpImageAttributes* imageAttributes);
    GpStatus WINAPI GdipPlayMetafileRecord(GDIPCONST GpMetafile* metafile, EmfPlusRecordType recordType, UINT flags, UINT dataSize, GDIPCONST BYTE* data);
    GpStatus WINAPI GdipSetClipGraphics(GpGraphics* graphics, GpGraphics* srcgraphics, CombineMode combineMode);
    GpStatus WINAPI GdipSetClipRect(GpGraphics* graphics, REAL x, REAL y, REAL width, REAL height, CombineMode combineMode);
    GpStatus WINAPI GdipSetClipRectI(GpGraphics* graphics, INT x, INT y, INT width, INT height, CombineMode combineMode);
    GpStatus WINAPI GdipSetClipPath(GpGraphics* graphics, GpPath* path, CombineMode combineMode);
    GpStatus WINAPI GdipSetClipRegion(GpGraphics* graphics, GpRegion* region, CombineMode combineMode);
    GpStatus WINAPI GdipSetClipHrgn(GpGraphics* graphics, HRGN hRgn, CombineMode combineMode);
    GpStatus WINAPI GdipResetClip(GpGraphics* graphics);
    GpStatus WINAPI GdipTranslateClip(GpGraphics* graphics, REAL dx, REAL dy);
    GpStatus WINAPI GdipTranslateClipI(GpGraphics* graphics, INT dx, INT dy);
    GpStatus WINAPI GdipGetClip(GpGraphics* graphics, GpRegion* region);
    GpStatus WINAPI GdipGetClipBounds(GpGraphics* graphics, GpRectF* rect);
    GpStatus WINAPI GdipGetClipBoundsI(GpGraphics* graphics, GpRect* rect);
    GpStatus WINAPI GdipIsClipEmpty(GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipGetVisibleClipBounds(GpGraphics* graphics, GpRectF* rect);
    GpStatus WINAPI GdipGetVisibleClipBoundsI(GpGraphics* graphics, GpRect* rect);
    GpStatus WINAPI GdipIsVisibleClipEmpty(GpGraphics* graphics, BOOL* result);
    GpStatus WINAPI GdipIsVisiblePoint(GpGraphics* graphics, REAL x, REAL y, BOOL* result);
    GpStatus WINAPI GdipIsVisiblePointI(GpGraphics* graphics, INT x, INT y, BOOL* result);
    GpStatus WINAPI GdipIsVisibleRect(GpGraphics* graphics, REAL x, REAL y, REAL width, REAL height, BOOL* result);
    GpStatus WINAPI GdipIsVisibleRectI(GpGraphics* graphics, INT x, INT y, INT width, INT height, BOOL* result);
    GpStatus WINAPI GdipSaveGraphics(GpGraphics* graphics, GraphicsState* state);
    GpStatus WINAPI GdipRestoreGraphics(GpGraphics* graphics, GraphicsState state);
    GpStatus WINAPI GdipBeginContainer(GpGraphics* graphics, GDIPCONST GpRectF* dstrect, GDIPCONST GpRectF* srcrect, GpUnit unit, GraphicsContainer* state);
    GpStatus WINAPI GdipBeginContainerI(GpGraphics* graphics, GDIPCONST GpRect* dstrect, GDIPCONST GpRect* srcrect, GpUnit unit, GraphicsContainer* state);
    GpStatus WINAPI GdipBeginContainer2(GpGraphics* graphics, GraphicsContainer* state);
    GpStatus WINAPI GdipEndContainer(GpGraphics* graphics, GraphicsContainer state);
    GpStatus WINAPI GdipGetMetafileHeaderFromWmf(HMETAFILE hWmf, GDIPCONST WmfPlaceableFileHeader* wmfPlaceableFileHeader, MetafileHeader* header);
    GpStatus WINAPI GdipGetMetafileHeaderFromEmf(HENHMETAFILE hEmf, MetafileHeader* header);
    GpStatus WINAPI GdipGetMetafileHeaderFromFile(GDIPCONST WCHAR* filename, MetafileHeader* header);
    GpStatus WINAPI GdipGetMetafileHeaderFromStream(IStream* stream, MetafileHeader* header);
    GpStatus WINAPI GdipGetMetafileHeaderFromMetafile(GpMetafile* metafile, MetafileHeader* header);
    GpStatus WINAPI GdipGetHemfFromMetafile(GpMetafile* metafile, HENHMETAFILE* hEmf);
    GpStatus WINAPI GdipCreateStreamOnFile(GDIPCONST WCHAR* filename, UINT access, IStream** stream);
    GpStatus WINAPI GdipCreateMetafileFromWmf(HMETAFILE hWmf, BOOL deleteWmf, GDIPCONST WmfPlaceableFileHeader* wmfPlaceableFileHeader, GpMetafile** metafile);
    GpStatus WINAPI GdipCreateMetafileFromEmf(HENHMETAFILE hEmf, BOOL deleteEmf, GpMetafile** metafile);
    GpStatus WINAPI GdipCreateMetafileFromFile(GDIPCONST WCHAR* file, GpMetafile** metafile);
    GpStatus WINAPI GdipCreateMetafileFromWmfFile(GDIPCONST WCHAR* file, GDIPCONST WmfPlaceableFileHeader* wmfPlaceableFileHeader, GpMetafile** metafile);
    GpStatus WINAPI GdipCreateMetafileFromStream(IStream* stream, GpMetafile** metafile);
    GpStatus WINAPI GdipRecordMetafile(HDC referenceHdc, EmfType type, GDIPCONST GpRectF* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
    GpStatus WINAPI GdipRecordMetafileI(HDC referenceHdc, EmfType type, GDIPCONST GpRect* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
    GpStatus WINAPI GdipRecordMetafileFileName(GDIPCONST WCHAR* fileName, HDC referenceHdc, EmfType type, GDIPCONST GpRectF* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
    GpStatus WINAPI GdipRecordMetafileFileNameI(GDIPCONST WCHAR* fileName, HDC referenceHdc, EmfType type, GDIPCONST GpRect* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
    GpStatus WINAPI GdipRecordMetafileStream(IStream* stream, HDC referenceHdc, EmfType type, GDIPCONST GpRectF* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
    GpStatus WINAPI GdipRecordMetafileStreamI(IStream* stream, HDC referenceHdc, EmfType type, GDIPCONST GpRect* frameRect, MetafileFrameUnit frameUnit, GDIPCONST WCHAR* description, GpMetafile** metafile);
    GpStatus WINAPI GdipSetMetafileDownLevelRasterizationLimit(GpMetafile* metafile, UINT metafileRasterizationLimitDpi);
    GpStatus WINAPI GdipGetMetafileDownLevelRasterizationLimit(GDIPCONST GpMetafile* metafile, UINT* metafileRasterizationLimitDpi);
    GpStatus WINAPI GdipGetImageDecodersSize(UINT* numDecoders, UINT* size);
    GpStatus WINAPI GdipGetImageDecoders(UINT numDecoders, UINT size, ImageCodecInfo* decoders);
    GpStatus WINAPI GdipGetImageEncodersSize(UINT* numEncoders, UINT* size);
    GpStatus WINAPI GdipGetImageEncoders(UINT numEncoders, UINT size, ImageCodecInfo* encoders);
    GpStatus WINAPI GdipComment(GpGraphics* graphics, UINT sizeData, GDIPCONST BYTE* data);

    //----------------------------------------------------------------------------
    // FontFamily APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateFontFamilyFromName(GDIPCONST WCHAR* name, GpFontCollection* fontCollection, GpFontFamily** FontFamily);
    GpStatus WINAPI GdipDeleteFontFamily(GpFontFamily* FontFamily);
    GpStatus WINAPI GdipCloneFontFamily(GpFontFamily* FontFamily, GpFontFamily** clonedFontFamily);
    GpStatus WINAPI GdipGetGenericFontFamilySansSerif(GpFontFamily** nativeFamily);
    GpStatus WINAPI GdipGetGenericFontFamilySerif(GpFontFamily** nativeFamily);
    GpStatus WINAPI GdipGetGenericFontFamilyMonospace(GpFontFamily** nativeFamily);
    GpStatus WINAPI GdipGetFamilyName(GDIPCONST GpFontFamily* family, WCHAR name[LF_FACESIZE], LANGID language);
    GpStatus WINAPI GdipIsStyleAvailable(GDIPCONST GpFontFamily* family, INT style, BOOL* IsStyleAvailable);
    GpStatus WINAPI GdipFontCollectionEnumerable(GpFontCollection* fontCollection, GpGraphics* graphics, INT* numFound);
    GpStatus WINAPI GdipFontCollectionEnumerate(GpFontCollection* fontCollection, INT numSought, GpFontFamily* gpfamilies[], INT* numFound, GpGraphics* graphics);
    GpStatus WINAPI GdipGetEmHeight(GDIPCONST GpFontFamily* family, INT style, UINT16* EmHeight);
    GpStatus WINAPI GdipGetCellAscent(GDIPCONST GpFontFamily* family, INT style, UINT16* CellAscent);
    GpStatus WINAPI GdipGetCellDescent(GDIPCONST GpFontFamily* family, INT style, UINT16* CellDescent);
    GpStatus WINAPI GdipGetLineSpacing(GDIPCONST GpFontFamily* family, INT style, UINT16* LineSpacing);

    //----------------------------------------------------------------------------
    // Font APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateFontFromDC(HDC hdc, GpFont** font);
    GpStatus WINAPI GdipCreateFontFromLogfontA(HDC hdc, GDIPCONST LOGFONTA* logfont, GpFont** font);
    GpStatus WINAPI GdipCreateFontFromLogfontW(HDC hdc, GDIPCONST LOGFONTW* logfont, GpFont** font);
    GpStatus WINAPI GdipCreateFont(GDIPCONST GpFontFamily* fontFamily, REAL emSize, INT style, Unit unit, GpFont** font);
    GpStatus WINAPI GdipCloneFont(GpFont* font, GpFont** cloneFont);
    GpStatus WINAPI GdipDeleteFont(GpFont* font);
    GpStatus WINAPI GdipGetFamily(GpFont* font, GpFontFamily** family);
    GpStatus WINAPI GdipGetFontStyle(GpFont* font, INT* style);
    GpStatus WINAPI GdipGetFontSize(GpFont* font, REAL* size);
    GpStatus WINAPI GdipGetFontUnit(GpFont* font, Unit* unit);
    GpStatus WINAPI GdipGetFontHeight(GDIPCONST GpFont* font, GDIPCONST GpGraphics* graphics, REAL* height);
    GpStatus WINAPI GdipGetFontHeightGivenDPI(GDIPCONST GpFont* font, REAL dpi, REAL* height);
    GpStatus WINAPI GdipGetLogFontA(GpFont* font, GpGraphics* graphics, LOGFONTA* logfontA);
    GpStatus WINAPI GdipGetLogFontW(GpFont* font, GpGraphics* graphics, LOGFONTW* logfontW);
    GpStatus WINAPI GdipNewInstalledFontCollection(GpFontCollection** fontCollection);
    GpStatus WINAPI GdipNewPrivateFontCollection(GpFontCollection** fontCollection);
    GpStatus WINAPI GdipDeletePrivateFontCollection(GpFontCollection** fontCollection);
    GpStatus WINAPI GdipGetFontCollectionFamilyCount(GpFontCollection* fontCollection, INT* numFound);
    GpStatus WINAPI GdipGetFontCollectionFamilyList(GpFontCollection* fontCollection, INT numSought, GpFontFamily* gpfamilies[], INT* numFound);
    GpStatus WINAPI GdipPrivateAddFontFile(GpFontCollection* fontCollection, GDIPCONST WCHAR* filename);
    GpStatus WINAPI GdipPrivateAddMemoryFont(GpFontCollection* fontCollection, GDIPCONST void* memory, INT length);

    //----------------------------------------------------------------------------
    // Text APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipDrawString(GpGraphics* graphics, GDIPCONST WCHAR* string, INT length, GDIPCONST GpFont* font, GDIPCONST RectF* layoutRect, GDIPCONST GpStringFormat* stringFormat, GDIPCONST GpBrush* brush);
    GpStatus WINAPI GdipMeasureString(GpGraphics* graphics, GDIPCONST WCHAR* string, INT length, GDIPCONST GpFont* font, GDIPCONST RectF* layoutRect, GDIPCONST GpStringFormat* stringFormat, RectF* boundingBox, INT* codepointsFitted, INT* linesFilled);
    GpStatus WINAPI GdipMeasureCharacterRanges(GpGraphics* graphics, GDIPCONST WCHAR* string, INT length, GDIPCONST GpFont* font, GDIPCONST RectF& layoutRect, GDIPCONST GpStringFormat* stringFormat, INT regionCount, GpRegion** regions);
    GpStatus WINAPI GdipDrawDriverString(GpGraphics* graphics, GDIPCONST UINT16* text, INT length, GDIPCONST GpFont* font, GDIPCONST GpBrush* brush, GDIPCONST PointF* positions, INT flags, GDIPCONST GpMatrix* matrix);
    GpStatus WINAPI GdipMeasureDriverString(GpGraphics* graphics, GDIPCONST UINT16* text, INT length, GDIPCONST GpFont* font, GDIPCONST PointF* positions, INT flags, GDIPCONST GpMatrix* matrix, RectF* boundingBox);

    //----------------------------------------------------------------------------
    // String format APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateStringFormat(INT formatAttributes, LANGID language, GpStringFormat** format);
    GpStatus WINAPI GdipStringFormatGetGenericDefault(GpStringFormat** format);
    GpStatus WINAPI GdipStringFormatGetGenericTypographic(GpStringFormat** format);
    GpStatus WINAPI GdipDeleteStringFormat(GpStringFormat* format);
    GpStatus WINAPI GdipCloneStringFormat(GDIPCONST GpStringFormat* format, GpStringFormat** newFormat);
    GpStatus WINAPI GdipSetStringFormatFlags(GpStringFormat* format, INT flags);
    GpStatus WINAPI GdipGetStringFormatFlags(GDIPCONST GpStringFormat* format, INT* flags);
    GpStatus WINAPI GdipSetStringFormatAlign(GpStringFormat* format, StringAlignment align);
    GpStatus WINAPI GdipGetStringFormatAlign(GDIPCONST GpStringFormat* format, StringAlignment* align);
    GpStatus WINAPI GdipSetStringFormatLineAlign(GpStringFormat* format, StringAlignment align);
    GpStatus WINAPI GdipGetStringFormatLineAlign(GDIPCONST GpStringFormat* format, StringAlignment* align);
    GpStatus WINAPI GdipSetStringFormatTrimming(GpStringFormat* format, StringTrimming trimming);
    GpStatus WINAPI GdipGetStringFormatTrimming(GDIPCONST GpStringFormat* format, StringTrimming* trimming);
    GpStatus WINAPI GdipSetStringFormatHotkeyPrefix(GpStringFormat* format, INT hotkeyPrefix);
    GpStatus WINAPI GdipGetStringFormatHotkeyPrefix(GDIPCONST GpStringFormat* format, INT* hotkeyPrefix);
    GpStatus WINAPI GdipSetStringFormatTabStops(GpStringFormat* format, REAL firstTabOffset, INT count, GDIPCONST REAL* tabStops);
    GpStatus WINAPI GdipGetStringFormatTabStops(GDIPCONST GpStringFormat* format, INT count, REAL* firstTabOffset, REAL* tabStops);
    GpStatus WINAPI GdipGetStringFormatTabStopCount(GDIPCONST GpStringFormat* format, INT* count);
    GpStatus WINAPI GdipSetStringFormatDigitSubstitution(GpStringFormat* format, LANGID language, StringDigitSubstitute substitute);
    GpStatus WINAPI GdipGetStringFormatDigitSubstitution(GDIPCONST GpStringFormat* format, LANGID* language, StringDigitSubstitute* substitute);
    GpStatus WINAPI GdipGetStringFormatMeasurableCharacterRangeCount(GDIPCONST GpStringFormat* format, INT* count);
    GpStatus WINAPI GdipSetStringFormatMeasurableCharacterRanges(GpStringFormat* format, INT rangeCount, GDIPCONST CharacterRange* ranges);

    //----------------------------------------------------------------------------
    // Cached Bitmap APIs
    //----------------------------------------------------------------------------
    GpStatus WINAPI GdipCreateCachedBitmap(GpBitmap* bitmap, GpGraphics* graphics, GpCachedBitmap** cachedBitmap);
    GpStatus WINAPI GdipDeleteCachedBitmap(GpCachedBitmap* cachedBitmap);
    GpStatus WINAPI GdipDrawCachedBitmap(GpGraphics* graphics, GpCachedBitmap* cachedBitmap, INT x, INT y);
    UINT WINAPI GdipEmfToWmfBits(HENHMETAFILE hemf, UINT cbData16, LPBYTE pData16, INT iMapMode, INT eFlags);
};

#endif

extern GdiplusWrapper gdiplusWrapper;