// AboutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "AboutDlg.h"
#include "MainWnd.h"
#include "MainHelper.h"
#include "AutoUpdater.h"
#include "version.ver"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CWhatNewDlg::CWhatNewDlg() : CDialog(IDD_WHATNEW)
{
    m_text.LoadString(AfxGetInstanceHandle(), IDS_WHATNEW);
    m_text.Replace(_T("\n \n"), _T("\n"));
    m_text.Replace(_T("\r"), _T(""));
    m_text.Replace(_T("\n"), _T("\r\n"));
    m_text = m_text.Mid(m_text.Find(_T("[")));
}

BOOL CWhatNewDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_WHATNEW);

    SetIcon(s_mainWnd.m_stpIcon, TRUE);
    SetIcon(s_mainWnd.m_stpIconSm, FALSE);

    GetDlgItem(IDC_WHAT)->SetWindowText(m_text);
    return TRUE;
}

void CWhatNewDlg::DoDataExchange(CDataExchange* pDX)
{
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDOK, m_btnOk);
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog


CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    CString strCredits = _T("\tSystray Play\n") _T("\rVersion 2010\n\n") _T("\r 2000 - 2001\n") _T("\b Youri Stous - Yaroslavl, Russie\n\n") _T("\r 2001 - 2010\n") _T("\b Mickal Sebire - Lyon, France\n\n");
    strCredits += m_Helper.MyLoadString(IDS_CREDIT);

    m_aboutCtrl.SetCredits(strCredits);
}

CAboutDlg::~CAboutDlg()
{
}

IMPLEMENT_MENUXP(CAboutDlg, CDialog);

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
  ON_BN_CLICKED(IDC_BUTTON_MAIL, OnBtnMail)
  ON_WM_CLOSE()
  ON_BN_CLICKED(IDC_BUTTON_HOMEPAGE, OnBtnHomepage)
  ON_BN_CLICKED(IDC_BUTTON_UPDATENOW, OnBtnUpdateNow)
  ON_BN_CLICKED(IDC_BUTTON_WHATNEW, OnBtnWhatNew)
  ON_MENUXP_MESSAGES()
  ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg message handlers

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_BUTTON_HOMEPAGE, m_btnInternet);
    DDX_Control(pDX, IDC_BUTTON_MAIL, m_btnMail);
    DDX_Control(pDX, IDC_BUTTON_UPDATENOW, m_btnUpdateNow);
    DDX_Control(pDX, IDC_BUTTON_WHATNEW, m_btnWhatNew);
    DDX_Control(pDX, IDOK, m_btnOk);
    DDX_Control(pDX, IDC_ABOUTCTRL, m_aboutCtrl);
}
void CAboutDlg::OnBtnHomepage()
{
    ShellExecute(NULL, _T("open"), _T("http://systrayplay.free.fr/"), NULL, NULL, SW_SHOWNORMAL);
}
void CAboutDlg::OnBtnMail()
{
    ShellExecute(NULL, NULL, _T("mailto:micksebire@yahoo.fr"), NULL, NULL, SW_SHOWNORMAL);
}
void CAboutDlg::OnBtnUpdateNow()
{
    CAutoUpdater updater;
    CAutoUpdater::ErrorType err = updater.CheckForUpdate(_T("http://systrayplay.free.fr/"));
    switch (err)
    {
        case CAutoUpdater::Success:
            MessageBox(m_Helper.MyLoadString(IDS_UPDATEOK), _T("STP"), MB_ICONINFORMATION | MB_OK);
            ::SendMessage(s_mainWnd.m_hWnd, WM_COMMAND, ID_POPUPMENU_EXIT, 0);
            break;
        case CAutoUpdater::UpdateNotRequired:
            MessageBox(m_Helper.MyLoadString(IDS_UPDATENOTREQUIRED), _T("STP"), MB_ICONINFORMATION | MB_OK);
            break;
        case CAutoUpdater::UpdateNotComplete:
            MessageBox(m_Helper.MyLoadString(IDS_UPDATEKO), _T("STP"), MB_ICONINFORMATION | MB_OK);
            break;
        case CAutoUpdater::NoExecutableVersion:
            MessageBox(m_Helper.MyLoadString(IDS_UPDATENOEXECUTABLEVERSION), _T("STP"), MB_ICONINFORMATION | MB_OK);
            break;
        default:
            MessageBox(m_Helper.MyLoadString(IDS_UPDATECONNECTFAILED), _T("STP"), MB_ICONINFORMATION | MB_OK);
            break;
    }
}

void CAboutDlg::OnBtnWhatNew()
{
    CWhatNewDlg what;
    what.DoModal();
}

BOOL CAboutDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_ABOUT);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_MAIL);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_HOMEPAGE);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_UPDATENOW);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_WHATNEW);
    m_Helper.translateDlgItemText(this, IDOK);

    SetIcon(s_mainWnd.m_stpIcon, TRUE);
    SetIcon(s_mainWnd.m_stpIconSm, FALSE);

    CString title, version;
    GetWindowText(title);
    version.Format(_T("%s %d.%d.%d.%d"), title, VERSION_MAJOR, VERSION_MINOR, VERSION_BUILD, VERSION_QFE);
    SetWindowText(version);

    return TRUE;
}

BOOL CAboutDlg::OnEraseBkgnd(CDC* pDC)
{
    CPaintDC dc(this); 
    CRect rcPlaceholder;
    ASSERT(dc);
    CRect rcClient;
    GetClientRect(rcClient);

    GetDlgItem(IDC_ABOUTCTRL)->GetWindowRect(rcPlaceholder);
    ScreenToClient(rcPlaceholder);

    MARGINS marGlassInset =
    {
        rcPlaceholder.left, rcClient.right - rcPlaceholder.right, rcPlaceholder.top, rcClient.bottom - rcPlaceholder.bottom
    };

    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled() && SUCCEEDED(dwmApi.DwmExtendFrameIntoClientArea(m_hWnd, &marGlassInset)))
    {
        CRect rcScratch = rcClient;
        rcScratch.right = marGlassInset.cxLeftWidth;
        CPaintDC::FromHandle(dc)->PatBlt(rcScratch.left, rcScratch.top, rcScratch.Width(), rcScratch.Height(), BLACKNESS);
        rcScratch = rcClient;
        rcScratch.bottom = marGlassInset.cyTopHeight;
        CPaintDC::FromHandle(dc)->PatBlt(rcScratch.left, rcScratch.top, rcScratch.Width(), rcScratch.Height(), BLACKNESS);

        rcScratch = rcClient;
        rcScratch.left = rcScratch.right - marGlassInset.cxRightWidth;
        CPaintDC::FromHandle(dc)->PatBlt(rcScratch.left, rcScratch.top, rcScratch.Width(), rcScratch.Height(), BLACKNESS);

        rcScratch = rcClient;
        rcScratch.top = rcScratch.bottom - marGlassInset.cyBottomHeight;
        CPaintDC::FromHandle(dc)->PatBlt(rcScratch.left, rcScratch.top, rcScratch.Width(), rcScratch.Height(), BLACKNESS);
        return TRUE;
    }
    return CDialog::OnEraseBkgnd(pDC);
}
