// AutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "AutDlg.h"
#include "MainWnd.h"
#include "MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAutDlg dialog


CAutDlg::CAutDlg() : CDialog(CAutDlg::IDD)
{
    m_mins = 0;
    m_remove = FALSE;
    m_rescan = FALSE;
    m_sort = FALSE;
    m_every = FALSE;
    m_onStart = FALSE;
    m_removedup = FALSE;
    m_saveset = FALSE;
}

CAutDlg::~CAutDlg()
{
}

IMPLEMENT_MENUXP(CAutDlg, CDialog)

BEGIN_MESSAGE_MAP(CAutDlg, CDialog)
ON_BN_CLICKED(IDC_ADD, OnAdd)
ON_BN_CLICKED(IDC_DEL, OnDel)
ON_WM_CLOSE()
ON_MENUXP_MESSAGES()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutDlg message handlers

void CAutDlg::DoDataExchange(CDataExchange* pDX)
{
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_SPIN, m_spin);
    DDX_Control(pDX, IDC_FOLDERS, m_folders);
    DDX_Text(pDX, IDC_MIN, m_mins);
    DDX_Check(pDX, IDC_REMOVE, m_remove);
    DDX_Check(pDX, IDC_RESCAN, m_rescan);
    DDX_Check(pDX, IDC_SORT, m_sort);
    DDX_Check(pDX, IDC_EVERY, m_every);
    DDX_Check(pDX, IDC_ONSTART, m_onStart);
    DDX_Check(pDX, IDC_REMOVEDUP, m_removedup);
    DDX_Check(pDX, IDC_SAVESET, m_saveset);
    DDX_Control(pDX, IDOK, m_btnOk);
    DDX_Control(pDX, IDCANCEL, m_btnCancel);
    DDX_Control(pDX, IDC_ADD, m_btnAdd);
    DDX_Control(pDX, IDC_DEL, m_btnDel);
}


void CAutDlg::OnAdd()
{
    LPMALLOC pMalloc;
    if (SHGetMalloc(&pMalloc) != NOERROR)
        return;

    BROWSEINFO bi;
    TCHAR buf[MAX_PATH];

    CString title;
    title = m_Helper.MyLoadString(IDS_OPENFOLDER);

    bi.hwndOwner = m_hWnd;
    bi.pszDisplayName = buf;
    bi.pidlRoot = NULL;
    bi.lpszTitle = LPCTSTR(title);
    bi.ulFlags = BIF_RETURNONLYFSDIRS;
    bi.lpfn = NULL;

    LPITEMIDLIST pidl;
    if ((pidl = SHBrowseForFolder(&bi)) == NULL)
    {
        pMalloc->Free(pidl);
        pMalloc ->Release();
        return;
    }
    if (SHGetPathFromIDList(pidl, buf) == false)
    {
        pMalloc->Free(pidl);
        pMalloc ->Release();
        return;
    }
    pMalloc->Free(pidl);
    pMalloc->Release();

    CString theDir = buf;
    if (theDir[theDir.GetLength() - 1] != '\\')
        theDir += "\\";
    m_folders.AddString(theDir);
}

void CAutDlg::OnDel()
{
    if (m_folders.GetCurSel() != LB_ERR)
        m_folders.DeleteString(m_folders.GetCurSel());
}

BOOL CAutDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_AUTOMATION);
    m_Helper.translateDlgItemText(this, IDC_SAVESET);
    m_Helper.translateDlgItemText(this, IDC_SORT);
    m_Helper.translateDlgItemText(this, IDC_REMOVE);
    m_Helper.translateDlgItemText(this, IDC_REMOVEDUP);
    m_Helper.translateDlgItemText(this, IDC_RESCAN);
    m_Helper.translateDlgItemText(this, IDC_ONSTART);
    m_Helper.translateDlgItemText(this, IDC_EVERY);
    m_Helper.translateDlgItemText(this, IDC_MINUTES);
    m_Helper.translateDlgItemText(this, IDOK);
    m_Helper.translateDlgItemText(this, IDCANCEL);

    SetIcon(s_mainWnd.m_stpIcon, TRUE);
    SetIcon(s_mainWnd.m_stpIconSm, FALSE);

    m_spin.SetRange(1, 60);

    m_folders.SetHorizontalExtent(500);

    m_mins = s_mainWnd.m_autPeriod;
    m_remove = s_mainWnd.m_autRemove;
    m_removedup = s_mainWnd.m_autRemovedup;
    m_rescan = s_mainWnd.m_autRescan;
    m_sort = s_mainWnd.m_autSort;
    m_every = s_mainWnd.m_autEvery;
    m_saveset = s_mainWnd.m_autSaveset;
    m_onStart = s_mainWnd.m_autOnStart;

    m_mins = s_mainWnd.m_autPeriod;

    for (int i = 0; i < s_mainWnd.m_autDirs.GetSize(); i++)
        m_folders.AddString(s_mainWnd.m_autDirs[i]);

    UpdateData(FALSE);

    return TRUE;
}

void CAutDlg::OnOK()
{
    UpdateData(TRUE);

    bool UpdTimerFlag = (s_mainWnd.m_autPeriod != m_mins);

    s_mainWnd.m_autPeriod = m_mins;
    s_mainWnd.m_autRemove = m_remove;
    s_mainWnd.m_autRemovedup = m_removedup;
    s_mainWnd.m_autRescan = m_rescan;
    s_mainWnd.m_autSort = m_sort;
    s_mainWnd.m_autPeriod = m_mins;
    s_mainWnd.m_autEvery = m_every;
    s_mainWnd.m_autSaveset = m_saveset;
    s_mainWnd.m_autOnStart = m_onStart;

    CString buf;
    s_mainWnd.m_autDirs.RemoveAll();

    for (int i = 0; i < m_folders.GetCount(); i++)
    {
        m_folders.GetText(i, buf);
        s_mainWnd.m_autDirs.Add(buf);
    }

    if (UpdTimerFlag)
    {
        s_mainWnd.KillTimer(30);
        s_mainWnd.SetTimer(30, s_mainWnd.m_autPeriod * 60000, NULL);
    }
    CDialog::OnOK();
}
