// EqualizerDlg.cpp : implementation file
//

#include "StdAfx.h"
#include "aerosubc.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "resource.h"       // main symbols
#include "EqualizerDlg.h"
#include "MainWnd.h"
#include "MainHelper.h"
#include "paramlist.h"
#include "CommonFunc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern float last_srate;
extern void equMakeTable(float* lbc, float* rbc, paramlist*, float fs);

int lslpos[19];
int rslpos[19];
extern float lbands[];
extern float rbands[];
extern paramlist paramroot;
paramlist lastparamroot;

int freqs[] =
{
    55, 77, 110, 156, 220, 311, 440, 622, 880, 1244, 1760, 2489, 3520, 4978, 7040, 9956, 14080, 19912
};

void loadFrom(CStringArray* listString)
{
    TCHAR buf[256];
    CString tmp = listString->GetAt(0);

    if (tmp == _T(""))
    {
        return;
    }

    _tcscpy(buf, tmp.GetString());

    if (_stscanf(buf, _T("%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d"), &lslpos[0], &lslpos[1], &lslpos[2], &lslpos[3], &lslpos[4], &lslpos[5], &lslpos[6], &lslpos[7], &lslpos[8], &lslpos[9], &lslpos[10], &lslpos[11], &lslpos[12], &lslpos[13], &lslpos[14], &lslpos[15], &lslpos[16], &lslpos[17], &lslpos[18], &rslpos[0], &rslpos[1], &rslpos[2], &rslpos[3], &rslpos[4], &rslpos[5], &rslpos[6], &rslpos[7], &rslpos[8], &rslpos[9], &rslpos[10], &rslpos[11], &rslpos[12], &rslpos[13], &rslpos[14], &rslpos[15], &rslpos[16], &rslpos[17], &rslpos[18]) != 38)
    {
        ::MessageBox(NULL, _T("Format error"), _T("STP"), MB_OK | MB_ICONEXCLAMATION);
        // error
    }

    delete paramroot.elm;
    paramroot.elm = NULL;
    paramlistelm** p;
    int i = 1;

    for (p = &paramroot.elm; i < listString->GetSize(); p = &(*p)->next)
    {
        float lower, upper, gain;
        int left, right, r;

        tmp = listString->GetAt(i);

        _tcscpy(buf, tmp.GetString());

        r = _stscanf(buf, _T("%g %g %g %d %d"), &upper, &lower, &gain, &left, &right);
        if (r == 0 || r == EOF)
            break;
        if (r != 5)
        {
            wsprintf(buf, _T("Format error 2 (%d)"), r);
            ::MessageBox(NULL, buf, _T("STP"), MB_OK | MB_ICONEXCLAMATION);
            break;
        }

        *p = new paramlistelm;
        (*p)->lower = lower;
        (*p)->upper = upper;
        (*p)->gain = gain;
        (*p)->left = left;
        (*p)->right = right;
        i++;
    }
}

void loadFromFilename(CString filename)
{
    CStdioFile f;

    if (!f.Open(filename, CFile::modeRead))
    {
        if (filename != _T(""))
        {
            ::MessageBox(NULL, m_Helper.MyLoadString(IDS_CANTOPEN), _T("STP"), MB_OK | MB_ICONEXCLAMATION);
        }
        return;
    }

    CStringArray listString;

    CString tmp;

    while (f.ReadString(tmp))
    {
        listString.Add(tmp);
    }

    f.Close();

    loadFrom(&listString);
}

CStringArray* SaveTo()
{
    CStringArray* result = new CStringArray();
    CString buf;

    buf.Format(_T("%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n"), lslpos[0], lslpos[1], lslpos[2], lslpos[3], lslpos[4], lslpos[5], lslpos[6], lslpos[7], lslpos[8], lslpos[9], lslpos[10], lslpos[11], lslpos[12], lslpos[13], lslpos[14], lslpos[15], lslpos[16], lslpos[17], lslpos[18], rslpos[0], rslpos[1], rslpos[2], rslpos[3], rslpos[4], rslpos[5], rslpos[6], rslpos[7], rslpos[8], rslpos[9], rslpos[10], rslpos[11], rslpos[12], rslpos[13], rslpos[14], rslpos[15], rslpos[16], rslpos[17], rslpos[18]);

    result->Add(buf);

    for (paramlistelm* p = paramroot.elm; p != NULL; p = p->next)
    {
        buf.Format(_T("%.20g %.20g %.20g %d %d\n"), (double)p->upper, (double)p->lower, (double)p->gain, (int)p->left, (int)p->right);
        result->Add(buf);
    }
    return result;
}

void SetBandsFromSlpos()
{
    int i;
    float lpreamp = lslpos[0] == 96 ? (float)0.0 : (float)pow((double)10, (double)lslpos[0] / -20.0);
    float rpreamp = rslpos[0] == 96 ? (float)0.0 : (float)pow((double)10, (double)rslpos[0] / -20.0);

    for (i = 0; i < 18; i++)
    {
        lbands[i] = lslpos[i + 1] == 96 ? (float)0.0 : lpreamp * (float)pow((double)10, (double)lslpos[i + 1] / -20.0);
        rbands[i] = rslpos[i + 1] == 96 ? (float)0.0 : rpreamp * (float)pow((double)10, (double)rslpos[i + 1] / -20.0);
    }

    equMakeTable(lbands, rbands, &paramroot, last_srate);
}

CEqualizerDlg::CEqualizerDlg() : CDialog(CEqualizerDlg::IDD)
{
    last_param_index = 0;
    m_chPleft = FALSE;
    m_chPright = FALSE;
}

CEqualizerDlg::~CEqualizerDlg()
{
}

IMPLEMENT_MENUXP(CEqualizerDlg, CDialog)

BEGIN_MESSAGE_MAP(CEqualizerDlg, CDialog)
ON_WM_VSCROLL()
ON_BN_CLICKED(IDC_BUT_LOAD, OnBtnLoad)
ON_BN_CLICKED(IDOK, OnBtnOk)
ON_BN_CLICKED(IDC_BUT_SAVE, OnBtnSave)
ON_BN_CLICKED(IDC_ENABLE, OnChEnable)
ON_BN_CLICKED(IDC_CH_LOCK, OnChEnable)
ON_BN_CLICKED(IDC_CH_DITHER, OnChEnable)
ON_BN_CLICKED(IDC_BUT_UP, OnBtnUp)
ON_BN_CLICKED(IDC_BUT_DOWN, OnBtnDown)
ON_BN_CLICKED(IDC_BUT_APPLY, OnBtnApply)
ON_WM_DESTROY()
ON_BN_CLICKED(IDC_BUT_PNEW, OnBtnPnew)
ON_BN_CLICKED(IDC_BUT_PDEL, OnBtnPdel)
ON_LBN_SELCHANGE(IDC_LIST_PARAM, OnSelchangeListParam)
ON_EN_KILLFOCUS(IDC_ED_PLOW, SetParamListelmFromGui)
ON_EN_KILLFOCUS(IDC_ED_PUP, SetParamListelmFromGui)
ON_EN_KILLFOCUS(IDC_ED_GAIN, SetParamListelmFromGui)
ON_BN_CLICKED(IDC_CH_PLEFT, SetParamListelmFromGui)
ON_BN_CLICKED(IDC_CH_PRIGHT, SetParamListelmFromGui)
ON_WM_SYSCOMMAND()
ON_MENUXP_MESSAGES()
ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEqualizerDlg message handlers

void CEqualizerDlg::DoDataExchange(CDataExchange* pDX)
{
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_BUT_PNEW, m_btnNew);
    DDX_Control(pDX, IDC_BUT_PDEL, m_btnDelete);
    DDX_Control(pDX, IDC_BUT_LOAD, m_btnLoad);
    DDX_Control(pDX, IDC_BUT_SAVE, m_btnSave);
    DDX_Control(pDX, IDC_BUT_UP, m_btnUp);
    DDX_Control(pDX, IDC_BUT_DOWN, m_btnDown);
    DDX_Control(pDX, IDOK, m_btnOk);
    DDX_Control(pDX, IDCANCEL, m_btnCancel);
    DDX_Control(pDX, IDC_CH_PRIGHT, m_chPright2);
    DDX_Control(pDX, IDC_CH_PLEFT, m_chPleft2);
    DDX_Control(pDX, IDC_LIST_PARAM, m_listParam);
    DDX_Control(pDX, IDC_ED_PUP, m_editPup);
    DDX_Control(pDX, IDC_ED_PLOW, m_editPlow);
    DDX_Control(pDX, IDC_ED_GAIN, m_editGain);
    DDX_Control(pDX, IDC_BUT_APPLY, m_btnApply);
    DDX_Control(pDX, IDC_ED_TARGET, m_editTarget);
    DDX_Control(pDX, IDC_SL_RPRE, m_r[0]);
    DDX_Control(pDX, IDC_SL_R1,   m_r[1]);
    DDX_Control(pDX, IDC_SL_R2,   m_r[2]);
    DDX_Control(pDX, IDC_SL_R3,   m_r[3]);
    DDX_Control(pDX, IDC_SL_R4,   m_r[4]);
    DDX_Control(pDX, IDC_SL_R5,   m_r[5]);
    DDX_Control(pDX, IDC_SL_R6,   m_r[6]);
    DDX_Control(pDX, IDC_SL_R7,   m_r[7]);
    DDX_Control(pDX, IDC_SL_R8,   m_r[8]);
    DDX_Control(pDX, IDC_SL_R9,   m_r[9]);
    DDX_Control(pDX, IDC_SL_R10,  m_r[10]);
    DDX_Control(pDX, IDC_SL_R11,  m_r[11]);
    DDX_Control(pDX, IDC_SL_R12,  m_r[12]);
    DDX_Control(pDX, IDC_SL_R13,  m_r[13]);
    DDX_Control(pDX, IDC_SL_R14,  m_r[14]);
    DDX_Control(pDX, IDC_SL_R15,  m_r[15]);
    DDX_Control(pDX, IDC_SL_R16,  m_r[16]);
    DDX_Control(pDX, IDC_SL_R17,  m_r[17]);
    DDX_Control(pDX, IDC_SL_R18,  m_r[18]);
    DDX_Control(pDX, IDC_SL_LPRE, m_l[0]);
    DDX_Control(pDX, IDC_SL_L1,   m_l[1]);
    DDX_Control(pDX, IDC_SL_L2,   m_l[2]);
    DDX_Control(pDX, IDC_SL_L3,   m_l[3]);
    DDX_Control(pDX, IDC_SL_L4,   m_l[4]);
    DDX_Control(pDX, IDC_SL_L5,   m_l[5]);
    DDX_Control(pDX, IDC_SL_L6,   m_l[6]);
    DDX_Control(pDX, IDC_SL_L7,   m_l[7]);
    DDX_Control(pDX, IDC_SL_L8,   m_l[8]);
    DDX_Control(pDX, IDC_SL_L9,   m_l[9]);
    DDX_Control(pDX, IDC_SL_L10,  m_l[10]);
    DDX_Control(pDX, IDC_SL_L11,  m_l[11]);
    DDX_Control(pDX, IDC_SL_L12,  m_l[12]);
    DDX_Control(pDX, IDC_SL_L13,  m_l[13]);
    DDX_Control(pDX, IDC_SL_L14,  m_l[14]);
    DDX_Control(pDX, IDC_SL_L15,  m_l[15]);
    DDX_Control(pDX, IDC_SL_L16,  m_l[16]);
    DDX_Control(pDX, IDC_SL_L17,  m_l[17]);
    DDX_Control(pDX, IDC_SL_L18,  m_l[18]);
    DDX_Check(pDX, IDC_CH_LOCK, m_chLock);
    extern int enable, dither;
    DDX_Check(pDX, IDC_ENABLE, enable);
    DDX_Check(pDX, IDC_CH_DITHER, dither);
    DDX_Check(pDX, IDC_CH_PLEFT, m_chPleft);
    DDX_Check(pDX, IDC_CH_PRIGHT, m_chPright);
}

void CEqualizerDlg::SortParam()
{
    paramlistelm* selelm = NULL,* lastelm = NULL;
    int sel = m_listParam.GetCurSel();
    if (sel != LB_ERR)
        selelm = (paramlistelm *)m_listParam.GetItemDataPtr(sel);
    if (last_param_index != -1)
        lastelm = (paramlistelm *)m_listParam.GetItemDataPtr(last_param_index);

    m_listParam.ResetContent();
    paramroot.sortelm();

    for (paramlistelm* e = paramroot.elm; e != NULL; e = e->next)
    {
        int indx = m_listParam.AddString(e->getString());
        m_listParam.SetItemDataPtr(indx, e);
        if (selelm == e)
            sel = indx;
        if (lastelm == e)
            last_param_index = indx;
    }

    if (sel != LB_ERR)
    {
        m_listParam.SetCurSel(sel);
    }
}

void CEqualizerDlg::SetParamListelmFromGui()
{
    UpdateData(TRUE);
    
    int sel = m_listParam.GetCurSel();
    paramlistelm* e = (paramlistelm*)m_listParam.GetItemDataPtr(last_param_index);

    e->left = m_chPleft2.GetCheck();   
    e->right = m_chPright2.GetCheck(); 

    CString str;
    m_editPup.GetWindowText(str);
    e->upper = (float)_tstof(str);
    m_editPlow.GetWindowText(str);
    e->lower = (float)_tstof(str);
    m_editGain.GetWindowText(str);
    e->gain = (float)_tstof(str);

    m_listParam.DeleteString(last_param_index);
    m_listParam.InsertString(last_param_index, e->getString());
    m_listParam.SetItemDataPtr(last_param_index, e);

    m_listParam.SetCurSel(sel);

    SortParam();
}

void CEqualizerDlg::SetGuiFromParamListeLm(int index)
{
    if (index == -1)
    {
        m_editPlow.SetWindowText(_T(""));
        m_editPup.SetWindowText(_T(""));
        m_editGain.SetWindowText(_T(""));
        m_chPleft = FALSE;
        m_chPright = FALSE;
        m_editPlow.EnableWindow(FALSE);
        m_editPup.EnableWindow(FALSE);
        m_editGain.EnableWindow(FALSE);
        m_chPleft2.SetCheck(FALSE);
        m_chPleft2.EnableWindow(FALSE);
        m_chPright2.SetCheck(FALSE);
        m_chPright2.EnableWindow(FALSE);
        return;
    }

    int sel = m_listParam.GetCurSel();
    paramlistelm* e = (paramlistelm*)m_listParam.GetItemDataPtr(index);

    m_chPleft2.SetCheck(e->left);
    m_chPright2.SetCheck(e->right);

    CString str;
    str.Format(_T("%.10g"), e->upper);
    m_editPup.SetWindowText(str);

    str.Format(_T("%.10g"), e->lower);
    m_editPlow.SetWindowText(str);

    str.Format(_T("%.10g"), e->gain);
    m_editGain.SetWindowText(str);

    m_listParam.SetCurSel(sel);

    m_editPlow.EnableWindow(TRUE);
    m_editPup.EnableWindow(TRUE);
    m_editGain.EnableWindow(TRUE);
    m_chPleft2.EnableWindow(TRUE);
    m_chPright2.EnableWindow(TRUE);
}

void CEqualizerDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
    int i, l, r;

    l = m_l[0].GetPos();
    r = m_r[0].GetPos();

    if (lslpos[0] != l)
    {
        CString str;
        if (l == 96)
            str = m_Helper.MyLoadString(IDS_LPREAMPCUT);
        else
            str.Format(m_Helper.MyLoadString(IDS_LPREAMPDB), -l);
        m_editTarget.SetWindowText(str);
    }

    if (rslpos[0] != r)
    {
        CString str;
        if (r == 96)
            str = m_Helper.MyLoadString(IDS_RPREAMPCUT);
        else
            str.Format(m_Helper.MyLoadString(IDS_RPREAMPDB), -r);
        m_editTarget.SetWindowText(str);
    }

    if (m_chLock)
    {
        if (lslpos[0] != l)
        {
            r = l;
            m_r[0].SetPos(l);
        }
        if (rslpos[0] != r)
        {
            l = r;
            m_l[0].SetPos(r);
        }
    }

    lslpos[0] = l;
    rslpos[0] = r;

    for (i = 0; i < 18; i++)
    {
        l = m_l[i + 1].GetPos();
        r = m_r[i + 1].GetPos();

        if (lslpos[i + 1] != l)
        {
            CString str;
            if (l == 96)
                str.Format(m_Helper.MyLoadString(IDS_LHZCUT), freqs[i]);
            else
                str.Format(m_Helper.MyLoadString(IDS_LHZDB), freqs[i], -l);
            m_editTarget.SetWindowText(str);
        }

        if (rslpos[i + 1] != r)
        {
            CString str;
            if (r == 96)
                str.Format(m_Helper.MyLoadString(IDS_RHZCUT), freqs[i]);
            else
                str.Format(m_Helper.MyLoadString(IDS_RHZDB), freqs[i], -r);
            m_editTarget.SetWindowText(str);
        }

        if (m_chLock)
        {
            if (lslpos[i + 1] != l)
            {
                r = l;
                m_r[i + 1].SetPos(l);
            }
            if (rslpos[i + 1] != r)
            {
                l = r;
                m_l[i + 1].SetPos(r);
            }
        }

        lslpos[i + 1] = l;
        rslpos[i + 1] = r;
    }

    CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CEqualizerDlg::OnBtnLoad()
{
    CFileDialog filedialog(TRUE, _T("eq"), _T(""), OFN_FILEMUSTEXIST, m_Helper.MyLoadString(IDS_OPENEQ));

    if (filedialog.DoModal() == IDCANCEL)
    {
        return;
    }

    loadFromFilename(filedialog.GetPathName());

    for (int i = 0; i < 19; i++)
    {
        m_l[i].SetPos(lslpos[i]);
        m_r[i].SetPos(rslpos[i]);
    }

    m_listParam.ResetContent();

    for (paramlistelm* e = paramroot.elm; e != NULL; e = e->next)
    {
        int indx = m_listParam.AddString(e->getString());
        m_listParam.SetItemDataPtr(indx, e);
    }

    SetBandsFromSlpos();
}

void CEqualizerDlg::OnBtnOk()
{
    CDialog::OnOK();

    for (int i = 0; i < 19; i++)
    {
        last_lslpos[i] = lslpos[i];
        last_rslpos[i] = rslpos[i];
    }

    lastparamroot.copy(paramroot);
}

void CEqualizerDlg::OnBtnSave()
{
    CFileDialog filedialog(TRUE, _T("eq"), _T(""), OFN_OVERWRITEPROMPT, m_Helper.MyLoadString(IDS_OPENEQ));

    SetBandsFromSlpos();

    if (filedialog.DoModal() == IDCANCEL)
    {
        return;
    }

    CStdioFile f;

    if (!f.Open(filedialog.GetPathName(), CFile::modeCreate | CFile::modeWrite))
    {
        ::MessageBox(NULL, m_Helper.MyLoadString(IDS_CANTOPEN), _T("STP"), MB_OK | MB_ICONEXCLAMATION);
        // error
        return;
    }

    CStringArray* buf = SaveTo();

    for (int i = 0; i < buf->GetSize(); i++)
    {
        f.WriteString(buf->GetAt(i));
    }
    delete buf;
    f.Close();
}

BOOL CEqualizerDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS - ASC_SUBCLASS_SLIDER, 0L);

    m_Helper.translateWindowText(this, IDD_EQUALIZER);
    m_Helper.translateDlgItemText(this, IDC_GRAPHIC_EQUALIZER);
    m_Helper.translateDlgItemText(this, IDC_LLEFT);
    m_Helper.translateDlgItemText(this, IDC_LRIGHT);
    m_Helper.translateDlgItemText(this, IDC_CH_LOCK);
    m_Helper.translateDlgItemText(this, IDC_BUT_UP);
    m_Helper.translateDlgItemText(this, IDC_BUT_DOWN);
    m_Helper.translateDlgItemText(this, IDC_BUT_LOAD);
    m_Helper.translateDlgItemText(this, IDC_BUT_SAVE);
    m_Helper.translateDlgItemText(this, IDC_BUT_APPLY);
    m_Helper.translateDlgItemText(this, IDCANCEL);
    m_Helper.translateDlgItemText(this, IDC_ENABLE);
    m_Helper.translateDlgItemText(this, IDC_CH_DITHER);
    m_Helper.translateDlgItemText(this, IDC_LPARAMETRIC_EQUALIZER);
    m_Helper.translateDlgItemText(this, IDC_BUT_PNEW);
    m_Helper.translateDlgItemText(this, IDC_BUT_PDEL);
    m_Helper.translateDlgItemText(this, IDC_CH_PLEFT);
    m_Helper.translateDlgItemText(this, IDC_CH_PRIGHT);
    m_Helper.translateDlgItemText(this, IDC_LLOW_FREQ);
    m_Helper.translateDlgItemText(this, IDC_LUPPER_FREQ);
    m_Helper.translateDlgItemText(this, IDC_LGAIN);
    m_Helper.translateDlgItemText(this, IDC_LHZ1);
    m_Helper.translateDlgItemText(this, IDC_LHZ2);
    m_Helper.translateDlgItemText(this, IDC_LDB);
    m_Helper.translateDlgItemText(this, IDC_LCHANNEL);

    SetIcon(s_mainWnd.m_stpIcon, TRUE);
    SetIcon(s_mainWnd.m_stpIconSm, FALSE);

    CRect workAreaRect, windowRect;

    workAreaRect.left = 0;
    workAreaRect.right = GetSystemMetrics(SM_CXVIRTUALSCREEN);
    workAreaRect.top = 0;
    workAreaRect.bottom = GetSystemMetrics(SM_CYVIRTUALSCREEN);

    GetWindowRect(&windowRect);
    if (s_mainWnd.m_equalizerRect.left == -1000)
        s_mainWnd.m_equalizerRect.left = (workAreaRect.right - windowRect.Width()) / 2;
    if (s_mainWnd.m_equalizerRect.top == -1000)
        s_mainWnd.m_equalizerRect.top = (workAreaRect.bottom - windowRect.Height()) / 2;
    if (s_mainWnd.m_equalizerRect.left < 0)
        s_mainWnd.m_equalizerRect.left = 0;
    if (s_mainWnd.m_equalizerRect.top < 0)
        s_mainWnd.m_equalizerRect.top = 0;
    if (s_mainWnd.m_equalizerRect.left + windowRect.Width() > workAreaRect.right)
        s_mainWnd.m_equalizerRect.left = workAreaRect.right - windowRect.Width();
    if (s_mainWnd.m_equalizerRect.top + windowRect.Height() > workAreaRect.bottom)
        s_mainWnd.m_equalizerRect.top = workAreaRect.bottom - windowRect.Height();
    SetWindowPos(NULL, s_mainWnd.m_equalizerRect.left, s_mainWnd.m_equalizerRect.top, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        pSysMenu->AppendMenu(MF_SEPARATOR);
        pSysMenu->AppendMenu(MF_STRING, 9999, m_Helper.MyLoadString(IDS_ALWAYSONTOP));
        if (s_mainWnd.m_eQOnTop)
        {
            pSysMenu->CheckMenuItem(9999, MF_BYCOMMAND | MF_CHECKED);
            ModifyStyleEx(WS_EX_APPWINDOW, 0);
            SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
        }
        else
        {
            pSysMenu->CheckMenuItem(9999, MF_BYCOMMAND | MF_UNCHECKED);
            ModifyStyleEx(0, WS_EX_APPWINDOW);
            SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
        }
    }

    m_hHandCur = ::LoadCursor(NULL, MAKEINTRESOURCE(IDC_HAND));

    m_chLock = TRUE;
    for (int i = 0; i < 19; i++)
    {
        CString lFirstMessage;
        CString rFirstMessage;
        CString lSecondMessage;
        CString rSecondMessage;
        if (i == 0)
        {
            lFirstMessage = m_Helper.MyLoadString(IDS_LPREAMPCUT);
            lSecondMessage = m_Helper.MyLoadString(IDS_LPREAMPDB);
            rFirstMessage = m_Helper.MyLoadString(IDS_RPREAMPCUT);
            rSecondMessage = m_Helper.MyLoadString(IDS_RPREAMPDB);
        }
        else
        {
            lFirstMessage = m_Helper.MyLoadString(IDS_LHZCUT);
            lSecondMessage = m_Helper.MyLoadString(IDS_LHZDB);
            rFirstMessage = m_Helper.MyLoadString(IDS_RHZCUT);
            rSecondMessage = m_Helper.MyLoadString(IDS_RHZDB);
        }

        InitCursor(&m_l[i]);
        m_l[i].SetMessage(freqs[i], lFirstMessage, lSecondMessage);
        m_l[i].SetPos(lslpos[i]);
        last_lslpos[i] = lslpos[i];

        InitCursor(&m_r[i]);
        m_r[i].SetMessage(freqs[i], rFirstMessage, rSecondMessage);
        m_r[i].SetPos(rslpos[i]);
        last_rslpos[i] = rslpos[i];
        if(lslpos[i] != rslpos[i])
            m_chLock = TRUE;
    }

    for (paramlistelm* e = paramroot.elm; e != NULL; e = e->next)
    {
        int indx = m_listParam.AddString(e->getString());
        m_listParam.SetItemDataPtr(indx, e);
    }

    last_param_index = -1;

    SetGuiFromParamListeLm(-1);

    lastparamroot.copy(paramroot);

    m_editTarget.SetWindowText(_T(""));

    UpdateData(FALSE);

    return TRUE;
}

void CEqualizerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if (nID == 9999)
    {
        DWORD dwStyle = GetWindowLong(m_hWnd, GWL_STYLE);
        if (s_mainWnd.m_eQOnTop)
        {
            GetSystemMenu(FALSE)->CheckMenuItem(9999, MF_BYCOMMAND | MF_UNCHECKED);
            ShowWindow(SW_HIDE);
            ModifyStyleEx(0, WS_EX_APPWINDOW);
            SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
            ShowWindow(SW_SHOW);
            s_mainWnd.m_eQOnTop = FALSE;
        }
        else
        {
            GetSystemMenu(FALSE)->CheckMenuItem(9999, MF_BYCOMMAND | MF_CHECKED);
            ShowWindow(SW_HIDE);
            ModifyStyleEx(WS_EX_APPWINDOW, 0);
            SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
            ShowWindow(SW_SHOW);
            s_mainWnd.m_eQOnTop = TRUE;
        }
        dwStyle = GetWindowLong(m_hWnd, GWL_EXSTYLE);
    }
    else
        CDialog::OnSysCommand(nID, lParam);
}

void CEqualizerDlg::InitCursor(CBitSlider* slider)
{
    slider->SetFlipCursor(m_hHandCur);
    slider->BuildThumbItem(IDB_VERTICAL_THUMB, 12, 6);
    slider->BuildBackItem(IDB_VERTICAL_NORMAL, IDB_VERTICAL_ACTIVE);
    slider->SetLeftOffset(3);
    slider->SetTopOffset(3);
    slider->SetRangeMin(0);
    slider->SetRangeMax(96);
    slider->SetLineSize(0);
}

void CEqualizerDlg::OnChEnable()
{
    UpdateData(TRUE);
}

void CEqualizerDlg::OnBtnUp()
{
    for (int i = 1; i < 19; i++)
        if (lslpos[i] == 0 || rslpos[i] == 0)
            return;

    for (int i = 1; i < 19; i++)
    {
        lslpos[i]--;
        rslpos[i]--;
        m_l[i].SetPos(lslpos[i]);
        m_r[i].SetPos(rslpos[i]);
    }
}

void CEqualizerDlg::Save()
{
    CRect rect;
    GetWindowRect(&rect);
    s_mainWnd.m_equalizerRect.left = rect.left;
    s_mainWnd.m_equalizerRect.top = rect.top;
}

void CEqualizerDlg::OnBtnDown()
{
    for (int i = 1; i < 19; i++)
        if (lslpos[i] == 96 || rslpos[i] == 96)
            return;

    for (int i = 1; i < 19; i++)
    {
        lslpos[i]++;
        rslpos[i]++;
        m_l[i].SetPos(lslpos[i]);
        m_r[i].SetPos(rslpos[i]);
    }
}


void CEqualizerDlg::OnBtnApply()
{
    SetBandsFromSlpos();
}

void CEqualizerDlg::OnDestroy()
{
    CDialog::OnDestroy();

    int i;

    for (i = 0; i < 19; i++)
    {
        lslpos[i] = last_lslpos[i];
        rslpos[i] = last_rslpos[i];
    }

    paramroot.copy(lastparamroot);

    SetBandsFromSlpos();
}

void CEqualizerDlg::OnBtnPnew()
{
    paramlistelm* e = paramroot.newelm();
    int indx = m_listParam.AddString(e->getString());
    m_listParam.SetItemDataPtr(indx, e);

    last_param_index = indx;

    SetGuiFromParamListeLm(indx);
    m_listParam.SetCurSel(indx);
}

void CEqualizerDlg::OnBtnPdel()
{
    int indx = m_listParam.GetCurSel();
    if (indx == LB_ERR)
        return;
    paramlistelm* e = (paramlistelm*)m_listParam.GetItemDataPtr(indx);
    m_listParam.DeleteString(indx);
    paramroot.delelm(e);

    last_param_index = -1;
    SetGuiFromParamListeLm(-1);
}

void CEqualizerDlg::Display(CString mes)
{
    m_editTarget.SetWindowText(mes);
}

void CEqualizerDlg::OnSelchangeListParam()
{
    UpdateData(TRUE);

    if (last_param_index != -1)
        SetParamListelmFromGui();

    last_param_index = m_listParam.GetCurSel();
    if (last_param_index == LB_ERR)
        last_param_index = -1;
   
    SetGuiFromParamListeLm(last_param_index);
}

void CEqualizerDlg::OnBnClickedCancel()
{
    CDialog::OnCancel();
}
