#ifndef EQUALIZERDLG_H
#define EQUALIZERDLG_H

#include "MenuXP.h"
#include "ButtonXP.h"
#include "BitSlider.h"

void loadFrom(CStringArray listString);
void loadFromFilename(CString filename);

/////////////////////////////////////////////////////////////////////////////
// CEqualizerDlg dialog

class CEqualizerDlg : public CDialog
{
public:
    CEqualizerDlg();
    ~CEqualizerDlg();
    void Display(CString mes);
    void SetParamListelmFromGui();
    void SetGuiFromParamListeLm(int);
    void SortParam();
    afx_msg void OnBnClickedCancel();
    void Save();

    enum
    {
        IDD = IDD_EQUALIZER
    };

private:
    HCURSOR m_hHandCur;
    CEdit m_editAutoLoad;
    CButtonXP m_btnNew;
    CButtonXP m_btnDelete;
    CButtonXP m_btnLoad;
    CButtonXP m_btnSave;
    CButtonXP m_btnUp;
    CButtonXP m_btnDown;
    CButtonXP m_btnOk;
    CButtonXP m_btnCancel;
    CButton m_chPright2;
    CButton m_chPleft2;
    CListBox m_listParam;
    CEdit m_editPup;
    CEdit m_editPlow;
    CEdit m_editGain;
    CButtonXP m_btnApply;
    CEdit m_editTarget;
    BOOL m_chLock;
    BOOL m_chPleft;
    BOOL m_chPright;
    int last_lslpos[19];
    int last_rslpos[19];
    int last_param_index;
    CBitSlider m_l[19];
    CBitSlider m_r[19];

protected:
    virtual void DoDataExchange(CDataExchange* pDX);
    afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
    afx_msg void OnBtnLoad();
    afx_msg void OnBtnOk();
    afx_msg void OnBtnSave();
    virtual BOOL OnInitDialog();
    afx_msg void OnChEnable();
    afx_msg void OnBtnUp();
    afx_msg void OnBtnDown();
    afx_msg void OnBtnApply();
    afx_msg void OnDestroy();
    afx_msg void OnBtnPnew();
    afx_msg void OnBtnPdel();
    afx_msg void OnSelchangeListParam();
    afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
    void InitCursor(CBitSlider* slider);
    DECLARE_MESSAGE_MAP()
    DECLARE_MENUXP()
};

#endif
