#ifndef STANDARDOUTPUTCONFIG_H
#define STANDARDOUTPUTCONFIG_H
#include "audio.h"
#include "ComboBoxXP.h"

BOOL CALLBACK config_proc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

class CConfigOutputDialog : public CPropertyPage
{
    DECLARE_DYNAMIC(CConfigOutputDialog)
	WNDPROC m_wndproc;
    enum { IDD = IDD_CONFIGDLG };
    CComboBoxXP m_comboDevice;
    CStatic m_labelTotal;
    CStatic m_labelBlocks;
    CStatic m_labelWritten;
    CStatic m_labelPlayed;
    CStatic m_labelStart;
    CStatic m_labelLatency;
    CStatic m_labelFormat;
    CStatic m_labelConv;
    CStatic m_labelSize;
    CStatic m_labelCount;
    CProgressCtrl m_progressUsage;
    CSliderCtrl m_blockCount;
    CSliderCtrl m_blockSize;

public:
    CConfigOutputDialog();
    virtual ~CConfigOutputDialog();
	virtual WNDPROC* GetSuperWndProcAddr();
    int timer_slow;
    stats_t stats;
    BOOL volume_enabled;
    BOOL reverse_balance;
    BOOL pcmconv_enabled;

protected:
    virtual void DoDataExchange(CDataExchange* pDX);  // Prise en charge DDX/DDV
    afx_msg BOOL OnInitDialog();
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    DECLARE_MESSAGE_MAP()
public:
    afx_msg void OnOK();
    afx_msg void OnTimer(UINT nIDEvent);
    afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
};

#endif
