#ifndef PLAYLISTDLG_H
#define PLAYLISTDLG_H

#include "MenuXP.h"
#include "QArray.h"
#include "PlaylistManager.h"

class CSrchEdit : public CEdit
{
protected:
    afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
    DECLARE_MESSAGE_MAP()
};

class CPLLB : public CListBox
{

public:
    CPLLB();
    ~CPLLB();
    int GetFirstSelected(int from = 0);

    int m_prev;
    bool m_shiftDown;
    bool m_ctrlDown;

private:
    int m_posfrom;

protected:
    virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
    virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
    afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
    afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
    afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg void OnPaint();
    afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
    DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CPlaylistDlg dialog

class CPlaylistDlg : public CDialog
{
public:
    CPlaylistDlg();
    ~CPlaylistDlg();
    void ShowFileName();
    void ShowTimes();
    void Save();
    void PlayTheFile(int fnum);
    void Remove(bool RAll = false, bool FromDisk = false);
    bool StopRemovene();
    bool StopRemoveDuplicateEntries();
    bool StopSort();
    afx_msg void OnArrangeRemovene();
    afx_msg void OnArrangeRemoveDuplicateEntries();
    afx_msg void OnArrangeSortEngine(CString sortTemplate = _T(""));
    afx_msg BOOL DestroyWindow();
    void SortThread();
    void RemoveneThread();
    void RemoveDuplicateEntriesThread();
    void ReloadMenu();

    enum
    {
        IDD = IDD_PLAYLIST
    };

    CPLLB m_playlistAt;
    CSortedArray<CachedTag, CachedTag&>* m_cachedPlaylistTags;
    HANDLE m_sortThreadHan;
    HANDLE m_removeneThreadHan;
    HANDLE m_removeDuplicateEntriesThreadHan;

private:
    CEdit m_filename;
    CSrchEdit m_search;
    HACCEL m_accel;
    CMenu m_menu;
    BOOL m_canResize;
    UINT m_totalTime;
    CString m_playingFile;
    CCritSec m_critSec;

protected:
    void ResizeWindow();
    void FillPlaylist();
    void PlaylistSave(bool saveall = true);
    virtual BOOL PreTranslateMessage(MSG* pMsg);

    virtual void DoDataExchange(CDataExchange* pDX);
    afx_msg void OnStopAll();
    afx_msg void OnArrangeSort();
    afx_msg void OnArrangeShuffle();
    afx_msg void OnArrangeSortByFilename();
    afx_msg void OnArrangeSortByTemplate();
    afx_msg void OnChangeSearch();
    afx_msg void OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnDropFiles(HDROP hDropInfo);
    afx_msg void OnEnterMenuLoop(BOOL bIsTrackPopupMenu);
    afx_msg void OnExitMenuLoop(BOOL bIsTrackPopupMenu);
    afx_msg void OnFileAddFile();
    afx_msg void OnFileAddFolder();
    afx_msg void OnFileEditTag();
    afx_msg void OnFileRemove();
    afx_msg void OnFileSaveInExtendedFormat();
    virtual BOOL OnInitDialog();
    afx_msg void OnKillFocusPlaylistAt();
    virtual void OnOK();
    afx_msg void OnPlaylistOpen();
    afx_msg void OnPlaylistSave();
    afx_msg void OnPopupSelectAll();
    afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
    afx_msg void OnTracksAddPlaylist();
    afx_msg void OnTracksFileManagementCopyTo();
    afx_msg void OnTracksFileManagementDelete();
    afx_msg void OnTracksFileManagementMoveTo();
    afx_msg void OnTracksRemoveAll();
    afx_msg void OnTracksRenameFiles();
    afx_msg void OnTracksReReadAllTags();
    afx_msg void OnTracksSelectionAddToExistentPlaylist();
    afx_msg void OnTracksSelectionCreateNewPlaylist();
    afx_msg void OnTrackMenu(UINT nID);
    afx_msg void OnTrackRefresh();
    DECLARE_MESSAGE_MAP()
    DECLARE_MENUXP()
};

#endif

extern CPlaylistDlg s_playlistDlg;
