// SeekDialog.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "systrayplay.h"
#include "MainWnd.h"
#include "PlaylistDlg.h"
#include "SeekDialog.h"
#include "PlaylistManager.h"
#include "MultiDllInput.h"
#include "WAEmuWnd.h"

#include "Volume.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define POLICENAME _T("Arial")

CTranspBmp::CTranspBmp(bool inverse) : CStatic()
{
    m_inverse = inverse;
}

BEGIN_MESSAGE_MAP(CTranspBmp,CStatic)
    ON_WM_PAINT()
END_MESSAGE_MAP()

void CTranspBmp::Create(WORD idb, int width, int height)
{
    m_width = width;m_height = height;
    bmp = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(idb), IMAGE_BITMAP, m_width, m_height, LR_DEFAULTCOLOR);
}

void CTranspBmp::Delete()
{
    DeleteObject(bmp);
}

void CTranspBmp::OnPaint()
{
    CPaintDC dc(this);
    COLORREF crGradientStart = s_mainWnd.m_skin.startColor;
    COLORREF crGradientEnd = s_mainWnd.m_skin.endColor;

    HDC hDC = CreateCompatibleDC(dc.m_hDC);

    CRect rect;
    GetClientRect(&rect);

    bmp = (HBITMAP)SelectObject(hDC, bmp);

    HDC hdc1 = CreateCompatibleDC(dc.m_hDC);
    HDC hdc2 = CreateCompatibleDC(dc.m_hDC);
    HDC hdc3 = CreateCompatibleDC(dc.m_hDC);
    HDC hdc4 = CreateCompatibleDC(dc.m_hDC);
    HDC hdc5 = CreateCompatibleDC(dc.m_hDC);

    HBITMAP bm1 = CreateBitmap(m_width, m_height, 1, 1, NULL);
    HBITMAP bm2 = CreateBitmap(m_width, m_height, 1, 1, NULL);
    HBITMAP bm3 = CreateCompatibleBitmap(hDC, m_width, m_height);
    HBITMAP bm4 = CreateCompatibleBitmap(hDC, m_width, m_height);
    HBITMAP bm5 = CreateCompatibleBitmap(hDC, m_width, m_height);

    SelectObject(hdc1, bm1);
    SelectObject(hdc2, bm2);
    SelectObject(hdc3, bm3);
    SelectObject(hdc4, bm4);
    SelectObject(hdc5, bm5);

    //Image Original
    COLORREF cColor = SetBkColor(hDC, RGB(255, 0, 255));
    BitBlt(hdc1, 0, 0, m_width, m_height, hDC, 0, 0, SRCCOPY);
    //Image invers
    BitBlt(hdc2, 0, 0, m_width, m_height, hdc1, 0, 0, NOTSRCCOPY);
    SetBkColor(hDC, cColor);
    if (!s_mainWnd.m_skin.xpLookNFeel)
        CDC::FromHandle(hdc5)->FillSolidRect(0, 0, m_width, m_height, GetSysColor(COLOR_BTNFACE));
    else if (m_inverse)
        s_mainWnd.DrawGradient(CDC::FromHandle(hdc5), crGradientEnd, crGradientStart, CRect(0, 0, m_width, m_height));
    else
        s_mainWnd.DrawGradient(CDC::FromHandle(hdc5), crGradientStart, crGradientEnd, CRect(0, 0, m_width, m_height));
    StretchBlt(hdc3, 0, 0, m_width, m_height, hdc5, 0, 0, m_width, m_height, SRCCOPY);
    StretchBlt(hdc4, 0, 0, m_width, m_height, hDC, 0, 0, m_width, m_height, SRCCOPY);
    //Fond Orignal
    //Et entre Image invers et fond
    BitBlt(hdc3, 0, 0, m_width, m_height, hdc1, 0, 0, SRCAND);      
    BitBlt(hdc4, 0, 0, m_width, m_height, hdc2, 0, 0, SRCAND);      
    //Ou entre les 2 images obtenu
    BitBlt(hdc4, 0, 0, m_width, m_height, hdc3, 0, 0, SRCPAINT);
    BitBlt(hdc5, 0, 0, m_width, m_height, hdc4, 0, 0, SRCCOPY);
    BitBlt(dc.m_hDC, 0, 0, m_width, m_height, hdc5, 0, 0, SRCCOPY);

    DeleteDC(hdc1);
    DeleteDC(hdc2);
    DeleteDC(hdc3);
    DeleteDC(hdc4);
    DeleteDC(hdc5);
    DeleteObject(bm1);
    DeleteObject(bm2);
    DeleteObject(bm3);
    DeleteObject(bm4);
    DeleteObject(bm5);

    bmp = (HBITMAP)SelectObject(hDC, bmp);

    DeleteDC(hDC);
}

CMyPrBar::CMyPrBar() : CProgressCtrl()
{
    m_scrollFlag = false;
}

BEGIN_MESSAGE_MAP(CMyPrBar,CProgressCtrl)
    ON_WM_LBUTTONDOWN()
    ON_WM_LBUTTONUP()
    ON_WM_RBUTTONUP()
    ON_WM_MOUSEMOVE()
    ON_WM_PAINT()
END_MESSAGE_MAP()

void CMyPrBar::SetCurrentSong(CString currentSong)
{
    m_currentSong = currentSong;
}

void CMyPrBar::SetCurrentTime(int trackTime, int totalTime)
{
    SetRange(0, totalTime);
    SetPos(trackTime);
    if (s_mainWnd.m_showTTT)
        m_currentTime.Format(_T("%02d:%02d/%02d:%02d"), s_mainWnd.m_showRemainingTime ? (int)((totalTime - trackTime) / 60) : trackTime / 60, s_mainWnd.m_showRemainingTime ? ((totalTime - trackTime) % 60) : trackTime % 60, totalTime / 60, totalTime % 60);
    else
        m_currentTime.Format(_T("%02d:%02d"), s_mainWnd.m_showRemainingTime ? (int)((totalTime - trackTime) / 60) : trackTime / 60, s_mainWnd.m_showRemainingTime ? ((totalTime - trackTime) % 60) : trackTime % 60);
}

bool CMyPrBar::isScrollFlag()
{
    return m_scrollFlag;
}

void CMyPrBar::OnLButtonDown(UINT nFlags, CPoint point)
{
    if (stdIn.isSeekable())
    {
        m_scrollFlag = true;
        CRect rect;
        GetClientRect(&rect);
        int newpos = (int)((point.x >= 0 ? (point.x < rect.Width() ? point.x : rect.Width()) : 0) * s_mainWnd.m_trackDurI / rect.Width());
        SetCurrentTime(newpos, s_mainWnd.m_trackDurI);

        SetCapture();
    }
}

void CMyPrBar::OnLButtonUp(UINT nFlags, CPoint point)
{
    if (m_scrollFlag && stdIn.isSeekable())
    {
        CRect rect;
        GetClientRect(&rect);
        int newpos = (int)((point.x >= 0 ? (point.x < rect.Width() ? point.x : rect.Width()) : 0) * s_mainWnd.m_trackDurI / rect.Width());
        stdIn.SetOutputTime(newpos * 1000);
        m_scrollFlag = false;
        ::ReleaseCapture();
    }
}

void CMyPrBar::OnMouseMove(UINT nFlags, CPoint point)
{
    if ((nFlags & MK_LBUTTON) && m_scrollFlag && stdIn.isSeekable())
    {
        CRect rect;
        GetClientRect(&rect);
        int newpos = (int)((point.x >= 0 ? (point.x < rect.Width() ? point.x : rect.Width()) : 0) * s_mainWnd.m_trackDurI / rect.Width());
        SetCurrentTime(newpos, s_mainWnd.m_trackDurI);
        SetPos(newpos);
    }
}

void CMyPrBar::OnPaint()
{
    CPaintDC dc(this);

    COLORREF crGradientStart = s_mainWnd.m_skin.startColor;
    COLORREF crGradientEnd = s_mainWnd.m_skin.endColor;

    if (!s_mainWnd.m_skin.xpLookNFeel)
    {
        crGradientStart = ::GetSysColor(COLOR_MENUTEXT);
        crGradientEnd = ::GetSysColor(COLOR_BTNFACE);
    }

    CRect clientRect;
    GetClientRect(clientRect);
    
    HDC hdc1 = CreateCompatibleDC(dc.m_hDC);
    HBITMAP bm1 = CreateCompatibleBitmap(dc.m_hDC, clientRect.Width(), clientRect.Height());
    SelectObject(hdc1, bm1);

    int pos = GetPos();
    int minRange, maxRange;
    GetRange(minRange, maxRange);
    CDC::FromHandle(hdc1)->FillSolidRect(clientRect.left + clientRect.Width() * pos / maxRange, clientRect.top, clientRect.Width() - clientRect.Width() * pos / maxRange, clientRect.Height(), crGradientEnd);
    if (s_mainWnd.m_skin.xpLookNFeel)
        CDC::FromHandle(hdc1)->FillSolidRect(clientRect.left, clientRect.top, clientRect.Width() * pos / maxRange, clientRect.Height(), crGradientStart);
    else
        CDC::FromHandle(hdc1)->FillSolidRect(clientRect.left, clientRect.top, clientRect.Width() * pos / maxRange, clientRect.Height(), ::GetSysColor(COLOR_HIGHLIGHT));

    CRect r;

    LOGFONT lfont;
    memset(&lfont, 0, sizeof(LOGFONT));
    lfont.lfCharSet = DEFAULT_CHARSET;                 // DWORD fdwCharSet
    _tcscpy(lfont.lfFaceName, POLICENAME);
    lfont.lfHeight = 68;
    //lfont.lfWeight = FW_BOLD;
    CFont font;
    font.CreatePointFontIndirect(&lfont);
    CDC::FromHandle(hdc1)->SelectObject(&font);
    CDC::FromHandle(hdc1)->SetBkMode(TRANSPARENT);
    CDC::FromHandle(hdc1)->SetTextColor(crGradientStart);
    if (m_currentSong != _T(""))
    {
        r = clientRect;
        r.left = r.right - (long)((s_mainWnd.m_showTTT ? 6.5 : 3.5) * LOWORD(GetDialogBaseUnits()));
        CDC::FromHandle(hdc1)->DrawText(m_currentTime, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

        if (s_mainWnd.m_skin.xpLookNFeel)
            CDC::FromHandle(hdc1)->SetTextColor(crGradientEnd);
        else
            CDC::FromHandle(hdc1)->SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));

        if (r.right > clientRect.Width() * pos / maxRange)
            r.right = clientRect.Width() * pos / maxRange;
        CDC::FromHandle(hdc1)->DrawText(m_currentTime, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

        CDC::FromHandle(hdc1)->SetTextColor(crGradientStart);

        r = clientRect;
        r.right -= (long)((s_mainWnd.m_showTTT ? 6.5 : 3.5) * LOWORD(GetDialogBaseUnits()));
        CDC::FromHandle(hdc1)->DrawText(m_currentSong, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

        if (s_mainWnd.m_skin.xpLookNFeel)
            CDC::FromHandle(hdc1)->SetTextColor(crGradientEnd);
        else
            CDC::FromHandle(hdc1)->SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));

        if (r.right > clientRect.Width() * pos / maxRange)
            r.right = clientRect.Width() * pos / maxRange;
        if (s_mainWnd.m_skin.xpLookNFeel)
            CDC::FromHandle(hdc1)->SetBkColor(crGradientStart);
        CDC::FromHandle(hdc1)->DrawText(m_currentSong, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
    }
    else
    {
        r = clientRect;
        CDC::FromHandle(hdc1)->DrawText(_T("STP MP3 player"), -1, &r, DT_CENTER | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
    }

    GetClientRect(clientRect);
    BitBlt(dc.m_hDC, clientRect.left, clientRect.top, clientRect.Width(), clientRect.Height(), hdc1, 0, 0, SRCCOPY);
    DeleteDC(hdc1);
    DeleteObject(bm1);
}

void CMyPrBar::OnRButtonUp(UINT nFlags, CPoint point)
{
    if (!m_scrollFlag)
        s_mainWnd.ShowPopup(2);
}

CMyPrBarVol::CMyPrBarVol() : CProgressCtrl()
{
    m_scrollFlag = false;
}

BEGIN_MESSAGE_MAP(CMyPrBarVol,CProgressCtrl)
    ON_WM_LBUTTONDOWN()
    ON_WM_LBUTTONUP()
    ON_WM_RBUTTONUP()
    ON_WM_MOUSEMOVE()
    ON_WM_PAINT()
END_MESSAGE_MAP()

void CMyPrBarVol::OnLButtonDown(UINT nFlags, CPoint point)
{
    m_scrollFlag = true;
    CRect rect;
    GetClientRect(&rect);
    DWORD currentVolume = (DWORD)((point.x >= 0 ? (point.x < rect.Width() ? point.x : rect.Width()) : 0) * 255 / rect.Width());
    SetPos(currentVolume);

    SetCapture();
    s_volume.SetCurrentVolume(currentVolume);
    stdIn.SetVolume(currentVolume);
}

void CMyPrBarVol::OnLButtonUp(UINT nFlags, CPoint point)
{
    if (m_scrollFlag)
    {
        CRect rect;
        GetClientRect(&rect);
        DWORD currentVolume = (DWORD)((point.x >= 0 ? (point.x < rect.Width() ? point.x : rect.Width()) : 0) * 255 / rect.Width());
        SetPos(currentVolume);
        s_volume.SetCurrentVolume(currentVolume);
        stdIn.SetVolume(currentVolume);
        m_scrollFlag = false;
        ::ReleaseCapture();
    }
}

void CMyPrBarVol::OnMouseMove(UINT nFlags, CPoint point)
{
    if (nFlags & MK_LBUTTON && m_scrollFlag)
    {
        CRect rect;
        GetClientRect(&rect);
        DWORD currentVolume = (DWORD)((point.x >= 0 ? (point.x < rect.Width() ? point.x : rect.Width()) : 0) * 255 / rect.Width());
        SetPos(currentVolume);
        s_volume.SetCurrentVolume(currentVolume);
        stdIn.SetVolume(currentVolume);
    }
}

void CMyPrBarVol::OnPaint()
{
    CPaintDC dc(this);

    COLORREF crGradientStart = s_mainWnd.m_skin.startColor;
    COLORREF crGradientEnd = s_mainWnd.m_skin.endColor;

    if (!s_mainWnd.m_skin.xpLookNFeel)
    {
        crGradientStart = ::GetSysColor(COLOR_MENUTEXT);
        crGradientEnd = ::GetSysColor(COLOR_BTNFACE);
    }

    CRect clientRect;
    GetClientRect(clientRect);

    HDC hdc1 = CreateCompatibleDC(dc.m_hDC);
    HBITMAP bm1 = CreateCompatibleBitmap(dc.m_hDC, clientRect.Width(), clientRect.Height());
    SelectObject(hdc1, bm1);

    int pos = GetPos();
    int minRange, maxRange;
    GetRange(minRange, maxRange);
    CDC::FromHandle(hdc1)->FillSolidRect(clientRect.left + clientRect.Width() * pos / maxRange, clientRect.top, clientRect.Width() - clientRect.Width() * pos / maxRange, clientRect.Height(), crGradientEnd);
    if (s_mainWnd.m_skin.xpLookNFeel)
        CDC::FromHandle(hdc1)->FillSolidRect(clientRect.left, clientRect.top, clientRect.Width() * pos / maxRange, clientRect.Height(), crGradientStart);
    else
        CDC::FromHandle(hdc1)->FillSolidRect(clientRect.left, clientRect.top, clientRect.Width() * pos / maxRange, clientRect.Height(), ::GetSysColor(COLOR_HIGHLIGHT));

    CString buf;
    buf.Format(_T("%3d%%"), pos * 100 / 255);

    LOGFONT lfont;
    memset(&lfont, 0, sizeof(LOGFONT));
    lfont.lfCharSet = DEFAULT_CHARSET;                 // DWORD fdwCharSet
    _tcscpy(lfont.lfFaceName, POLICENAME);
    lfont.lfHeight = 68;
    //lfont.lfWeight = FW_BOLD;
    CFont font;
    font.CreatePointFontIndirect(&lfont);
    CDC::FromHandle(hdc1)->SelectObject(&font);
    CDC::FromHandle(hdc1)->SetBkMode(TRANSPARENT);
    CDC::FromHandle(hdc1)->SetTextColor(crGradientStart);

    CRect r = clientRect;
    CDC::FromHandle(hdc1)->DrawText(buf, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

    if (s_mainWnd.m_skin.xpLookNFeel)
        CDC::FromHandle(hdc1)->SetTextColor(crGradientEnd);
    else
        CDC::FromHandle(hdc1)->SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));

    if (r.right > clientRect.Width() * pos / maxRange)
        r.right = clientRect.Width() * pos / maxRange;
     CDC::FromHandle(hdc1)->DrawText(buf, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
    GetClientRect(clientRect);
    BitBlt(dc.m_hDC, clientRect.left, clientRect.top, clientRect.Width(), clientRect.Height(), hdc1, 0, 0, SRCCOPY);
    DeleteDC(hdc1);
    DeleteObject(bm1);
}

void CMyPrBarVol::OnRButtonUp(UINT nFlags, CPoint point)
{
    s_mainWnd.ShowPopup(2);
}


CSeekDialog::CSeekDialog() : CDialog(CSeekDialog::IDD), m_ipe(true), m_mb(false)
{
    m_HDocked = m_VDocked = true;
    m_canResize = FALSE;
}
CSeekDialog::~CSeekDialog()
{
}

BEGIN_MESSAGE_MAP(CSeekDialog, CDialog)
    ON_WM_CLOSE()
    ON_WM_LBUTTONDOWN()
    ON_WM_RBUTTONDOWN()
    ON_WM_RBUTTONUP()
    ON_WM_LBUTTONUP()
    ON_WM_DESTROY()
    ON_WM_TIMER()
    ON_WM_SIZE()
    ON_WM_SHOWWINDOW()
    ON_WM_MOVING()
    ON_WM_SIZING()
    ON_WM_DROPFILES()
    ON_WM_PAINT()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSeekDialog message handlers

void CSeekDialog::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_BAR, m_bar);
    DDX_Control(pDX, IDC_VOL, m_vol);
    DDX_Control(pDX, IDC_FORIEPT, m_ipe);
    DDX_Control(pDX, IDC_FORCONTROLS, m_mb);
}

void CSeekDialog::OnClose()
{
    WAEmuWnd.ShowWindow(SW_HIDE);
    CDialog::OnClose();
}

void CSeekDialog::OnDestroy()
{
    m_ipe.Delete();
    m_mb.Delete();
    m_bar.DestroyWindow();
    m_vol.DestroyWindow();
    CDialog::OnDestroy();
}

void CSeekDialog::OnDropFiles(HDROP hDropInfo)
{
    TCHAR szFileName[_MAX_PATH];
    CString buf;
    UINT nFileCount = ::DragQueryFile(hDropInfo, 0xFFFFFFFF, NULL, 0);
    for (UINT i = 0; i < nFileCount; i++)
    {
        ::DragQueryFile(hDropInfo, i, szFileName, _MAX_PATH);
        buf = szFileName;
        if (::GetFileAttributes(szFileName) & FILE_ATTRIBUTE_DIRECTORY)
        {
            if (buf[buf.GetLength() - 1] != '\\')
                buf += "\\";
            s_mainWnd.FindMP3Files(buf);
        }
        else
        {
            if ((buf.Right(4)).CompareNoCase(_T(".M3U")) == 0 || (buf.Right(4)).CompareNoCase(_T(".PLS")) == 0)
                s_mainWnd.OpenPlaylist(buf, false, false);
            else
                s_playlistManager.Add(buf);
        }
    }

    UINT PLLPrev = s_playlistManager.GetSize();
    if (s_playlistManager.GetSize() > 0)
    {
        if (PLLPrev == 0)
        {
            if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE)
                ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
            if (s_mainWnd.m_shuffleMode)
            {
                s_mainWnd.m_firstInMyRandom = s_mainWnd.MyRandom(true, true);
                s_playlistManager.SetCurrent(s_mainWnd.m_firstInMyRandom);
            }
            else
            {
                s_playlistManager.SetCurrent(0);
                s_mainWnd.m_firstInMyRandom = 0xFFFFFFFF;
            }
            if (s_playlistManager.GetCurrent() < s_playlistManager.GetSize() - 1)
                s_playlistManager.incCurrent();
            else
            {
                s_playlistManager.SetCurrent(0);
            }
            if (s_mainWnd.m_autoPlay)
            {
                enqueueFileWithMetaStructW eFile;
                eFile.filename = (TCHAR *)s_playlistManager.GetPlaylist(s_playlistManager.GetCurrent()).GetString();
                ::SendMessage(WAEmuWnd.m_hWnd, IPC_PLAYFILEW, 0, (WPARAM)&eFile);
            }
            else if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE)
                ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
        }
        if (s_playlistDlg.IsWindowVisible())
        {
            ::SendMessage(s_playlistDlg.m_hWnd, WM_COMMAND, ID_TRACKS_REFRESH, 0);
        }
    }
    ::DragFinish(hDropInfo);
}

BOOL CSeekDialog::OnInitDialog()
{
    CDialog::OnInitDialog();

    SetWindowText(_T("STP MiniBar"));
    ModifyStyleEx(0, WS_EX_ACCEPTFILES);
    ModifyStyleEx(0, WS_EX_TOOLWINDOW);
    SetTimer(1, 100, NULL);

    CRect clientRect, workAreaRect, windowRect;

    workAreaRect.left = 0;
    workAreaRect.right = GetSystemMetrics(SM_CXVIRTUALSCREEN);
    workAreaRect.top = 0;
    workAreaRect.bottom = GetSystemMetrics(SM_CYVIRTUALSCREEN);

    GetWindowRect(&windowRect);
    if (s_mainWnd.m_seekBarRect.left == -1000)
        s_mainWnd.m_seekBarRect.left = (workAreaRect.right - s_mainWnd.m_seekBarRect.right) / 2;
    if (s_mainWnd.m_seekBarRect.right == -1000)
        s_mainWnd.m_seekBarRect.right = s_mainWnd.m_seekBarRect.left + windowRect.Width();
    if (s_mainWnd.m_seekBarRect.top == -1000)
        s_mainWnd.m_seekBarRect.top = workAreaRect.top;
    if (s_mainWnd.m_seekBarRect.left < workAreaRect.left)
        s_mainWnd.m_seekBarRect.left = workAreaRect.left;
    if (s_mainWnd.m_seekBarRect.top < workAreaRect.top)
        s_mainWnd.m_seekBarRect.top = workAreaRect.top;
    if (s_mainWnd.m_seekBarRect.Width() > workAreaRect.right)
        s_mainWnd.m_seekBarRect.left = workAreaRect.right - s_mainWnd.m_seekBarRect.right;
    if (s_mainWnd.m_seekBarRect.top + windowRect.Height() > workAreaRect.bottom)
        s_mainWnd.m_seekBarRect.top = workAreaRect.bottom - windowRect.Height();

    SetWindowPos(&wndTopMost, s_mainWnd.m_seekBarRect.left, s_mainWnd.m_seekBarRect.top, s_mainWnd.m_seekBarRect.Width(), windowRect.Height(), SWP_NOACTIVATE);

    if (s_mainWnd.m_dockSD)
    {
        CRect windowRect, desktopWindowRect, trayWindowRect;
        GetWindowRect(&windowRect);
        ::GetWindowRect(::GetDesktopWindow(), &desktopWindowRect);
        ::GetWindowRect(::FindWindow(_T("Shell_TrayWnd"), NULL), &trayWindowRect);
        SetWindowPos(NULL, (workAreaRect.right - 400) / 2, (trayWindowRect.bottom < desktopWindowRect.bottom) ? workAreaRect.bottom - windowRect.Height() : workAreaRect.top, 400, windowRect.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
    }

    m_ipe.Create(IDB_IPEN, 48, 15);
    m_mb.Create(IDB_MB, 60, 15);

    m_vol.SetRange(0, 255);

    UpdateData(FALSE);

    ResizeWindow();

    return TRUE;
}

void CSeekDialog::ResizeWindow()
{
    CRect clientRect, windowRect;
    int volWidth, ipeWidth, barWidth;

    m_bar.GetWindowRect(&clientRect);
    ScreenToClient(&clientRect);
    barWidth = clientRect.left;
    m_vol.GetWindowRect(&clientRect);
    volWidth = clientRect.Width();
    m_ipe.GetWindowRect(&clientRect);
    ipeWidth = clientRect.Width();

    GetClientRect(&clientRect);

    m_bar.SetWindowPos(NULL, 0, 0, clientRect.Width() - barWidth - volWidth - ipeWidth, clientRect.Height(), SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
    m_vol.SetWindowPos(NULL, clientRect.Width() - volWidth - ipeWidth, 0, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
    m_ipe.SetWindowPos(NULL, clientRect.Width() - ipeWidth, 0, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
    m_bar.Invalidate();
    m_vol.Invalidate();
    m_ipe.Invalidate();

    //Calcul de la zone  effacer
    GetWindowRect(&clientRect);
    ScreenToClient(&clientRect);

    GetWindowRect(&windowRect);
    ScreenToClient(&windowRect);

    InflateRect(windowRect, -1, -1);

    CRgn windowRgn;
    CRgn preserveRgn;

    windowRect.OffsetRect(-clientRect.top, -clientRect.top);
    clientRect.OffsetRect(-clientRect.top, -clientRect.top);

    windowRgn.CreateRectRgn(clientRect.left, clientRect.top, clientRect.right, clientRect.bottom);
    preserveRgn.CreateRectRgn(windowRect.left, windowRect.top, windowRect.right, windowRect.bottom);
    windowRgn.CombineRgn(&windowRgn, &preserveRgn, RGN_AND);
    SetWindowRgn((HRGN__ *)windowRgn.m_hObject, TRUE);
}

void CSeekDialog::OnLButtonDown(UINT nFlags, CPoint point)
{
    CPoint thePoint = point;
    ClientToScreen(&thePoint);
    CRect rect;
    GetDlgItem(IDC_FORIEPT)->GetWindowRect(&rect);
    if (thePoint.x >= rect.left + (rect.Width()) * 5 / 6 && thePoint.x <= rect.right && thePoint.y >= rect.top + (rect.Height()) / 3 && thePoint.y <= rect.bottom)
    {
        ReleaseCapture();
        SendMessage(WM_NCLBUTTONDOWN, HTCAPTION, 0);
    }
}

void CSeekDialog::OnRButtonDown(UINT nFlags, CPoint point)
{
    CPoint thePoint = point;
    ClientToScreen(&thePoint);
    CRect rect;
    GetDlgItem(IDC_FORIEPT)->GetWindowRect(&rect);
    if (thePoint.x >= rect.left + (rect.Width()) * 5 / 6 && thePoint.x <= rect.right && thePoint.y >= rect.top + (rect.Height()) / 3 && thePoint.y <= rect.bottom)
    {
        ReleaseCapture();
        SendMessage(WM_NCLBUTTONDOWN, HTRIGHT, 0);
    }
}

void CSeekDialog::OnLButtonUp(UINT nFlags, CPoint point)
{
    CPoint thePoint = point;
    ClientToScreen(&thePoint);
    CRect rect;
    GetDlgItem(IDC_FORIEPT)->GetWindowRect(&rect);
    if (thePoint.x >= rect.left && thePoint.x <= rect.right && thePoint.y >= rect.top && thePoint.y <= rect.bottom)
    {
        if (thePoint.x < rect.left + (rect.Width()) * 1 / 6)
        {
            if (s_playlistManager.GetSize() > 0)
            {
                stdIn.InfoBox((TCHAR *)s_playlistManager.GetPlaylist(s_playlistManager.GetCurrent()).GetString(), WAEmuWnd.m_hWnd);
            }
        }
        else if (thePoint.x < rect.left + (rect.Width()) * 2 / 6)
        {
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_OPTIONS_EQ, 0);
        }
        else if (thePoint.x < rect.left + (rect.Width()) * 3 / 6)
        {
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_OPTIONS_PLEDIT, 0);
        }
        else if (thePoint.x < rect.left + (rect.Width()) * 4 / 6)
            s_mainWnd.ShowTracksMenu(2);
        else if (thePoint.x < rect.left + (rect.Width()) * 5 / 6)
            s_mainWnd.ShowTracksMenu(2, true);
        else
        {
            if (thePoint.y < rect.top + (rect.Height()) / 3)
            {
                ShowWindow(SW_HIDE);
            }
        }
    }
    else
    {
        GetDlgItem(IDC_FORCONTROLS)->GetWindowRect(&rect);
        if (thePoint.x >= rect.left && thePoint.x <= rect.right && thePoint.y >= rect.top && thePoint.y <= rect.bottom)
        {
            if (thePoint.x < rect.left + (rect.Width()) * 1 / 5)
                OnPlay();
            else if (thePoint.x < rect.left + (rect.Width()) * 2 / 5)
                OnPause();
            else if (thePoint.x < rect.left + (rect.Width()) * 3 / 5)
                OnStop();
            else if (thePoint.x < rect.left + (rect.Width()) * 4 / 5)
                OnPrev();
            else
                OnNext();
        }
    }
}

void CSeekDialog::OnMoving(UINT nSide, LPRECT lpRect)
{
    //TRACE(_T("OnMoving\n"));
    if (s_mainWnd.m_dockSD)
        GetWindowRect(lpRect);
    CRect workAreaRect;

    workAreaRect.left = 0;
    workAreaRect.right = GetSystemMetrics(SM_CXVIRTUALSCREEN);
    workAreaRect.top = 0;
    workAreaRect.bottom = GetSystemMetrics(SM_CYVIRTUALSCREEN);

    int newx = lpRect-> left, newy = lpRect->top;

    if (m_HDocked)
    {
        if (abs(lpRect->right - workAreaRect.right) < 5)
        {
            if (abs(lpRect->right - workAreaRect.right) > 1)
            {
                newx = lpRect->left;
                m_HDocked = false;
                //TRACE(_T("UnDockH %d %d %d %d"), lpRect->left, rect1.left, lpRect->right, rect1.right);
            }
            else
                newx = workAreaRect.right - (lpRect->right - lpRect->left);
        }
        if (abs(lpRect->left) < 5)
        {
            if (abs(lpRect->left - workAreaRect.left) > 1)
            {
                newx = lpRect->left;
                m_HDocked = false;
                //TRACE(_T("UnDockH %d %d %d %d"), lpRect->left, rect1.left, lpRect->right, rect1.right);
            }
            else
                newx = workAreaRect.left - 2;
        }
    }
    else
    {
        if (abs(lpRect->right - workAreaRect.right) < 5)
        {
            if (abs(lpRect->right - workAreaRect.right) > 1)
            {
                m_HDocked = true;
                newx = workAreaRect.right - (lpRect->right - lpRect->left);
                //TRACE(_T("DockH %d %d %d %d"), lpRect->left, rect1.left, lpRect->right, rect1.right);
            }
            else
                newx = lpRect->left;
        }
        if (abs(lpRect->left - workAreaRect.left) < 5)
        {
            if (abs(lpRect->left - workAreaRect.left) > 1)
            {
                m_HDocked = true;
                newx = workAreaRect.left;
                //TRACE(_T("DockH %d %d %d %d"), lpRect->left, rect1.left, lpRect->right, rect1.right);
            }
            else
                newx = lpRect->left - 2;
        }
    }
    if (m_VDocked)
    {
        if (abs(lpRect->bottom - workAreaRect.bottom) > 5)
        {
            if (abs(lpRect->bottom - workAreaRect.bottom) > 1)
            {
                newy = lpRect->top;
                m_VDocked = false;
                //TRACE(_T("UnDockV %d %d %d %d"), lpRect->bottom, rect1.bottom, lpRect->top, rect1.top);
            }
            else
                newy = workAreaRect.top - 2;
        }
        if (abs(lpRect->top - workAreaRect.top) > 5)
        {
            if (abs(lpRect->top - workAreaRect.top) > 1)
            {
                newy = lpRect->top;
                m_VDocked = false;
                //TRACE(_T("UnDockV %d %d %d %d"), lpRect->bottom, rect1.bottom, lpRect->top, rect1.top);
            }
            else
                newy = workAreaRect.top - 2;
        }
    }
    else
    {
        if (abs(lpRect->bottom - workAreaRect.bottom) < 5)
        {
            if (abs(lpRect->bottom - workAreaRect.bottom) > 1)
            {
                m_VDocked = true;
                newy = workAreaRect.top - 2;
                //TRACE(_T("DockV %d %d %d %d"), lpRect->bottom, rect1.bottom, lpRect->top, rect1.top);
            }
            else
                newy = lpRect->top;
        }
        if (abs(lpRect->top - workAreaRect.top) < 5)
        {
            if (abs(lpRect->top - workAreaRect.top) > 1)
            {
                m_VDocked = true;
                newy = workAreaRect.top - 2;
                //TRACE(_T("DockV %d %d %d %d"), lpRect->bottom, rect1.bottom, lpRect->top, rect1.top);
            }
            else
                newy = lpRect->top;
        }
    }

    lpRect->right = newx + (lpRect->right - lpRect->left);
    lpRect->left = newx;
    lpRect->bottom = newy + (lpRect->bottom - lpRect->top);
    lpRect->top = newy;
}

void CSeekDialog::OnNext()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON5, 0);
}

void CSeekDialog::OnPaint()
{
    if (!s_mainWnd.m_skin.xpLookNFeel)
    {
        CDialog::OnPaint();
        return;
    }

    // Get a handle to the window's device context
    HDC hDC = ::GetWindowDC(m_hWnd);
    CPaintDC dc(this);

    CRect rect;

    HDC hdc1 = CreateCompatibleDC(hDC);
    GetWindowRect(&rect);

    HBITMAP bm1 = CreateCompatibleBitmap(hDC, rect.Width(), rect.Height());
    SelectObject(hdc1, bm1);
    COLORREF crGradientStart = s_mainWnd.m_skin.startColor;
    COLORREF crGradientEnd = s_mainWnd.m_skin.endColor;

    rect.bottom = rect.Height() - 2;
    rect.top = 2;
    rect.left = 2;
    rect.right = 3;
    s_mainWnd.DrawGradient(CDC::FromHandle(hdc1), crGradientStart, crGradientStart, rect);    
    BitBlt(hDC, rect.left, rect.top, rect.Width(), rect.Height(), hdc1, rect.left, rect.top, SRCCOPY);

    rect.left = 3;
    rect.right = 63;
    s_mainWnd.DrawGradient(CDC::FromHandle(hdc1), crGradientStart, crGradientEnd, rect);
    BitBlt(hDC, rect.left, rect.top, rect.Width(), rect.Height(), hdc1, rect.left, rect.top, SRCCOPY);

    GetClientRect(&rect);
    ClientToScreen(&rect);
    GetWindowRect(&rect);
    rect.bottom = rect.Height() - 2;
    rect.top = 2;
    rect.right = rect.Width() / 2;
    rect.left = 63;
    s_mainWnd.DrawGradient(CDC::FromHandle(hdc1), crGradientEnd, crGradientStart, rect);  
    BitBlt(hDC, rect.left, rect.top, rect.Width(), rect.Height(), hdc1, rect.left, rect.top, SRCCOPY);
    GetWindowRect(&rect);
    rect.bottom = rect.Height() - 2;
    rect.top = 2;
    rect.right = rect.Width() - 48;
    rect.left = rect.right / 2;
    s_mainWnd.DrawGradient(CDC::FromHandle(hdc1), crGradientStart, crGradientEnd, rect);  
    BitBlt(hDC, rect.left, rect.top, rect.Width(), rect.Height(), hdc1, rect.left, rect.top, SRCCOPY);
    GetWindowRect(&rect);
    rect.bottom = rect.Height() - 2;
    rect.top = 2;
    rect.left = rect.Width() - 48;
    rect.right = rect.left + 48 - 3;
    s_mainWnd.DrawGradient(CDC::FromHandle(hdc1), crGradientEnd, crGradientStart, rect);  
    BitBlt(hDC, rect.left, rect.top, rect.Width(), rect.Height(), hdc1, rect.left, rect.top, SRCCOPY);

    rect.left = rect.right;
    rect.right = rect.left + 3;
    s_mainWnd.DrawGradient(CDC::FromHandle(hdc1), crGradientStart, crGradientStart, rect);    
    BitBlt(hDC, rect.left, rect.top, rect.Width(), rect.Height(), hdc1, rect.left, rect.top, SRCCOPY);

    ::ReleaseDC(m_hWnd, hDC);
    DeleteObject(hDC);

    m_mb.Invalidate();
    m_vol.Invalidate();
    m_ipe.Invalidate();
    m_bar.Invalidate();
}

void CSeekDialog::OnPause()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON3, 0);
}

void CSeekDialog::OnPlay()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
}

void CSeekDialog::OnPrev()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON1, 0);
}

void CSeekDialog::OnRButtonUp(UINT nFlags, CPoint point)
{
    s_mainWnd.ShowPopup(2);
}

void CSeekDialog::OnShowWindow(BOOL bShow, UINT nStatus)
{
    CDialog::OnShowWindow(bShow, nStatus);
    m_canResize = bShow;
}
void CSeekDialog::OnSize(UINT nType, int cx, int cy)
{
    CDialog::OnSize(nType, cx, cy);
    if (m_canResize)
    {
        ResizeWindow();
    }
}

void CSeekDialog::OnSizing(UINT nSide, LPRECT lpRect)
{
    TRACE(_T("OnSizing"));
    ResizeWindow();
}

void CSeekDialog::OnStop()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
}

void CSeekDialog::OnTimer(UINT nIDEvent)
{
    if (nIDEvent == 1 && s_mainWnd.m_dockSD)
    {
        HWND foregroundWindow = ::GetForegroundWindow();
        if (foregroundWindow != NULL && foregroundWindow != s_mainWnd.m_hWnd && !(::GetWindow(foregroundWindow, GW_OWNER) != NULL && ::GetWindow(foregroundWindow, GW_OWNER) == s_mainWnd.m_hWnd) 
            && !(::GetWindow(::GetWindow(foregroundWindow, GW_OWNER), GW_OWNER) != NULL && ::GetWindow(::GetWindow(foregroundWindow, GW_OWNER), GW_OWNER) == s_mainWnd.m_hWnd) 
            && !(::GetWindow(::GetWindow(::GetWindow(foregroundWindow, GW_OWNER), GW_OWNER), GW_OWNER) != NULL && ::GetWindow(::GetWindow(::GetWindow(foregroundWindow, GW_OWNER), GW_OWNER), GW_OWNER) == s_mainWnd.m_hWnd) && foregroundWindow != ::FindWindow(_T("Shell_TrayWnd"), NULL))
        {
            CRect rect, rect1, rect2;
            ::GetWindowRect(foregroundWindow, &rect);
            ::GetWindowRect(::GetDesktopWindow(), &rect2);
            GetWindowRect(&rect1);
            int sbcnt = ((::GetWindowLong(foregroundWindow, GWL_STYLE) & WS_SYSMENU) ? 1 : 0) + ((::GetWindowLong(foregroundWindow, GWL_STYLE) & WS_MINIMIZEBOX) ? 1 : 0) + ((::GetWindowLong(foregroundWindow, GWL_STYLE) & WS_MINIMIZEBOX) ? 1 : 0);
            if (rect == rect2 || (::IsWindowVisible(foregroundWindow) && (::GetWindowLong(foregroundWindow, GWL_STYLE) & WS_CAPTION) && !(::GetWindowLong(foregroundWindow, GWL_EXSTYLE) & WS_EX_TOOLWINDOW)) && !(::GetWindowLong(foregroundWindow, GWL_EXSTYLE) & WS_EX_TOPMOST) && rect.Width() - GetSystemMetrics(SM_CXSIZE) * ((float)sbcnt + .5) > 200)
            {
                long neww = 200;
                if (rect.Width() > 350)
                    neww = 250;
                if (rect.Width() > 550)
                    neww = 300;
                if (rect.Width() > 700)
                    neww = 350;
                if (rect.Width() > 900)
                    neww = 400;
                long newx = rect.right - neww - GetSystemMetrics(SM_CXSIZE) * (long)((float)sbcnt + 0.5) - 25;
                long newy = rect.top + ((::GetWindowLong(foregroundWindow, GWL_STYLE) & WS_THICKFRAME) ? 1 : 0) + 1;
                if (rect == rect2)
                {
                    CRect workAreaRect, rect4;

                    workAreaRect.left = 0;
                    workAreaRect.right = GetSystemMetrics(SM_CXVIRTUALSCREEN);
                    workAreaRect.top = 0;
                    workAreaRect.bottom = GetSystemMetrics(SM_CYVIRTUALSCREEN);

                    ::GetWindowRect(::FindWindow(_T("Shell_TrayWnd"), NULL), &rect4);
                    SetWindowPos(NULL, (workAreaRect.right - 400) / 2, (rect4.bottom < rect2.bottom) ? workAreaRect.bottom - rect1.Height() : workAreaRect.top, 400, rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
                }
                else
                {
                    if (newx != rect1.left || ((newy < 0) ? 0 : newy) != rect1.top)
                    {
                        SetWindowPos(NULL, newx, (newy < 0) ? 0 : newy, neww, rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
                        ResizeWindow();
                    }
                }
            }
        }
        else if (foregroundWindow == NULL)
        {
            CRect rect1, rect2, workAreaRect, trayWindowRect;
            GetWindowRect(&rect1);
            ::GetWindowRect(::GetDesktopWindow(), &rect2);

            workAreaRect.left = 0;
            workAreaRect.right = GetSystemMetrics(SM_CXVIRTUALSCREEN);
            workAreaRect.top = 0;
            workAreaRect.bottom = GetSystemMetrics(SM_CYVIRTUALSCREEN);

            ::GetWindowRect(::FindWindow(_T("Shell_TrayWnd"), NULL), &trayWindowRect);
            SetWindowPos(NULL, (workAreaRect.right - 400) / 2, (trayWindowRect.bottom < rect2.bottom) ? workAreaRect.bottom - rect1.Height() : workAreaRect.top, 400, rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
        }
    }

    CDialog::OnTimer(nIDEvent);
}

void CSeekDialog::Save()
{
    CRect rect;
    GetWindowRect(&rect);
    s_mainWnd.m_seekBarRect = rect;
}
