#ifndef SEEKDIALOG_H
#define SEEKDIALOG_H

class CTranspBmp : public CStatic
{

public:
    CTranspBmp(bool inverse);
    void Create(WORD idb, int width, int height);
    void Delete();

private:
    HBITMAP bmp;
    int m_width;
    int m_height;
    //inversion de gradient
    bool m_inverse;

protected:
    afx_msg void OnPaint();
    DECLARE_MESSAGE_MAP()
};

class CMyPrBar : public CProgressCtrl
{

public:
    CMyPrBar();
    void SetCurrentSong(CString currentSong);
    void SetCurrentTime(int trackTime, int totalTime);
    bool isScrollFlag();

private:
    bool m_scrollFlag;
    CString m_currentTime;
    CString m_currentSong;

protected:
    afx_msg void OnPaint();
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
    DECLARE_MESSAGE_MAP()
};

class CMyPrBarVol : public CProgressCtrl
{

public:
    CMyPrBarVol();

private:
    bool m_scrollFlag;

protected:
    afx_msg void OnPaint();
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
    DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CSeekDialog dialog

class CSeekDialog : public CDialog
{

public:
    CSeekDialog();
    ~CSeekDialog();
    void Save();

    CMyPrBar m_bar;
    CMyPrBarVol m_vol;
    CTranspBmp m_ipe;
    CTranspBmp m_mb;

    enum
    {
        IDD = IDD_SEEK
    };

private:
    BOOL m_canResize;
    bool m_HDocked;
    bool m_VDocked;

protected:
    virtual void DoDataExchange(CDataExchange* pDX);
    void ResizeWindow();
    virtual BOOL OnInitDialog();
    afx_msg void OnClose();
    afx_msg void OnDestroy();
    afx_msg void OnDropFiles(HDROP hDropInfo);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
    afx_msg void OnMoving(UINT nSide, LPRECT lpRect);
    afx_msg void OnPaint();
    afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
    afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnSizing(UINT nSide, LPRECT lpRect);
    afx_msg void OnTimer(UINT nIDEvent);
    void OnNext();
    void OnPause();
    void OnPlay();
    void OnPrev();
    void OnStop();
    DECLARE_MESSAGE_MAP()
};

#endif
