#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H
#include "ButtonXP.h"
#include "MenuXP.h"
#include "TestPropertyPage.h"
#include "SettingsDialogGeneral.h"
#include "SettingsDialogHotkeys.h"
#include "SettingsDialogW2File.h"
#include "SettingsDialogMouseClicks.h"
#include "SettingsDialogApparence.h"
#include "SettingsDialogApparenceSkins.h"
#include "SettingsDialogApparenceTooltip.h"
#include "SettingsDialogInput.h"
#include "SettingsDialogOutput.h"
#include "SettingsDialogGen.h"
#include "SettingsDialogPlugins.h"
#include "TreePropSheet.h"
#include "wa_ipc.h"

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialog dialog

class CSettingsDialog : public TreePropSheet::CTreePropSheet
{
    DECLARE_DYNAMIC(CSettingsDialog)

public:
    CSettingsDialog();
    ~CSettingsDialog();
    virtual BOOL DestroyWindow();
    void DisplaySkin(CWnd* pSkinSampleWnd, int frg = -1, int forceText = -1);
    void DisplayImage(HDC hdc, HDC hdc1, CRect rect, int frg = -1);
    void DisplayText(HDC hdc, HDC hdc5, CRect rect, int frg = -1, int forceText = -1);
    void SetActiveSettingPage(int index);
    void SetActiveSettingPage(prefsDlgRec* iPrefs);
    BOOL RelayToolTipEvent(MSG* pMsg);

    BOOL m_showGradient;
    BOOL m_showGradientSel;
    int m_currentSkinSel;
    SkinStruct m_loadSkin;
    bool m_needToRestart;
    bool m_changeApparence;
    CPPToolTip m_tooltip;

    enum
    {
        IDD = IDD_SETTINGS
    };

    CSettingsDialogApparenceTooltip m_settingsDialogApparenceTooltip;
    CSettingsDialogApparenceSkins m_settingsDialogApparenceSkins;

private:
    CButtonXP m_btnOk;
    CButtonXP m_btnCancel;
    CButtonXP m_btnApplyNow;
    CArray<CTestPropertyPage*, CTestPropertyPage*> m_listPropertyPage;

    CSettingsDialogGeneral m_settingsDialogGeneral;
    CSettingsDialogHotkeys m_settingsDialogHotkeys;
    CSettingsDialogW2File m_settingsDialogW2File;
    CSettingsDialogMouseClicks m_settingsDialogMouseClicks;
    CSettingsDialogApparence m_settingsDialogApparence;
    CSettingsDialogInput m_settingsDialogInput;
    CSettingsDialogOutput m_settingsDialogOutput;
    CSettingsDialogGen m_settingsDialogGen;
    CSettingsDialogPlugins m_settingsDialogPlugins;

protected:
    virtual void DoDataExchange(CDataExchange* pDX);
    afx_msg void OnCreate(LPCREATESTRUCT lpCreateStruct);
    virtual BOOL OnInitDialog();
    virtual void OnOk();
    virtual void OnApplyNow();
	BOOL OnEraseBkgnd(CDC* pDC);
    DECLARE_MESSAGE_MAP()
    DECLARE_MENUXP()
};
#endif

