// SettingsDialogApparence.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "SettingsDialog.h"
#include "MainHelper.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSettingsDialog* s_settingsDialog;

// Bote de dialogue CSettingsDialogApparence

IMPLEMENT_MENUXP(CSettingsDialogApparence, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogApparence, CPropertyPage)

CSettingsDialogApparence::CSettingsDialogApparence() : CPropertyPage(CSettingsDialogApparence::IDD)
{
}

CSettingsDialogApparence::~CSettingsDialogApparence()
{
}

void CSettingsDialogApparence::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    DDX_Control(pDX, IDC_GRADIENTSTART, m_startColor);
    DDX_ColourPicker(pDX, IDC_GRADIENTSTART, s_settingsDialog->m_loadSkin.startColor);
    DDX_Control(pDX, IDC_GRADIENTEND, m_endColor);
    DDX_ColourPicker(pDX, IDC_GRADIENTEND, s_settingsDialog->m_loadSkin.endColor);
    DDX_Check(pDX, IDC_SHOWGRADIENT, s_settingsDialog->m_showGradient);
    s_settingsDialog->m_loadSkin.toolTipText.Replace(_T("\\r"), _T("\r"));
    s_settingsDialog->m_loadSkin.toolTipText.Replace(_T("\\n"), _T("\n"));
    s_settingsDialog->m_loadSkin.toolTipText.Replace(_T("\\t"), _T("\t"));
    DDX_Check(pDX, IDC_SHOWGRADIENTSEL, s_settingsDialog->m_showGradientSel);
    DDX_Check(pDX, IDC_SHOWTOOLTIP, m_showToolTip);
    DDX_Text(pDX, IDC_EDIT1, s_settingsDialog->m_loadSkin.toolTipText);
    DDX_Control(pDX, IDC_LOOK_TOOLTIP, m_btnLook);
    DDX_Control(pDX, IDC_GRADIENTSAMPLE, m_gradientSample);
}

BOOL CSettingsDialogApparence::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_SETTINGS_APPARENCE);
    m_Helper.translateDlgItemText(this, IDC_LGRADIENTSTART);
    m_Helper.translateDlgItemText(this, IDC_LGRADIENTEND);
    m_Helper.translateDlgItemText(this, IDC_SHOWGRADIENT);
    m_Helper.translateDlgItemText(this, IDC_SHOWGRADIENTSEL);
    m_Helper.translateDlgItemText(this, IDC_SHOWTOOLTIP);
    m_Helper.translateDlgItemText(this, IDC_LCONTENTTOOLTIP);
    m_Helper.translateDlgItemText(this, IDC_LOOK_TOOLTIP);

    s_settingsDialog->m_showGradient = s_mainWnd.m_showGradient;
    s_settingsDialog->m_showGradientSel = s_mainWnd.m_showGradientSel;
    m_showToolTip = s_mainWnd.m_showToolTip;

    s_settingsDialog->m_tooltip.AddTool(GetDlgItem(IDC_LOOK_TOOLTIP), s_settingsDialog->m_loadSkin.toolTipText);
    s_settingsDialog->m_tooltip.SetNotify();

    UpdateData(FALSE);

    return TRUE;
}

BOOL CSettingsDialogApparence::OnEraseBkgnd(CDC* pDC)
{
    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcClient;
        GetClientRect(&rcClient);

        VERIFY(pDC->PatBlt(0, 0, rcClient.Width(), rcClient.Height(), BLACKNESS));
        return TRUE;
    }
    return CPropertyPage::OnEraseBkgnd(pDC);
}

void CSettingsDialogApparence::OnOK()
{
    UpdateData(TRUE);

    s_mainWnd.m_showGradient = s_settingsDialog->m_showGradient;
    s_mainWnd.m_showGradientSel = s_settingsDialog->m_showGradientSel;

    AfxGetApp()->WriteProfileInt(_T("MenuXP"), _T("ShowGradient"), s_settingsDialog->m_showGradient);
    AfxGetApp()->WriteProfileInt(_T("MenuXP"), _T("ShowGradientSel"), s_settingsDialog->m_showGradientSel);

    s_mainWnd.m_showToolTip = m_showToolTip;

    AfxGetApp()->WriteProfileString(_T("MenuXP"), _T("GradientStart"), m_Helper.ConvertColorHexa(s_settingsDialog->m_loadSkin.startColor));
    AfxGetApp()->WriteProfileString(_T("MenuXP"), _T("GradientEnd"), m_Helper.ConvertColorHexa(s_settingsDialog->m_loadSkin.endColor));
    s_settingsDialog->m_changeApparence = true;

    CPropertyPage::OnOK();
}

void CSettingsDialogApparence::OnChangeTooltipText()
{
    UpdateData(TRUE);
    s_settingsDialog->m_tooltip.RemoveAllTools();
    s_settingsDialog->m_tooltip.AddTool(GetDlgItem(IDC_LOOK_TOOLTIP), s_settingsDialog->m_loadSkin.toolTipText);
    s_settingsDialog->m_tooltip.AddTool(s_settingsDialog->m_settingsDialogApparenceTooltip.GetDlgItem(IDC_LOOK_TOOLTIP), s_settingsDialog->m_loadSkin.toolTipText);
    s_settingsDialog->m_tooltip.AddTool(s_settingsDialog->m_settingsDialogApparenceSkins.GetDlgItem(IDC_LOOK_TOOLTIP), s_settingsDialog->m_loadSkin.toolTipText);
}

BOOL CSettingsDialogApparence::PreTranslateMessage(MSG* pMsg)
{
    s_settingsDialog->RelayToolTipEvent(pMsg);

    return CPropertyPage::PreTranslateMessage(pMsg);
}

BEGIN_MESSAGE_MAP(CSettingsDialogApparence, CPropertyPage)
    ON_EN_CHANGE(IDC_EDIT1, OnChangeTooltipText)
    ON_MESSAGE(CPN_SELENDOK, OnUpdateGradient)
    ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

LONG CSettingsDialogApparence::OnUpdateGradient(UINT lParam, LONG wParam)
{
    UpdateData(TRUE);
    m_gradientSample.Invalidate();
    return 0L;
}