// SettingsDialogApparenceSkins.cpp : fichier d'implmentation
//

#include "StdAfx.h"
#include "resource.h"
#include "aerosubc.h"
#include "aeroglss.h"
#include "SettingsDialog.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "Draw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSettingsDialog* s_settingsDialog;

// Bote de dialogue CSettingDialogApparenceSkins

IMPLEMENT_MENUXP(CSettingsDialogApparenceSkins, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogApparenceSkins, CPropertyPage)

CSettingsDialogApparenceSkins::CSettingsDialogApparenceSkins() : CPropertyPage(CSettingsDialogApparenceSkins::IDD), m_skinSample(0), m_skinText(1)
{
    m_includeSubDirectory = FALSE;
}

CSettingsDialogApparenceSkins::~CSettingsDialogApparenceSkins()
{
}


void CSettingsDialogApparenceSkins::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    DDX_Check(pDX, IDC_INCLUDESUBDIRECTORY, m_includeSubDirectory);
    DDX_Control(pDX, IDC_L_SKINS, m_listSkin);
    DDX_Check(pDX, IDC_CHANGESKINONEACHTRACK, m_changeSkinOnEachTrack);
    DDX_Check(pDX, IDC_RANDOMSKIN, m_randomSkin);
    DDX_Control(pDX, IDC_SAVESKINBROWSE, m_btnSave);
    DDX_Control(pDX, IDC_DELETESKINFROMSELECTION, m_btnDelete);
    DDX_Control(pDX, IDC_USEDEFAULTSKIN, m_btnUseDefault);
    DDX_Control(pDX, IDC_SKINDIRECTORYBROWSE, m_btnBrowse);
    DDX_Control(pDX, IDC_LOOK_TOOLTIP, m_btnLook);
    DDX_Control(pDX, IDC_SKINSAMPLE, m_skinSample);
    DDX_Control(pDX, IDC_SKINTEXT, m_skinText);
    DDX_Control(pDX, IDC_GRADIENTSAMPLE, m_gradientSample);
}

BOOL CSettingsDialogApparenceSkins::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_SETTINGS_APPARENCE_SKINS);
    m_Helper.translateDlgItemText(this, IDC_LSKINDIRECTORY);
    m_Helper.translateDlgItemText(this, IDC_SKINDIRECTORYBROWSE);
    m_Helper.translateDlgItemText(this, IDC_INCLUDESUBDIRECTORY);
    m_Helper.translateDlgItemText(this, IDC_SAVESKINBROWSE);
    m_Helper.translateDlgItemText(this, IDC_LOOK_TOOLTIP);
    m_Helper.translateDlgItemText(this, IDC_CHANGESKINONEACHTRACK);
    m_Helper.translateDlgItemText(this, IDC_RANDOMSKIN);
    m_Helper.translateDlgItemText(this, IDC_USEDEFAULTSKIN);
    m_Helper.translateDlgItemText(this, IDC_DELETESKINFROMSELECTION);

    m_changeSkinOnEachTrack = s_mainWnd.m_changeSkinOnEachTrack;
    m_randomSkin = s_mainWnd.m_randomSkin;

    for (int i = 0; i < s_mainWnd.m_currentSkin.GetSize(); i++)
    {
        if (s_mainWnd.m_currentSkin[i].GetLength() != 0 && s_mainWnd.m_currentSkin[i] != _T("NONE"))
        {
            if (m_listSkin.FindString(0, s_mainWnd.m_currentSkin[i]) == -1)
            {
                m_listSkin.AddString(s_mainWnd.m_currentSkin[i]);
            }
        }
        else
        {
            CString tmp = m_Helper.MyLoadString(IDS_DEFAULTSKIN);
            if (m_listSkin.FindString(0, tmp) == -1)
            {
                m_listSkin.AddString(tmp);
            }
        }
    }
    m_listSkin.SetSel(s_mainWnd.m_currentSkinSel, TRUE);

    s_settingsDialog->m_currentSkinSel = s_mainWnd.m_currentSkinSel;
    if (m_listSkin.GetCount() != 0)
    {
        CString buf;
        m_listSkin.GetText(s_settingsDialog->m_currentSkinSel, buf);
        s_mainWnd.LoadSkin(buf, &s_settingsDialog->m_loadSkin);
    }
    else
    {
        s_mainWnd.LoadSkin(_T(""), &s_settingsDialog->m_loadSkin);
    }
    m_listSkin.SetCurSel(s_settingsDialog->m_currentSkinSel);

    GetDlgItem(IDC_RANDOMSKIN)->EnableWindow(m_changeSkinOnEachTrack);

    s_settingsDialog->m_tooltip.AddTool(GetDlgItem(IDC_LOOK_TOOLTIP), s_settingsDialog->m_loadSkin.toolTipText);
    s_settingsDialog->m_tooltip.SetNotify();

    UpdateData(FALSE);

    return TRUE;
}

BOOL CSettingsDialogApparenceSkins::OnEraseBkgnd(CDC* pDC)
{
    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcClient;
        GetClientRect(&rcClient);

        VERIFY(pDC->PatBlt(0, 0, rcClient.Width(), rcClient.Height(), BLACKNESS));
        return TRUE;
    }
    return CPropertyPage::OnEraseBkgnd(pDC);
}

void CSettingsDialogApparenceSkins::OnOK()
{
    UpdateData(TRUE);

    s_mainWnd.m_currentSkin.RemoveAll();
    for (int i = 0; i < m_listSkin.GetCount(); i++)
    {
        CString buf;
        m_listSkin.GetText(i, buf);
        s_mainWnd.m_currentSkin.Add(buf);
    }
    s_mainWnd.m_currentSkinSel = s_settingsDialog->m_currentSkinSel;
    if (s_mainWnd.m_currentSkin.GetSize() != 0)
    {
        s_mainWnd.m_currentSkinSel %= s_mainWnd.m_currentSkin.GetSize();
        s_mainWnd.LoadSkin(s_mainWnd.m_currentSkin[s_mainWnd.m_currentSkinSel], &s_mainWnd.m_skin);
    }
    else
    {
        s_mainWnd.LoadSkin(_T(""), &s_mainWnd.m_skin);
    }
    s_mainWnd.m_changeSkinOnEachTrack = m_changeSkinOnEachTrack;
    s_mainWnd.m_randomSkin = m_randomSkin;
    s_settingsDialog->m_changeApparence = true;

    CPropertyPage::OnOK();
}

BEGIN_MESSAGE_MAP(CSettingsDialogApparenceSkins, CPropertyPage)
    ON_BN_CLICKED(IDC_SKINDIRECTORYBROWSE, OnSkinDirectoryBrowse)
    ON_BN_CLICKED(IDC_SAVESKINBROWSE, OnSaveSkin)
    ON_LBN_SELCHANGE(IDC_L_SKINS, OnLbnSelchangeLSkins)
    ON_BN_CLICKED(IDC_DELETESKINFROMSELECTION, OnBnClickedDeleteskinfromselection)
    ON_BN_CLICKED(IDC_USEDEFAULTSKIN, OnBnClickedUsedefaultskin)
    ON_BN_CLICKED(IDC_CHANGESKINONEACHTRACK, OnBnClickedChangeskinoneachtrack)
    ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

void CSettingsDialogApparenceSkins::OnSkinDirectoryBrowse()
{
    UpdateData(TRUE);
    LPMALLOC pMalloc;
    if (SHGetMalloc(&pMalloc) != NOERROR)
        return;

    BROWSEINFO bi;
    TCHAR buf[MAX_PATH];
    _tcscpy(buf, s_mainWnd.m_initDir.GetString());

    CString title;
    title = m_Helper.MyLoadString(IDS_OPENFOLDER);

    bi.hwndOwner = m_hWnd;
    bi.pszDisplayName = buf;
    bi.pidlRoot = NULL;
    bi.lpszTitle = LPCTSTR(title);
    bi.ulFlags = BIF_RETURNONLYFSDIRS;
    bi.lpfn = NULL;

    LPITEMIDLIST pidl;
    if ((pidl = SHBrowseForFolder(&bi)) == NULL)
    {
        pMalloc->Free(pidl);
        pMalloc ->Release();
        return;
    }
    if (SHGetPathFromIDList(pidl, buf) == false)
    {
        pMalloc->Free(pidl);
        pMalloc ->Release();
        return;
    }
    pMalloc->Free(pidl);
    pMalloc->Release();

    CString theDir;
    theDir.Format(_T("%s\\"), buf);
    GetDlgItem(IDC_SKINDIRECTORY)->SetWindowText(theDir.GetString());
    FindSkin(theDir);
}

void CSettingsDialogApparenceSkins::FindSkin(CString path)
{
    CFileFind finder;
    CString fp, fext;
    CString posExt = _T("SKN;SK2;");
    BOOL bWorking = finder.FindFile(path + _T("\\*.*"));
    while (bWorking)
    {
        bWorking = finder.FindNextFile();
        fp = finder.GetFilePath();
        fext = fp.Mid(fp.ReverseFind('.') + 1, 3);
        fext.MakeUpper();
        fext += ";";
        if (posExt.Find(fext) != -1)
        {
            if (finder.GetLength() > 0)
            {
                if (m_listSkin.FindString(0, fp) == -1)
                    m_listSkin.AddString(fp);
                continue;
            }
        }
        if (finder.IsDirectory() && !finder.IsDots() && m_includeSubDirectory)
            FindSkin(fp + _T("\\"));
    }
}

void CSettingsDialogApparenceSkins::OnSaveSkin()
{
    UpdateData(TRUE);

    CFileDialog dialog(FALSE, _T("sk2"), _T(""), OFN_OVERWRITEPROMPT, m_Helper.MyLoadString(IDS_SAVESKIN));

    if (dialog.DoModal() == IDOK)
    {
        CString m_file = dialog.GetPathName();

        if (m_listSkin.FindString(0, m_file) == -1)
            m_listSkin.AddString(m_file);

        WritePrivateProfileString(_T("Skin"), _T("PlayIcon"), CopyResourceForSkin(m_file, s_settingsDialog->m_loadSkin.playIconName), m_file);
        WritePrivateProfileString(_T("Skin"), _T("PauseIcon"), CopyResourceForSkin(m_file, s_settingsDialog->m_loadSkin.pauseIconName), m_file);
        WritePrivateProfileString(_T("Skin"), _T("StopIcon"), CopyResourceForSkin(m_file, s_settingsDialog->m_loadSkin.stopIconName), m_file);
        WritePrivateProfileString(_T("Skin"), _T("PrevIcon"), CopyResourceForSkin(m_file, s_settingsDialog->m_loadSkin.prevIconName), m_file);
        WritePrivateProfileString(_T("Skin"), _T("NextIcon"), CopyResourceForSkin(m_file, s_settingsDialog->m_loadSkin.nextIconName), m_file);
        WritePrivateProfileString(_T("Skin"), _T("Buttons"), CopyResourceForSkin(m_file, s_settingsDialog->m_loadSkin.buttonsName), m_file);
        WritePrivateProfileString(_T("Skin"), _T("ButtonsDn"), CopyResourceForSkin(m_file, s_settingsDialog->m_loadSkin.buttonsDnName), m_file);

        WritePrivateProfileString(_T("Skin"), _T("GradientStart"), m_Helper.ConvertColorHexa(s_settingsDialog->m_loadSkin.startColor), m_file);
        WritePrivateProfileString(_T("Skin"), _T("GradientEnd"), m_Helper.ConvertColorHexa(s_settingsDialog->m_loadSkin.endColor), m_file);
        WritePrivateProfileString(_T("Skin"), _T("border_color"), m_Helper.ConvertColorHexa(s_settingsDialog->m_loadSkin.border_color), m_file);
        WritePrivateProfileString(_T("Skin"), _T("end_bk"), m_Helper.ConvertColorHexa(s_settingsDialog->m_loadSkin.end_bk), m_file);
        WritePrivateProfileString(_T("Skin"), _T("mid_bk"), m_Helper.ConvertColorHexa(s_settingsDialog->m_loadSkin.mid_bk), m_file);
        WritePrivateProfileString(_T("Skin"), _T("start_bk"), m_Helper.ConvertColorHexa(s_settingsDialog->m_loadSkin.start_bk), m_file);

        CString tmp;
        tmp = s_settingsDialog->m_loadSkin.toolTipText;
        tmp.Replace(_T("\r\n"), _T("\\r\\n"));
        tmp.Replace(_T("\n"), _T("\\n"));
        tmp.Replace(_T("\t"), _T("\\t"));
        WritePrivateProfileString(_T("Skin"), _T("ToolTipText"), tmp, m_file);

        tmp.Format(_T("%d"), s_settingsDialog->m_loadSkin.theme);
        WritePrivateProfileString(_T("Skin"), _T("Theme"), tmp, m_file);
        tmp.Format(_T("%d"), s_settingsDialog->m_loadSkin.effect_bk);
        WritePrivateProfileString(_T("Skin"), _T("effect_bk"), tmp, m_file);
        tmp.Format(_T("%d"), s_settingsDialog->m_loadSkin.granularity);
        WritePrivateProfileString(_T("Skin"), _T("granularity"), tmp, m_file);
        tmp.Format(_T("%d"), s_settingsDialog->m_loadSkin.border);
        WritePrivateProfileString(_T("Skin"), _T("border"), tmp, m_file);
        tmp.Format(_T("%d"), s_settingsDialog->m_loadSkin.custom_border);
        WritePrivateProfileString(_T("Skin"), _T("custom_border"), tmp, m_file);
        tmp.Format(_T("%d"), s_settingsDialog->m_loadSkin.border_width);
        WritePrivateProfileString(_T("Skin"), _T("border_width"), tmp, m_file);
        tmp.Format(_T("%d"), s_settingsDialog->m_loadSkin.border_height);
        WritePrivateProfileString(_T("Skin"), _T("border_height"), tmp, m_file);
        tmp.Format(_T("%d"), s_settingsDialog->m_loadSkin.transparency);
        WritePrivateProfileString(_T("Skin"), _T("transparency"), tmp, m_file);

        UpdateData(FALSE);
    }
}

CString CSettingsDialogApparenceSkins::CopyResourceForSkin(CString skinPath, CString resourcePath)
{
    TCHAR pathFile[MAX_PATH];
    TCHAR pathName[MAX_PATH];
    TCHAR driveFile[MAX_PATH];
    TCHAR driveName[MAX_PATH];
    TCHAR directoryFile[MAX_PATH];
    TCHAR directoryName[MAX_PATH];
    TCHAR fileName[MAX_PATH];
    TCHAR extName[MAX_PATH];

    CString saveName = resourcePath;

    if (saveName.GetLength() != 0)
    {
        _tcscpy(pathFile, (TCHAR *)skinPath.GetString());
        _tcscpy(pathName, (TCHAR *)resourcePath.GetString());

        _tsplitpath(pathFile, driveFile, directoryFile, NULL, NULL);
        _tsplitpath(pathName, driveName, directoryName, fileName, extName);

        if (_tcscmp(driveFile, driveName) == 0)
        {
            if (_tcsstr(directoryName, directoryFile) != NULL)
            {
                saveName = resourcePath.Right(resourcePath.GetLength() - _tcslen(driveFile) - _tcslen(directoryFile));
            }
            else
            {
                saveName.Format(_T("%s%s%s%s"), driveFile, directoryFile, fileName, extName);
                CopyFile(resourcePath, saveName, FALSE);
                saveName.Format(_T("%s%s"), fileName, extName);
            }
        }
        else
        {
            saveName.Format(_T("%s%s%s%s"), driveFile, directoryFile, fileName, extName);
            CopyFile(resourcePath, saveName, FALSE);
            saveName.Format(_T("%s%s"), fileName, extName);
        }
    }
    return saveName;
}

void CSettingsDialogApparenceSkins::OnLbnSelchangeLSkins()
{
    if (m_listSkin.GetCurSel() != -1)
    {
        CString buf;
        m_listSkin.GetText(m_listSkin.GetCurSel(), buf);
        s_settingsDialog->m_currentSkinSel = m_listSkin.GetCurSel();

        s_mainWnd.LoadSkin(buf, &s_settingsDialog->m_loadSkin);
        s_mainWnd.UseSkin(&s_settingsDialog->m_loadSkin);
        s_settingsDialog->m_loadSkin.toolTipText.Replace(_T("\\r"), _T("\r"));
        s_settingsDialog->m_loadSkin.toolTipText.Replace(_T("\\n"), _T("\n"));
        s_settingsDialog->m_loadSkin.toolTipText.Replace(_T("\\t"), _T("\t"));

        CWnd* pWnd = GetDlgItem(IDC_SKINSAMPLE);
        s_settingsDialog->DisplaySkin(pWnd, -1, FALSE);
        pWnd = GetDlgItem(IDC_SKINTEXT);
        s_settingsDialog->DisplaySkin(pWnd, -1, TRUE);
        GetDlgItem(IDC_GRADIENTSAMPLE)->Invalidate();
    }
}

BOOL CSettingsDialogApparenceSkins::PreTranslateMessage(MSG* pMsg)
{
    s_settingsDialog->RelayToolTipEvent(pMsg);

    return CPropertyPage::PreTranslateMessage(pMsg);
}


void CSettingsDialogApparenceSkins::OnBnClickedDeleteskinfromselection()
{
    if (m_listSkin.GetCurSel() != -1)
    {
        int cur = m_listSkin.GetCurSel();
        m_listSkin.DeleteString(m_listSkin.GetCurSel());
        m_listSkin.SetCurSel(cur - 1);
        OnLbnSelchangeLSkins();
    }
}

void CSettingsDialogApparenceSkins::OnBnClickedUsedefaultskin()
{
    CString tmp = m_Helper.MyLoadString(IDS_DEFAULTSKIN);
    if (m_listSkin.FindString(0, tmp) == -1)
        m_listSkin.AddString(tmp);

    m_listSkin.SetCurSel(m_listSkin.FindString(0, tmp));
    OnLbnSelchangeLSkins();
}

void CSettingsDialogApparenceSkins::OnBnClickedChangeskinoneachtrack()
{
    UpdateData(TRUE);
    GetDlgItem(IDC_RANDOMSKIN)->EnableWindow(m_changeSkinOnEachTrack);
}
