// SettingsDialogApparenceTooltip.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "SettingsDialog.h"
#include "MainHelper.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSettingsDialog* s_settingsDialog;

// Bote de dialogue CSettingsDialogApparenceTooltip

IMPLEMENT_MENUXP(CSettingsDialogApparenceTooltip, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogApparenceTooltip, CPropertyPage)

CSettingsDialogApparenceTooltip::CSettingsDialogApparenceTooltip() : CPropertyPage(CSettingsDialogApparenceTooltip::IDD)
{
}

CSettingsDialogApparenceTooltip::~CSettingsDialogApparenceTooltip()
{
}

void CSettingsDialogApparenceTooltip::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    DDX_Control(pDX, IDC_BUTTON4, m_border_color);
    DDX_ColourPicker(pDX, IDC_BUTTON4, s_settingsDialog->m_loadSkin.border_color);
    DDX_Control(pDX, IDC_BUTTON3, m_end_bk);
    DDX_ColourPicker(pDX, IDC_BUTTON3, s_settingsDialog->m_loadSkin.end_bk);
    DDX_Control(pDX, IDC_BUTTON2, m_mid_bk);
    DDX_ColourPicker(pDX, IDC_BUTTON2, s_settingsDialog->m_loadSkin.mid_bk);
    DDX_Control(pDX, IDC_BUTTON1, m_start_bk);
    DDX_ColourPicker(pDX, IDC_BUTTON1, s_settingsDialog->m_loadSkin.start_bk);
    DDX_Check(pDX, IDC_RADIO1, s_settingsDialog->m_loadSkin.custom_border);
    DDX_CBIndex(pDX, IDC_TYPE, s_settingsDialog->m_loadSkin.theme);
    DDX_CBIndex(pDX, IDC_BACKGROUND, s_settingsDialog->m_loadSkin.effect_bk);
    DDX_Text(pDX, IDC_CHANGEGRANULARITY, s_settingsDialog->m_loadSkin.granularity);
    DDV_MinMaxByte(pDX, s_settingsDialog->m_loadSkin.granularity, 0, 255);
    DDX_Check(pDX, IDC_CHECKBORDER, s_settingsDialog->m_loadSkin.border);
    DDX_Text(pDX, IDC_CHANGEWIDTH, s_settingsDialog->m_loadSkin.border_width);
    DDX_Text(pDX, IDC_CHANGEHEIGHT, s_settingsDialog->m_loadSkin.border_height);
    DDX_Text(pDX, IDC_CHANGETRANSPARENCY, s_settingsDialog->m_loadSkin.transparency);
    DDX_Text(pDX, IDC_CHANGESHOWTIME, m_show_time);
    DDX_Text(pDX, IDC_CHANGEHIDETIME, m_hide_time);
    DDX_Text(pDX, IDC_CHANGEFADEIN, m_fade_in);
    DDX_Text(pDX, IDC_CHANGEFADEOUT, m_fade_out);
    DDX_Text(pDX, IDC_CHANGEANIMATION, m_animation);
    DDX_Control(pDX, IDC_LOOK_TOOLTIP, m_btnLook);
    DDX_Control(pDX, IDC_TYPE, m_type);
    DDX_CBIndex(pDX, IDC_TYPE, s_settingsDialog->m_loadSkin.theme);
    DDX_Control(pDX, IDC_BACKGROUND, m_background);
}

BOOL CSettingsDialogApparenceTooltip::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_SETTINGS_APPARENCE_TOOLTIP);
    m_Helper.translateDlgItemText(this, IDC_LBACKGROUNDEFFECT);
    m_Helper.translateDlgItemText(this, IDC_LTYPE);
    m_Helper.translateDlgItemText(this, IDC_LSTART);
    m_Helper.translateDlgItemText(this, IDC_LMID);
    m_Helper.translateDlgItemText(this, IDC_LEND);
    m_Helper.translateDlgItemText(this, IDC_LGRANULARITY);
    m_Helper.translateDlgItemText(this, IDC_LTRANSPARENCY);
    m_Helper.translateDlgItemText(this, IDC_LCOLORS);
    m_Helper.translateDlgItemText(this, IDC_LCOLORTHEME);
    m_Helper.translateDlgItemText(this, IDC_LTIMERS);
    m_Helper.translateDlgItemText(this, IDC_LBORDER);
    m_Helper.translateDlgItemText(this, IDC_LWIDTH);
    m_Helper.translateDlgItemText(this, IDC_LHEIGHT);
    m_Helper.translateDlgItemText(this, IDC_LSHOWAFTER);
    m_Helper.translateDlgItemText(this, IDC_LHIDEAFTER);
    m_Helper.translateDlgItemText(this, IDC_LFADEIN);
    m_Helper.translateDlgItemText(this, IDC_LFADEOUT);
    m_Helper.translateDlgItemText(this, IDC_LANIMATION);
    m_Helper.translateDlgItemText(this, IDC_CHECKBORDER);
    m_Helper.translateDlgItemText(this, IDC_RADIO1);
    m_Helper.translateDlgItemText(this, IDC_RADIO2);
    m_Helper.translateDlgItemText(this, IDC_LOOK_TOOLTIP);

    m_show_time = s_mainWnd.m_show_time;
    m_hide_time = s_mainWnd.m_hide_time;
    m_fade_in = s_mainWnd.m_fade_in;
    m_fade_out = s_mainWnd.m_fade_out;
    m_animation = s_mainWnd.m_animation;

    m_type.AddString(m_Helper.MyLoadString(IDS_TYPESTANDARD));
    m_type.AddString(m_Helper.MyLoadString(IDS_TYPESILVER));
    m_type.AddString(m_Helper.MyLoadString(IDS_TYPEBUTTON));
    m_type.AddString(m_Helper.MyLoadString(IDS_TYPEEXOTIC));
    m_type.AddString(m_Helper.MyLoadString(IDS_TYPEAQUA));
    m_type.AddString(m_Helper.MyLoadString(IDS_TYPECHROME));
    m_type.AddString(m_Helper.MyLoadString(IDS_TYPEGOLD));
    m_type.AddString(m_Helper.MyLoadString(IDS_TYPESUNNY));
    m_type.AddString(m_Helper.MyLoadString(IDS_TYPEJUNGLE));
    m_type.AddString(m_Helper.MyLoadString(IDS_TYPESKY));
    m_type.AddString(m_Helper.MyLoadString(IDS_TYPEFIRE));

    m_background.AddString(_T("SOLID"));
    m_background.AddString(_T("HGRADIENT"));
    m_background.AddString(_T("VGRADIENT"));
    m_background.AddString(_T("HCGRADIENT"));
    m_background.AddString(_T("HVGRADIENT"));
    m_background.AddString(_T("3HGRADIENT"));
    m_background.AddString(_T("3VGRADIENT"));
    m_background.AddString(_T("NOISE"));
    m_background.AddString(_T("DIAGSHADE"));
    m_background.AddString(_T("HSHADE"));
    m_background.AddString(_T("VSHADE"));
    m_background.AddString(_T("HBUMP"));
    m_background.AddString(_T("VBUMP"));
    m_background.AddString(_T("SOFTBUMP"));
    m_background.AddString(_T("HARDBUMP"));
    m_background.AddString(_T("METAL"));

    s_settingsDialog->m_tooltip.AddTool(GetDlgItem(IDC_LOOK_TOOLTIP), s_settingsDialog->m_loadSkin.toolTipText);
    s_settingsDialog->m_tooltip.SetNotify();

    UpdateData(FALSE);

    OnChangeColorTheme();
    s_settingsDialog->m_tooltip.SetEffectBk(s_settingsDialog->m_loadSkin.effect_bk, s_settingsDialog->m_loadSkin.granularity);

    CheckDlgButton(IDC_RADIO2, !s_mainWnd.m_skin.custom_border);

    return TRUE;
}

BOOL CSettingsDialogApparenceTooltip::OnEraseBkgnd(CDC* pDC)
{
    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcClient;
        GetClientRect(&rcClient);

        VERIFY(pDC->PatBlt(0, 0, rcClient.Width(), rcClient.Height(), BLACKNESS));
        return TRUE;
    }
    return CPropertyPage::OnEraseBkgnd(pDC);
}

void CSettingsDialogApparenceTooltip::OnOK()
{
    UpdateData(TRUE);

    s_mainWnd.m_show_time = m_show_time;
    s_mainWnd.m_hide_time = m_hide_time;
    s_mainWnd.m_fade_in = m_fade_in;
    s_mainWnd.m_fade_out = m_fade_out;
    s_mainWnd.m_animation = m_animation;

    CPropertyPage::OnOK();
}

BEGIN_MESSAGE_MAP(CSettingsDialogApparenceTooltip, CPropertyPage)
    ON_CBN_SELCHANGE(IDC_TYPE, OnChangeColorTheme)
    ON_CBN_SELCHANGE(IDC_BACKGROUND, OnChangeColorTheme)
    ON_BN_CLICKED(IDC_BACKGROUND, OnSetBorder)
    ON_EN_CHANGE(IDC_CHANGEGRANULARITY, OnSetBorder)
    ON_EN_CHANGE(IDC_CHANGEWIDTH, OnSetBorder)
    ON_EN_CHANGE(IDC_CHANGEHEIGHT, OnSetBorder)
    ON_BN_CLICKED(IDC_RADIO1, OnSetBorder)
    ON_BN_CLICKED(IDC_RADIO2, OnSetBorder)
    ON_BN_CLICKED(IDC_BUTTON1, OnSetBorder)
    ON_BN_CLICKED(IDC_BUTTON2, OnSetBorder)
    ON_BN_CLICKED(IDC_BUTTON3, OnSetBorder)
    ON_BN_CLICKED(IDC_BUTTON4, OnSetBorder)
    ON_EN_CHANGE(IDC_CHANGETRANSPARENCY, OnSetBorder)
    ON_EN_CHANGE(IDC_CHANGESHOWTIME, OnSetBorder)
    ON_EN_CHANGE(IDC_CHANGEHIDETIME, OnSetBorder)
    ON_EN_CHANGE(IDC_CHANGEFADEIN, OnSetBorder)
    ON_EN_CHANGE(IDC_CHANGEFADEOUT, OnSetBorder)
    ON_EN_CHANGE(IDC_CHANGEANIMATION, OnSetBorder)
    ON_MESSAGE(CPN_SELENDOK, OnChangeColorBk)
    ON_BN_CLICKED(IDC_CHECKBORDER, OnSetBorder)
    ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

LONG CSettingsDialogApparenceTooltip::OnChangeColorBk(UINT lParam, LONG wParam)
{
    OnSetBorder();
    return 0L;
}

void CSettingsDialogApparenceTooltip::OnChangeColorTheme()
{
    OnSetBorder();
    switch (s_settingsDialog->m_loadSkin.theme)
    {
        case 0:
            //Standard
            m_start_bk.SetColour(RGB(255, 255, 223));
            m_mid_bk.SetColour(RGB(192, 192, 172));
            m_end_bk.SetColour(RGB(128, 128, 112));
            break;
        case 1:
            //Silver
            m_start_bk.SetColour(RGB(255, 255, 255));
            m_mid_bk.SetColour(RGB(240, 247, 255));
            m_end_bk.SetColour(RGB(192, 192, 208));
            break;
        case 2:
            //Button
            m_start_bk.SetColour(RGB(223, 223, 223));
            m_mid_bk.SetColour(RGB(191, 191, 191));
            m_end_bk.SetColour(RGB(127, 127, 127));
            break;
        case 3:
            //Exotic
            m_start_bk.SetColour(RGB(0, 255, 255));
            m_mid_bk.SetColour(RGB(255, 255, 0));
            m_end_bk.SetColour(RGB(0, 255, 0));
            break;
        case 4:
            //Aqua
            m_start_bk.SetColour(RGB(123, 158, 198));
            m_mid_bk.SetColour(RGB(173, 207, 247));
            m_end_bk.SetColour(RGB(198, 239, 255));
            break;
        case 5:
            //Chrome
            m_start_bk.SetColour(RGB(231, 251, 255));
            m_mid_bk.SetColour(RGB(214, 211, 214));
            m_end_bk.SetColour(RGB(165, 162, 173));
            break;
        case 6:
            //Gold
            m_start_bk.SetColour(RGB(255, 255, 148));
            m_mid_bk.SetColour(RGB(255, 231, 132));
            m_end_bk.SetColour(RGB(255, 207, 0));
            break;
        case 7:
            //Sunny
            m_start_bk.SetColour(RGB(255, 248, 229));
            m_mid_bk.SetColour(RGB(255, 209, 115));
            m_end_bk.SetColour(RGB(255, 156, 0));
            break;
        case 8:
            //Jungle
            m_start_bk.SetColour(RGB(214, 250, 183));
            m_mid_bk.SetColour(RGB(148, 236, 104));
            m_end_bk.SetColour(RGB(4, 202, 0));
            break;
        case 9:
            //Sky
            m_start_bk.SetColour(RGB(203, 233, 254));
            m_mid_bk.SetColour(RGB(88, 175, 241));
            m_end_bk.SetColour(RGB(0, 67, 202));
            break;
        case 10:
            //Fire
            m_start_bk.SetColour(RGB(255, 255, 0));
            m_mid_bk.SetColour(RGB(255, 104, 32));
            m_end_bk.SetColour(RGB(194, 3, 0));
            break;
    }
    s_settingsDialog->m_tooltip.SetEffectBk(s_settingsDialog->m_loadSkin.effect_bk, s_settingsDialog->m_loadSkin.granularity);
}

void CSettingsDialogApparenceTooltip::OnSetBorder()
{
    UpdateData(TRUE);
    m_border_color.EnableWindow(s_settingsDialog->m_loadSkin.border);
    GetDlgItem(IDC_BUTTON4)->EnableWindow(s_settingsDialog->m_loadSkin.border && !s_settingsDialog->m_loadSkin.custom_border);
    GetDlgItem(IDC_RADIO1)->EnableWindow(s_settingsDialog->m_loadSkin.border);
    GetDlgItem(IDC_RADIO2)->EnableWindow(s_settingsDialog->m_loadSkin.border);
    GetDlgItem(IDC_CHANGEWIDTH)->EnableWindow(s_settingsDialog->m_loadSkin.border);
    GetDlgItem(IDC_CHANGEHEIGHT)->EnableWindow(s_settingsDialog->m_loadSkin.border);
    if (s_settingsDialog->m_loadSkin.border)
    {
        if (s_settingsDialog->m_loadSkin.custom_border)
            s_settingsDialog->m_tooltip.SetBorder(s_settingsDialog->m_loadSkin.end_bk, s_settingsDialog->m_loadSkin.border_width, s_settingsDialog->m_loadSkin.border_height);
        else
            s_settingsDialog->m_tooltip.SetBorder(s_settingsDialog->m_loadSkin.border_color, s_settingsDialog->m_loadSkin.border_width, s_settingsDialog->m_loadSkin.border_height);
    }
    else
    {
        s_settingsDialog->m_tooltip.HideBorder();
    } //if

    s_settingsDialog->m_tooltip.SetTransparency(s_settingsDialog->m_loadSkin.transparency);
    s_settingsDialog->m_tooltip.SetDelayTime(PPTOOLTIP_TIME_INITIAL, m_show_time);
    s_settingsDialog->m_tooltip.SetDelayTime(PPTOOLTIP_TIME_AUTOPOP, m_hide_time);
    s_settingsDialog->m_tooltip.SetDelayTime(PPTOOLTIP_TIME_FADEIN, m_fade_in);
    s_settingsDialog->m_tooltip.SetDelayTime(PPTOOLTIP_TIME_FADEOUT, m_fade_out);
    s_settingsDialog->m_tooltip.SetDelayTime(PPTOOLTIP_TIME_ANIMATION, m_animation);
    m_start_bk.SetColour(s_settingsDialog->m_loadSkin.start_bk);
    m_mid_bk.SetColour(s_settingsDialog->m_loadSkin.mid_bk);
    m_end_bk.SetColour(s_settingsDialog->m_loadSkin.end_bk);
    m_border_color.SetColour(s_settingsDialog->m_loadSkin.border_color);
    s_settingsDialog->m_tooltip.SetColorBk(s_settingsDialog->m_loadSkin.start_bk, s_settingsDialog->m_loadSkin.mid_bk, s_settingsDialog->m_loadSkin.end_bk);
    s_settingsDialog->m_tooltip.SetEffectBk(s_settingsDialog->m_loadSkin.effect_bk, s_settingsDialog->m_loadSkin.granularity);
}

BOOL CSettingsDialogApparenceTooltip::PreTranslateMessage(MSG* pMsg)
{
    s_settingsDialog->RelayToolTipEvent(pMsg);

    return CPropertyPage::PreTranslateMessage(pMsg);
}
