// SettingsDialogGen.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "SettingsDialog.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "MultiDllGen.h"
#include "WAEmuwnd.h"
#include "CommonFunc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CSettingsDialogGen


IMPLEMENT_MENUXP(CSettingsDialogGen, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogGen, CPropertyPage)

CSettingsDialogGen::CSettingsDialogGen() : CPropertyPage(CSettingsDialogGen::IDD)
{
    m_current = -1;
}

CSettingsDialogGen::~CSettingsDialogGen()
{
}

void CSettingsDialogGen::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    DDX_Control(pDX, IDC_CONFIG_GEN, m_btnConfiguration);
    DDX_Control(pDX, IDC_LOAD_GEN, m_btnLoad);
    DDX_Control(pDX, IDC_UNLOAD_GEN, m_btnUnload);
    DDX_Control(pDX, IDC_LIST_GEN, m_listGen);
}

BOOL CSettingsDialogGen::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateDlgItemText(this, IDC_CONFIG_GEN);
    m_Helper.translateDlgItemText(this, IDC_LOAD_GEN);
    m_Helper.translateDlgItemText(this, IDC_UNLOAD_GEN);

    return TRUE;
}

BOOL CSettingsDialogGen::OnEraseBkgnd(CDC* pDC)
{
    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcClient;
        GetClientRect(&rcClient);

        VERIFY(pDC->PatBlt(0, 0, rcClient.Width(), rcClient.Height(), BLACKNESS));
        return TRUE;
    }
    return CPropertyPage::OnEraseBkgnd(pDC);
}

BOOL CSettingsDialogGen::OnSetActive()
{
    while (m_listGen.GetCount() != 0)
    {
        m_listGen.DeleteString(0);
    }
    for (int i = 0; i < stdGen.GetSize(); i++)
    {
        CDllGen* gen = stdGen.getDllGen(i);
        CString desc = _T("");
        TCHAR descTCHAR[500];
        Strcpy(descTCHAR, 500, gen->GetDescription());
        desc.Format(_T("%s (%s)"), descTCHAR, gen->GetFileName());
        m_listGen.AddString(desc);
        m_listGen.SetCurSel(i);
        m_current = i;
    }
    return TRUE;
}

void CSettingsDialogGen::OnOK()
{
    UpdateData(TRUE);

    CString dllInKey = _T("");
    for (int i = 0; i < stdGen.GetSize(); i++)
    {
        CDllGen* gen = stdGen.getDllGen(i);
        dllInKey.Format(_T("dllGenName%d"), i);
        AfxGetApp()->WriteProfileString(_T("Preferences"), dllInKey, gen->GetFilePath());
    }
    dllInKey.Format(_T("dllGenName%d"), stdGen.GetSize());
    AfxGetApp()->WriteProfileString(_T("Preferences"), dllInKey, _T("NONE"));
    CPropertyPage::OnOK();
}
BEGIN_MESSAGE_MAP(CSettingsDialogGen, CPropertyPage)
  ON_BN_CLICKED(IDC_CONFIG_GEN, OnBnClickedConfig)
  ON_BN_CLICKED(IDC_LOAD_GEN, OnBnClickedLoad)
  ON_BN_CLICKED(IDC_UNLOAD_GEN, OnBnClickedUnload)
  ON_MENUXP_MESSAGES()
  ON_WM_ERASEBKGND()
END_MESSAGE_MAP()


// Gestionnaires de messages CSettingsDialogGen
void CSettingsDialogGen::OnBnClickedConfig()
{
    for (int i = stdGen.GetSize() - 1; i >= 0; i--)
    {
        if (m_listGen.GetSel(i) != 0)
        {
            CDllGen* gen = stdGen.getDllGen(i);
            gen->Config();
        }
    }
}

void CSettingsDialogGen::OnBnClickedLoad()
{
    CString filter = _T("");
    CFileDialog dialog(TRUE, _T("dll"), _T(""), OFN_FILEMUSTEXIST, m_Helper.MyLoadString(IDS_OPENGEN));
    TCHAR buffer[_MAX_PATH*500 + 1];
    buffer[0] = '\0';
    dialog.m_ofn.lpstrFile = buffer;
    dialog.m_ofn.nMaxFile = _MAX_PATH * 500;
    if (dialog.DoModal() == IDOK)
    {
        int oldSize = stdGen.GetSize();
        stdGen.Load(dialog.GetPathName(), WAEmuWnd.m_hWnd);
        if (oldSize != stdGen.GetSize())
        {
            CDllGen* gen = stdGen.getDllGen(oldSize);
            CString desc = _T("");
            TCHAR descTCHAR[500];
            Strcpy(descTCHAR, 500, gen->GetDescription());
            desc.Format(_T("%s (%s)"), descTCHAR, gen->GetFileName());
            m_listGen.AddString(desc);
        }
    }
}

void CSettingsDialogGen::OnBnClickedUnload()
{
    if (-1 < m_listGen.GetCurSel() && m_listGen.GetCurSel() < stdGen.GetSize())
    {
        int index = m_listGen.GetCurSel();
        m_listGen.DeleteString(index);
        stdGen.UnLoad(index);
        m_current = -1;
        m_listGen.SetCurSel(m_current);
    }
}






