// SettingsDialogHotkeys.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "SettingsDialog.h"
#include "MainWnd.h"
#include "MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSettingsDialog* s_settingsDialog;

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialogHotkeys dialog


CSettingsDialogHotkeys::CSettingsDialogHotkeys() : CPropertyPage(CSettingsDialogHotkeys::IDD)
{
}

CSettingsDialogHotkeys::~CSettingsDialogHotkeys()
{
}


IMPLEMENT_MENUXP(CSettingsDialogHotkeys, CPropertyPage)

IMPLEMENT_DYNAMIC(CSettingsDialogHotkeys, CPropertyPage)

BEGIN_MESSAGE_MAP(CSettingsDialogHotkeys, CPropertyPage)
ON_MENUXP_MESSAGES()
ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialogHotkeys message handlers

bool CSettingsDialogHotkeys::CheckDoubles()
{
    WORD k[26], m[26];

    m_h_albummode.     GetHotKey(k[0], m[0]);
    m_h_tracks.      GetHotKey(k[1], m[1]);
    m_h_album.       GetHotKey(k[2], m[2]);
    m_h_menu.        GetHotKey(k[3], m[3]);
    m_h_trayicon.      GetHotKey(k[4], m[4]);
    m_h_open3.       GetHotKey(k[5], m[5]);
    m_h_back.        GetHotKey(k[6], m[6]);
    m_h_forw.        GetHotKey(k[7], m[7]);
    m_h_np.            GetHotKey(k[8], m[8]);
    m_h_exit.        GetHotKey(k[10], m[10]);
    m_h_mp3info. GetHotKey(k[11], m[11]);
    m_h_vup.       GetHotKey(k[12], m[12]);
    m_h_vdown.       GetHotKey(k[13], m[13]);
    m_h_stop.        GetHotKey(k[14], m[14]);
    m_h_prev.        GetHotKey(k[15], m[15]);
    m_h_play.        GetHotKey(k[16], m[16]);
    m_h_next.        GetHotKey(k[17], m[17]);
    m_h_shuffle. GetHotKey(k[18], m[18]);
    m_h_repeat.      GetHotKey(k[19], m[19]);
    m_h_playlist.      GetHotKey(k[20], m[20]);
    m_h_open2.       GetHotKey(k[21], m[21]);
    m_h_open1.       GetHotKey(k[22], m[22]);
    m_h_minibar. GetHotKey(k[23], m[23]);
    m_h_equalizer.     GetHotKey(k[24], m[24]);
    m_h_automation.    GetHotKey(k[25], m[25]);

    int i, j;
    for (i = 0; i < 26; i++)
        for (j = i + 1; j < 26; j++)
            if (k[i] == k[j] && m[i] == m[j] && !(k[i] == 0 && m[i] == 0))
                return true;

    return false;
}
void CSettingsDialogHotkeys::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_H_AUTOMATION, m_h_automation);
    DDX_Control(pDX, IDC_H_ALBUMMODE, m_h_albummode);
    DDX_Control(pDX, IDC_H_TRACKS, m_h_tracks);
    DDX_Control(pDX, IDC_H_ALBUM, m_h_album);
    DDX_Control(pDX, IDC_H_MENU, m_h_menu);
    DDX_Control(pDX, IDC_H_TRAYICON, m_h_trayicon);
    DDX_Control(pDX, IDC_H_OPEN3, m_h_open3);
    DDX_Control(pDX, IDC_H_BACK, m_h_back);
    DDX_Control(pDX, IDC_H_FORW, m_h_forw);
    DDX_Control(pDX, IDC_H_NP, m_h_np);
    DDX_Control(pDX, IDC_H_EXIT, m_h_exit);
    DDX_Control(pDX, IDC_H_MP3INFO, m_h_mp3info);
    DDX_Control(pDX, IDC_H_VUP, m_h_vup);
    DDX_Control(pDX, IDC_H_VDOWN, m_h_vdown);
    DDX_Control(pDX, IDC_H_STOP, m_h_stop);
    DDX_Control(pDX, IDC_H_PREV, m_h_prev);
    DDX_Control(pDX, IDC_H_PLAY, m_h_play);
    DDX_Control(pDX, IDC_H_NEXT, m_h_next);
    DDX_Control(pDX, IDC_H_SHUFFLE, m_h_shuffle);
    DDX_Control(pDX, IDC_H_REPEAT, m_h_repeat);
    DDX_Control(pDX, IDC_H_PLAYLIST, m_h_playlist);
    DDX_Control(pDX, IDC_H_OPEN2, m_h_open2);
    DDX_Control(pDX, IDC_H_OPEN1, m_h_open1);
    DDX_Control(pDX, IDC_H_MINIBAR, m_h_minibar);
    DDX_Control(pDX, IDC_H_EQUALIZER, m_h_equalizer);
}


void CSettingsDialogHotkeys::OnCancel()
{
    s_mainWnd.RegHotKeys();

    CPropertyPage::OnCancel();
}

BOOL CSettingsDialogHotkeys::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_SETTINGS_HOTKEYS);
    m_Helper.translateDlgItemText(this, IDC_LPLAYPAUSE);
    m_Helper.translateDlgItemText(this, IDC_LPREVNEXT);
    m_Helper.translateDlgItemText(this, IDC_LBACKFORW);
    m_Helper.translateDlgItemText(this, IDC_LVOLUME);
    m_Helper.translateDlgItemText(this, IDC_LOPENFILEURL);
    m_Helper.translateDlgItemText(this, IDC_LMIMIBAR);
    m_Helper.translateDlgItemText(this, IDC_LPLAYLIST);
    m_Helper.translateDlgItemText(this, IDC_LEQUALIZER);
    m_Helper.translateDlgItemText(this, IDC_LINFO);
    m_Helper.translateDlgItemText(this, IDC_LREPEAT);
    m_Helper.translateDlgItemText(this, IDC_LSHUFFLE);
    m_Helper.translateDlgItemText(this, IDC_LALBUMMODE);
    m_Helper.translateDlgItemText(this, IDC_LTRACKALBUM);
    m_Helper.translateDlgItemText(this, IDC_LAUTOMATION);
    m_Helper.translateDlgItemText(this, IDC_LNPCLIP);
    m_Helper.translateDlgItemText(this, IDC_LSHOWHIDETRAY);
    m_Helper.translateDlgItemText(this, IDC_LEXIT);
    m_Helper.translateDlgItemText(this, IDOK);
    m_Helper.translateDlgItemText(this, IDCANCEL);

    s_mainWnd.UnregHotKeys();

    WORD k, m;

    k = (WORD)s_mainWnd.m_forwKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_forwMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_forwMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_forwMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_forw.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_backKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_backMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_backMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_backMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_back.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_exitKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_exitMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_exitMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_exitMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_exit.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_NPKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_NPMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_NPMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_NPMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_np.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_playKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_playMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_playMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_playMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_play.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_stopKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_stopMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_stopMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_stopMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_stop.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_prevKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_prevMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_prevMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_prevMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_prev.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_nextKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_nextMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_nextMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_nextMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_next.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_vDownKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_vDownMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_vDownMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_vDownMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_vdown.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_vUpKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_vUpMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_vUpMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_vUpMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_vup.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_openKey1;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_openMod1 & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_openMod1 & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_openMod1 & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_open1.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_openKey2;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_openMod2 & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_openMod2 & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_openMod2 & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_open2.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_openKey3;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_openMod3 & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_openMod3 & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_openMod3 & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_open3.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_minibarKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_minibarMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_minibarMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_minibarMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_minibar.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_MP3InfoKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_MP3InfoMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_MP3InfoMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_MP3InfoMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_mp3info.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_playlistKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_playlistMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_playlistMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_playlistMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_playlist.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_equalizerKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_equalizerMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_equalizerMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_equalizerMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_equalizer.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_repeatKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_repeatMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_repeatMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_repeatMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_repeat.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_shuffleKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_shuffleMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_shuffleMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_shuffleMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_shuffle.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_albumModeKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_albumModeMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_albumModeMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_albumModeMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_albummode.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_trayIconKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_trayIconMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_trayIconMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_trayIconMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_trayicon.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_menuKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_menuMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_menuMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_menuMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_menu.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_tracksKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_tracksMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_tracksMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_tracksMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_tracks.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_albumKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_albumMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_albumMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_albumMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_album.SetHotKey(k, m);

    k = (WORD)s_mainWnd.m_automationKey;
    m = (k >= VK_PRIOR && k <= VK_DOWN || k == VK_INSERT || k == VK_DELETE) ? HOTKEYF_EXT : 0;
    if (s_mainWnd.m_automationMod & MOD_ALT)
        m |= HOTKEYF_ALT;
    if (s_mainWnd.m_automationMod & MOD_CONTROL)
        m |= HOTKEYF_CONTROL;
    if (s_mainWnd.m_automationMod & MOD_SHIFT)
        m |= HOTKEYF_SHIFT;
    m_h_automation.SetHotKey(k, m);

    UpdateData(FALSE);

    return TRUE;
}

BOOL CSettingsDialogHotkeys::OnEraseBkgnd(CDC* pDC)
{    
    CDwmApiImpl dwmApi;

    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcPlaceholder, rcPlaceholder2;
        CRect rcClient;
        s_settingsDialog->GetClientRect(rcClient);

        GetDlgItem(IDC_H_PLAY)->GetWindowRect(rcPlaceholder);
        GetDlgItem(IDC_H_EXIT)->GetWindowRect(rcPlaceholder2);
        rcPlaceholder.right = rcPlaceholder2.right;
        rcPlaceholder.bottom = rcPlaceholder2.bottom;
        s_settingsDialog->ScreenToClient(rcPlaceholder);
        rcPlaceholder.DeflateRect(1, 1);

        MARGINS marGlassInset =
        {
            rcPlaceholder.left, rcClient.right - rcPlaceholder.right, rcPlaceholder.top, rcClient.bottom - rcPlaceholder.bottom
        };

        CRect rcScratch = rcClient;
        s_settingsDialog->ClientToScreen(rcPlaceholder);
        ScreenToClient(rcPlaceholder);
        GetClientRect(rcClient);

        rcScratch = rcClient;
        rcScratch.right = rcPlaceholder.left;
        pDC->PatBlt(rcScratch.left, rcScratch.top, rcScratch.Width(), rcScratch.Height(), BLACKNESS);
        rcScratch = rcClient;
        rcScratch.bottom = rcPlaceholder.top;
        pDC->PatBlt(rcScratch.left, rcScratch.top, rcScratch.Width(), rcScratch.Height(), BLACKNESS);

        rcScratch = rcClient;
        rcScratch.left = rcScratch.right - (rcClient.right - rcPlaceholder.right);
        pDC->PatBlt(rcScratch.left, rcScratch.top, rcScratch.Width(), rcScratch.Height(), BLACKNESS);

        rcScratch = rcClient;
        rcScratch.top = rcScratch.bottom - (rcClient.bottom - rcPlaceholder.bottom);
        pDC->PatBlt(rcScratch.left, rcScratch.top, rcScratch.Width(), rcScratch.Height(), BLACKNESS);

        rcScratch = rcPlaceholder;
        rcScratch.InflateRect(1, 1);
        pDC->PatBlt(rcScratch.left, rcScratch.top, rcScratch.Width(), rcScratch.Height(), WHITENESS);

        SUCCEEDED(dwmApi.DwmExtendFrameIntoClientArea(GetParent()->m_hWnd, &marGlassInset));

        return TRUE;
    }
    return CPropertyPage::OnEraseBkgnd(pDC);
}

BOOL CSettingsDialogHotkeys::OnSetActive()
{
    CDwmApiImpl dwmApi;

    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcPlaceholder, rcPlaceholder2;
        CRect rcClient;
        s_settingsDialog->GetClientRect(rcClient);

        GetDlgItem(IDC_H_PLAY)->GetWindowRect(rcPlaceholder);
        GetDlgItem(IDC_H_EXIT)->GetWindowRect(rcPlaceholder2);
        rcPlaceholder.right = rcPlaceholder2.right;
        rcPlaceholder.bottom = rcPlaceholder2.bottom;
        s_settingsDialog->ScreenToClient(rcPlaceholder);
        rcPlaceholder.DeflateRect(1, 1);

    }
    return TRUE;
}

BOOL CSettingsDialogHotkeys::OnKillActive()
{
    CDwmApiImpl dwmApi;

    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        MARGINS marGlassInset =
        {
            -1, -1, -1, -1
        };
        SUCCEEDED(dwmApi.DwmExtendFrameIntoClientArea(GetParent()->m_hWnd, &marGlassInset));
    }
    return TRUE;
}

void CSettingsDialogHotkeys::OnOK()
{
    if (CheckDoubles())
    {
        MessageBox(m_Helper.MyLoadString(IDS_HOTKEYS), _T("STP"), MB_OK | MB_ICONERROR);
        return;
    }
    WORD k, m;

    m_h_forw.GetHotKey(k, m);
    s_mainWnd.m_forwKey = (UINT)k;
    s_mainWnd.m_forwMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_forwMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_forwMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_forwMod |= MOD_SHIFT;

    m_h_back.GetHotKey(k, m);
    s_mainWnd.m_backKey = (UINT)k;
    s_mainWnd.m_backMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_backMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_backMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_backMod |= MOD_SHIFT;

    m_h_exit.GetHotKey(k, m);
    s_mainWnd.m_exitKey = (UINT)k;
    s_mainWnd.m_exitMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_exitMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_exitMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_exitMod |= MOD_SHIFT;

    m_h_np.GetHotKey(k, m);
    s_mainWnd.m_NPKey = (UINT)k;
    s_mainWnd.m_NPMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_NPMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_NPMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_NPMod |= MOD_SHIFT;

    m_h_play.GetHotKey(k, m);
    s_mainWnd.m_playKey = (UINT)k;
    s_mainWnd.m_playMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_playMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_playMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_playMod |= MOD_SHIFT;

    m_h_stop.GetHotKey(k, m);
    s_mainWnd.m_stopKey = (UINT)k;
    s_mainWnd.m_stopMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_stopMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_stopMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_stopMod |= MOD_SHIFT;

    m_h_prev.GetHotKey(k, m);
    s_mainWnd.m_prevKey = (UINT)k;
    s_mainWnd.m_prevMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_prevMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_prevMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_prevMod |= MOD_SHIFT;

    m_h_next.GetHotKey(k, m);
    s_mainWnd.m_nextKey = (UINT)k;
    s_mainWnd.m_nextMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_nextMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_nextMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_nextMod |= MOD_SHIFT;

    m_h_vdown.GetHotKey(k, m);
    s_mainWnd.m_vDownKey = (UINT)k;
    s_mainWnd.m_vDownMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_vDownMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_vDownMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_vDownMod |= MOD_SHIFT;

    m_h_vup.GetHotKey(k, m);
    s_mainWnd.m_vUpKey = (UINT)k;
    s_mainWnd.m_vUpMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_vUpMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_vUpMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_vUpMod |= MOD_SHIFT;

    m_h_open1.GetHotKey(k, m);
    s_mainWnd.m_openKey1 = (UINT)k;
    s_mainWnd.m_openMod1 = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_openMod1 |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_openMod1 |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_openMod1 |= MOD_SHIFT;

    m_h_open2.GetHotKey(k, m);
    s_mainWnd.m_openKey2 = (UINT)k;
    s_mainWnd.m_openMod2 = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_openMod2 |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_openMod2 |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_openMod2 |= MOD_SHIFT;

    m_h_open3.GetHotKey(k, m);
    s_mainWnd.m_openKey3 = (UINT)k;
    s_mainWnd.m_openMod3 = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_openMod3 |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_openMod3 |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_openMod3 |= MOD_SHIFT;

    m_h_minibar.GetHotKey(k, m);
    s_mainWnd.m_minibarKey = (UINT)k;
    s_mainWnd.m_minibarMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_minibarMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_minibarMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_minibarMod |= MOD_SHIFT;

    m_h_mp3info.GetHotKey(k, m);
    s_mainWnd.m_MP3InfoKey = (UINT)k;
    s_mainWnd.m_MP3InfoMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_MP3InfoMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_MP3InfoMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_MP3InfoMod |= MOD_SHIFT;

    m_h_playlist.GetHotKey(k, m);
    s_mainWnd.m_playlistKey = (UINT)k;
    s_mainWnd.m_playlistMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_playlistMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_playlistMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_playlistMod |= MOD_SHIFT;

    m_h_equalizer.GetHotKey(k, m);
    s_mainWnd.m_equalizerKey = (UINT)k;
    s_mainWnd.m_equalizerMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_equalizerMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_equalizerMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_equalizerMod |= MOD_SHIFT;

    m_h_repeat.GetHotKey(k, m);
    s_mainWnd.m_repeatKey = (UINT)k;
    s_mainWnd.m_repeatMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_repeatMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_repeatMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_repeatMod |= MOD_SHIFT;

    m_h_shuffle.GetHotKey(k, m);
    s_mainWnd.m_shuffleKey = (UINT)k;
    s_mainWnd.m_shuffleMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_shuffleMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_shuffleMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_shuffleMod |= MOD_SHIFT;

    m_h_albummode.GetHotKey(k, m);
    s_mainWnd.m_albumModeKey = (UINT)k;
    s_mainWnd.m_albumModeMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_albumModeMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_albumModeMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_albumModeMod |= MOD_SHIFT;

    m_h_trayicon.GetHotKey(k, m);
    s_mainWnd.m_trayIconKey = (UINT)k;
    s_mainWnd.m_trayIconMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_trayIconMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_trayIconMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_trayIconMod |= MOD_SHIFT;

    m_h_menu.GetHotKey(k, m);
    s_mainWnd.m_menuKey = (UINT)k;
    s_mainWnd.m_menuMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_menuMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_menuMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_menuMod |= MOD_SHIFT;

    m_h_tracks.GetHotKey(k, m);
    s_mainWnd.m_tracksKey = (UINT)k;
    s_mainWnd.m_tracksMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_tracksMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_tracksMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_tracksMod |= MOD_SHIFT;

    m_h_album.GetHotKey(k, m);
    s_mainWnd.m_albumKey = (UINT)k;
    s_mainWnd.m_albumMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_albumMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_albumMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_albumMod |= MOD_SHIFT;

    m_h_automation.GetHotKey(k, m);
    s_mainWnd.m_automationKey = (UINT)k;
    s_mainWnd.m_automationMod = 0;
    if (m & HOTKEYF_ALT)
        s_mainWnd.m_automationMod |= MOD_ALT;
    if (m & HOTKEYF_CONTROL)
        s_mainWnd.m_automationMod |= MOD_CONTROL;
    if (m & HOTKEYF_SHIFT)
        s_mainWnd.m_automationMod |= MOD_SHIFT;

    s_mainWnd.RegHotKeys();

    CPropertyPage::OnOK();
}