// SettingsDialogInput.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "SysTrayPlay.h"
#include "SettingsDialog.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "MultiDllInput.h"
#include "MultiDlloutput.h"
#include "WAEmuwnd.h"
#include "CommonFunc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CSettingsDialogInput


IMPLEMENT_MENUXP(CSettingsDialogInput, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogInput, CPropertyPage)

CSettingsDialogInput::CSettingsDialogInput() : CPropertyPage(CSettingsDialogInput::IDD)
{
    m_current = -1;
}

CSettingsDialogInput::~CSettingsDialogInput()
{
}

void CSettingsDialogInput::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    DDX_Text(pDX, IDC_GAP, m_gap);
    DDX_Control(pDX, IDC_ABOUT_INPUT, m_btnAbout);
    DDX_Control(pDX, IDC_CONFIG_INPUT, m_btnConfiguration);
    DDX_Control(pDX, IDC_LOAD_INPUT, m_btnLoad);
    DDX_Control(pDX, IDC_UNLOAD_INPUT, m_btnUnload);
    DDX_Control(pDX, IDC_LIST_INPUT, m_listInput);
    DDX_Control(pDX, IDC_INPUTDOWN, m_btnDown);
    DDX_Control(pDX, IDC_INPUTUP, m_btnUp);
}

BOOL CSettingsDialogInput::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateDlgItemText(this, IDC_LGAP);
    m_Helper.translateDlgItemText(this, IDC_LMILLISECONDS);
    m_Helper.translateDlgItemText(this, IDC_CONFIG_INPUT);
    m_Helper.translateDlgItemText(this, IDC_ABOUT_INPUT);
    m_Helper.translateDlgItemText(this, IDC_LOAD_INPUT);
    m_Helper.translateDlgItemText(this, IDC_UNLOAD_INPUT);

    m_gap = s_mainWnd.m_gapBtwTracks;

    m_btnDown.SetIcon((HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_ICON_DOWN), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR));
    m_btnUp.SetIcon((HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_ICON_UP), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR));

    UpdateData(FALSE);

    return TRUE;
}

BOOL CSettingsDialogInput::OnEraseBkgnd(CDC* pDC)
{
    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcClient;
        GetClientRect(&rcClient);

        VERIFY(pDC->PatBlt(0, 0, rcClient.Width(), rcClient.Height(), BLACKNESS));
        return TRUE;
    }
    return CPropertyPage::OnEraseBkgnd(pDC);
}

BOOL CSettingsDialogInput::OnSetActive()
{
    while (m_listInput.GetCount() != 0)
    {
        m_listInput.DeleteString(0);
    }
    for (int i = 0; i < stdIn.GetSize(); i++)
    {
        CDllInput* input = stdIn.getDllInput(i);
        CString desc;
        TCHAR descTCHAR[500];
        Strcpy(descTCHAR, 500, input->GetDescription());
        desc.Format(_T("%s (%s)"), descTCHAR, input->GetFileName());
        m_listInput.AddString(desc);
        if (stdIn.GetIn_Module() == input->GetIn_Module())
        {
            m_listInput.SetCurSel(i);
            m_current = i;
        }
    }
    return TRUE;
}

void CSettingsDialogInput::OnOK()
{
    UpdateData(TRUE);

    s_mainWnd.m_gapBtwTracks = m_gap;
    CPropertyPage::OnOK();
}
BEGIN_MESSAGE_MAP(CSettingsDialogInput, CPropertyPage)
  ON_BN_CLICKED(IDC_CONFIG_INPUT, OnBnClickedConfig)
  ON_BN_CLICKED(IDC_ABOUT_INPUT, OnBnClickedAbout)
  ON_BN_CLICKED(IDC_LOAD_INPUT, OnBnClickedLoad)
  ON_BN_CLICKED(IDC_UNLOAD_INPUT, OnBnClickedUnload)
  ON_BN_CLICKED(IDC_INPUTDOWN, OnBnClickedDown)
  ON_BN_CLICKED(IDC_INPUTUP, OnBnClickedUp)
  ON_LBN_SELCHANGE(IDC_LIST_INPUT,OnListChange)
  ON_MENUXP_MESSAGES()
  ON_WM_ERASEBKGND()
END_MESSAGE_MAP()


// Gestionnaires de messages CSettingsDialogInput
void CSettingsDialogInput::OnBnClickedConfig()
{
    for (int i = stdIn.GetSize() - 1; i >= 0; i--)
    {
        if (m_listInput.GetSel(i) != 0)
        {
            CDllInput* input = stdIn.getDllInput(i);
            input->Config(GetParent()->m_hWnd);
        }
    }
}

void CSettingsDialogInput::OnBnClickedAbout()
{
    for (int i = stdIn.GetSize() - 1; i >= 0; i--)
    {
        if (m_listInput.GetSel(i) != 0)
        {
            CDllInput* input = stdIn.getDllInput(i);
            input->About(GetParent()->m_hWnd);
        }
    }
}

void CSettingsDialogInput::OnBnClickedLoad()
{
    CString filter = _T("");
    CFileDialog dialog(TRUE, _T("dll"), _T(""), OFN_FILEMUSTEXIST, m_Helper.MyLoadString(IDS_OPENINPUT));
    TCHAR buffer[_MAX_PATH*500 + 1];
    buffer[0] = '\0';
    dialog.m_ofn.lpstrFile = buffer;
    dialog.m_ofn.nMaxFile = _MAX_PATH * 500;
    if (dialog.DoModal() == IDOK)
    {
        int oldSize = stdIn.GetSize();
        stdIn.Load(dialog.GetPathName(), WAEmuWnd.m_hWnd);
        if (oldSize != stdIn.GetSize())
        {
            CDllInput* input = stdIn.getDllInput(oldSize);
            stdIn.SetOutMod(stdOut.GetOut_Module());
            CString desc = _T("");
            TCHAR descTCHAR[500];
            Strcpy(descTCHAR, 500, input->GetDescription());
            desc.Format(_T("%s (%s)"), descTCHAR, input->GetFileName());
            m_listInput.AddString(desc);
            m_current = -1;
            m_listInput.SetCurSel(m_current);
        }
    }
}

void CSettingsDialogInput::OnBnClickedUnload()
{
    if (-1 < m_listInput.GetCurSel() && m_listInput.GetCurSel() < stdIn.GetSize())
    {
        int index = m_listInput.GetCurSel();
        CDllInput* input = stdIn.getDllInput(index);
        if (input->GetFilePath() != "STANDARD")
        {
            if (input->GetIn_Module() == stdIn.GetIn_Module() && input->GetPlayerMode() != PLAYER_MODE_CLOSE)
                ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
            stdIn.UnLoad(index);
            m_listInput.DeleteString(index);
            m_current = -1;
            m_listInput.SetCurSel(m_current);
        }
    }
}

void CSettingsDialogInput::OnListChange()
{
    m_current = m_listInput.GetCurSel();
}

void CSettingsDialogInput::OnBnClickedDown()
{
    UpdateData(TRUE);
    if (m_current >= 0 && m_current < stdIn.GetSize() - 1)
    {
        stdIn.UpDllInput(m_current + 1);
        CDllInput* input = stdIn.getDllInput(m_current);
        CString desc = _T("");
        TCHAR descTCHAR[500];
        Strcpy(descTCHAR, 500, input->GetDescription());
        desc.Format(_T("%s (%s)"), descTCHAR, input->GetFileName());
        m_listInput.DeleteString(m_current + 1);
        m_listInput.InsertString(m_current, desc);
        m_current++;
        m_listInput.SetCurSel(m_current);
    }
}

void CSettingsDialogInput::OnBnClickedUp()
{
    UpdateData(TRUE);
    if (m_current > 0 && m_current <= stdIn.GetSize() - 1)
    {
        stdIn.UpDllInput(m_current);
        CDllInput* input = stdIn.getDllInput(m_current - 1);
        CString desc = _T("");
        TCHAR descTCHAR[500];
        Strcpy(descTCHAR, 500, input->GetDescription());
        desc.Format(_T("%s (%s)"), descTCHAR, input->GetFileName());
        m_listInput.DeleteString(m_current);
        m_listInput.InsertString(m_current - 1, desc);
        m_current--;
        m_listInput.SetCurSel(m_current);
    }
}