// SettingsDialogMouseClicks.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "SettingsDialog.h"
#include "MainHelper.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CSettingsDialogMouseClicks

IMPLEMENT_MENUXP(CSettingsDialogMouseClicks, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogMouseClicks, CPropertyPage)
CSettingsDialogMouseClicks::CSettingsDialogMouseClicks() : CPropertyPage(CSettingsDialogMouseClicks::IDD)
{
    m_noclicks = FALSE;
}

CSettingsDialogMouseClicks::~CSettingsDialogMouseClicks()
{
}

bool CSettingsDialogMouseClicks::CheckClicks()
{
    for(int i = 0;i < 8;i++)
    {
        if (m_iclicks[i] == IDS_CLICKS10 - IDS_CLICKS0)
            return true;
    }
    return false;
}

void CSettingsDialogMouseClicks::DoDataExchange(CDataExchange* pDX)
{
    CPropertyPage::DoDataExchange(pDX);
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    DDX_Control(pDX, IDC_CLICKS1, m_clicks[0]);
    DDX_Control(pDX, IDC_CLICKS2, m_clicks[1]);
    DDX_Control(pDX, IDC_CLICKS3, m_clicks[2]);
    DDX_Control(pDX, IDC_CLICKS4, m_clicks[3]);
    DDX_Control(pDX, IDC_CLICKSR1, m_clicks[4]);
    DDX_Control(pDX, IDC_CLICKSR2, m_clicks[5]);
    DDX_Control(pDX, IDC_CLICKSR3, m_clicks[6]);
    DDX_Control(pDX, IDC_CLICKSR4, m_clicks[7]);
    DDX_Check(pDX, IDC_NOCLICKS, m_noclicks);

    DDX_CBIndex(pDX, IDC_CLICKS1, m_iclicks[0]);
    DDX_CBIndex(pDX, IDC_CLICKS2, m_iclicks[1]);
    DDX_CBIndex(pDX, IDC_CLICKS3, m_iclicks[2]);
    DDX_CBIndex(pDX, IDC_CLICKS4, m_iclicks[3]);
    DDX_CBIndex(pDX, IDC_CLICKSR1, m_iclicks[4]);
    DDX_CBIndex(pDX, IDC_CLICKSR2, m_iclicks[5]);
    DDX_CBIndex(pDX, IDC_CLICKSR3, m_iclicks[6]);
    DDX_CBIndex(pDX, IDC_CLICKSR4, m_iclicks[7]);

    DDX_Check(pDX, IDC_NOCLICKS, m_noclicks);
    DDX_Control(pDX, IDC_PANDH, m_pandh);
}

BOOL CSettingsDialogMouseClicks::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateDlgItemText(this, IDC_LPRESSHOLD);
    m_Helper.translateDlgItemText(this, IDC_NOCLICKS);
    m_Helper.translateDlgItemText(this, IDC_LG1);
    m_Helper.translateDlgItemText(this, IDC_LG2);
    m_Helper.translateDlgItemText(this, IDC_LG3);
    m_Helper.translateDlgItemText(this, IDC_LG4);
    m_Helper.translateDlgItemText(this, IDC_LR1);
    m_Helper.translateDlgItemText(this, IDC_LR2);
    m_Helper.translateDlgItemText(this, IDC_LR3);
    m_Helper.translateDlgItemText(this, IDC_LR4);

    for(int i = 0;i < 8;i++)
    {
        m_iclicks[i] = s_mainWnd.m_clicks[i];
        for(int j = 0;j < 12;j++)
        {
            m_clicks[i].AddString(m_Helper.MyLoadString(IDS_CLICKS0 + j));
        }
        m_clicks[i].EnableWindow(!m_noclicks);
    }

    m_pandh.AddString(m_Helper.MyLoadString(IDS_PANDH1));
    m_pandh.AddString(m_Helper.MyLoadString(IDS_PANDH2));
    m_pandh.AddString(m_Helper.MyLoadString(IDS_PANDH3));

    m_noclicks = s_mainWnd.m_noClicks;

    switch (s_mainWnd.m_pressAndHold)
    {
        case 2:
            m_pandh.SetCurSel(0);
            break;
        case 0:
            m_pandh.SetCurSel(1);
            break;
        case 1:
            m_pandh.SetCurSel(2);
            break;
    }

    m_pandh.EnableWindow(!m_noclicks);

    UpdateData(FALSE);

    return TRUE;
}

BOOL CSettingsDialogMouseClicks::OnEraseBkgnd(CDC* pDC)
{
    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcClient;
        GetClientRect(&rcClient);

        VERIFY(pDC->PatBlt(0, 0, rcClient.Width(), rcClient.Height(), BLACKNESS));
        return TRUE;
    }
    return CPropertyPage::OnEraseBkgnd(pDC);
}

void CSettingsDialogMouseClicks::OnOK()
{
    UpdateData(TRUE);
    if (!CheckClicks())
    {
        MessageBox(m_Helper.MyLoadString(IDS_WRONGCLICKS), _T("STP"), MB_OK | MB_ICONERROR);
        CPropertyPage::OnCancel();
        return;
    }

    switch (m_pandh.GetCurSel())
    {
        case 0:
            s_mainWnd.m_pressAndHold = 2;
            break;
        case 1:
            s_mainWnd.m_pressAndHold = 0;
            break;
        case 2:
            s_mainWnd.m_pressAndHold = 1;
            break;
    }
    s_mainWnd.m_noClicks = m_noclicks;

    for(int i = 0;i < 8;i++)
    {
        s_mainWnd.m_clicks[i] = m_iclicks[i];
    }

    CPropertyPage::OnOK();
}

void CSettingsDialogMouseClicks::OnNoClicks()
{
    UpdateData(TRUE);

    for(int i = 0;i < 8;i++)
    {
        m_clicks[i].EnableWindow(!m_noclicks);
    }
    m_pandh.EnableWindow(!m_noclicks);
}
BEGIN_MESSAGE_MAP(CSettingsDialogMouseClicks, CPropertyPage)
    ON_BN_CLICKED(IDC_NOCLICKS, OnNoClicks)
    ON_MENUXP_MESSAGES()
    ON_WM_ERASEBKGND()
END_MESSAGE_MAP()


// Gestionnaires de messages CSettingsDialogMouseClicks
