// SettingsDialogW2File.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "aeroglss.h"
#include "SettingsDialog.h"
#include "MainWnd.h"
#include "MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialogW2File dialog
IMPLEMENT_MENUXP(CSettingsDialogW2File, CPropertyPage);
IMPLEMENT_DYNAMIC(CSettingsDialogW2File, CPropertyPage)

CSettingsDialogW2File::CSettingsDialogW2File() : CPropertyPage(CSettingsDialogW2File::IDD)
{
    m_del = FALSE;
    m_exit = _T("");
    m_file = _T("");
    m_oem = FALSE;
    m_pause = _T("");
    m_play = _T("");
    m_stop = _T("");
    m_enabled = FALSE;
    m_ftp = FALSE;
}


void CSettingsDialogW2File::DoDataExchange(CDataExchange* pDX)
{
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    CPropertyPage::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_W2FBROWSE, m_btnBrowse);
    DDX_Check(pDX, IDC_W2FDELONEXIT, m_del);
    DDX_Text(pDX, IDC_W2FEXIT, m_exit);
    DDX_Text(pDX, IDC_W2FFILE, m_file);
    DDX_Check(pDX, IDC_W2FOEM, m_oem);
    DDX_Text(pDX, IDC_W2FPAUSE, m_pause);
    DDX_Text(pDX, IDC_W2FPLAY, m_play);
    DDX_Text(pDX, IDC_W2FSTOP, m_stop);
    DDX_Check(pDX, IDC_W2FENABLE, m_enabled);
    DDX_Check(pDX, IDC_W2FFTP, m_ftp);
    DDX_Text(pDX, IDC_W2FSITE, m_site);
    DDX_Text(pDX, IDC_W2FUSER, m_user);
    DDX_Text(pDX, IDC_W2FPASSWORD, m_password);
}


BEGIN_MESSAGE_MAP(CSettingsDialogW2File, CPropertyPage)
    ON_BN_CLICKED(IDC_W2FBROWSE, OnBrowse)
    ON_BN_CLICKED(IDC_W2FFTP, OnBnClickedW2fftp)
    ON_BN_CLICKED(IDC_W2FENABLE, OnBnClickedW2fenable)
    ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialogW2File message handlers

BOOL CSettingsDialogW2File::OnInitDialog()
{
    CPropertyPage::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_SETTINGS_W2FILE);
    m_Helper.translateDlgItemText(this, IDC_LW2FEXIT);
    m_Helper.translateDlgItemText(this, IDC_LW2FFILENAME);
    m_Helper.translateDlgItemText(this, IDC_LW2FFORMAT);
    m_Helper.translateDlgItemText(this, IDC_LW2FPAUSE);
    m_Helper.translateDlgItemText(this, IDC_LW2FPLAY);
    m_Helper.translateDlgItemText(this, IDC_LW2FSTOP);
    m_Helper.translateDlgItemText(this, IDC_W2FENABLE);
    m_Helper.translateDlgItemText(this, IDC_W2FDELONEXIT);
    m_Helper.translateDlgItemText(this, IDC_W2FOEM);
    m_Helper.translateDlgItemText(this, IDC_W2FBROWSE);
    m_Helper.translateDlgItemText(this, IDC_W2FFTP);
    m_Helper.translateDlgItemText(this, IDC_LUPLOADONFTP);
    m_Helper.translateDlgItemText(this, IDC_LW2FSITE);
    m_Helper.translateDlgItemText(this, IDC_LW2FUSER);
    m_Helper.translateDlgItemText(this, IDC_LW2FPASSWORD);

    m_file = s_mainWnd.m_W2Ffile;

    m_play = s_mainWnd.m_W2Fplay;
    m_pause = s_mainWnd.m_W2Fpause;
    m_stop = s_mainWnd.m_W2Fstop;
    m_exit = s_mainWnd.m_W2Fexit;


    m_play.Replace(_T("\\r"), _T("\r"));
    m_play.Replace(_T("\\n"), _T("\n"));

    m_pause.Replace(_T("\\r"), _T("\r"));
    m_pause.Replace(_T("\\n"), _T("\n"));

    m_stop.Replace(_T("\\r"), _T("\r"));
    m_stop.Replace(_T("\\n"), _T("\n"));

    m_exit.Replace(_T("\\r"), _T("\r"));
    m_exit.Replace(_T("\\n"), _T("\n"));

    m_oem = s_mainWnd.m_W2Foem;
    m_del = s_mainWnd.m_W2Fdel;
    m_enabled = s_mainWnd.m_W2Fenabled;
    m_ftp = s_mainWnd.m_W2FFtp;
    m_site = s_mainWnd.m_W2FSite;
    m_user = s_mainWnd.m_W2FUser;
    m_password = s_mainWnd.m_W2FPassword;

    GetDlgItem(IDC_W2FFILE)->EnableWindow(m_ftp);
    GetDlgItem(IDC_W2FSITE)->EnableWindow(m_ftp);
    GetDlgItem(IDC_W2FUSER)->EnableWindow(m_ftp);
    GetDlgItem(IDC_W2FPASSWORD)->EnableWindow(m_ftp);
    GetDlgItem(IDC_W2FBROWSE)->EnableWindow(!m_ftp);

    UpdateData(FALSE);

    OnBnClickedW2fenable();

    return TRUE;
}

BOOL CSettingsDialogW2File::OnEraseBkgnd(CDC* pDC)
{
    CDwmApiImpl dwmApi;
    if (dwmApi.Initialize() && dwmApi.IsDwmCompositionEnabled())
    {
        CRect rcClient;
        GetClientRect(&rcClient);

        VERIFY(pDC->PatBlt(0, 0, rcClient.Width(), rcClient.Height(), BLACKNESS));
        return TRUE;
    }
    return CPropertyPage::OnEraseBkgnd(pDC);
}

void CSettingsDialogW2File::OnOK()
{
    UpdateData(TRUE);

    s_mainWnd.m_W2Ffile = m_file;
    s_mainWnd.m_W2Fplay = m_play;
    s_mainWnd.m_W2Fpause = m_pause;
    s_mainWnd.m_W2Fstop = m_stop;
    s_mainWnd.m_W2Fexit = m_exit;

    s_mainWnd.m_W2Fplay.Replace(_T("\r"), _T("\\r"));
    s_mainWnd.m_W2Fplay.Replace(_T("\n"), _T("\\n"));

    s_mainWnd.m_W2Fpause.Replace(_T("\r"), _T("\\r"));
    s_mainWnd.m_W2Fpause.Replace(_T("\n"), _T("\\n"));

    s_mainWnd.m_W2Fstop.Replace(_T("\r"), _T("\\r"));
    s_mainWnd.m_W2Fstop.Replace(_T("\n"), _T("\\n"));

    s_mainWnd.m_W2Fexit.Replace(_T("\r"), _T("\\r"));
    s_mainWnd.m_W2Fexit.Replace(_T("\n"), _T("\\n"));

    s_mainWnd.m_W2Foem = m_oem;
    s_mainWnd.m_W2Fdel = m_del;
    s_mainWnd.m_W2Fenabled = m_enabled;
    s_mainWnd.m_W2FFtp = m_ftp;
    s_mainWnd.m_W2FSite = m_site;
    s_mainWnd.m_W2FUser = m_user;
    s_mainWnd.m_W2FPassword = m_password;

    CPropertyPage::OnOK();
}

void CSettingsDialogW2File::OnBrowse()
{
    CFileDialog dialog(FALSE, _T("txt"), _T(""), OFN_OVERWRITEPROMPT, m_Helper.MyLoadString(IDS_OPENW2FFILE));

    if (dialog.DoModal() == IDOK)
    {
        m_file = dialog.GetPathName();
        UpdateData(FALSE);
    }
}

void CSettingsDialogW2File::OnBnClickedW2fftp()
{
    UpdateData(TRUE);
    GetDlgItem(IDC_W2FFILE)->EnableWindow(m_ftp);
    GetDlgItem(IDC_W2FSITE)->EnableWindow(m_ftp);
    GetDlgItem(IDC_W2FUSER)->EnableWindow(m_ftp);
    GetDlgItem(IDC_W2FPASSWORD)->EnableWindow(m_ftp);
    GetDlgItem(IDC_W2FBROWSE)->EnableWindow(!m_ftp);

    GetDlgItem(IDC_W2FFILE)->Invalidate();
    GetDlgItem(IDC_W2FSITE)->Invalidate();
    GetDlgItem(IDC_W2FUSER)->Invalidate();
    GetDlgItem(IDC_W2FPASSWORD)->Invalidate();
    GetDlgItem(IDC_W2FBROWSE)->Invalidate();
}
void CSettingsDialogW2File::OnBnClickedW2fenable()
{
    UpdateData(TRUE);

    GetDlgItem(IDC_W2FBROWSE)->EnableWindow(m_enabled && !m_ftp);
    GetDlgItem(IDC_W2FFTP)->EnableWindow(m_enabled);
    GetDlgItem(IDC_W2FFILE)->EnableWindow(m_enabled && m_ftp);
    GetDlgItem(IDC_W2FSITE)->EnableWindow(m_enabled && m_ftp);
    GetDlgItem(IDC_W2FUSER)->EnableWindow(m_enabled && m_ftp);
    GetDlgItem(IDC_W2FPASSWORD)->EnableWindow(m_enabled && m_ftp);
    GetDlgItem(IDC_W2FPLAY)->EnableWindow(m_enabled);
    GetDlgItem(IDC_W2FPAUSE)->EnableWindow(m_enabled);
    GetDlgItem(IDC_W2FSTOP)->EnableWindow(m_enabled);
    GetDlgItem(IDC_W2FEXIT)->EnableWindow(m_enabled);
    GetDlgItem(IDC_W2FOEM)->EnableWindow(m_enabled);
    GetDlgItem(IDC_W2FDELONEXIT)->EnableWindow(m_enabled);

    GetDlgItem(IDC_W2FBROWSE)->Invalidate();
    GetDlgItem(IDC_W2FFTP)->Invalidate();
    GetDlgItem(IDC_W2FFILE)->Invalidate();
    GetDlgItem(IDC_W2FSITE)->Invalidate();
    GetDlgItem(IDC_W2FUSER)->Invalidate();
    GetDlgItem(IDC_W2FPASSWORD)->Invalidate();
    GetDlgItem(IDC_W2FPLAY)->Invalidate();
    GetDlgItem(IDC_W2FPAUSE)->Invalidate();
    GetDlgItem(IDC_W2FSTOP)->Invalidate();
    GetDlgItem(IDC_W2FEXIT)->Invalidate();
    GetDlgItem(IDC_W2FOEM)->Invalidate();
    GetDlgItem(IDC_W2FDELONEXIT)->Invalidate();
}
