// SortDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "aerosubc.h"
#include "SortDlg.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "PlaylistDlg.h"
#include "PlaylistManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSortDlg dialog


CSortDlg::CSortDlg() : CDialog(CSortDlg::IDD)
{
}


BEGIN_MESSAGE_MAP(CSortDlg, CDialog)
    ON_EN_CHANGE(IDC_TEMPLATE, OnChangeTemplate)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSortDlg message handlers

void CSortDlg::DoDataExchange(CDataExchange* pDX)
{
    CMenuXP::SetXPLookNFeel(this, s_mainWnd.m_skin.xpLookNFeel);
    CDialog::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_SORT_TEMPLATE, m_sortTemplate);
    DDX_Control(pDX, IDOK, m_btnOk);
    DDX_Control(pDX, IDCANCEL, m_btnCancel);
}


void CSortDlg::OnChangeTemplate()
{
    UpdateData(TRUE);
    GetDlgItem(IDOK)->EnableWindow(m_sortTemplate != "");
}
BOOL CSortDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    AeroAutoSubclass(m_hWnd, ASC_SUBCLASS_ALL_CONTROLS, 0L);

    m_Helper.translateWindowText(this, IDD_SORT);
    m_Helper.translateDlgItemText(this, IDC_LSORT_TEMPLATE);
    m_Helper.translateDlgItemText(this, IDC_LSORTDESCRIPTIONPOSSIBILITY);
    m_Helper.translateDlgItemText(this, IDOK);
    m_Helper.translateDlgItemText(this, IDCANCEL);

    SetIcon(s_mainWnd.m_stpIcon, TRUE);
    SetIcon(s_mainWnd.m_stpIconSm, FALSE);

    m_sortTemplate = s_mainWnd.m_sortTemplate;

    UpdateData(FALSE);

    return TRUE;
}

void CSortDlg::OnOK()
{
    UpdateData(TRUE);

    s_mainWnd.m_sortTemplate = m_sortTemplate;
    CreateMemberThread<CPlaylistDlg>(&s_playlistDlg, &CPlaylistDlg::SortThread, &s_playlistDlg.m_sortThreadHan);

    CDialog::OnOK();
}

