#include "StdAfx.h"
#include "DllGen.h"
#include "MainHelper.h"
#include "Resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDllGen::~CDllGen()
{
    delete internatGen;
    if (hModGen != NULL)
    {
        try
        {
            dllGenMod->quit();
        }
        catch (...)
        {
        }
        SetWindowLong(dllGenMod->hwndParent, GWL_WNDPROC, (LONG)WndprocBefore);
        FreeLibrary(hModGen);
    }
    hModGen = NULL;
}

CDllGen::CDllGen(CString dllPath, HWND hWnd) : GenInterface(dllPath)
{
    internatGen = new CStandardGen(_T(""), hWnd);
    internalGenMod = internatGen->GetWinampGeneralPurposePlugin();

    if (dllPath.GetLength() != 0)
    {
        // returns a handle to the dll, otherwise NULL
        hModGen = LoadLibrary(dllPath); 
        if (hModGen == NULL)
        {
            AfxMessageBox(m_Helper.MyLoadString(IDS_FAILED_LOAD_GEN) + GetFileName(), MB_OK | MB_ICONEXCLAMATION);
            dllGenMod = internalGenMod;
            SetFilePath(_T("STANDARD"));
            hModGen = AfxGetInstanceHandle();
        }
        else
        {
            // returns the address of the dll function, otherwise NULL
            try
            {
                pfun1 = (winampGeneralPurposePluginGetter)GetProcAddress(hModGen, "winampGetGeneralPurposePlugin");

                // (Dll function address) (function parameters)
                dllGenMod = (pfun1)();
                dllGenMod->hDllInstance = hModGen;
                dllGenMod->hwndParent = hWnd;
                //Init des fonctions non dclare par celle par dfaut..

                if (dllGenMod->config == NULL)
                    dllGenMod->config = internalGenMod->config;
                if (dllGenMod->init == NULL)
                    dllGenMod->init = internalGenMod->init;
                if (dllGenMod->quit == NULL)
                    dllGenMod->quit = internalGenMod->quit;
            }
            catch (...)
            {
                AfxMessageBox(m_Helper.MyLoadString(IDS_FAILED_LOAD_GEN) + GetFileName(), MB_OK | MB_ICONEXCLAMATION);
                dllGenMod = internalGenMod;
                SetFilePath(_T("STANDARD"));
                hModGen = AfxGetInstanceHandle();
            }
        }
    }
    else
    {
        dllGenMod = internalGenMod;
        SetFilePath(_T("STANDARD"));
        hModGen = AfxGetInstanceHandle();
    }
    dllGenMod->hDllInstance = hModGen;
}

void CDllGen::Config() // configuration dialog
{
    try
    {
        dllGenMod->config();
    }
    catch (...)
    {
    }
}

int CDllGen::Init()
{
    int res = 0;
    WndprocBefore = (WNDPROC)GetWindowLong(dllGenMod->hwndParent, GWL_WNDPROC);
    try
    {
        res = dllGenMod->init();
    }
    catch (...)
    {
        TRACE(_T("Problme d'init"));
    }
    WndprocAfter = (WNDPROC)GetWindowLong(dllGenMod->hwndParent, GWL_WNDPROC);
    if (WndprocBefore != WndprocAfter)
    {
        TRACE(_T("Proc change\n"));
    }
    return res;
}

void CDllGen::Quit()
{
    try
    {
        dllGenMod->quit();
    }
    catch (...)
    {
    }
}

int CDllGen::GetVersion()        // module type (IN_VER)
{
    int res = 0;
    try
    {
        res = dllGenMod->version;
    }
    catch (...)
    {
    }
    return res;
}
char* CDllGen::GetDescription()  // description of module, with version string
{
    try
    {
        return dllGenMod->description;
    }
    catch (...)
    {
    }
}

void CDllGen::SethwndParent(HWND hWnd)   // winamp's main window (filled gen by winamp)
{
    dllGenMod->hwndParent = hWnd;
    internatGen->SethwndParent(hWnd);
}
void CDllGen::SethDllInstance(HINSTANCE hDLL)   // DLL instance handle (Also filled gen by winamp)
{
    hModGen = hDLL;
}

winampGeneralPurposePlugin* CDllGen::GetWinampGeneralPurposePlugin()
{
    return dllGenMod;
}
