#include "StdAfx.h"
#include <commctrl.h>
#include <mmsystem.h>
#include <initguid.h>
#include "wxdebug.h"
#include "AudioFilter.h"
#include "InterfaceIn.h"
#include "in_vid.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern In_Module modVideo;

CAudioFilter::CAudioFilter(IUnknown* pUnk, HRESULT* phr) : CBaseRenderer(CLSID_Audio, NAME("Audio filter"), pUnk, phr)
{
}

CAudioFilter::~CAudioFilter()
{
}
// make sure media type is what we want
//
HRESULT CAudioFilter::CheckMediaType(const CMediaType* pmt)
{
    CheckPointer(pmt, E_POINTER);

    WAVEFORMATEX* pwfx = (WAVEFORMATEX*)pmt->Format();

    if (pwfx == NULL)
        return E_INVALIDARG;

    // Reject non-PCM Audio type

    if (pmt->majortype != MEDIATYPE_Audio)
    {
        return E_INVALIDARG;
    }

    if (pmt->formattype != FORMAT_WaveFormatEx)
    {
        return E_INVALIDARG;
    }

    if (pwfx->wFormatTag != WAVE_FORMAT_PCM)
    {
        return E_INVALIDARG;
    }

    modVideo.outMod->Open(pwfx->nSamplesPerSec, pwfx->nChannels, pwfx->wBitsPerSample, 0, 0);

    return NOERROR;
}

HRESULT CAudioFilter::DoRenderSample(IMediaSample* pMediaSample)
{
    CheckPointer(pMediaSample, E_POINTER);

    BYTE* data;
    pMediaSample->GetPointer(&data);
    while (modVideo.outMod->CanWrite() < pMediaSample->GetSize());
    if (pMediaSample->GetSize() > 8192)
    {
        int size = 8192;
        do
        {
            modVideo.outMod->Write((char*)data + size, pMediaSample->GetSize() - size > 8192 ? 8192 : pMediaSample->GetSize() - size);
            size += 8192;
        }
        while (size <= pMediaSample->GetSize());
    }
    else
        modVideo.outMod->Write((char*)data, pMediaSample->GetSize());

    return S_OK;
}