#ifndef CMULTIDLLINPUT_H
#define CMULTIDLLINPUT_H
#include "DllInput.h"

class CMultiDllInput
{
private:
    CArray<CDllInput*, CDllInput*> listDllInput;
    CDllInput* currentDllInput;

public:

    int GetVersion();       // module type (IN_VER)
    char* GetDescription();  // description of module, with version string

    void SethMainWindow(HWND hWnd);   // winamp's main window (filled in by winamp)

    CString GetFileExtensions();    // "mp3\0Layer 3 MPEG\0mp2\0Layer 2 MPEG\0mpg\0Layer 1 MPEG\0"
    // May be altered from Config, so the user can select what they want

    int isSeekable();     // is this stream seekable? 
    int isUsesOutputPlug();     // does this plug-in use the output plug-ins? (musn't ever change, ever :)

    void SetOutMod(Out_Module* out); // filled in by winamp, optionally used :)

    void LoadAll(HWND hWnd);
    void UnloadAll();

    void GetFileInfo(TCHAR* file, TCHAR* title, int* length_in_ms); // if file == NULL, current playing is used
    int InfoBox(TCHAR* file, HWND hwndParent);

    int IsOurFile(TCHAR* fn);  // called before extension checks, to allow detection of mms://, etc
    // playback stuff
    int Play(TCHAR* fn);   // return zero on success, -1 on file-not-found, some other value on other (stopping winamp) error
    int winampGetExtendedFileInfo(extendedFileInfoStruct ExtendedFileInfo);
    int winampGetExtendedFileInfoW(extendedFileInfoStructW ExtendedFileInfo);
    void Pause();     // pause stream
    void UnPause();     // unpause stream
    int IsPaused();     // ispaused? return 1 if paused, 0 if not
    void Stop();        // stop (unload) stream

    // time stuff
    int GetLength();      // get length in ms
    int GetOutputTime();    // returns current output time in ms. (usually returns outMod->GetOutputTime()
    void SetOutputTime(int time_in_ms); // seeks to point in stream (in ms). Usually you signal yoru thread to seek, which seeks and calls outMod->Flush()..

    // volume stuff
    void SetVolume(int volume); // from 0 to 255.. usually just call outMod->SetVolume
    void SetPan(int pan); // from -127 to 127.. usually just call outMod->SetPan

    // info setting (filled in by winamp)
    void SetInfo(int bitrate, int srate, int stereo, int synched); // if -1, changes ignored? :)
    int GetPlayerMode();
    void SetPlayerMode(int statut);
    In_Module* GetIn_Module();
    CString GetFileExtensionsFilter();
    int GetSize(); // return the number of loaded input
    CDllInput* getDllInput(int pos); //Return the DllInput at pos
    void UnLoad(int pos); //Unload the DllInput at pos
    void Load(CString file, HWND hWnd); //Load the DllInput
    void UpDllInput(int pos); //Up the DllInput in the list
};
#endif

extern CMultiDllInput stdIn;
