#ifndef IN_MPG123_H
#define IN_MPG123_H

#include <afxinet.h>

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define VER                     L"v1.18y ot112.1"

#define _VER                    "v1.18y ot112.1"

#define MPG123_FILESYS_NO       0

#define OBSIZE                  65536
#define FBSIZE                  8192

#define MIN_STREAM_SIZE         (FBSIZE * 2)
#define PRE_READ_STREAM_SIZE    512
#define READ_STREAM_SIZE        FBSIZE

#define POST_DELAY              1152
#define DECODE_DELAY_LAYER1     0
#define DECODE_DELAY_LAYER2     (480 + 1)
#define DECODE_DELAY_LAYER3     (528 + 1)

#define MAX_SEARCH_HEADER       65536

#define FILE_EXT                "MP3;MP2;MP1;RMP\0MPEG Audio Files (*.MP3;*.MP2;*.MP1;*.RMP)\0m3u;pls\0Playlists (*.m3u, *.pls)\0"

#define PLAY2ND_CLASS           L"in_!mpg123 Play2nd"

#define USER_AGENT              L"WINAMP mpg123 " VER

#define REPLAYGAIN_TAG_NONE     0x00000000U
#define REPLAYGAIN_TAG_ID3V2    0x00000001U
#define REPLAYGAIN_TAG_APE      0x00000002U
#define REPLAYGAIN_TAG_LAME     0x00000004U
#define REPLAYGAIN_TAG_INIT     (REPLAYGAIN_TAG_ID3V2 | REPLAYGAIN_TAG_APE)

typedef void    (*OUT_DATA_FUNC)(char* OutBuff, unsigned char* InBuff, const int Size);
typedef void    (*VIS_DATA_FUNC)(char* OutBuff, char* InBuff, const int Size);

struct
mp3info
{
    bool stream;
    bool vbr_tag;
    int hpos;
    int nbytes;
    int hnbytes;
    bool mpeg25;
    int lsf;
    int lay;
    int freq;
    int mode;
    int nch;
    int bitrate;
    int frame_samples;
    int frames;
    int samples;
    int length;
    int out_bps;
    int out_bps_b;
    int out_bps_b_nch;
    int vis_bps_b_nch;
    int bps;
    int bps_b;
    int bps_b_nch;
    int decode_delay;
    int skip_start;
    double skip_start_ms;
    bool replaygain_valid_track_gain;
    bool replaygain_valid_track_peak;
    bool replaygain_valid_album_gain;
    bool replaygain_valid_album_peak;
    double replaygain_track_gain;
    double replaygain_track_peak;
    double replaygain_album_gain;
    double replaygain_album_peak;
};


// begin pl2 by YunaSoft
class CIn_mpg123dSession : public CInternetSession
{
public:
    CIn_mpg123dSession(LPCTSTR pstrAgent, DWORD dwContext, DWORD dwAccessType, LPCTSTR pstrProxyName, LPCTSTR pstrProxyBypass, DWORD dwFlags);
};
// end pl2
void __cdecl    config(HWND);
void __cdecl    about(HWND);
void __cdecl    init();
void __cdecl    quit();
void __cdecl    getfileinfo(const WCHAR* filename, WCHAR* title, int* length_in_ms);
int __cdecl infobox(const WCHAR* fn, HWND hwnd);
int __cdecl isourfile(const WCHAR* fn);
int __cdecl play(const WCHAR* fn);
void __cdecl    pause();
void __cdecl    unpause();
int __cdecl ispaused();
void __cdecl    stop();
int __cdecl getlength();
int __cdecl getoutputtime();
void __cdecl    setoutputtime(int time_in_ms);
void __cdecl    setvolume(int volume);
void __cdecl    setpan(int pan);
void __cdecl    eq_set(int on, char data[10], int preamp);

#endif
