#include "VideoFilter.h"
#include "AudioFilter.h"

#ifndef IN_VID_H
#define IN_VID_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
#error include 'stdafx.h' before including this file for PCH
#endif


#define FILE_EXT        "avi\0AVI format(*.avi)\0vob;mpeg;mpg\0DVD format(*.vob;*.mpeg;*.mpg)\0wmv;wma\0WMV format(*.wmv;*.wma)\0rm;rmvb\0RM format(*.rm;*.rmvb)\0mp3\0MP3 format(*.mp3)\0dat\0MTV format(*.dat)\0mp4;mov;3gp;3g2\0MP4 format(*.mp4;*.mov;*.3gp;*.3g2)\0"

namespace VideoInput
{
    void __cdecl    config(HWND);
    void __cdecl    about(HWND);
    void __cdecl    init();
    void __cdecl    quit();
    void __cdecl    getfileinfo(const WCHAR* filename, WCHAR* title, int* length_in_ms);
    int __cdecl infobox(const WCHAR* fn, HWND hwnd);
    int __cdecl isourfile(const WCHAR* fn);
    int __cdecl play(const WCHAR* fn);
    void __cdecl    pause();
    void __cdecl    unpause();
    int __cdecl ispaused();
    void __cdecl    stop();
    int __cdecl getlength();
    int __cdecl getoutputtime();
    void __cdecl    setoutputtime(int time_in_ms);
    void __cdecl    setvolume(int volume);
    void __cdecl    setpan(int pan);
    void __cdecl    eq_set(int on, char data[10], int preamp);
}

class CPlayer : public CWnd
{
public:
    CPlayer();
    virtual ~CPlayer();
    HRESULT RenderAVI(LPCTSTR szFilePath, CComPtr<IGraphBuilder>& gb);
    HRESULT RenderWMV(LPCTSTR szFilePath, CComPtr<IGraphBuilder>& gb);
    HRESULT RenderMediaFile(LPCTSTR szFilePath, CComPtr<IGraphBuilder>& gb);
    BOOL Open(LPCTSTR szUrl);
    void Pause();
    void Play();
    void Stop();
    void Close();
    LONGLONG GetPosition();
    void SetPosition(LONGLONG llPos);
    LONGLONG GetLength();
    BOOL IsRunning();
    BOOL IsFinished();
    CString GetFilterName(IBaseFilter* pBF);
    HRESULT CreateFilterByName(LPCTSTR lpszName, IBaseFilter** ppFilter);
    HRESULT AddFilterByName(IGraphBuilder* pGB, LPCTSTR lpszDispName, LPCTSTR lpszName, IBaseFilter** ppFilter);
    HRESULT AddFilterByClsid(IGraphBuilder* pGB, REFCLSID clsid, LPCTSTR lpszName, IBaseFilter** ppFilter);
    HRESULT Init();
    HRESULT Uninit();

private:
    IBaseFilter* m_BV;
    IBaseFilter* m_BA;
    CComPtr<IGraphBuilder> m_GB;
    CComPtr<IMediaControl> m_MC;
    CComPtr<IMediaEventEx> m_ME;
    CComPtr<IMediaSeeking> m_MS;
    CComPtr<IMediaPosition> m_MP;
};

#endif

extern CPlayer player;