#ifndef PLAYLIST_H
#define PLAYLIST_H

#include <playlist/api_playlistmanager.h>

class CPlaylist : public api_playlistmanager
{
    int _Load(const wchar_t* filename, api_playlistloadercallback* playlist);
    int _LoadAs(const wchar_t* filename, const wchar_t* ext, api_playlistloadercallback* playlist); // call with ext in the format ".pls"   
    int _LoadFromDialog(const wchar_t* fns, api_playlistloadercallback* playlist);
    int _LoadFromANSIDialog(const char* fns, api_playlistloadercallback* playlist);
    int _Save(const wchar_t* filename, api_playlist* playlist);
    size_t _Copy(const wchar_t* destFn, const wchar_t* srcFn); // returns number of items copied
    size_t _CountItems(const wchar_t* filename);
    int _GetLengthMilliseconds(const wchar_t* filename);
    void _Randomize(api_playlist* playlist);
    void _Reverse(api_playlist* playlist);
    void _LoadDirectory(const wchar_t* directory, api_playlistloadercallback* callback, api_playlistdirectorycallback* dirCallback);
    bool _CanLoad(const wchar_t* filename);
    void _GetExtensionList(wchar_t* extensionList, size_t extensionListCch);
    void _GetFilterList(wchar_t* extensionList, size_t extensionListCch);
    const wchar_t* _EnumExtension(size_t num);

#undef CBCLASS
#define CBCLASS CPlaylist
    START_DISPATCH;
    CB(API_PLAYLISTMANAGER_LOAD, _Load);
    CB(API_PLAYLISTMANAGER_LOADNULLDELIMITED, _LoadFromDialog);
    CB(API_PLAYLISTMANAGER_LOADNULLDELIMITED_ANSI, _LoadFromANSIDialog);
    CB(API_PLAYLISTMANAGER_LOADAS, _LoadAs);
    CB(API_PLAYLISTMANAGER_SAVE, _Save);
    CB(API_PLAYLISTMANAGER_COPY, _Copy);
    CB(API_PLAYLISTMANAGER_COUNT, _CountItems);
    CB(API_PLAYLISTMANAGER_GETLENGTH, _GetLengthMilliseconds);
    VCB(API_PLAYLISTMANAGER_LOADDIRECTORY, _LoadDirectory);
    VCB(API_PLAYLISTMANAGER_RANDOMIZE, _Randomize);
    VCB(API_PLAYLISTMANAGER_REVERSE, _Reverse);
    CB(API_PLAYLISTMANAGER_CANLOAD, _CanLoad);
    VCB(API_PLAYLISTMANAGER_GETEXTENSIONLIST, _GetExtensionList);
    VCB(API_PLAYLISTMANAGER_GETFILTERLIST, _GetFilterList);
    CB(API_PLAYLISTMANAGER_ENUMEXTENSION, _EnumExtension);
    END_DISPATCH;
#undef CBCLASS
};

#endif