// MainWnd.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"       // main symbols
#include "SysTrayPlay.h"
#include "MainWnd.h"
#include "EqualizerDlg.h"
#include "PlaylistDlg.h"
#include "SeekDialog.h"
#include "SettingsDialog.h"
#include "UrlDlg.h"
#include "AutDlg.h"
#include "MainHelper.h"
#include "WAEmuWnd.h"
#include "AutoUpdater.h"
#include "PlaylistManager.h"
#include "SortDlg.h"
#include "Draw.h"

#include "MultiDllOutput.h"
#include "MultiDllInput.h"
#include "CommonFunc.h"
#include "MultiDllGen.h"

#include "Volume.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Redfinition pour Visual C++ 6.0
#ifndef MN_GETHMENU
#define MN_GETHMENU                     0x01E1
#endif

#define HOTKEY_PLAY         101
#define HOTKEY_STOP         102
#define HOTKEY_PREV         103
#define HOTKEY_NEXT         104
#define HOTKEY_VDOWN        202
#define HOTKEY_VUP          201
#define HOTKEY_OPEN1        301
#define HOTKEY_OPEN2        302
#define HOTKEY_OPEN3        303
#define HOTKEY_MINIBAR      501
#define HOTKEY_MP3INFO      901
#define HOTKEY_PLAYLIST     801
#define HOTKEY_EQUALIZER    601
#define HOTKEY_REPEAT       701
#define HOTKEY_SHUFFLE      401
#define HOTKEY_ALBUMMODE    1601
#define HOTKEY_EXIT         1001
#define HOTKEY_NP           1201
#define HOTKEY_FORW         1301
#define HOTKEY_BACK         1302
#define HOTKEY_TRAYICON     1401
#define HOTKEY_MENU         1501
#define HOTKEY_TRACKS       1502
#define HOTKEY_ALBUM        1503
#define HOTKEY_AUTOMATION   1701

CWAEmuWnd WAEmuWnd;
CMainWnd s_mainWnd;

CEqualizerDlg s_equalizerDlg;
CAutDlg s_autDlg;
extern CVideoDialog s_videoDialog;

CPlaylistDlg s_playlistDlg;
CSettingsDialog* s_settingsDialog = NULL;
CSeekDialog s_seekDialog;

CVolume s_volume;

Helper m_Helper;

extern HANDLE m_hAutomationThread;
CPlaylistManager s_playlistManager;
unsigned long rnd;

CMultiDllInput stdIn;
CMultiDllOutput stdOut;
CMultiDllGen stdGen;

CImageList m_imgList;
CStringArray m_eq;

extern CStringArray* SaveTo();

static int __stdcall BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
    CString dir;
    dir = s_mainWnd.m_initDir;
    if (dir.Right(1) == "\\")
        dir = dir.Left(dir.GetLength() - 1);

    if (uMsg == BFFM_INITIALIZED)
        ::SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)dir.GetString());
    return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainWnd

IMPLEMENT_DYNCREATE(CMainWnd, CFrameWnd);

CMainWnd::CMainWnd() : CFrameWnd()
{
    m_incCounter = 0;
    m_created = false;
    m_prevTitle = "";
}

CMainWnd::~CMainWnd()
{
    m_mainMenu.DestroyMenu();
    m_consoleMenu.DestroyMenu();
    delete m_traytip;
}

BEGIN_MESSAGE_MAP(CMainWnd, CFrameWnd)
    ON_COMMAND(ID_POPUPMENU_EXIT, OnPopupMenuExit)
    ON_COMMAND(ID_POPUPMENU_OPEN_FILE, OnPopupMenuOpenFile)
    ON_COMMAND(ID_POPUPMENU_ADD_FILE, OnPopupMenuAddFile)
    ON_COMMAND(ID_POPUPMENU_PLAY, OnPopupMenuPlay)
    ON_COMMAND(ID_POPUPMENU_PAUSE, OnPopupMenuPause)
    ON_COMMAND(ID_POPUPMENU_STOP, OnPopupMenuStop)
    ON_COMMAND(ID_POPUPMENU_ABOUT, OnPopupMenuAbout)
    ON_COMMAND(ID_POPUPMENU_NEXT, OnPopupMenuNext)
    ON_COMMAND(ID_POPUPMENU_PREVIOUS, OnPopupMenuPrevious)
    ON_COMMAND(ID_POPUPMENU_EQUALIZER, OnPopupMenuEqualizer)
    ON_COMMAND(ID_POPUPMENU_PLAYLISTEDITOR, OnPopupMenuPlaylistEditor)
    ON_COMMAND(ID_POPUPMENU_SEEK, OnPopupMenuSeek)
    ON_COMMAND(ID_POPUPMENU_VIDEO, OnPopupMenuVideo)
    ON_COMMAND(ID_POPUPMENU_CONSOLE, OnPopupMenuConsole)
    ON_COMMAND(ID_POPUPMENU_OPENFOLDER, OnPopupMenuOpenFolder)
    ON_COMMAND(ID_POPUPMENU_ADDFOLDER, OnPopupMenuAddFolder)
    ON_COMMAND(ID_POPUPMENU_FILEINFO, OnPopupMenuFileInfo)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_FILEINFO, OnUpdatePopupMenuFileInfo)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_REPEAT, OnUpdatePopupMenuSettingsRepeat)
    ON_COMMAND(ID_POPUPMENU_SETTINGS_REPEATTRACK, OnPopupMenuSettingsRepeatTrack)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_REPEATTRACK, OnUpdatePopupMenuSettingsRepeatTrack)
    ON_WM_ENDSESSION()
    ON_COMMAND(ID_POPUPMENU_SETTINGS_REPEAT, OnPopupMenuSettingsRepeat)
    ON_COMMAND(ID_POPUPMENU_SETTINGS_ADVANCED, OnPopupMenuSettingsAdvanced)
    ON_COMMAND(ID_POPUPMENU_SETTINGS_SORTBYNAME, OnPopupMenuSettingsSortByName)
    ON_COMMAND(ID_POPUPMENU_SETTINGS_SORTBYFILENAME, OnPopupMenuSettingsSortByFilename)
    ON_COMMAND(ID_POPUPMENU_SETTINGS_SORTBYTEMPLATE, OnPopupMenuSettingsSortByTemplate)
    ON_COMMAND(ID_POPUPMENU_SETTINGS_SHUFFLEMODE, OnPopupMenuSettingsShuffleMode)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_SHUFFLEMODE, OnUpdatePopupMenuSettingsShuffleMode)
    ON_WM_COPYDATA()
    ON_WM_CREATE()
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_EQUALIZER, OnUpdatePopupMenuEqualizer)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_PLAYLISTEDITOR, OnUpdatePopupMenuPlaylistEditor)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SEEK, OnUpdatePopupMenuSeek)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_VIDEO, OnUpdatePopupMenuVideo)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_CONSOLE, OnUpdatePopupMenuConsole)
    ON_WM_CLOSE()
    ON_COMMAND(ID_POPUPMENU_ELAPSEDTIME, OnPopupMenuElapsedTime)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_ELAPSEDTIME, OnUpdatePopupMenuElapsedTime)
    ON_COMMAND(ID_POPUPMENU_REMAININGTIME, OnPopupMenuRemainingTime)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_REMAININGTIME, OnUpdatePopupMenuRemainingTime)
    ON_COMMAND(ID_POPUPMENU_SETTINGS_RANDOMLYSELECTFIRSTTRACK, OnPopupMenuSettingsRandomlySelectFirstTrack)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_RANDOMLYSELECTFIRSTTRACK, OnUpdatePopupMenuSettingsRandomlySelectFirstTrack)
    ON_COMMAND(ID_POPUPMENU_FILENAME, OnPopupMenuFilename)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_FILENAME, OnUpdatePopupMenuFilename)
    ON_COMMAND(ID_POPUPMENU_TITLE, OnPopupMenuTitle)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_TITLE, OnUpdatePopupMenuTitle)
    ON_COMMAND(ID_POPUPMENU_ARTISTTITLE, OnPopupMenuArtistTitle)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_ARTISTTITLE, OnUpdatePopupMenuArtistTitle)
    ON_COMMAND(ID_POPUPMENU_OPEN_URL, OnPopupMenuOpenUrl)
    ON_COMMAND(ID_POPUPMENU_SETTINGS_AFTERENDOFTHEPLAYBACK_EXITSTP, OnPopupMenuSettingsAfterEndOfThePlaybackExitStp)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_AFTERENDOFTHEPLAYBACK_EXITSTP, OnUpdatePopupMenuSettingsAfterEndOfThePlaybackExitStp)
    ON_COMMAND(ID_POPUPMENU_SETTINGS_AFTERENDOFTHEPLAYBACK_TURNOFFTHECOMPUTER, OnPopupMenuSettingsAfterEndOfThePlaybackTurnOffTheComputer)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_AFTERENDOFTHEPLAYBACK_TURNOFFTHECOMPUTER, OnUpdatePopupMenuSettingsAfterEndOfThePlaybackTurnOffComputer)
    ON_WM_TIMER()
    ON_COMMAND(ID_POPUPMENU_DOCKTOACTIVEWINDOW, OnPopupMenuDockToActiveWindow)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_DOCKTOACTIVEWINDOW, OnUpdatePopupMenuDockToActiveWindow)
    ON_COMMAND(ID_POPUPMENU_SHOW_TOTALTRACKTIME, OnPopupMenuShowTotalTrackTime)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SHOW_TOTALTRACKTIME, OnUpdatePopupMenuShowTotalTrackTime)
    ON_COMMAND(ID_POPUPMENU_SETTINGS_STOPAFTEREACHALBUM, OnPopupMenuSettingsStopAfterEachAlbum)
    ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_STOPAFTEREACHALBUM, OnUpdatePopupMenuSettingsStopAfterEachAlbum)
    ON_COMMAND(ID_AUTOMATION_SETUP, OnAutomationSetup)
    ON_COMMAND(ID_AUTOMATION_PERFORMNOW, OnAutomationPerformNow)
    ON_COMMAND_RANGE(IDM_RECENT_FILES,IDM_RECENT_FILES+9,OnPopupMenuOpenRecent)
    ON_COMMAND_RANGE(IDM_TRACKS,IDM_TRACKS+MAXFILE,OnTrackMenu)
    ON_COMMAND_RANGE(IDM_DRIVES,IDM_DRIVES+25,OnDrivesMenu)
    //TODO ON_COMMAND(ID_FILE_ADDFILE, OnFileAddFile)
    ON_MESSAGE(WM_PLAYOVER,OnPostPlayerOver)
    ON_MESSAGE(WM_ICON_NOTIFY,IconNotify)
    ON_MESSAGE(WM_QUERYENDSESSION, QueryEndSession)
    ON_MESSAGE(MM_MIXM_CONTROL_CHANGE, MixControlChange)
    ON_MESSAGE(WM_HOTKEY, OnHotKey)
    ON_WM_MEASUREITEM()
    ON_WM_DRAWITEM()
    ON_WM_CONTEXTMENU()
    ON_COMMAND(IDS_CONSOLE_CLEAR, OnConsoleClear)
    ON_COMMAND(IDS_CONSOLE_AOT, OnConsoleAot)
    ON_COMMAND(IDS_CONSOLE_CLOSE, OnClose)
    ON_COMMAND(IDS_CONSOLE_COPY, OnConsoleCopy)
    ON_REGISTERED_MESSAGE(STP_WND, OnAreYouMe)
    ON_WM_INITMENUPOPUP()
    ON_MENUXP_MESSAGES()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainWnd message handlers

void CMainWnd::AddRecent(CString fdn)
{
    if (fdn[fdn.GetLength() - 1] == '\\')
        fdn = fdn.Left(fdn.GetLength() - 1);
    if (fdn[1] == ':' && fdn.GetLength() == 2)
        return;
    int i;
    for (i = 0; i <= 9; i++)
    {
        if (fdn.CompareNoCase(m_recent[i]) == 0)
        {
            for (int j = i; j > 0; j--)
                m_recent[j] = m_recent[j - 1];
            m_recent[0] = fdn;
            return;
        }
    }
    for (i = 9; i > 0; i--)
        m_recent[i] = m_recent[i - 1];
    m_recent[0] = fdn;
}

void CMainWnd::BuildAlbumMenu(CMenu* m)
{
    int start, finish;
    int i;
    CMenu* pm = m;
    GetAlbumRange(&start, &finish, true);
    CString sortpath = s_playlistManager.GetSortPath(start);
    CString folder = _T("");
    if (sortpath.ReverseFind('\\') != -1)
        folder = sortpath.Left(sortpath.ReverseFind('\\'));
    if (folder.Find('\\', 0) != -1)
    {
        if (folder.ReverseFind('\\') == folder.GetLength() - 1)
            folder = folder.Left(folder.GetLength() - 1);
        folder = folder.Right(folder.GetLength() - folder.ReverseFind('\\') - 1);
        pm->AppendMenu(MF_STRING, ID_DUMMY, folder);
        pm->AppendMenu(MF_SEPARATOR);
    }
    for (i = start; i <= finish; i++)
    {
        CString buf;
        if (pm->GetMenuItemCount() == m_tpc * 3 - 1)
        {
            UINT menuID = pm->GetMenuItemID(pm->GetMenuItemCount() - 1);
            if (menuID != 0)
            {
                CMenu tmpMenu;
                if (tmpMenu.CreatePopupMenu())
                {
                    HMENU tmpHMenu = tmpMenu.Detach();
                    CString nextFile = m_Helper.MyLoadString(IDS_NEXTFILES);
                    pm->AppendMenu(MF_POPUP, (UINT)tmpHMenu, nextFile);
                    pm = CMenu::FromHandle(tmpHMenu);
                }
                else
                {
                    throw "Memory allocation failure!";
                }
            }
        }
        buf.Format(_T("%d|%s"), i, s_playlistManager.GetPlaylist(i));
        if (m_tpc && pm->GetMenuItemCount() % m_tpc == 0 && pm->GetMenuItemCount() / m_tpc > 0)
        {
            pm->AppendMenu(MF_STRING | MF_MENUBARBREAK, IDM_TRACKS - 1, _T(""));
            pm->AppendMenu(MF_SEPARATOR);
        }
        pm->AppendMenu(MF_STRING, IDM_TRACKS + i, buf);

        if (i == s_playlistManager.GetCurrent())
            pm->SetDefaultItem(pm->GetMenuItemCount() - 1, TRUE);
    }
    //On comble par des blancs
    if (m_tpc && pm->GetMenuItemCount() / m_tpc > 0)
        while (pm->GetMenuItemCount() % m_tpc != 0)
            pm->AppendMenu(MF_STRING, IDM_TRACKS - 1, _T(""));
}

void CMainWnd::BuildMenu(CMenu* m)
{
    int i = 0, j = 0;
    int sl;
    CString buf;
    CMenu* pm = m;
    do
    {
        buf = s_playlistManager.GetSortPath(i).Left(s_playlistManager.GetSortPath(i).Find(_T("\\")) + 1);
        do
        {
            i++;
        }
        while (i < s_playlistManager.GetSize() && s_playlistManager.GetSortPath(i).Left(buf.GetLength()).CompareNoCase(buf) == 0);
        if (s_playlistManager.GetSortPath(j).Find(_T(":\\")) != -1)
            sl = GetStartLevel(j, i);
        else
            sl = 0;
        if (sl > 0 && !(j == 0 && i == s_playlistManager.GetSize()))
        {
            if (sl == GetMaxLevel(j, i))
                sl--;
        }
        CString menuTmp = _T("");

        do
        {
            if (menuTmp == m_Helper.MyLoadString(IDS_NEXTFILES))
            {
                pm = pm->GetSubMenu(pm->GetMenuItemCount() - 1);
            }
            //Prvidage des blancs d'avants!!
            int l = pm->GetMenuItemCount() - 1;
            int lcount = pm->GetMenuItemCount();
            while (l >= 0)
            {
                pm->GetMenuString(l, menuTmp, MF_BYPOSITION);
                lcount = pm->GetMenuItemCount();
                if (menuTmp == "")
                {
                    pm->RemoveMenu(l, MF_BYPOSITION);
                }
                else
                {
                    break;
                }
                l--;
            }
        }
        while (menuTmp == m_Helper.MyLoadString(IDS_NEXTFILES));


        BuildMenuLevel(pm, sl, j, i, _T(""));
        j = i;
    }
    while (i < s_playlistManager.GetSize());
}

int CMainWnd::BuildMenuLevel(CMenu* m, int l, int start, int finish, CString cur)
{
    int cl = cur.GetLength();
    CString buf;
    int i = start;

    for (i = start; i < finish; i++)
    {
        if (m->GetMenuItemCount() == m_tpc * 3 - 1)
        {
            UINT menuID = m->GetMenuItemID(m->GetMenuItemCount() - 1);
            if (menuID != 0)
            {
                CMenu tmpMenu;
                if (tmpMenu.CreatePopupMenu())
                {
                    HMENU tmpHMenu = tmpMenu.Detach();
                    CString nextFile = m_Helper.MyLoadString(IDS_NEXTFILES);
                    m->AppendMenu(MF_POPUP, (UINT)tmpHMenu, nextFile);
                    return BuildMenuLevel(CMenu::FromHandle(tmpHMenu), l, i, finish, cur);
                }
                else
                {
                    throw "Memory allocation failure!";
                }
            }
        }
        if (s_playlistManager.GetSortPath(i).Left(cl).CompareNoCase(cur) != 0)
        {
            //On comble par des blancs
            if (m_tpc && m->GetMenuItemCount() / m_tpc > 0)
                while (m->GetMenuItemCount() % m_tpc != 0)
                    m->AppendMenu(MF_STRING, IDM_TRACKS - 1, _T(""));
            return i - 1;
        }

        if (ExtractLevel(s_playlistManager.GetSortPath(i), l + 1, &buf))
        {
            if (buf.Trim() != "")
            {
                CMenu tmpMenu;
                if (tmpMenu.CreatePopupMenu())
                {
                    HMENU tmpHMenu = tmpMenu.Detach();
                    m->AppendMenu(MF_POPUP | ((m_tpc && m->GetMenuItemCount() % m_tpc == 0 && m->GetMenuItemCount() > 0) ? MF_MENUBARBREAK : 0), (UINT)tmpHMenu, ReplaceAmpersand(buf));
                    int j = BuildMenuLevel(CMenu::FromHandle(tmpHMenu), l + 1, i, finish, ExtractLevelPath(s_playlistManager.GetSortPath(i), l + 1));
                    if (s_playlistManager.GetCurrent() >= i && s_playlistManager.GetCurrent() <= j)
                        m->SetDefaultItem(m->GetMenuItemCount() - 1, TRUE);
                    i = j;
                }
                else
                {
                    throw "Memory allocation failure!";
                }
            }
            else
            {
                int j = BuildMenuLevel(m, l + 1, i, finish, ExtractLevelPath(s_playlistManager.GetSortPath(i), l + 1));
                if (s_playlistManager.GetCurrent() >= i && s_playlistManager.GetCurrent() <= j)
                    m->SetDefaultItem(m->GetMenuItemCount() - 1, TRUE);
                i = j;
            }
            continue;
        }
        buf.Format(_T("%d|%s"), i, s_playlistManager.GetFilenameExt(i));
        if (i < MAXFILE)
        {
            m->AppendMenu(MF_STRING, IDM_TRACKS + i, buf);
            if (m_tpc && (m->GetMenuItemCount() - 1) % m_tpc == 0 && (m->GetMenuItemCount() - 1) > 0)
                m->ModifyMenu(IDM_TRACKS + i, MF_BYCOMMAND | MF_MENUBARBREAK | MF_STRING, IDM_TRACKS + i, buf);
            if (i == s_playlistManager.GetCurrent())
                m->SetDefaultItem(m->GetMenuItemCount() - 1, TRUE);
        }
    }
    //On comble par des blancs
    if (m_tpc && m->GetMenuItemCount() / m_tpc > 0)
        while (m->GetMenuItemCount() % m_tpc != 0)
        {
            m->AppendMenu(MF_STRING, IDM_TRACKS - 1, _T(""));
        }
    return i - 1;
}

void CMainWnd::BuildPrevNextMenu(CMenu* m)
{
    int start, finish, j, oldCurrent;
    int i;
    GetAlbumRange(&start, &finish);
    CString sortpath = s_playlistManager.GetSortPath(s_playlistManager.GetCurrent());
    CString folder = _T("");
    if (sortpath.ReverseFind('\\') != -1)
        folder = sortpath.Left(sortpath.ReverseFind('\\'));
    if (folder.Find('\\', 0) != -1)
    {
        if (folder.ReverseFind('\\') == folder.GetLength() - 1)
            folder = folder.Left(folder.GetLength() - 1);
        folder = folder.Right(folder.GetLength() - folder.ReverseFind('\\') - 1);
        m->AppendMenu(MF_STRING, ID_DUMMY, folder);
        m->AppendMenu(MF_SEPARATOR);
    }
    oldCurrent = s_playlistManager.GetCurrent();
    if (m_shuffleMode)
        for (i = 0; i < 3 && i < s_playlistManager.GetSize() / 2; i++)
            s_playlistManager.SetCurrent(MyRandom(false));
    else
        for (i = 0; i < 2 && i < s_playlistManager.GetSize() / 2; i++)
        {
            if (s_playlistManager.GetCurrent() == start)
                s_playlistManager.SetCurrent(finish);
            else
                s_playlistManager.decCurrent();
        }
    for (i = 0; i < 5 && i < s_playlistManager.GetSize(); i++)
    {
        if (m_shuffleMode)
            j = MyRandom(true);
        else
            j = s_playlistManager.GetCurrent();
        CString buf;
        buf.Format(_T("%d|%s"), j, s_playlistManager.GetPlaylist(j));
        m->AppendMenu(MF_STRING, IDM_TRACKS + j, buf);
        if (m_tpc && (m->GetMenuItemCount() + 1) % m_tpc == 0 && (m->GetMenuItemCount() + 1) > 0 && (m->GetMenuItemCount() + 1) < 5)
        {
            folder = s_playlistManager.GetDrive(j) + s_playlistManager.GetDir(j);
            if (folder.Find('\\', 0) != -1 && !m_shuffleMode)
            {
                folder = folder.Right(folder.GetLength() - folder.ReverseFind('\\') - 1);
                m->AppendMenu(MF_MENUBARBREAK | MF_STRING, ID_DUMMY, folder);
                m->AppendMenu(MF_SEPARATOR);
            }
        }

        if (i == 2)
            m->SetDefaultItem(m->GetMenuItemCount() - 1, TRUE);
        if (m_shuffleMode)
            s_playlistManager.SetCurrent(j);
        else if (s_playlistManager.GetCurrent() == finish)
            s_playlistManager.SetCurrent(start);
        else
            s_playlistManager.incCurrent();
    }
    //On comble par des blancs
    if (m_tpc && m->GetMenuItemCount() / m_tpc > 0)
        while (m->GetMenuItemCount() % m_tpc != 0)
            m->AppendMenu(MF_STRING, IDM_TRACKS - 1, _T(""));
    s_playlistManager.SetCurrent(oldCurrent);
}

void CMainWnd::ClickAction(int action)
{
    TRACE(_T("Action %d\n"), action);
    switch (IDS_CLICKS0 + action)
    {
            // play-pause
        case IDS_CLICKS1:
            switch (stdIn.GetPlayerMode())
            {
                case PLAYER_MODE_CLOSE :
                    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
                    break;
                case PLAYER_MODE_PAUSED :
                case PLAYER_MODE_PLAYING :
                    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON3, 0);
                    break;
            }
            break;
            // stop-play
        case IDS_CLICKS2:
            switch (stdIn.GetPlayerMode())
            {
                case PLAYER_MODE_CLOSE :
                    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
                    break;
                case PLAYER_MODE_PAUSED :
                case PLAYER_MODE_PLAYING :
                    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
                    break;
            }
            break;
            // prev
        case IDS_CLICKS3:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON1, 0);
            break;
            // next
        case IDS_CLICKS4:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON5, 0);
            break;
            // tracks
        case IDS_CLICKS5:
            ShowTracksMenu();
            break;
            // minibar
        case IDS_CLICKS6:
            OnPopupMenuSeek();
            break;
            // playlist
        case IDS_CLICKS7:
            ::SetForegroundWindow(m_hWnd);
            OnPopupMenuPlaylistEditor();
            break;
            // equalizer
        case IDS_CLICKS8:
            OnPopupMenuEqualizer();
            break;
            // mp3 info
        case IDS_CLICKS9:
            if (s_playlistManager.GetSize() > 0)
                OnPopupMenuFileInfo();
            break;
        case IDS_CLICKS10:
            ShowPopup();
            break;
            // album tracks
        case IDS_CLICKS11:
            ShowTracksMenu(0, true);
            break;
    }
}
void CMainWnd::DisplayTooltip()
{
    s_playlistManager.ReadTagAT(s_playlistManager.GetCurrent());
    switch (stdIn.GetPlayerMode())
    {
        case PLAYER_MODE_PAUSED:
            m_nid.hIcon = m_skin.pauseIcon;
            break;
        case PLAYER_MODE_PLAYING:
            m_nid.hIcon = m_skin.playIcon;
            break;
        case PLAYER_MODE_CLOSE:
            m_nid.hIcon = m_skin.stopIcon;
            break;
    }
    Shell_NotifyIcon(NIM_MODIFY, &m_nid);

    CString str;

    str = m_skin.toolTipText;
    str.Replace(_T("\\r"), _T("\r"));
    str.Replace(_T("\\n"), _T("\n"));
    str.Replace(_T("\\t"), _T("\t"));

    str.Replace(_T("%1"), s_playlistManager.GetArtist(s_playlistManager.GetCurrent()));
    str.Replace(_T("%2"), s_playlistManager.GetTitle(s_playlistManager.GetCurrent()));
    str.Replace(_T("%3"), s_playlistManager.GetAlbum(s_playlistManager.GetCurrent()));
    str.Replace(_T("%4"), s_playlistManager.GetYear(s_playlistManager.GetCurrent()));
    str.Replace(_T("%5"), s_playlistManager.GetComment(s_playlistManager.GetCurrent()));
    str.Replace(_T("%6"), s_playlistManager.GetDuration(s_playlistManager.GetCurrent()));
    str.Replace(_T("%7"), s_playlistManager.GetFilenameExt(s_playlistManager.GetCurrent()));
    str.Replace(_T("%8"), s_playlistManager.GetDrive(s_playlistManager.GetCurrent()));
    str.Replace(_T("%9"), s_playlistManager.GetDir(s_playlistManager.GetCurrent()));
    if (str.Find(_T("%A")) != -1)
    {
        CString image = s_playlistManager.GetDrive(s_playlistManager.GetCurrent()) + s_playlistManager.GetDir(s_playlistManager.GetCurrent()) + _T("*.*");
        CFileFind fileF;
        CString fp, fext, posExt = _T("BMP;JPG;");
        BOOL bWorking = fileF.FindFile(image);
        while (bWorking)
        {
            bWorking = fileF.FindNextFile();
            fp = fileF.GetFilePath();
            fext = fp.Mid(fp.ReverseFind('.') + 1, 3);fext.MakeUpper();
            if (fext.GetLength() != 0 && posExt.Find(fext) != -1)
            {
                bWorking = FALSE;
                str.Replace(_T("%A"), fp);
            }
        }
    }

    if (m_showToolTip)
    {
        if (m_skin.border)
        {
            if (!m_skin.custom_border)
                m_traytip->SetBorder(m_skin.end_bk, m_skin.border_width, m_skin.border_height);
            else
                m_traytip->SetBorder(m_skin.border_color, m_skin.border_width, m_skin.border_height);
        }
        else
        {
            m_traytip->HideBorder();
        } //if

        m_traytip->SetColorBk(m_skin.start_bk, m_skin.mid_bk, m_skin.end_bk);
        m_traytip->SetEffectBk(m_skin.effect_bk, m_skin.granularity);
        m_traytip->SetTransparency(m_skin.transparency);

        m_traytip->SetDelayTime(PPTOOLTIP_TIME_INITIAL, m_show_time);
        m_traytip->SetDelayTime(PPTOOLTIP_TIME_AUTOPOP, m_hide_time);
        m_traytip->SetDelayTime(PPTOOLTIP_TIME_FADEIN, m_fade_in);
        m_traytip->SetDelayTime(PPTOOLTIP_TIME_FADEOUT, m_fade_out);
        m_traytip->SetDelayTime(PPTOOLTIP_TIME_ANIMATION, m_animation);

        CRect trayWndRect(0, 0, 0, 0);
        HWND hWnd = ::FindWindowEx(::FindWindow(_T("Shell_TrayWnd"), NULL), NULL, _T("TrayNotifyWnd"), NULL);
        if (hWnd)
        {
            ::GetWindowRect(hWnd, trayWndRect);        
        }
        else
        {
            int nWidth = GetSystemMetrics(SM_CXSCREEN);
            int nHeight = GetSystemMetrics(SM_CYSCREEN);
            trayWndRect.SetRect(nWidth - 40, nHeight - 20, nWidth, nHeight);
        }    

        m_traytip->ShowHelpTooltip(&trayWndRect.TopLeft(), str);
    }
}

void CMainWnd::DrawFragment(DRAWITEMSTRUCT* psI, int frg)
{
    //Rfrence rapport au haut du menu
    CMenuItem m((HMENU)psI->hwndItem, psI->itemID, false);
    HDC hDC = CreateCompatibleDC(psI->hDC);
    int oWidth = 90;
    int oHeight = 90 / 5;
    if (psI->itemState & ODS_SELECTED)
        m_skin.buttonsDn = (HBITMAP)SelectObject(hDC, m_skin.buttonsDn);
    else
        m_skin.buttons = (HBITMAP)SelectObject(hDC, m_skin.buttons);

    int imgWidth = (oWidth * (psI->rcItem.bottom - psI->rcItem.top) < oHeight * (psI->rcItem.right - psI->rcItem.left)) ? oWidth * (psI->rcItem.bottom - psI->rcItem.top) / oHeight : oWidth;
    int imgHeight = (oWidth * (psI->rcItem.bottom - psI->rcItem.top) < oHeight * (psI->rcItem.right - psI->rcItem.left)) ? oHeight* imgWidth / oWidth : oHeight;

    HDC hdc1 = CreateCompatibleDC(psI->hDC);
    HDC hdc2 = CreateCompatibleDC(psI->hDC);
    HDC hdc3 = CreateCompatibleDC(psI->hDC);
    HDC hdc4 = CreateCompatibleDC(psI->hDC);
    HDC hdc5 = CreateCompatibleDC(psI->hDC);
    //Masque binaire
    HBITMAP bm1 = CreateBitmap(imgWidth, imgHeight, 1, 1, NULL);
    HBITMAP bm2 = CreateBitmap(imgWidth, imgHeight, 1, 1, NULL);
    HBITMAP bm3 = CreateCompatibleBitmap(hDC, imgWidth, imgHeight);
    HBITMAP bm4 = CreateCompatibleBitmap(hDC, imgWidth, imgHeight);
    HBITMAP bm5 = CreateCompatibleBitmap(hDC, psI->rcItem.right - psI->rcItem.left, imgHeight);
    SelectObject(hdc1, bm1);
    SelectObject(hdc2, bm2);
    SelectObject(hdc3, bm3);
    SelectObject(hdc4, bm4);
    SelectObject(hdc5, bm5);

    //Image Original
    COLORREF cColor = SetBkColor(hDC, RGB(255, 0, 255));
    StretchBlt(hdc1, 0, 0, imgWidth, imgHeight, hDC, 0, oHeight * frg, oWidth, oHeight, SRCCOPY);
    //Image invers
    StretchBlt(hdc2, 0, 0, imgWidth, imgHeight, hDC, 0, oHeight * frg, oWidth, oHeight, NOTSRCCOPY);
    if (m_skin.xpLookNFeel)
        SetBkColor(hDC, cColor);
    else
        SetBkColor(hdc1, cColor);
    if (!m_skin.xpLookNFeel)
        CDC::FromHandle(hdc5)->FillSolidRect(0, 0, psI->rcItem.right - psI->rcItem.left, imgHeight, (COLORREF)((psI->itemState & ODS_SELECTED) != 0) ? GetSysColor(COLOR_HIGHLIGHT) : GetSysColor(COLOR_MENU));
    else
        m.Draw(CDC::FromHandle(hdc5), &CRect(0, 0, psI->rcItem.right - psI->rcItem.left, imgHeight), (psI->itemState & ODS_SELECTED) != 0, LOBYTE(LOWORD(psI->itemData)) == 0, (psI->itemState & ODS_HOTLIGHT) != 0, (psI->itemState & ODS_INACTIVE) != 0, (psI->itemState & ODS_NOACCEL) != 0);
    StretchBlt(hdc3, 0, 0, imgWidth, imgHeight, hdc5, (psI->rcItem.right - psI->rcItem.left - imgWidth) / 2, 0, imgWidth, imgHeight, SRCCOPY);
    StretchBlt(hdc4, 0, 0, imgWidth, imgHeight, hDC, 0, oHeight * frg, oWidth, oHeight, SRCCOPY);
    //Fond Orignal
    //Et entre Image invers et fond
    BitBlt(hdc3, 0, 0, imgWidth, imgHeight, hdc1, 0, 0, SRCAND);
    BitBlt(hdc4, 0, 0, imgWidth, imgHeight, hdc2, 0, 0, SRCAND);
    //Ou entre les 2 images obtenu
    BitBlt(hdc4, 0, 0, imgWidth, imgHeight, hdc3, 0, 0, SRCPAINT);
    BitBlt(hdc5, (psI->rcItem.right - psI->rcItem.left - imgWidth) / 2, 0, imgWidth, imgHeight, hdc4, 0, 0, SRCCOPY);
    BitBlt(psI->hDC, psI->rcItem.left, psI->rcItem.top, psI->rcItem.right - psI->rcItem.left, imgHeight, hdc5, 0, 0, SRCCOPY);

    DeleteDC(hdc1);DeleteDC(hdc2);DeleteDC(hdc3);DeleteDC(hdc4);DeleteDC(hdc5);
    DeleteObject(bm1);DeleteObject(bm2);DeleteObject(bm3);DeleteObject(bm4);DeleteObject(bm5);

    if (psI->itemState & ODS_SELECTED)
        m_skin.buttonsDn = (HBITMAP)SelectObject(hDC, m_skin.buttonsDn);
    else
        m_skin.buttons = (HBITMAP)SelectObject(hDC, m_skin.buttons);

    DeleteDC(hDC);
}

bool CMainWnd::ExtractLevel(CString s, int l, CString* r)
{
    int i, j;
    int start = 0;
    if (s.Left(2) == "\\\\")
        start = 2;
    else if (s.Left(1) == "\\")
        start = 1;
    else if (s.Find(_T("://")) > 0)
    {
        start = 3 + s.Find(_T("://")); 
        l--;
    }
    if (l == 0)
    {
        //      *r = s.Left(start);
        //      return true;
        *r = "";
        return false;
    }
    j = start - 1;
    i = start;
    while (i < s.GetLength() && i != -1)
    {
        if (s[i] == '\\' || s[i] == '/')
        {
            l--;
            if (l == 0)
            {
                *r = s.Mid(j + 1, i - j - 1);
                return true;
            }
            j = i;
        }
        i = (s.Find(_T("\\"), i + 1) != -1) ? s.Find(_T("\\"), i + 1) : s.Find(_T("/"), i + 1);
    }
    return false;
}

CString CMainWnd::ExtractLevelPath(CString s, int l)
{
    int i;
    int start = 0;
    if (s.Left(2) == "\\\\")
        start = 2;
    else if (s.Left(1) == "\\")
        start = 1;
    else if (s.Find(_T("://")) > 0)
    {
        start = 3 + s.Find(_T("://"));
    }
    if (l == 0)
        return s.Left(start);
    i = start; 
    while (i < s.GetLength() && i != -1)
    {
        if (s[i] == '\\' || s[i] == '/')
        {
            l--;
            if (l == 0)
                return s.Left(i + 1);
        }
        i = (s.Find(_T("\\"), i + 1) != -1) ? s.Find(_T("\\"), i + 1) : s.Find(_T("/"), i + 1);
    }
    return _T("");
}
bool CMainWnd::FileExists(CString fname)
{
    if (fname.Find(_T("://")) > 0)
        return true;
    CFileFind finder;
    if (finder.FindFile(fname))
    {
        finder.FindNextFile();
        return(finder.GetLength() > 0);
    }
    else
        return false;
}


void CMainWnd::FindMP3Files(CString path, bool nodups)
{
    CFileFind finder;
    CString fp, fext;
    CString posExt = _T(";") + stdIn.GetFileExtensions();
    BOOL bWorking = finder.FindFile(path + _T("*.*"));
    while (bWorking)
    {
        bWorking = finder.FindNextFile();
        fp = finder.GetFilePath();
        fext = _T(";") + fp.Mid(fp.ReverseFind('.') + 1, 3) + _T(";");
        fext.MakeUpper();
        if (posExt.Find(fext) != -1)
        {
            if (finder.GetLength() > 0)
            {
                CString nTag = fp;
                if (nodups)
                {
                    bool flag = false;
                    for (int i = 0; i < s_playlistManager.GetSize(); i++)
                    {
                        CString nom = s_playlistManager.GetPlaylist(i);
                        if (nom.CompareNoCase(fp) == 0)
                        {
                            flag = true; 
                            break;
                        }
                    }
                    if (flag)
                        continue;
                }
                s_playlistManager.Add(nTag);
                continue;
            }
        }
        if (finder.IsDirectory() && !finder.IsDots())
            FindMP3Files(fp + _T("\\"), nodups);
    }
}

void CMainWnd::Finish()
{
    CRect rect;
    if (m_created)
    {
        m_created = false;

        s_playlistManager.StopReadAll();
        s_playlistManager.StopPerformAutomation();

        s_playlistDlg.SendMessage(PLAYLIST_STOP_ALL);

        if (m_firstPass)
        {
            m_firstPass = false;
            SaveThePlaylist();
            CString ininame;

            TCHAR path[MAX_PATH + 1];
            TCHAR drive[MAX_PATH];
            TCHAR dir[MAX_PATH];
            TCHAR fname[MAX_PATH];

            GetModuleFileName(theApp.m_hInstance, path, MAX_PATH);  
            _tsplitpath(path, drive, dir, fname, NULL);
            ininame.Format(_T("%s%s%s.ini"), drive, dir, fname);

            ::WritePrivateProfileSection(_T("Preferences"), _T(""), ininame);
            SaveSettings();

            theApp.WriteProfileInt(_T("Preferences"), _T("BarAtStartup"), (s_seekDialog.m_hWnd != NULL && s_seekDialog.IsWindowVisible()));
            if (s_seekDialog.m_hWnd != NULL)
                s_seekDialog.Save();
            SaveRect(_T("Preferences"), _T("SeekBar"), m_seekBarRect);
            if (s_videoDialog.m_hWnd != NULL)
                s_videoDialog.Save();
            SaveRect(_T("Preferences"), _T("Video"), m_videoRect);
            theApp.WriteProfileInt(_T("Preferences"), _T("PlaylistAtStartup"), s_playlistDlg.IsWindowVisible());
            if (s_playlistDlg.m_hWnd != NULL)
                s_playlistDlg.Save();
            SaveRect(_T("Preferences"), _T("Playlist"), m_playlistRect);
            theApp.WriteProfileInt(_T("Preferences"), _T("EQAtStartup"), (s_equalizerDlg.m_hWnd != NULL && s_equalizerDlg.IsWindowVisible()));
            if(s_equalizerDlg.m_hWnd != NULL)
                s_equalizerDlg.Save();
            SaveRect(_T("Preferences"), _T("Equalizer"), m_equalizerRect);
            GetWindowRect(&m_consoleRect);
            SaveRect(_T("Preferences"), _T("Console"), m_consoleRect);

            if (m_W2Fenabled)
                PerformW2File(true);
        }
        if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE)
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);

        theApp.WriteProfileInt(_T("Preferences"), _T("CurrentInPlaylist"), s_playlistManager.GetCurrent());

        Shell_NotifyIcon(NIM_DELETE, &m_nid);

        DeleteObject(m_skin.buttons);
        DeleteObject(m_skin.buttonsDn);
        DeleteObject(m_skin.playIcon);
        DeleteObject(m_skin.stopIcon);
        DeleteObject(m_skin.pauseIcon);
        DeleteObject(m_stpIcon);
        DeleteObject(m_stpIconSm);

        if (s_autDlg.m_hWnd != NULL)
            s_autDlg.DestroyWindow();

        if (s_settingsDialog!= NULL && s_settingsDialog->m_hWnd != NULL)
            s_settingsDialog->DestroyWindow();
        if (s_settingsDialog!= NULL)
            delete s_settingsDialog;
        s_settingsDialog = NULL;

        if (s_videoDialog.m_hWnd != NULL)
            s_videoDialog.DestroyWindow();

        if (s_equalizerDlg.m_hWnd != NULL)
            s_equalizerDlg.DestroyWindow();
        UnhookWindowsHookEx(hHook);
        AfxPostQuitMessage(0);
    }
}

void CMainWnd::GetAlbumRange(int* b, int* e, bool force, int track)
{
    if (track == -1)
        track = s_playlistManager.GetCurrent();
    if (!m_albumStop && !force)
    {
        *b = 0;
        *e = s_playlistManager.GetSize() - 1;
    }
    else
    {
        CString sortpath = s_playlistManager.GetSortPath(track);
        CString lastfolder = _T("");
        if (sortpath.ReverseFind('\\') != -1)
            lastfolder = sortpath.Left(sortpath.ReverseFind('\\'));
        int i;
        for (i = track; i > 0; i--)
        {
            CString comppath = s_playlistManager.GetSortPath(i);
            CString compfolder = _T("");
            if (comppath.ReverseFind('\\') != -1)
                compfolder = comppath.Left(comppath.ReverseFind('\\'));
            if (lastfolder.CompareNoCase(compfolder) != 0)
                break;
        }
        *b = i + 1;
        if (i + 1 == s_playlistManager.GetSize() || s_playlistManager.GetCurrent() == 0)
            *b = 0;
        for (i = track + 1; i < s_playlistManager.GetSize(); i++)
        {
            CString comppath = s_playlistManager.GetSortPath(i);
            CString compfolder = _T("");
            if (comppath.ReverseFind('\\') != -1)
                compfolder = comppath.Left(comppath.ReverseFind('\\'));
            if (lastfolder.CompareNoCase(compfolder) != 0)
                break;
        }
        *e = i - 1;
    }
}

int CMainWnd::GetMaxLevel(UINT start, UINT finish)
{
    int ml = 0, cl;
    UINT i;
    int j;
    CString buf;

    for (i = start; i < finish; i++)
    {
        cl = 0;
        if (s_playlistManager.GetDrive(i) == "")
            j = 1;
        else
            j = 0;

        while (j < s_playlistManager.GetDir(i).GetLength() && j != -1)
        {
            if (s_playlistManager.GetDir(i)[j] == '\\' || s_playlistManager.GetDir(i)[j] == '/')
                cl++;
            j = (s_playlistManager.GetDir(i).Find(_T("\\"), j + 1) != -1) ? s_playlistManager.GetDir(i).Find(_T("\\"), j + 1) : s_playlistManager.GetDir(i).Find(_T("/"), j + 1);
        }
        if (cl > ml)
            ml = cl;
    }
    return ml;
}

void CMainWnd::GetPosForMenu(LPPOINT point)
{
    CRect rect1, rect2, workAreaRect;
    ::GetWindowRect(::FindWindow(_T("Shell_TrayWnd"), NULL), &rect1);
    ::GetWindowRect(::GetDesktopWindow(), &rect2);
    ::SystemParametersInfo(SPI_GETWORKAREA, 0, &workAreaRect, 0);
    if (rect1.right < rect2.right)
    {
        point->x = workAreaRect.left;
        point->y = workAreaRect.top;
    }
    else if (rect1.left > rect2.left)
    {
        point->x = workAreaRect.right;
        point->y = workAreaRect.top;
    }
    else if (rect1.bottom < rect2.bottom)
    {
        point->x = workAreaRect.right;
        point->y = workAreaRect.top;
    }
    else
    {
        point->x = workAreaRect.right;
        point->y = workAreaRect.bottom;
    }
}
int CMainWnd::GetStartLevel(UINT start, UINT finish)
{
    int sl = 0;
    bool flag;
    UINT i;
    CString buf;

    do
    {
        sl++;
        buf = ExtractLevelPath(s_playlistManager.GetSortPath(start), sl);
        if (buf == "")
        {
            flag = false; break;
        }
        flag = true;
        for (i = start; i < finish; i++)
        {
            if (s_playlistManager.GetSortPath(i).Left(buf.GetLength()).CompareNoCase(buf) != 0)
            {
                flag = false;
                break;
            }
        }
    }
    while (flag);
    return sl - 1;
}
BOOL CMainWnd::PreTranslateMessage(MSG* pMsg)
{
    m_traytip->RelayEvent(pMsg);
    return CWnd::PreTranslateMessage(pMsg);
}

void CMainWnd::GoNext()
{
    if (m_gapBtwTracks > 0)
        Sleep(m_gapBtwTracks);

    if (m_repeatTrack)
    {
        if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE)
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
        COPYDATASTRUCT copyData;
        copyData.dwData = IPC_PLAYFILEW;
        copyData.cbData = s_playlistManager.GetPlaylist(s_playlistManager.GetCurrent()).GetLength() * sizeof(char*);

        copyData.lpData = (PVOID)s_playlistManager.GetPlaylist(s_playlistManager.GetCurrent()).GetString();
        ::SendMessage(WAEmuWnd.m_hWnd, WM_COPYDATA, 0, (WPARAM)&copyData);
    }
    else
        ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON5, 0);

    if (m_changeSkinOnEachTrack && m_currentSkin.GetSize() != 0)
    {
        if (m_randomSkin)
        {
            m_currentSkinSel = rand() % m_currentSkin.GetSize();
        }
        else
        {
            m_currentSkinSel++;
            m_currentSkinSel %= m_currentSkin.GetSize();
        }
        LoadSkin(m_currentSkin[m_currentSkinSel], &m_skin);
        UseSkin(&m_skin);
        if (s_seekDialog.m_hWnd != NULL)
            s_seekDialog.Invalidate();
        if (s_playlistDlg.IsWindowVisible())
            s_playlistDlg.Invalidate();
    }
}

void CMainWnd::HideTooltip()
{
    m_traytip->HideTooltip();
}

LRESULT CMainWnd::IconNotify(WPARAM wParam, LPARAM lParam)
{
    if (lParam == WM_MOUSEMOVE)
    {
        GetCursorPos(&m_curMousePos);
        if (!m_startToolTip)
        {
            m_startToolTip = true;
            SetTimer(DELAY_FROM_TOOLTIP, 1000, NULL);
        }
        return TRUE;
    }
    if (m_noClicks)
    {
        KillTimer(DELAY_FROM_TOOLTIP);
        SetTimer(DELAY_FROM_BEBORE_RESTART_TOOLTIP, 1000, NULL);
        if (lParam == WM_MOUSEMOVE || lParam == WM_RBUTTONUP || lParam == WM_LBUTTONUP)
            ShowPopup();
    }
    else
    {
        KillTimer(DELAY_FROM_TOOLTIP);
        SetTimer(DELAY_FROM_BEBORE_RESTART_TOOLTIP, 1000, NULL);
        switch (lParam)
        {
            case WM_LBUTTONDBLCLK:
            case WM_LBUTTONDOWN:
                m_lbd = true;
                if (m_lbs == 0 && m_rbs == 0 && m_pressAndHold < 2)
                    SetTimer(LBUTTON_CLICK, GetDoubleClickTime(), NULL);
                return TRUE;
                break;
            case WM_RBUTTONDBLCLK:
            case WM_RBUTTONDOWN:
                m_rbd = true;
                if (m_lbs == 0 && m_rbs == 0 && m_pressAndHold < 2)
                    SetTimer(RBUTTON_CLICK, GetDoubleClickTime(), NULL);
                return TRUE;
                break;
            case WM_RBUTTONUP:
                if (m_rbd || m_rbs > 0)
                {
                    KillTimer(1);KillTimer(RBUTTON_UP);KillTimer(LBUTTON_CLICK);KillTimer(RBUTTON_CLICK);
                    if (!m_traySeeking)
                    {
                        if (m_rbs == 0 && m_clicks[5] == 0 && m_clicks[6] == 0 && m_clicks[7] == 0)
                            ClickAction(m_clicks[4]);
                        else
                        {
                            m_rbs++;
                            SetTimer(RBUTTON_UP, GetDoubleClickTime(), NULL);
                        }
                    }
                    m_traySeeking = false;
                    m_rbd = false;
                }
                return TRUE;
                break;
            case WM_LBUTTONUP:
                if (m_lbd || m_lbs > 0)
                {
                    KillTimer(LBUTTON_UP);KillTimer(RBUTTON_UP);KillTimer(LBUTTON_CLICK);KillTimer(RBUTTON_CLICK);
                    if (!m_traySeeking)
                    {
                        if (m_lbs == 0 && m_clicks[1] == 0 && m_clicks[2] == 0 && m_clicks[3] == 0)
                            ClickAction(m_clicks[0]);
                        else
                        {
                            m_lbs++;
                            SetTimer(LBUTTON_UP, GetDoubleClickTime(), NULL);
                        }
                    }
                    m_traySeeking = false;
                    m_lbd = false;
                }
                return TRUE;
                break;
        }
    }
    TRACE(_T("Message non reu %d %d\n"), wParam, lParam);
    return FALSE;
}
void CMainWnd::LoadSkin(CString fname, SkinStruct* loadSkin)
{
    CString tmp = fname;
    TCHAR path[MAX_PATH];
    TCHAR ext[MAX_PATH];
    _tcscpy(path, (TCHAR *)fname.GetString());
    _tsplitpath(path, NULL, NULL, NULL, ext);
    if (_tcsicmp(ext, _T(".sk2")) == 0)
    {
        LoadSkinNew(fname, loadSkin);
    }
    else
    {
        LoadSkinOld(fname, loadSkin);
    }
}
void CMainWnd::LoadSkinOld(CString fname, SkinStruct* loadSkin)
{
    CStdioFile sknfile;

    if (fname == "" || !sknfile.Open(fname, CFile::modeRead | CFile::shareDenyNone))
    {
        loadSkin->buttons = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_BUTTONS), IMAGE_BITMAP, 90, 90, LR_DEFAULTCOLOR);
        loadSkin->buttonsDn = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_BUTTONSDN), IMAGE_BITMAP, 90, 90, LR_DEFAULTCOLOR);
        loadSkin->playIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PLAY), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->stopIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_STOP), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->pauseIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PAUSE), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->prevIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PREV), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->nextIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_NEXT), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->playIconName = "";
        loadSkin->pauseIconName = "";
        loadSkin->stopIconName = "";
        loadSkin->prevIconName = "";
        loadSkin->nextIconName = "";
        loadSkin->buttonsName = "";
        loadSkin->buttonsDnName = "";
        loadSkin->startColor = m_skin.startColor;
        loadSkin->endColor = m_skin.endColor;
        loadSkin->border_color = m_skin.border_color;
        loadSkin->end_bk = m_skin.end_bk;
        loadSkin->mid_bk = m_skin.mid_bk;
        loadSkin->start_bk = m_skin.start_bk;

        loadSkin->toolTipText = m_skin.toolTipText;

        loadSkin->theme = m_skin.theme;
        loadSkin->effect_bk = m_skin.effect_bk;
        loadSkin->granularity = m_skin.granularity;
        loadSkin->border = m_skin.border;
        loadSkin->custom_border = m_skin.custom_border;
        loadSkin->border_width = m_skin.border_width;
        loadSkin->border_height = m_skin.border_height;
        loadSkin->transparency = m_skin.transparency;
        return;
    }

    CString buf;
    CString CurPath = fname.Left(fname.ReverseFind('\\') + 1);
    if (sknfile.ReadString(buf))
    {
        if (buf != "*")
        {
            if ((loadSkin->buttons = (HBITMAP)::LoadImage(0, CurPath + buf, IMAGE_BITMAP, 90, 90, LR_LOADFROMFILE | LR_DEFAULTCOLOR)) == NULL)
            {
                loadSkin->buttons = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_BUTTONS), IMAGE_BITMAP, 90, 90, LR_DEFAULTCOLOR);
                loadSkin->buttonsName = "";
            }
            else
            {
                loadSkin->buttonsName = CurPath + buf;
            }
        }
        else
        {
            loadSkin->buttons = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_BUTTONS), IMAGE_BITMAP, 90, 90, LR_DEFAULTCOLOR);
            loadSkin->buttonsName = "";
        }
    }
    else
    {
        loadSkin->buttons = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_BUTTONS), IMAGE_BITMAP, 90, 90, LR_DEFAULTCOLOR);
        loadSkin->buttonsName = "";
    } 

    if (sknfile.ReadString(buf))
    {
        if (buf != "*")
        {
            if ((loadSkin->buttonsDn = (HBITMAP)::LoadImage(0, CurPath + buf, IMAGE_BITMAP, 90, 90, LR_LOADFROMFILE | LR_DEFAULTCOLOR)) == NULL)
            {
                loadSkin->buttonsDn = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_BUTTONSDN), IMAGE_BITMAP, 90, 90, LR_DEFAULTCOLOR);
                loadSkin->buttonsDnName = "";
            }
            else
            {
                loadSkin->buttonsDnName = CurPath + buf;
            }
        }
        else
        {
            loadSkin->buttonsDn = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_BUTTONSDN), IMAGE_BITMAP, 90, 90, LR_DEFAULTCOLOR);
            loadSkin->buttonsDnName = "";
        }
    }
    else
    {
        loadSkin->buttonsDn = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_BUTTONSDN), IMAGE_BITMAP, 90, 90, LR_DEFAULTCOLOR);
        loadSkin->buttonsDnName = "";
    } 
    if (sknfile.ReadString(buf))
    {
        if (buf != "*")
        {
            if ((loadSkin->playIcon = (HICON)::LoadImage(0, CurPath + buf, IMAGE_ICON, 16, 16, LR_LOADFROMFILE)) == NULL)
            {
                loadSkin->playIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PLAY), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
                loadSkin->playIconName = "";
            }
            else
            {
                loadSkin->playIconName = CurPath + buf;
            }
        }
        else
        {
            loadSkin->playIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PLAY), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
            loadSkin->playIconName = "";
        }
    }
    else
    {
        loadSkin->playIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PLAY), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->playIconName = "";
    } 
    if (sknfile.ReadString(buf))
    {
        if (buf != "*")
        {
            if ((loadSkin->pauseIcon = (HICON)::LoadImage(0, CurPath + buf, IMAGE_ICON, 16, 16, LR_LOADFROMFILE)) == NULL)
            {
                loadSkin->pauseIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PAUSE), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
                loadSkin->pauseIconName = "";
            }
            else
            {
                loadSkin->pauseIconName = CurPath + buf;
            }
        }
        else
        {
            loadSkin->pauseIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PAUSE), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
            loadSkin->pauseIconName = "";
        }
    }
    else
    {
        loadSkin->pauseIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PAUSE), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->pauseIconName = "";
    } 
    if (sknfile.ReadString(buf))
    {
        if (buf != "*")
        {
            if ((loadSkin->stopIcon = (HICON)::LoadImage(0, CurPath + buf, IMAGE_ICON, 16, 16, LR_LOADFROMFILE)) == NULL)
            {
                loadSkin->stopIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_STOP), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
                loadSkin->stopIconName = "";
            }
            else
            {
                loadSkin->stopIconName = CurPath + buf;
            }
        }
        else
        {
            loadSkin->stopIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_STOP), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
            loadSkin->stopIconName = "";
        }
    }
    else
    {
        loadSkin->stopIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_STOP), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->stopIconName = "";
    } 
    if (sknfile.ReadString(buf))
    {
        if (buf != "*")
        {
            if ((loadSkin->prevIcon = (HICON)::LoadImage(0, CurPath + buf, IMAGE_ICON, 16, 16, LR_LOADFROMFILE)) == NULL)
            {
                loadSkin->prevIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PREV), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
                loadSkin->prevIconName = "";
            }
            else
            {
                loadSkin->prevIconName = CurPath + buf;
            }
        }
        else
        {
            loadSkin->prevIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PREV), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
            loadSkin->prevIconName = "";
        }
    }
    else
    {
        loadSkin->prevIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PREV), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->prevIconName = "";
    } 
    if (sknfile.ReadString(buf))
    {
        if (buf != "*")
        {
            if ((loadSkin->nextIcon = (HICON)::LoadImage(0, CurPath + buf, IMAGE_ICON, 16, 16, LR_LOADFROMFILE)) == NULL)
            {
                loadSkin->nextIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_NEXT), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
                loadSkin->nextIconName = "";
            }
            else
            {
                loadSkin->nextIconName = CurPath + buf;
            }
        }
        else
        {
            loadSkin->nextIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_NEXT), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
            loadSkin->nextIconName = "";
        }
    }
    else
    {
        loadSkin->nextIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_NEXT), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->nextIconName = "";
    } 

    sknfile.Close();
}
void CMainWnd::LoadSkinNew(CString fname, SkinStruct* loadSkin)
{
    TCHAR pathFile[MAX_PATH];
    TCHAR driveFile[MAX_PATH];
    TCHAR directoryFile[MAX_PATH];
    TCHAR driveName[MAX_PATH];
    TCHAR cbuf[5000];

    _tcscpy(pathFile, (TCHAR *)fname.GetString());

    _tsplitpath(pathFile, driveFile, directoryFile, NULL, NULL);

    ::GetPrivateProfileString(_T("Skin"), _T("PlayIcon"), loadSkin->playIconName, cbuf, 255, fname);
    if (_tcslen(cbuf) != 0)
    {
        _tsplitpath(cbuf, driveName, NULL, NULL, NULL);
        if (_tcslen(driveName) != 0)
        {
            loadSkin->playIconName.Format(_T("%s"), cbuf);
        }
        else
        {
            loadSkin->playIconName.Format(_T("%s%s%s"), driveFile, directoryFile, cbuf);
        }
    }
    else
    {
        loadSkin->playIconName = "";
    }
    if ((loadSkin->playIcon = (HICON)::LoadImage(0, loadSkin->playIconName, IMAGE_ICON, 16, 16, LR_LOADFROMFILE)) == NULL)
    {
        loadSkin->playIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PLAY), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->playIconName = "";
    } 

    ::GetPrivateProfileString(_T("Skin"), _T("PauseIcon"), loadSkin->pauseIconName, cbuf, 255, fname);
    if (_tcslen(cbuf) != 0)
    {
        _tsplitpath(cbuf, driveName, NULL, NULL, NULL);
        if (_tcslen(driveName) != 0)
        {
            loadSkin->pauseIconName.Format(_T("%s"), cbuf);
        }
        else
        {
            loadSkin->pauseIconName.Format(_T("%s%s%s"), driveFile, directoryFile, cbuf);
        }
    }
    else
    {
        loadSkin->pauseIconName = "";
    }
    if ((loadSkin->pauseIcon = (HICON)::LoadImage(0, loadSkin->pauseIconName, IMAGE_ICON, 16, 16, LR_LOADFROMFILE)) == NULL)
    {
        loadSkin->pauseIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PAUSE), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->pauseIconName = "";
    } 

    ::GetPrivateProfileString(_T("Skin"), _T("StopIcon"), loadSkin->stopIconName, cbuf, 255, fname);
    if (_tcslen(cbuf) != 0)
    {
        _tsplitpath(cbuf, driveName, NULL, NULL, NULL);
        if (_tcslen(driveName) != 0)
        {
            loadSkin->stopIconName.Format(_T("%s"), cbuf);
        }
        else
        {
            loadSkin->stopIconName.Format(_T("%s%s%s"), driveFile, directoryFile, cbuf);
        }
    }
    else
    {
        loadSkin->stopIconName = "";
    }
    if ((loadSkin->stopIcon = (HICON)::LoadImage(0, loadSkin->stopIconName, IMAGE_ICON, 16, 16, LR_LOADFROMFILE)) == NULL)
    {
        loadSkin->stopIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_STOP), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->stopIconName = "";
    } 

    ::GetPrivateProfileString(_T("Skin"), _T("PrevIcon"), loadSkin->prevIconName, cbuf, 255, fname);
    if (_tcslen(cbuf) != 0)
    {
        _tsplitpath(cbuf, driveName, NULL, NULL, NULL);
        if (_tcslen(driveName) != 0)
        {
            loadSkin->prevIconName.Format(_T("%s"), cbuf);
        }
        else
        {
            loadSkin->prevIconName.Format(_T("%s%s%s"), driveFile, directoryFile, cbuf);
        }
    }
    else
    {
        loadSkin->prevIconName = "";
    }
    if ((loadSkin->prevIcon = (HICON)::LoadImage(0, loadSkin->prevIconName, IMAGE_ICON, 16, 16, LR_LOADFROMFILE)) == NULL)
    {
        loadSkin->prevIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PREV), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->prevIconName = "";
    } 

    ::GetPrivateProfileString(_T("Skin"), _T("NextIcon"), loadSkin->nextIconName, cbuf, 255, fname);
    if (_tcslen(cbuf) != 0)
    {
        _tsplitpath(cbuf, driveName, NULL, NULL, NULL);
        if (_tcslen(driveName) != 0)
        {
            loadSkin->nextIconName.Format(_T("%s"), cbuf);
        }
        else
        {
            loadSkin->nextIconName.Format(_T("%s%s%s"), driveFile, directoryFile, cbuf);
        }
    }
    else
    {
        loadSkin->nextIconName = "";
    }
    if ((loadSkin->nextIcon = (HICON)::LoadImage(0, loadSkin->nextIconName, IMAGE_ICON, 16, 16, LR_LOADFROMFILE)) == NULL)
    {
        loadSkin->nextIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_NEXT), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
        loadSkin->nextIconName = "";
    } 

    ::GetPrivateProfileString(_T("Skin"), _T("Buttons"), loadSkin->buttonsName, cbuf, 255, fname);
    if (_tcslen(cbuf) != 0)
    {
        _tsplitpath(cbuf, driveName, NULL, NULL, NULL);
        if (_tcslen(driveName) != 0)
        {
            loadSkin->buttonsName.Format(_T("%s"), cbuf);
        }
        else
        {
            loadSkin->buttonsName.Format(_T("%s%s%s"), driveFile, directoryFile, cbuf);
        }
    }
    else
    {
        loadSkin->buttonsName = "";
    }
    if ((loadSkin->buttons = (HBITMAP)::LoadImage(0, loadSkin->buttonsName, IMAGE_BITMAP, 90, 90, LR_LOADFROMFILE | LR_DEFAULTCOLOR)) == NULL)
    {
        loadSkin->buttons = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_BUTTONS), IMAGE_BITMAP, 90, 90, LR_DEFAULTCOLOR);
        loadSkin->buttonsName = "";
    } 

    ::GetPrivateProfileString(_T("Skin"), _T("ButtonsDn"), loadSkin->buttonsDnName, cbuf, 255, fname);
    if (_tcslen(cbuf) != 0)
    {
        _tsplitpath(cbuf, driveName, NULL, NULL, NULL);
        if (_tcslen(driveName) != 0)
        {
            loadSkin->buttonsDnName.Format(_T("%s"), cbuf);
        }
        else
        {
            loadSkin->buttonsDnName.Format(_T("%s%s%s"), driveFile, directoryFile, cbuf);
        }
    }
    else
    {
        loadSkin->buttonsDnName = "";
    }
    if ((loadSkin->buttonsDn = (HBITMAP)::LoadImage(0, loadSkin->buttonsDnName, IMAGE_BITMAP, 90, 90, LR_LOADFROMFILE | LR_DEFAULTCOLOR)) == NULL)
    {
        loadSkin->buttonsDn = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_BUTTONSDN), IMAGE_BITMAP, 90, 90, LR_DEFAULTCOLOR);
        loadSkin->buttonsDnName = "";
    } 

    loadSkin->startColor = ::GetPrivateProfileInt(_T("Skin"), _T("GradientStart"), loadSkin->startColor, fname);
    loadSkin->endColor = ::GetPrivateProfileInt(_T("Skin"), _T("GradientEnd"), loadSkin->endColor, fname);
    loadSkin->border_color = ::GetPrivateProfileInt(_T("Skin"), _T("border_color"), m_skin.border_color, fname);
    loadSkin->end_bk = ::GetPrivateProfileInt(_T("Skin"), _T("end_bk"), m_skin.end_bk, fname);
    loadSkin->mid_bk = ::GetPrivateProfileInt(_T("Skin"), _T("mid_bk"), m_skin.mid_bk, fname);
    loadSkin->start_bk = ::GetPrivateProfileInt(_T("Skin"), _T("start_bk"), m_skin.start_bk, fname);
    ::GetPrivateProfileString(_T("Skin"), _T("ToolTipText"), m_skin.toolTipText, cbuf, 5000, fname);
    loadSkin->toolTipText.Format(_T("%s"), cbuf);

    loadSkin->theme = ::GetPrivateProfileInt(_T("Skin"), _T("Theme"), m_skin.theme, fname);
    loadSkin->effect_bk = ::GetPrivateProfileInt(_T("Skin"), _T("effect_bk"), m_skin.effect_bk, fname);
    loadSkin->granularity = ::GetPrivateProfileInt(_T("Skin"), _T("granularity"), m_skin.granularity, fname);
    loadSkin->border = ::GetPrivateProfileInt(_T("Skin"), _T("border"), m_skin.border, fname);
    loadSkin->custom_border = ::GetPrivateProfileInt(_T("Skin"), _T("custom_border"), m_skin.custom_border, fname);
    loadSkin->border_width = ::GetPrivateProfileInt(_T("Skin"), _T("border_width"), m_skin.border_width, fname);
    loadSkin->border_height = ::GetPrivateProfileInt(_T("Skin"), _T("border_height"), m_skin.border_height, fname);
    loadSkin->transparency = ::GetPrivateProfileInt(_T("Skin"), _T("transparency"), m_skin.transparency, fname);
}
void CMainWnd::UseSkin(SkinStruct* useSkin)
{
    m_imgList.DeleteImageList();
    m_imgList.Create(IDB_BITMAP1, 16, 0, RGB(192, 192, 192));

    CMenuXP::ms_Images.RemoveKey(ID_POPUPMENU_PLAY);
    CMenuXP::ms_Images.RemoveKey(ID_POPUPMENU_PAUSE);
    CMenuXP::ms_Images.RemoveKey(ID_POPUPMENU_STOP);
    CMenuXP::ms_Images.RemoveKey(ID_POPUPMENU_PREVIOUS);
    CMenuXP::ms_Images.RemoveKey(ID_POPUPMENU_NEXT);

    CMenuXP::SetMenuItemImage(ID_POPUPMENU_PLAY, m_imgList, 5, useSkin->playIcon);
    CMenuXP::SetMenuItemImage(ID_POPUPMENU_PAUSE, m_imgList, 6, useSkin->pauseIcon);
    CMenuXP::SetMenuItemImage(ID_POPUPMENU_STOP, m_imgList, 7, useSkin->stopIcon);
    CMenuXP::SetMenuItemImage(ID_POPUPMENU_PREVIOUS, m_imgList, 8, useSkin->prevIcon);
    CMenuXP::SetMenuItemImage(ID_POPUPMENU_NEXT, m_imgList, 9, useSkin->nextIcon);
}

void CMainWnd::LoadThePlaylist()
{
    TCHAR buf2[MAX_PATH + 1];
    GetModuleFileName(theApp.m_hInstance, buf2, MAX_PATH);
    for (int i = _tcslen(buf2) - 1; i > 0; i--)
    {
        if (buf2[i] == '.')
        {
            buf2[i] = '\0';break;
        }
    }
    CString fname = buf2;
    fname += ".m3u";

    OpenPlaylistEngine(fname, m_randomFirst, false, true, true);
    if (s_playlistManager.GetSize() == 0)
    {
        return;
    }

    if (s_playlistDlg.m_hWnd != NULL)
        ::SendMessage(s_playlistDlg.m_hWnd, WM_COMMAND, ID_TRACKS_REFRESH, 0);
}

UINT CMainWnd::MyRandom(bool forw, bool init)
{
    if (init)
    {
        srand((unsigned)time(NULL));
        if (s_playlistManager.GetSize() != 0)
            s_playlistManager.SetCurrent(rand() % s_playlistManager.GetSize());
        else
            s_playlistManager.SetCurrent(0);
    }
    else if (m_firstInMyRandom == -1)
        m_firstInMyRandom = s_playlistManager.GetCurrent();
    while (*m_rndpntr != s_playlistManager.GetCurrent())
    {
        if (m_rndpntr == m_rndlst + 49999)
            m_rndpntr = m_rndlst;
        else
            m_rndpntr++;
    }
    int b, e; 
    GetAlbumRange(&b, &e);
    if (b <= 0 && e >= 0)
    {
        do
        {
            if (forw)
            {
                if (m_rndpntr == m_rndlst + 49999)
                    m_rndpntr = m_rndlst;
                else
                    m_rndpntr++;
            }
            else
            {
                if (m_rndpntr == m_rndlst)
                    m_rndpntr = m_rndlst + 49999;
                else
                    m_rndpntr--;
            }
        }
        while (*m_rndpntr < b || *m_rndpntr > e);
    }
    else
        return 0;
    return *m_rndpntr;
}

void CMainWnd::OnAutomationPerformNow()
{
    s_playlistManager.PerformAutomation();
    if (m_autSaveset)
        SaveSettings();
}

void CMainWnd::OnAutomationSetup()
{
    if (s_autDlg.m_hWnd == NULL)
        s_autDlg.Create(CAutDlg::IDD);
    s_autDlg.ShowWindow(SW_SHOW);
}

BOOL CMainWnd::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pData)
{
    TRACE(_T("OnCopyData "));
    if (m_created && pData->cbData == sizeof(MsgCmd))
    {
        MsgCmd cmd;
        memcpy(&cmd, pData->lpData, sizeof(MsgCmd));

        CFileFind finder;
        bool add = false;
        if (cmd.command == 1)
                add = true;
        CString buf = cmd.fname;
        if (buf.GetLength() == 3 && buf[1] == ':')
            OpenFolder(buf.Left(2) + '\\', m_randomFirst, add, !add);
        else if (finder.FindFile(buf))
        {
            finder.FindNextFile();
            if (finder.IsDirectory())
                OpenFolder(buf, m_randomFirst, add, !add);
            else
            {
                if ((buf.Mid(buf.ReverseFind('.') + 1, 3)).CompareNoCase(_T("M3U")) == 0 || (buf.Mid(buf.ReverseFind('.') + 1, 3)).CompareNoCase(_T("PLS")) == 0)
                    OpenPlaylist(buf, m_randomFirst, add, !add);
                else
                    OpenFile(buf, add, !add);
            }
            AddRecent(buf);
        }
        return TRUE;
    }
    else
        return FALSE;
}

void CMainWnd::ReloadMenu()
{
    if(m_mainMenu.m_hMenu !=NULL)
    {
        m_mainMenu.DestroyMenu();
    }
    m_mainMenu.LoadMenu(IDR_MENU);
    if(m_consoleMenu.m_hMenu !=NULL)
    {
        m_consoleMenu.DestroyMenu();
    }
    m_consoleMenu.LoadMenu(IDR_CONSOLE);
}
int CMainWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    lpCreateStruct->style |= WS_VSCROLL;
    lpCreateStruct->style = WS_VSCROLL | LBS_EXTENDEDSEL | LBS_HASSTRINGS | LBS_NOTIFY | LBS_NOINTEGRALHEIGHT | LBS_NODATA | 
        WS_CAPTION | WS_THICKFRAME | WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX;
    if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
        return -1;
    hHook = SetWindowsHookEx(WH_CALLWNDPROC, CMainWnd::HookCallWndProc, 0, ::GetCurrentThreadId());
    m_traytip = new CPPToolTip();
    m_traytip->Create(this);
    m_traytip->SetSize(CPPToolTip::PPTTSZ_MARGIN_CX, 4);
    m_traytip->SetSize(CPPToolTip::PPTTSZ_MARGIN_CY, 4);

    ReloadMenu();
    Start();

    // Default font
    HFONT hFont = CreateFont(-11,               // int nHeight
                0,                              // int nWidth
                0,                              // int nEscapement
                0,                              // int nOrientation
                FW_REGULAR,                     // int fnWeight
                FALSE,                          // DWORD fdwItalic
                FALSE,                          // DWORD fdwUnderline
                FALSE,                          // DWORD fdwStrikeOut
                DEFAULT_CHARSET,                // DWORD fdwCharSet
                OUT_TT_PRECIS,                  // DWORD fdwOutputPrecision
                CLIP_DEFAULT_PRECIS,            // DWORD fdwClipPrecision
                ANTIALIASED_QUALITY,            // DWORD fdwQuality
                FF_DONTCARE | DEFAULT_PITCH,    // DWORD fdwPitchAndFamily
                TEXT("Verdana")                 // LPCTSTR lpszFace
    );
    ModifyStyleEx(0, WS_EX_APPWINDOW);
    SendMessage(WM_SETFONT, (WPARAM)hFont, FALSE);

    return 0;
}

void CMainWnd::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
    if (lpDrawItemStruct->itemID == ID_POPUPMENU_PIC && lpDrawItemStruct->itemAction == ODA_DRAWENTIRE)
    {
        CRect sRect;
        COLORREF crGradientStart = m_skin.startColor;
        COLORREF crGradientEnd = m_skin.endColor;

        ::GetMenuItemRect(m_hWnd, (HMENU)lpDrawItemStruct->hwndItem, 1, &sRect);
        int menutop = sRect.top;

        ::GetMenuItemRect(m_hWnd, (HMENU)lpDrawItemStruct->hwndItem, ::GetMenuItemCount((HMENU)lpDrawItemStruct->hwndItem) - 1, &sRect);
        int menubottom = sRect.bottom;

        HDC hDC = CreateCompatibleDC(lpDrawItemStruct->hDC);
        HBITMAP bm1 = CreateCompatibleBitmap(lpDrawItemStruct->hDC, lpDrawItemStruct->rcItem.right, lpDrawItemStruct->rcItem.bottom);
        SelectObject(hDC, bm1);
        lpDrawItemStruct->rcItem.top = 0;
        lpDrawItemStruct->rcItem.bottom = (menubottom - menutop);

        CRect rect2 = lpDrawItemStruct->rcItem;
        // Initialize fonts:
        LOGFONT lf;
        memset(&lf, 0, sizeof(LOGFONT));

        // Text will be rotated counter-clockwise 90 degrees.
        lf.lfOrientation = lf.lfEscapement = 900;

        // We need a TrueType font to get rotated text.  MS Sans //Serif won't cut it!
        lstrcpy(lf.lfFaceName, _T("Times"));

        lf.lfHeight = 20;
        lf.lfWeight = FW_DEMIBOLD;
        lf.lfItalic = TRUE;

        // Create a font with the tweaked attributes.
        CFont font;
        font.CreateFontIndirect(&lf);

        CFont* oldFond = CDC::FromHandle(lpDrawItemStruct->hDC)->SelectObject(&font);
        CMenuItem m((HMENU)lpDrawItemStruct->hwndItem, 0, true);

        HBITMAP bm = CreateCompatibleBitmap(hDC, lpDrawItemStruct->rcItem.right, lpDrawItemStruct->rcItem.bottom);

        SelectObject(hDC, bm);
        m.DrawGradient(CDC::FromHandle(hDC), m_skin.xpLookNFeel ? crGradientEnd : RGB(0xFF, 0xFF, 0xFF), m_skin.xpLookNFeel ? crGradientStart : RGB(0x00, 0x00, 0x00), &CRect(0, 0, lpDrawItemStruct->rcItem.right - lpDrawItemStruct->rcItem.left, lpDrawItemStruct->rcItem.bottom - lpDrawItemStruct->rcItem.top), true);
        lpDrawItemStruct->rcItem.right += 2;
        StretchBlt(lpDrawItemStruct->hDC, 0, 0, lpDrawItemStruct->rcItem.right, lpDrawItemStruct->rcItem.bottom, hDC, 0, 0, lpDrawItemStruct->rcItem.right, lpDrawItemStruct->rcItem.bottom, SRCCOPY);
        COLORREF oldColor = CDC::FromHandle(lpDrawItemStruct->hDC)->SetTextColor(m_skin.xpLookNFeel ? crGradientEnd : RGB(0xFF, 0xFF, 0xFF));
        int oldBkMode = CDC::FromHandle(lpDrawItemStruct->hDC)->SetBkMode(TRANSPARENT);
        rect2.left -= 2;
        rect2.bottom += 15;
        CDC::FromHandle(lpDrawItemStruct->hDC)->DrawText(_T("STP   2009"), &rect2, DT_BOTTOM | DT_LEFT | DT_SINGLELINE);
        rect2.bottom -= 1;
        CDC::FromHandle(lpDrawItemStruct->hDC)->DrawText(_T("STP   2009"), &rect2, DT_BOTTOM | DT_LEFT | DT_SINGLELINE);

        CDC::FromHandle(lpDrawItemStruct->hDC)->SelectObject(oldFond);
        CDC::FromHandle(lpDrawItemStruct->hDC)->SetTextColor(oldColor);
        CDC::FromHandle(lpDrawItemStruct->hDC)->SetBkMode(oldBkMode);

        // clean up
        font.DeleteObject();

        DeleteDC(hDC);
        DeleteObject(bm1);
    }
    if (!m_skin.xpLookNFeel)
        CFrameWnd::OnDrawItem(nIDCtl, lpDrawItemStruct);
    //On affiche pas en style XP si image de gradient
    else if (lpDrawItemStruct->itemID == ID_POPUPMENU_PIC)
        CFrameWnd::OnDrawItem(nIDCtl, lpDrawItemStruct);
    else if (!CMenuXP::OnDrawItem(lpDrawItemStruct, m_hWnd))
        CFrameWnd::OnDrawItem(nIDCtl, lpDrawItemStruct);
    if (m_graphicalButtons)
    {
        if (lpDrawItemStruct->itemID == ID_POPUPMENU_PLAY)
            DrawFragment(lpDrawItemStruct, 0);
        if (lpDrawItemStruct->itemID == ID_POPUPMENU_PAUSE)
            DrawFragment(lpDrawItemStruct, 1);
        if (lpDrawItemStruct->itemID == ID_POPUPMENU_STOP)
            DrawFragment(lpDrawItemStruct, 2);
        if (lpDrawItemStruct->itemID == ID_POPUPMENU_PREVIOUS)
            DrawFragment(lpDrawItemStruct, 3);
        if (lpDrawItemStruct->itemID == ID_POPUPMENU_NEXT)
            DrawFragment(lpDrawItemStruct, 4);
    }
}

void CMainWnd::OnDrivesMenu(UINT nID)
{
    CString CDLetter;
    CDLetter.Format(_T("%c"), (char)(nID - IDM_DRIVES) + 'C');
    OpenFolder(CDLetter + _T(":\\"), m_randomFirst);
}

void CMainWnd::OnEndSession(BOOL bEnding)
{
    CFrameWnd::OnEndSession(bEnding);

    if (bEnding)
        ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_QUIT, 0);
}

void CMainWnd::OnInitMenuPopup(CMenu* pMenu, UINT wParam, BOOL isActive)
{
    for (UINT i = 0; i < pMenu->GetMenuItemCount(); i++)
    {
        UINT menuID = pMenu->GetMenuItemID(i);
        CString menuTitle;
        //Si on est pas sur un sous menu
        if (menuID != 0 && menuID != 0xFFFFFFFF)
        {
            pMenu->GetMenuString(i, menuTitle, MF_BYPOSITION);
            if (menuTitle.Find(_T("|")) != -1)
            {
                CString sNumber = menuTitle.Left(menuTitle.Find(_T("|")));
                int number = 0;
                for (int j = 0; j < sNumber.GetLength(); j++)
                    number = number * 10 + sNumber.GetAt(j) - '0';
                CString tmp;
                tmp.Format(_T("%s\t%s"), s_playlistManager.GetTag(number, true), s_playlistManager.GetDuration(number, true));
                pMenu->ModifyMenu(menuID, MF_BYCOMMAND | pMenu->GetMenuState(menuID, MF_BYCOMMAND), menuID, tmp);
            }
        }
    }
    CFrameWnd::OnInitMenuPopup(pMenu, wParam, isActive);
    CMenuXP::SetXPLookNFeel(this, pMenu->m_hMenu, m_skin.xpLookNFeel);
}

void CMainWnd::OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
    if (!m_skin.xpLookNFeel)
    {
        if (lpMeasureItemStruct->itemID == ID_POPUPMENU_PLAY || lpMeasureItemStruct->itemID == ID_POPUPMENU_PAUSE || lpMeasureItemStruct->itemID == ID_POPUPMENU_STOP || lpMeasureItemStruct->itemID == ID_POPUPMENU_PREVIOUS || lpMeasureItemStruct->itemID == ID_POPUPMENU_NEXT)
        {
            lpMeasureItemStruct->itemHeight = 18;
            lpMeasureItemStruct->itemWidth = 90 - GetSystemMetrics(SM_CXMENUCHECK) * 2;
            //TODO A corriger
            //if(psI->itemWidth+2*GetSystemMetrics(SM_CXMENUCHECK)<90) psI->itemWidth=90-GetSystemMetrics(SM_CXMENUCHECK)*2;
        }
        else if (lpMeasureItemStruct->itemID == ID_POPUPMENU_PIC)
            lpMeasureItemStruct->itemWidth = 20 - GetSystemMetrics(SM_CXMENUCHECK);
    }
    else if (lpMeasureItemStruct->itemID == ID_POPUPMENU_PIC)
        lpMeasureItemStruct->itemWidth = 20 - GetSystemMetrics(SM_CXMENUCHECK);
    else
        CMenuXP::OnMeasureItem(lpMeasureItemStruct);
}

LRESULT CMainWnd::OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu)
{
    if (m_skin.xpLookNFeel && CMenuXP::IsOwnerDrawn(pMenu->m_hMenu))
        return CMenuXP::OnMenuChar(pMenu->m_hMenu, nChar, nFlags);                                       
    return CFrameWnd::OnMenuChar(nChar, nFlags, pMenu);
}

void CMainWnd::OnPopupMenuAbout()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_HELP_ABOUT, 0);
}

void CMainWnd::OnPopupMenuArtistTitle()
{
    m_showingMode = 1;
    s_playlistManager.SetShowingMode(m_showingMode);
}

void CMainWnd::OnPopupMenuDockToActiveWindow()
{
    m_dockSD = !m_dockSD;
}

void CMainWnd::OnPopupMenuElapsedTime()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_OPTIONS_ELAPSED, 0);
}

void CMainWnd::OnPopupMenuEqualizer()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_OPTIONS_EQ, 0);
}

void CMainWnd::InternalOpenEqualizer()
{
    if(s_equalizerDlg.m_hWnd == NULL)
        s_equalizerDlg.Create(CEqualizerDlg::IDD);
    s_equalizerDlg.ShowWindow(SW_SHOW);
}

void CMainWnd::OnPopupMenuExit()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_QUIT, 0);
}

void CMainWnd::OnPopupMenuFileInfo()
{
    stdIn.InfoBox((TCHAR *)s_playlistManager.GetPlaylist(s_playlistManager.GetCurrent()).GetString(), WAEmuWnd.m_hWnd);
}

void CMainWnd::OnPopupMenuFilename()
{
    m_showingMode = 2;
    s_playlistManager.SetShowingMode(m_showingMode);
}

void CMainWnd::OnPopupMenuNext()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON5, 0);
}

void CMainWnd::OnPopupMenuOpenFile()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_PLAY, 0);
}

void CMainWnd::OnPopupMenuAddFile()
{
    UINT PLLPrev = s_playlistManager.GetSize();
    // open a file
    CFileDialog dialog(TRUE, _T("mp3"), _T(""), OFN_ALLOWMULTISELECT | OFN_FILEMUSTEXIST, stdIn.GetFileExtensionsFilter(), this);

    TCHAR buffer[_MAX_PATH*500 + 1];
    buffer[0] = '\0';
    dialog.m_ofn.lpstrFile = buffer;
    dialog.m_ofn.nMaxFile = _MAX_PATH * 500;
    dialog.m_ofn.lpstrInitialDir = LPCTSTR(m_initDir);
    int ret;
    ret = dialog.DoModal();
    if (ret == IDOK)
    {
        // a file was selected
        POSITION p = dialog.GetStartPosition();
        CString buf;
        while (p != NULL)
        {
            s_playlistManager.Add(dialog.GetNextPathName(p));
            m_initDir = buf.Left(buf.ReverseFind('\\') + 1);
        }
        if (PLLPrev == 0)
        {
            if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE)
                ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
            if (m_shuffleMode)
            {
                m_firstInMyRandom = MyRandom(true, true);
                s_playlistManager.SetCurrent(m_firstInMyRandom);
            }
            else
            {
                s_playlistManager.SetCurrent(0);
                m_firstInMyRandom = 0xFFFFFFFF;
            }

            if (s_playlistManager.GetCurrent() < s_playlistManager.GetSize() - 1)
                s_playlistManager.incCurrent();
            else
            {
                s_playlistManager.SetCurrent(0);
            }
            if (m_autoPlay)
            {
                enqueueFileWithMetaStructW eFile;
                eFile.filename = (TCHAR *)s_playlistManager.GetPlaylist(s_playlistManager.GetCurrent()).GetString();
                ::SendMessage(WAEmuWnd.m_hWnd, IPC_PLAYFILEW, 0, (WPARAM)&eFile);
            }
            else if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE)
                ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
        }
    }
}

void CMainWnd::OnPopupMenuOpenFolder()
{
    if (m_opening)
        return;
    m_opening = true;

    LPMALLOC pMalloc;
    if (SHGetMalloc(&pMalloc) != NOERROR)
        return;

    BROWSEINFO bi;
    TCHAR buf[MAX_PATH];
    _tcscpy(buf, m_initDir.GetString());
    CString title;
    title = m_Helper.MyLoadString(IDS_OPENFOLDER);
    bi.hwndOwner = m_hWnd;
    bi.pszDisplayName = buf;
    bi.pidlRoot = NULL;
    bi.lpszTitle = title.GetString();
    bi.ulFlags = BIF_RETURNONLYFSDIRS;
    bi.lpfn = BrowseCallbackProc;

    LPITEMIDLIST pidl;
    if ((pidl = SHBrowseForFolder(&bi)) == NULL)
    {
        pMalloc->Free(pidl);
        pMalloc ->Release();
        m_opening = false;
        return;
    }
    if (SHGetPathFromIDList(pidl, buf) == false)
    {
        pMalloc->Free(pidl);
        pMalloc ->Release();
        m_opening = false;
        return;
    }
    pMalloc->Free(pidl);
    pMalloc->Release();

    m_opening = false;

    AddRecent(buf);
    m_initDir = buf;
    OpenFolder(buf, m_randomFirst);
}

void CMainWnd::OnPopupMenuAddFolder()
{
    if (m_opening)
        return;
    m_opening = true;

    LPMALLOC pMalloc;
    if (SHGetMalloc(&pMalloc) != NOERROR)
        return;

    BROWSEINFO bi;
    TCHAR buf[MAX_PATH];
    _tcscpy(buf, m_initDir.GetString());
    CString title;
    title = m_Helper.MyLoadString(IDS_OPENFOLDER);
    bi.hwndOwner = m_hWnd;
    bi.pszDisplayName = buf;
    bi.pidlRoot = NULL;
    bi.lpszTitle = title.GetString();
    bi.ulFlags = BIF_RETURNONLYFSDIRS;
    bi.lpfn = BrowseCallbackProc;

    LPITEMIDLIST pidl;
    if ((pidl = SHBrowseForFolder(&bi)) == NULL)
    {
        pMalloc->Free(pidl);
        pMalloc ->Release();
        m_opening = false;
        return;
    }
    if (SHGetPathFromIDList(pidl, buf) == false)
    {
        pMalloc->Free(pidl);
        pMalloc ->Release();
        m_opening = false;
        return;
    }
    pMalloc->Free(pidl);
    pMalloc->Release();

    m_opening = false;

    AddRecent(buf);
    m_initDir = buf;
    OpenFolder(buf, m_randomFirst, true);
}

void CMainWnd::OnPopupMenuOpenRecent(UINT nID)
{
    OpenRecent(nID - IDM_RECENT_FILES);
}

void CMainWnd::OnPopupMenuOpenUrl()
{
    if (m_opening)
        return;
    m_opening = true;

    CUrlDlg dialog;

    int ret;
    ret = dialog.DoModal();
    if (ret == IDOK)
    {
        CString buf = dialog.m_URL;
        buf.Replace(_T(" "), _T("%20"));
        OpenUrl(buf);
        AddRecent(buf);
    }
    m_opening = false;
}

void CMainWnd::OnPopupMenuPause()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON3, 0);
}

void CMainWnd::OnPopupMenuPlay()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
}

void CMainWnd::OnPopupMenuPlaylistEditor()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_OPTIONS_PLEDIT, 0);
}

void CMainWnd::OnPopupMenuPrevious()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON1, 0);
}

void CMainWnd::OnPopupMenuRemainingTime()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_OPTIONS_REMAINING, 0);
}

void CMainWnd::OnPopupMenuSettingsAdvanced()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_OPTIONS_PREFS, 0);
}

void CMainWnd::InternalSettingsAdvanced()
{
    if (s_settingsDialog == NULL || s_settingsDialog->m_hWnd == NULL)
    {
        if(s_settingsDialog != NULL)
        {
            s_settingsDialog->DestroyWindow();
            delete s_settingsDialog;
        }
        s_settingsDialog = new CSettingsDialog();
        s_settingsDialog->Create();
    }
    s_settingsDialog->ShowWindow(SW_SHOW);
}

void CMainWnd::OnPopupMenuSettingsAfterEndOfThePlaybackExitStp()
{
    m_shutdownAfterEnd = false;
    m_exitAfterEnd = !m_exitAfterEnd;
    if (m_exitAfterEnd)
    {
        if (m_repeat || m_repeatTrack)
        {
            m_repeat = FALSE;
            m_repeatTrack = FALSE;
            MessageBox(m_Helper.MyLoadString(IDS_AUTOEXIT), _T("STP"), MB_OK | MB_ICONWARNING);
        }
    }
}

void CMainWnd::OnPopupMenuSettingsAfterEndOfThePlaybackTurnOffTheComputer()
{
    m_shutdownAfterEnd = !m_shutdownAfterEnd;
    m_exitAfterEnd = false;
    if (m_shutdownAfterEnd)
    {
        if (m_repeat || m_repeatTrack)
        {
            m_repeat = FALSE;
            m_repeatTrack = FALSE;
            MessageBox(m_Helper.MyLoadString(IDS_AUTOEXIT), _T("STP"), MB_OK | MB_ICONWARNING);
        }
    }
}

void CMainWnd::OnPopupMenuSettingsRandomlySelectFirstTrack()
{
    m_randomFirst = !m_randomFirst;
}

void CMainWnd::OnPopupMenuSettingsRepeat()
{
    m_repeat = !m_repeat;
    if (m_repeat)
        m_repeatTrack = FALSE;
}

void CMainWnd::OnPopupMenuSettingsRepeatTrack()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_REPEAT, 0);
}

void CMainWnd::OnPopupMenuSettingsShuffleMode()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_SHUFFLE, 0);
}

void CMainWnd::OnPopupMenuSettingsSortByName()
{
    m_sortTemplate = "%8\\%9\\%7";
    CreateMemberThread<CPlaylistDlg>(&s_playlistDlg, &CPlaylistDlg::SortThread, &s_playlistDlg.m_sortThreadHan);
}

void CMainWnd::OnPopupMenuSettingsSortByFilename()
{
    m_sortTemplate = "%7";
    CreateMemberThread<CPlaylistDlg>(&s_playlistDlg, &CPlaylistDlg::SortThread, &s_playlistDlg.m_sortThreadHan);
}

void CMainWnd::OnPopupMenuSettingsSortByTemplate()
{
    CSortDlg sortDlg;
    sortDlg.DoModal();
}

void CMainWnd::OnPopupMenuSettingsStopAfterEachAlbum()
{
    m_albumStop = !m_albumStop;
}

void CMainWnd::OnPopupMenuSeek()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_MAIN_WINDOW, 0);
}


void CMainWnd::InternalSeek()
{
    if( s_seekDialog.m_hWnd==NULL)
        s_seekDialog.Create(CSeekDialog::IDD);
    if( s_seekDialog.IsWindowVisible())
        s_seekDialog.ShowWindow(SW_HIDE);
    else
    {
        s_seekDialog.m_vol.SetPos(s_volume.GetCurrentVolume());
        s_seekDialog.ShowWindow(SW_SHOW);
    }
}

void CMainWnd::OnPopupMenuVideo()
{
    if( s_videoDialog.IsWindowVisible())
        s_videoDialog.ShowWindow(SW_HIDE);
    else
        s_videoDialog.ShowWindow(SW_SHOW);
}

void CMainWnd::OnPopupMenuConsole()
{
    if (!IsWindowVisible())
        ShowWindow(SW_SHOW);
    else
        ShowWindow(SW_HIDE);
}

void CMainWnd::OnPopupMenuShowTotalTrackTime()
{
    m_showTTT = !m_showTTT;
}

void CMainWnd::OnPopupMenuStop()
{
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
}


void CMainWnd::OnPopupMenuTitle()
{
    m_showingMode = 0;
    s_playlistManager.SetShowingMode(m_showingMode);
}

void CMainWnd::OnTimer(UINT nIDEvent)
{
    if (!m_created)
        return;
    switch (nIDEvent)
    {
        case DELAY_FROM_BEBORE_RESTART_TOOLTIP:
            {
                KillTimer(DELAY_FROM_BEBORE_RESTART_TOOLTIP);
                m_startToolTip = false;
                break;
            }
        case DELAY_FROM_TOOLTIP:
            {
                m_startToolTip = false;
                KillTimer(DELAY_FROM_TOOLTIP);
                Shell_NotifyIcon(NIM_MODIFY, &(m_nid));
                if (!m_traytip->IsVisible())
                    DisplayTooltip();
                break;
            }
        case LBUTTON_CLICK:
            {
                if (m_traySeeking == false)
                {
                    m_traySeeking = true;
                    KillTimer(LBUTTON_CLICK);
                    if (m_pressAndHold == 0)
                        SetTimer(LBUTTON_CLICK, 500, NULL);
                    else
                        SetTimer(LBUTTON_CLICK, 50, NULL);
                }
                if (m_pressAndHold == 0)
                {
                    if (s_playlistManager.GetSize() > 0 && stdIn.isSeekable())
                        stdIn.SetOutputTime(stdIn.GetOutputTime() - 5);
                }
                else
                {
                    ::SendMessage(WAEmuWnd.m_hWnd, WINAMP_VOLUMEDOWN, 0, 0);
                }
                break;
            }
        case RBUTTON_CLICK:
            {
                if (m_traySeeking == false)
                {
                    m_traySeeking = true;
                    KillTimer(RBUTTON_CLICK);
                    if (m_pressAndHold == 0)
                        SetTimer(RBUTTON_CLICK, 500, NULL);
                    else
                        SetTimer(RBUTTON_CLICK, 50, NULL);
                }
                if (m_pressAndHold == 0)
                {
                    if (s_playlistManager.GetSize() > 0 && stdIn.isSeekable())
                        stdIn.SetOutputTime(stdIn.GetOutputTime() + 5);
                }
                else
                {
                    ::SendMessage(WAEmuWnd.m_hWnd, WINAMP_VOLUMEUP, 0, 0);
                }
                break;
            }
        case REFRESH_WINDOW:
            {
                if (m_created)
                    UpdMBTR();
                break;
            }
        case LBUTTON_UP:
            {
                KillTimer(LBUTTON_UP);
                switch (m_lbs)
                {
                    case 1:
                        ClickAction(m_clicks[0]);
                        break;
                    case 2:
                        ClickAction(m_clicks[1]);
                        break;
                    case 3:
                        ClickAction(m_clicks[2]);
                        break;
                    case 4:
                        ClickAction(m_clicks[3]);
                        break;
                }
                m_lbs = 0;
                break;
            }
        case RBUTTON_UP:
            {
                KillTimer(RBUTTON_UP);
                switch (m_rbs)
                {
                    case 1:
                        ClickAction(m_clicks[4]);
                        break;
                    case 2:
                        ClickAction(m_clicks[5]);
                        break;
                    case 3:
                        ClickAction(m_clicks[6]);
                        break;
                    case 4:
                        ClickAction(m_clicks[7]);
                        break;
                }
                m_rbs = 0;
                break;
            }
        case AUTOMATION_START:
            {
                if (m_autEvery)
                {
                    s_playlistManager.PerformAutomation();
                    if (m_autSaveset)
                        SaveSettings();
                }
                break;
            }
        case WM_DELAY:
            {
                if (m_W2Fenabled)
                    PerformW2File(false);
                if (m_activateWindowsMessenger)
                {
                    CString category;
                    switch (m_wmIcon)
                    {
                        case 0:
                            category = "Games";
                            break;
                        case 1:
                            category = "Music";
                            break;
                        case 2:
                            category = "Office";
                            break;
                    }

                    CString buffer = m_wmTitle;
                    buffer.Replace(_T("%1"), s_playlistManager.GetArtist(s_playlistManager.GetCurrent()));
                    buffer.Replace(_T("%2"), s_playlistManager.GetTitle(s_playlistManager.GetCurrent()));
                    buffer.Replace(_T("%3"), s_playlistManager.GetAlbum(s_playlistManager.GetCurrent()));
                    buffer.Replace(_T("%4"), s_playlistManager.GetYear(s_playlistManager.GetCurrent()));
                    buffer.Replace(_T("%5"), s_playlistManager.GetComment(s_playlistManager.GetCurrent()));
                    buffer.Replace(_T("%6"), s_playlistManager.GetDuration(s_playlistManager.GetCurrent()));
                    buffer.Replace(_T("%7"), s_playlistManager.GetFilenameExt(s_playlistManager.GetCurrent()));
                    buffer.Replace(_T("%8"), s_playlistManager.GetDrive(s_playlistManager.GetCurrent()));
                    buffer.Replace(_T("%9"), s_playlistManager.GetDir(s_playlistManager.GetCurrent()));
                    CString time;

                    int p = stdIn.GetOutputTime() / 1000;

                    time.Format(_T("%02d:%02d"), p / 60, p % 60);
                    buffer.Replace(_T("%A"), time);

                    buffer += "          ";

                    m_incCounter = (++m_incCounter) % buffer.GetLength();

                    CString buffer2 = buffer;

                    switch (m_scrollMode)
                    {
                        case 1:
                            {
                                buffer2 = buffer.Right(buffer.GetLength() - m_incCounter) + buffer.Left(m_incCounter);
                                break;
                            }
                        case 2:
                            {
                                buffer2 = buffer.Right(m_incCounter) + buffer.Left(buffer.GetLength() - m_incCounter);
                                break;
                            }
                    }

                    SendMSNMessage(true, category, buffer2);
                }
                break;
            }
    }

    CFrameWnd::OnTimer(nIDEvent);
}

void CMainWnd::SendMSNMessage(bool enable, CString category, CString message)
{
    CString buffer = _T("");
    buffer.Format(_T("\\0%s\\0%s\\0{0}\\0%s\\0%s\\0%s\\0%s\\0\0"), category, (enable ? "1" : "0"), message, s_playlistManager.GetArtist(s_playlistManager.GetCurrent(), true), s_playlistManager.GetTitle(s_playlistManager.GetCurrent(), true), s_playlistManager.GetAlbum(s_playlistManager.GetCurrent()));

    // UTF16
    WCHAR wstrTitle[256];
    memset(wstrTitle, 0, sizeof(WCHAR) * 256);
    char wstrTitleTmp[5000];
    Strcpy(wstrTitleTmp, 5000, buffer.GetString()); 

    // convert ASCII to UTF16
    int nLen = MultiByteToWideChar(CP_ACP, 0, wstrTitleTmp, -1, NULL, NULL);
    MultiByteToWideChar(CP_ACP, 0, wstrTitleTmp, -1, wstrTitle, nLen);


    COPYDATASTRUCT data;
    data.dwData = 0x0547;
    data.lpData = (void*)wstrTitle;
    data.cbData = (nLen * 2) + 2;

    HWND handle = 0;
    handle = ::FindWindowEx(0, handle, _T("MsnMsgrUIManager"), NULL);

    if (handle > 0 && m_prevTitle != buffer)
    {
        ::SendMessage(handle, WM_COPYDATA, NULL, (WPARAM)&data);
        m_prevTitle = buffer;
    }
}

void CMainWnd::OnTrackMenu(UINT nID)
{
    s_playlistManager.SetCurrent(nID - IDM_TRACKS);
    if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE)
        ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
    bool first = true;       
    if (!first)
    {
        if (m_shuffleMode)
            s_playlistManager.SetCurrent(MyRandom(true));
        else
        {
            int b, e; 
            GetAlbumRange(&b, &e);
            if (s_playlistManager.GetCurrent() == e)
                s_playlistManager.SetCurrent(b);
            else
                s_playlistManager.incCurrent();
        }
    }
    else
        first = false;

    enqueueFileWithMetaStructW eFile;
    eFile.filename = (TCHAR *)s_playlistManager.GetPlaylist(s_playlistManager.GetCurrent()).GetString();
    ::SendMessage(WAEmuWnd.m_hWnd, IPC_PLAYFILEW, 0, (WPARAM)&eFile);

    if (s_playlistDlg.IsWindowVisible())
        s_playlistDlg.Invalidate();
}

void CMainWnd::OnUpdatePopupMenuArtistTitle(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_showingMode == 1);
}

void CMainWnd::OnUpdatePopupMenuDockToActiveWindow(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_dockSD);
}

void CMainWnd::OnUpdatePopupMenuElapsedTime(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(!m_showRemainingTime);
}

void CMainWnd::OnUpdatePopupMenuEqualizer(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(s_equalizerDlg.m_hWnd != NULL && s_equalizerDlg.IsWindowVisible());
}

void CMainWnd::OnUpdatePopupMenuFileInfo(CCmdUI* pCmdUI)
{
    pCmdUI->Enable(s_playlistManager.GetSize() != 0);
    /* TODO
        pCmdUI->SetCheck(MP3InfoDlg != NULL && MP3InfoDlg->m_hWnd != NULL);
    */
}

void CMainWnd::OnUpdatePopupMenuFilename(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_showingMode == 2);
}

void CMainWnd::OnUpdatePopupMenuPlaylistEditor(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(s_playlistDlg.IsWindowVisible());
}

void CMainWnd::OnUpdatePopupMenuRemainingTime(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_showRemainingTime);
}

void CMainWnd::OnUpdatePopupMenuSeek(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(s_seekDialog.m_hWnd != NULL && s_seekDialog.IsWindowVisible());
}

void CMainWnd::OnUpdatePopupMenuVideo(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(s_videoDialog.m_hWnd != NULL && s_videoDialog.IsWindowVisible());
}

void CMainWnd::OnUpdatePopupMenuConsole(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(IsWindowVisible());
}

void CMainWnd::OnUpdatePopupMenuSettingsAfterEndOfThePlaybackExitStp(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_exitAfterEnd);
}

void CMainWnd::OnUpdatePopupMenuSettingsAfterEndOfThePlaybackTurnOffComputer(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_shutdownAfterEnd);
}

void CMainWnd::OnUpdatePopupMenuSettingsRandomlySelectFirstTrack(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_randomFirst);
}

void CMainWnd::OnUpdatePopupMenuSettingsRepeat(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_repeat);
    pCmdUI->Enable(!m_exitAfterEnd && !m_shutdownAfterEnd);
}

void CMainWnd::OnUpdatePopupMenuSettingsRepeatTrack(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_repeatTrack);
    pCmdUI->Enable(!m_exitAfterEnd && !m_shutdownAfterEnd);
}

void CMainWnd::OnUpdatePopupMenuSettingsShuffleMode(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_shuffleMode);
}

void CMainWnd::OnUpdatePopupMenuSettingsStopAfterEachAlbum(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_albumStop);
}

void CMainWnd::OnUpdatePopupMenuShowTotalTrackTime(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_showTTT);
}

void CMainWnd::OnUpdatePopupMenuTitle(CCmdUI* pCmdUI)
{
    pCmdUI->SetCheck(m_showingMode == 0);
}

void CMainWnd::OpenFile(CString fname, bool add, bool forceStart)
{
    UINT PLLPrev = s_playlistManager.GetSize();
    if (!add)
    {
        s_playlistManager.StopReadAll();
        s_playlistManager.StopPerformAutomation();
        s_playlistManager.RemoveAll();
        s_playlistManager.SetCurrent(0);
    }
    if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE && forceStart)
        ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
    s_playlistManager.Add(fname);
    if (!add || PLLPrev == 0)
    {
        if (m_autoPlay || forceStart)
        {
            enqueueFileWithMetaStructW eFile;
            eFile.filename = (TCHAR *)fname.GetString();
            ::SendMessage(WAEmuWnd.m_hWnd, IPC_PLAYFILEW, 0, (WPARAM)&eFile);
        }
        else if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE)
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
    }
    if (s_playlistDlg.IsWindowVisible())
    {
        ::SendMessage(s_playlistDlg.m_hWnd, WM_COMMAND, ID_TRACKS_REFRESH, 0);
    }
}

void CMainWnd::OpenFolderThread()
{
    OpenFolderEngine(m_playlistStruct.fname, m_playlistStruct.randomFirst, m_playlistStruct.add, m_playlistStruct.forceStart);
    m_openFolderThreadHan = NULL;
}

void CMainWnd::PreOpenOperation(bool add)
{
    if (!add)
    {
        s_playlistManager.StopReadAll();
        s_playlistManager.StopPerformAutomation();
        s_playlistManager.RemoveAll();
        s_playlistManager.SetCurrent(0);
        if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE)
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
    }
}

void CMainWnd::PostOpenOperation(UINT PLLPrev, BOOL randomFirst, bool add, bool forceStart, bool firstStart)
{
    if (s_playlistManager.GetSize() == 0)
    {
        if (s_playlistDlg.IsWindowVisible())
        {
            ::SendMessage(s_playlistDlg.m_hWnd, WM_COMMAND, ID_TRACKS_REFRESH, 0);
        }
        return;
    }

    s_playlistManager.QuickSort(m_sortTemplate);
    if ((randomFirst || m_shuffleMode) && !(add && PLLPrev > 0))
    {
        m_firstInMyRandom = MyRandom(true, true);
        s_playlistManager.SetCurrent(m_firstInMyRandom);
    }
    else if (!add || PLLPrev == 0)
    {
        if (firstStart)
        {
            UINT FixedFirst = theApp.GetProfileInt(_T("Preferences"), _T("CurrentInPlaylist"), 0);
            if (FixedFirst < (UINT)s_playlistManager.GetSize())
                s_playlistManager.SetCurrent(FixedFirst);
            else
                s_playlistManager.SetCurrent(0);
        }
        else
            s_playlistManager.SetCurrent(0);
        m_firstInMyRandom = 0xFFFFFFFF;
    }

    if (s_playlistDlg.IsWindowVisible())
    {
        ::SendMessage(s_playlistDlg.m_hWnd, WM_COMMAND, ID_TRACKS_REFRESH, 0);
    }

    if (!add || PLLPrev == 0)
    {
        if (stdIn.GetPlayerMode() != PLAYER_MODE_CLOSE)
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
        if (m_autoPlay || forceStart)
        {
            enqueueFileWithMetaStructW eFile;
            eFile.filename = (TCHAR *)s_playlistManager.GetPlaylist(s_playlistManager.GetCurrent()).GetString();
            ::SendMessage(WAEmuWnd.m_hWnd, IPC_PLAYFILEW, 0, (WPARAM)&eFile);
        }
    }
    s_playlistManager.ReadAllTags();
}

void CMainWnd::OpenFolderEngine(CString theDir, BOOL randomFirst, bool add, bool forceStart)
{
    UINT PLLPrev = s_playlistManager.GetSize();
    if (theDir[theDir.GetLength() - 1] != '\\')
        theDir += "\\";

    PreOpenOperation(add);

    FindMP3Files(theDir);      

    PostOpenOperation(PLLPrev, randomFirst, add, forceStart);
}

void CMainWnd::OpenPlaylistThread()
{
    s_mainWnd.OpenPlaylistEngine(m_playlistStruct.fname, m_playlistStruct.randomFirst, m_playlistStruct.add, m_playlistStruct.forceStart);
    m_openPlaylistThreadHan = NULL;
}
void CMainWnd::OpenPlaylistEngine(CString fname, BOOL randomFirst, bool add, bool forceStart, bool firstStart)
{
    UINT PLLPrev = s_playlistManager.GetSize();
    CStdioFile plfile;
    if (!plfile.Open(fname, CFile::modeRead | CFile::shareDenyNone))
    {
        return;
    }
    PreOpenOperation(add);

    bool ifpls = ((fname.Right(4)).CompareNoCase(_T(".PLS")) == 0);

    TCHAR PLpath[MAX_PATH];
    TCHAR PLdrive[MAX_PATH];
    TCHAR PLdir[MAX_PATH];
    TCHAR PLfilename[MAX_PATH];
    TCHAR PLext[MAX_PATH];
    _tcscpy(PLpath, (TCHAR *)fname.GetString());
    _tsplitpath(PLpath, PLdrive, PLdir, PLfilename, PLext);

    CString buf;
    CString curPath;
    curPath.Format(_T("%s%s"), PLdrive, PLdir);
    CString curDisk;
    curDisk.Format(_T("%s"), PLdrive);
    CachedTag nTag;
    bool utf8 = false;
    while (plfile.ReadString(buf))
    {
        buf.TrimLeft();buf.TrimRight();
        if (utf8)
        {
            static char utf8Playlist[5000];
            TCHAR playlist[5000];
            Strcpy(utf8Playlist, 5000, buf.GetString());
            UTF8Strcpy(playlist, 5000, utf8Playlist);
            buf.Format(_T("%s"), playlist);
        }
        if (buf.Left(7) == _T("#EXTM3U") || buf == _T(""))
            continue;
        if (buf == _T("﻿#EXTM3U"))
        {
            utf8 = true;
            continue;
        }
        if (buf.Left(5) == _T("#TAG=") && s_playlistManager.GetSize() > 0 && !ifpls)
            continue;
        if (buf.Left(8) == _T("#EXTINF:") && s_playlistManager.GetSize() > 0 && !ifpls)
        {
            CString tmp = buf.Mid(8, buf.Find(',') - 8);
            nTag.SetDuration(_tstoi(tmp.GetString()));
            tmp = buf.Right(buf.GetLength() - buf.Find(',') - 1);
            if (tmp.Find(_T(" - ")) != -1)
            {
                CString tmp2 = tmp.Left(tmp.Find(_T(" - ")) - tmp.Find(',') - 1);
                nTag.SetArtist((TCHAR *)tmp2.GetString());
                nTag.SetTitle(tmp.Right(tmp.GetLength() - tmp.Find(_T(" - ")) - 3));
            }
            else
            {
                nTag.SetTitle(tmp);
                nTag.SetArtist(_T(""));
            }
            s_playlistManager.Add(nTag, s_playlistManager.GetSize() - 1);
            nTag.SetArtist(_T(""));
            nTag.SetTitle(_T(""));
            nTag.SetDuration(0);
            nTag.SetComment(_T(""));
            nTag.SetComposer(_T(""));
            nTag.SetYear(_T(""));
            nTag.SetRead(false);
            continue;
        }
        if (ifpls)
        {
            if (buf.Left(4).CompareNoCase(_T("file")) == 0)
                buf = buf.Mid(buf.Find('=') + 1);
            else
                continue;
        }

        TCHAR path[MAX_PATH];
        TCHAR drive[MAX_PATH];
        TCHAR dir[MAX_PATH];
        TCHAR fname[MAX_PATH];
        TCHAR ext[MAX_PATH];

        _tcscpy(path, (TCHAR *)buf.GetString());
        _tsplitpath(path, drive, dir, fname, ext);

        if (_tcslen(drive) > 0)
        {
            nTag.SetPlaylist(buf);
        }
        else if (buf.Find(_T("\\\\")) == 0 || buf.Find(_T("://")) != -1)
            nTag.SetPlaylist(buf);
        else if (buf.Find(_T(".\\")) == 0)
            nTag.SetPlaylist(curDisk + buf);
        else if (buf.Find(_T("..\\")) == 0)
        {
            TCHAR tmpPLdir[MAX_PATH];
            _tcscpy(tmpPLdir, PLdir);
            tmpPLdir[_tcslen(PLdir) - 1] = 0;
            CString tmpDir = dir;
            TCHAR* pEnd;
            do
            {
                tmpDir = tmpDir.Right(tmpDir.GetLength() - 3);
                pEnd = _tcsrchr(tmpPLdir, '\\');
                if (pEnd != NULL)
                {
                    pEnd[0] = 0;
                    if (tmpDir.Find(_T("..\\")) == -1)
                    {
                        break;
                    }
                }
            }
            while (tmpDir.Find(_T("..\\")) == 0);
            buf.Format(_T("%s%s\\%s%s%s"), PLdrive, tmpPLdir, tmpDir, fname, ext);
            nTag.SetPlaylist(buf);
        }
        else
        {
            buf.Format(_T("%s%s%s%s%s"), PLdrive, PLdir, dir, fname, ext);
            nTag.SetPlaylist(buf);
        }
        if (FileExists(nTag.GetPlaylist()))
        {
            nTag.SetSortPath(m_sortTemplate);
            s_playlistManager.Add(nTag);
            nTag.SetArtist(_T(""));
            nTag.SetTitle(_T(""));
            nTag.SetDuration(0);
            nTag.SetComment(_T(""));
            nTag.SetComposer(_T(""));
            nTag.SetYear(_T(""));
            nTag.SetRead(false);
        }
    }
    plfile.Close();

    PostOpenOperation(PLLPrev, randomFirst, add, forceStart, firstStart);
}

void CMainWnd::OpenFolder(CString theDir, BOOL randomFirst, bool add, bool forceStart)
{
    m_playlistStruct.fname = theDir;
    m_playlistStruct.randomFirst = randomFirst;
    m_playlistStruct.add = add;
    m_playlistStruct.forceStart = forceStart;
    CreateMemberThread<CMainWnd>(&s_mainWnd, &CMainWnd::OpenFolderThread, &m_openFolderThreadHan);
}

void CMainWnd::OpenPlaylist(CString fname, BOOL randomFirst, bool add, bool forceStart)
{
    m_playlistStruct.fname = fname;
    m_playlistStruct.randomFirst = randomFirst;
    m_playlistStruct.add = add;
    m_playlistStruct.forceStart = forceStart;
    CreateMemberThread<CMainWnd>(&s_mainWnd, &CMainWnd::OpenPlaylistThread, &m_openPlaylistThreadHan);
}

void CMainWnd::OpenRecent(int num)
{
    if (m_recent[num] == "")
        return;
    if (m_recent[num].Find(_T("://")) > 0)
    {
        OpenUrl(m_recent[num]);
        return;
    }
    CFileFind finder;
    if (finder.FindFile(m_recent[num]))
    {
        finder.FindNextFile();
        if (finder.IsDirectory())
            OpenFolder(m_recent[num], m_randomFirst);
        else
        {
            if ((m_recent[num].Mid(m_recent[num].ReverseFind('.') + 1, 3)).CompareNoCase(_T("M3U")) == 0 || (m_recent[num].Mid(m_recent[num].ReverseFind('.') + 1, 3)).CompareNoCase(_T("PLS")) == 0)
                OpenPlaylist(m_recent[num], m_randomFirst);
            else
                OpenFile(m_recent[num]);
        }
        CString buf = m_recent[num];
        for (int i = num; i > 0; i--)
            m_recent[i] = m_recent[i - 1];
        m_recent[0] = buf;
    }
    else
    {
        for (int i = num; i < 9; i++)
            m_recent[i] = m_recent[i + 1];
        m_recent[9] = "";
    }
}

void CMainWnd::OpenUrl(CString m_URL, bool add)
{
    CRect rect;

    UINT PLLPrev = s_playlistManager.GetSize();

    PreOpenOperation(add);

    s_playlistManager.Add(m_URL);

    PostOpenOperation(PLLPrev, false, add, true);
}

void CMainWnd::PerformW2File(bool ex)
{
    HINTERNET hInternet = NULL;
    HINTERNET m_hFTPConnection = NULL;
    HINTERNET m_hFTPFile = NULL;
    CStdioFile f;

    if (m_W2Ffile != "")
    {
        CString buf;
        if (!ex)
        {
            switch (stdIn.GetPlayerMode())
            {
                case PLAYER_MODE_PLAYING :
                    buf = m_W2Fplay;
                    break;
                case PLAYER_MODE_PAUSED :
                    buf = m_W2Fpause;
                    break;
                case PLAYER_MODE_CLOSE :
                    buf = m_W2Fstop;
                    break;
            }
            buf.Replace(_T("%1"), s_playlistManager.GetArtist(s_playlistManager.GetCurrent()));
            buf.Replace(_T("%2"), s_playlistManager.GetTitle(s_playlistManager.GetCurrent()));
            buf.Replace(_T("%3"), s_playlistManager.GetAlbum(s_playlistManager.GetCurrent()));
            buf.Replace(_T("%4"), s_playlistManager.GetYear(s_playlistManager.GetCurrent()));
            buf.Replace(_T("%5"), s_playlistManager.GetComment(s_playlistManager.GetCurrent()));
            buf.Replace(_T("%6"), s_playlistManager.GetDuration(s_playlistManager.GetCurrent()));
            buf.Replace(_T("%7"), s_playlistManager.GetFilenameExt(s_playlistManager.GetCurrent()));
            buf.Replace(_T("%8"), s_playlistManager.GetDrive(s_playlistManager.GetCurrent()));
            buf.Replace(_T("%9"), s_playlistManager.GetDir(s_playlistManager.GetCurrent()));
        }
        else
            buf = m_W2Fexit;
#ifndef _UNICODE
        if (W2Foem)
            buf.AnsiToOem();
#endif
        buf.TrimLeft(); 
        buf.TrimRight();

        buf.Replace(_T("\\r"), _T("\r"));
        buf.Replace(_T("\\n"), _T("\n"));
        if (m_W2FFtp)
        {
            hInternet = InternetOpen(_T("W2FileAgent"), PRE_CONFIG_INTERNET_ACCESS, NULL, NULL, NULL);
            m_hFTPConnection = ::InternetConnect(hInternet, m_W2FSite, INTERNET_DEFAULT_FTP_PORT, m_W2FUser, m_W2FPassword, INTERNET_SERVICE_FTP, 0, (DWORD) this);
            m_hFTPFile = FtpOpenFile(m_hFTPConnection, m_W2Ffile, GENERIC_WRITE, FTP_TRANSFER_TYPE_ASCII | INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE, (DWORD) this);
            DWORD dwBytesWritten = 0;
            ::InternetWriteFile(m_hFTPFile, buf, buf.GetLength(), &dwBytesWritten);
            ::InternetCloseHandle(m_hFTPFile);
            if (m_W2Fdel && ex)
            {
                FtpDeleteFile(m_hFTPConnection, m_W2Ffile);
            }
            ::InternetCloseHandle(m_hFTPConnection);
            ::InternetCloseHandle(hInternet);
        }
        else if (f.Open(m_W2Ffile, CFile::modeCreate | CFile::modeWrite))
        {
            f.WriteString(buf);
            f.Close();
            if (m_W2Fdel && ex)
            {
                ::DeleteFile(m_W2Ffile);
            }
        }
    }
}

void CMainWnd::RegHotKeys()
{
    if (m_playKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_PLAY, m_playMod, m_playKey);
    if (m_stopKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_STOP, m_stopMod, m_stopKey);
    if (m_prevKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_PREV, m_prevMod, m_prevKey);
    if (m_nextKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_NEXT, m_nextMod, m_nextKey);
    if (m_vUpKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_VUP, m_vUpMod, m_vUpKey);
    if (m_vDownKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_VDOWN, m_vDownMod, m_vDownKey);
    if (m_openKey1 != 0)
        RegisterHotKey(m_hWnd, HOTKEY_OPEN1, m_openMod1, m_openKey1);
    if (m_openKey2 != 0)
        RegisterHotKey(m_hWnd, HOTKEY_OPEN2, m_openMod2, m_openKey2);
    if (m_openKey3 != 0)
        RegisterHotKey(m_hWnd, HOTKEY_OPEN3, m_openMod3, m_openKey3);
    if (m_shuffleKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_SHUFFLE, m_shuffleMod, m_shuffleKey);
    if (m_minibarKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_MINIBAR, m_minibarMod, m_minibarKey);
    if (m_equalizerKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_EQUALIZER, m_equalizerMod, m_equalizerKey);
    if (m_repeatKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_REPEAT, m_repeatMod, m_repeatKey);
    if (m_playlistKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_PLAYLIST, m_playlistMod, m_playlistKey);
    if (m_MP3InfoKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_MP3INFO, m_MP3InfoMod, m_MP3InfoKey);
    if (m_exitKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_EXIT, m_exitMod, m_exitKey);
    if (m_NPKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_NP, m_NPMod, m_NPKey);
    if (m_forwKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_FORW, m_forwMod, m_forwKey);
    if (m_backKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_BACK, m_backMod, m_backKey);
    if (m_trayIconKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_TRAYICON, m_trayIconMod, m_trayIconKey);
    if (m_menuKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_MENU, m_menuMod, m_menuKey);
    if (m_tracksKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_TRACKS, m_tracksMod, m_tracksKey);
    if (m_albumKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_ALBUM, m_albumMod, m_albumKey);
    if (m_albumModeKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_ALBUMMODE, m_albumModeMod, m_albumModeKey);
    if (m_automationKey != 0)
        RegisterHotKey(m_hWnd, HOTKEY_AUTOMATION, m_automationMod, m_automationKey);
}

CString CMainWnd::ReplaceAmpersand(CString s)
{
    s.Replace(_T("&"), _T("&&"));
    return s;
}

void CMainWnd::SaveRect(CString section, CString name, CRect rect)
{
    CString tmp;
    tmp.Format(_T("%d %d %d %d"), rect.left, rect.top, rect.right, rect.bottom);
    theApp.WriteProfileString(section, name , tmp);
}
CRect CMainWnd::GetRect(CString section, CString name)
{
    CRect rect(-1000, -1000, -1000, -1000);
    CString tmp = theApp.GetProfileString(_T("Preferences"), name, _T("-1000 -1000 -1000 -1000"));
    _stscanf(tmp.GetString(), _T("%d %d %d %d"), &rect.left, &rect.top, &rect.right, &rect.bottom);
    return rect;
}

void CMainWnd::SaveSettings()
{
    theApp.WriteProfileString(_T("Preferences"), _T("Language"), m_language);
    theApp.WriteProfileInt(_T("Preferences"), _T("FullScreen"), m_fullScreen);
    theApp.WriteProfileInt(_T("Preferences"), _T("Clicks1"), m_clicks[0]);
    theApp.WriteProfileInt(_T("Preferences"), _T("Clicks2"), m_clicks[1]);
    theApp.WriteProfileInt(_T("Preferences"), _T("Clicks3"), m_clicks[2]);
    theApp.WriteProfileInt(_T("Preferences"), _T("Clicks4"), m_clicks[3]);
    theApp.WriteProfileInt(_T("Preferences"), _T("RClicks1"), m_clicks[4]);
    theApp.WriteProfileInt(_T("Preferences"), _T("RClicks2"), m_clicks[5]);
    theApp.WriteProfileInt(_T("Preferences"), _T("RClicks3"), m_clicks[6]);
    theApp.WriteProfileInt(_T("Preferences"), _T("RClicks4"), m_clicks[7]);

    theApp.WriteProfileInt(_T("Preferences"), _T("CurrentSkinSel"), m_currentSkinSel);
    for (int i = 1; i < m_currentSkin.GetCount(); i++)
    {
        CString tmp;
        tmp.Format(_T("CurrentSkin%d"), i);
        theApp.WriteProfileString(_T("Preferences"), tmp, m_currentSkin[i]);
    }
    CString tmp;
    tmp.Format(_T("CurrentSkin%d"), m_currentSkin.GetCount());
    theApp.WriteProfileString(_T("Preferences"), tmp, _T("NONE"));
    if (m_currentSkin.GetCount() != 0)
    {
        theApp.WriteProfileString(_T("Preferences"), _T("CurrentSkin"), m_currentSkin[0]);
    }
    else
    {
        theApp.WriteProfileString(_T("Preferences"), _T("CurrentSkin"), _T("NONE"));
    }

    theApp.WriteProfileInt(_T("Preferences"), _T("changeSkinOnEachTrack"), m_changeSkinOnEachTrack);
    theApp.WriteProfileInt(_T("Preferences"), _T("randomSkin"), m_randomSkin);

    theApp.WriteProfileString(_T("Preferences"), _T("RNTemplate"), m_rNTemplate);

    theApp.WriteProfileInt(_T("Preferences"), _T("DockMinibar"), m_dockSD);

    theApp.WriteProfileInt(_T("Preferences"), _T("SMTracks"), m_SMTracks);
    theApp.WriteProfileInt(_T("Preferences"), _T("SMAlbum"), m_SMAlbum);
    theApp.WriteProfileInt(_T("Preferences"), _T("SMPrevNext"), m_SMPrevNext);
    theApp.WriteProfileInt(_T("Preferences"), _T("WAEmu"), m_wAEmu);
    theApp.WriteProfileInt(_T("Preferences"), _T("PressAndHold"), m_pressAndHold);

    theApp.WriteProfileInt(_T("Preferences"), _T("ShowRemainingTime"), m_showRemainingTime);
    theApp.WriteProfileInt(_T("Preferences"), _T("ShowTTT"), m_showTTT);

    theApp.WriteProfileInt(_T("Preferences"), _T("ShowGradientBar"), m_showGradientBar);
    theApp.WriteProfileInt(_T("Preferences"), _T("GraphicalButtons"), m_graphicalButtons);

    theApp.WriteProfileInt(_T("Preferences"), _T("TPC"), m_tpc);

    theApp.WriteProfileInt(_T("Preferences"), _T("ExtPlaylistFormat"), m_extPlaylistFormat);

    theApp.WriteProfileInt(_T("Preferences"), _T("AlbumStop"), m_albumStop);

    theApp.WriteProfileInt(_T("Preferences"), _T("ShowingMode"), m_showingMode);   

    theApp.WriteProfileInt(_T("Preferences"), _T("NoClicks"), m_noClicks);

    theApp.WriteProfileInt(_T("Preferences"), _T("PlaylistOnTop"), m_playlistOnTop);
    theApp.WriteProfileInt(_T("Preferences"), _T("EQOnTop"), m_eQOnTop);

    theApp.WriteProfileInt(_T("Preferences"), _T("AutoPlay"), m_autoPlay);
    theApp.WriteProfileInt(_T("Preferences"), _T("RandomFirst"), m_randomFirst);

    theApp.WriteProfileInt(_T("Preferences"), _T("Gap"), m_gapBtwTracks);

    theApp.WriteProfileInt(_T("Preferences"), _T("NPKey"), m_NPKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("NPMod"), m_NPMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("ExitKey"), m_exitKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("ExitMod"), m_exitMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("ForwKey"), m_forwKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("ForwMod"), m_forwMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("BackKey"), m_backKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("BackMod"), m_backMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("PlayKey"), m_playKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("PlayMod"), m_playMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("StopKey"), m_stopKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("StopMod"), m_stopMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("PrevKey"), m_prevKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("PrevMod"), m_prevMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("NextKey"), m_nextKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("NextMod"), m_nextMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("VUpKey"), m_vUpKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("VUpMod"), m_vUpMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("VDownKey"), m_vDownKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("VDownMod"), m_vDownMod);

    theApp.WriteProfileInt(_T("Preferences"), _T("OpenKey1"), m_openKey1);
    theApp.WriteProfileInt(_T("Preferences"), _T("OpenMod1"), m_openMod1);
    theApp.WriteProfileInt(_T("Preferences"), _T("OpenKey2"), m_openKey2);
    theApp.WriteProfileInt(_T("Preferences"), _T("OpenMod2"), m_openMod2);
    theApp.WriteProfileInt(_T("Preferences"), _T("OpenKey3"), m_openKey3);
    theApp.WriteProfileInt(_T("Preferences"), _T("OpenMod3"), m_openMod3);
    theApp.WriteProfileInt(_T("Preferences"), _T("MinibarKey"), m_minibarKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("MinibarMod"), m_minibarMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("MP3InfoKey"), m_MP3InfoKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("MP3InfoMod"), m_MP3InfoMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("PlstKey"), m_playlistKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("PlstMod"), m_playlistMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("EqualizerKey"), m_equalizerKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("EqualizerMod"), m_equalizerMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("RptKey"), m_repeatKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("RptMod"), m_repeatMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("ShflKey"), m_shuffleKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("ShflMod"), m_shuffleMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("AlbummodeKey"), m_albumModeKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("AlbummodeMod"), m_albumModeMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("TrayIconKey"), m_trayIconKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("TrayIconMod"), m_trayIconMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("MenuKey"), m_menuKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("MenuMod"), m_menuMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("TracksKey"), m_tracksKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("TracksMod"), m_tracksMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("AlbumKey"), m_albumKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("AlbumMod"), m_albumMod);
    theApp.WriteProfileInt(_T("Preferences"), _T("AutomationKey"), m_automationKey);
    theApp.WriteProfileInt(_T("Preferences"), _T("AutomationMod"), m_automationMod);

    theApp.WriteProfileString(_T("Preferences"), _T("InitDir"), m_initDir);

    theApp.WriteProfileString(_T("Preferences"), _T("Recent0"), m_recent[0]);
    theApp.WriteProfileString(_T("Preferences"), _T("Recent1"), m_recent[1]);
    theApp.WriteProfileString(_T("Preferences"), _T("Recent2"), m_recent[2]);
    theApp.WriteProfileString(_T("Preferences"), _T("Recent3"), m_recent[3]);
    theApp.WriteProfileString(_T("Preferences"), _T("Recent4"), m_recent[4]);
    theApp.WriteProfileString(_T("Preferences"), _T("Recent5"), m_recent[5]);
    theApp.WriteProfileString(_T("Preferences"), _T("Recent6"), m_recent[6]);
    theApp.WriteProfileString(_T("Preferences"), _T("Recent7"), m_recent[7]);
    theApp.WriteProfileString(_T("Preferences"), _T("Recent8"), m_recent[8]);
    theApp.WriteProfileString(_T("Preferences"), _T("Recent9"), m_recent[9]);

    theApp.WriteProfileInt(_T("Preferences"), _T("Repeat"), m_repeat);
    theApp.WriteProfileInt(_T("Preferences"), _T("RepeatTrack"), m_repeatTrack);
    theApp.WriteProfileInt(_T("Preferences"), _T("ShuffleMode"), m_shuffleMode);
    extern int enable;

    theApp.WriteProfileInt(_T("Preferences"), _T("EnableEQ"), enable);

    CStringArray* tmpArray = SaveTo();

    m_eq.RemoveAll();

    CString buf;
    for (int i = 0; i < tmpArray->GetSize(); i++)
    {
        buf.Format(_T("EQ%d"), i);
        theApp.WriteProfileString(_T("Preferences"), buf, tmpArray->GetAt(i));
        m_eq.Add(tmpArray->GetAt(i));
    }

    delete tmpArray;

    buf.Format(_T("EQ%d"), m_eq.GetSize());
    theApp.WriteProfileString(_T("Preferences"), buf, _T(""));

    theApp.WriteProfileInt(_T("Preferences"), _T("AutSort"), m_autSort);
    theApp.WriteProfileString(_T("Preferences"), _T("sortTemplate"), m_sortTemplate);
    theApp.WriteProfileString(_T("Preferences"), _T("W2Ffile"), m_W2Ffile);
    theApp.WriteProfileString(_T("Preferences"), _T("W2Fplay"), _T("\"") + m_W2Fplay + _T("\""));
    theApp.WriteProfileString(_T("Preferences"), _T("W2Fpause"), _T("\"") + m_W2Fpause + _T("\""));
    theApp.WriteProfileString(_T("Preferences"), _T("W2Fstop"), _T("\"") + m_W2Fstop + _T("\""));
    theApp.WriteProfileString(_T("Preferences"), _T("W2Fexit"), _T("\"") + m_W2Fexit + _T("\""));
    theApp.WriteProfileInt(_T("Preferences"), _T("W2Foem"), m_W2Foem);
    theApp.WriteProfileInt(_T("Preferences"), _T("W2Fdel"), m_W2Fdel);
    theApp.WriteProfileInt(_T("Preferences"), _T("W2Fenabled"), m_W2Fenabled);
    theApp.WriteProfileInt(_T("Preferences"), _T("W2FFtp"), m_W2FFtp);
    theApp.WriteProfileString(_T("Preferences"), _T("W2FSite"), m_W2FSite);
    theApp.WriteProfileString(_T("Preferences"), _T("W2FUser"), m_W2FUser);
    theApp.WriteProfileString(_T("Preferences"), _T("W2FPassword"), m_W2FPassword);

    theApp.WriteProfileInt(_T("Preferences"), _T("AutOnStart"), m_autOnStart);
    theApp.WriteProfileInt(_T("Preferences"), _T("AutSaveset"), m_autSaveset);

    theApp.WriteProfileInt(_T("Preferences"), _T("AutRemove"), m_autRemove);
    theApp.WriteProfileInt(_T("Preferences"), _T("AutRemovedup"), m_autRemovedup);
    theApp.WriteProfileInt(_T("Preferences"), _T("AutRescan"), m_autRescan);
    theApp.WriteProfileInt(_T("Preferences"), _T("AutPeriod"), m_autPeriod);
    theApp.WriteProfileInt(_T("Preferences"), _T("AutEvery"), m_autEvery);

    int AutDirsCnt = m_autDirs.GetSize();
    theApp.WriteProfileInt(_T("Preferences"), _T("AutDirsCnt"), AutDirsCnt);

    CString adtmp;
    for (int i = 0; i < AutDirsCnt; i++)
    {
        adtmp.Format(_T("%d"), i + 1);
        theApp.WriteProfileString(_T("Preferences"), _T("AutDir") + adtmp, m_autDirs[i]);
    }

    theApp.WriteProfileInt(_T("MenuXP"), _T("ShowGradient"), m_showGradient);
    theApp.WriteProfileInt(_T("MenuXP"), _T("ShowGradientSel"), m_showGradientSel);
    theApp.WriteProfileInt(_T("Preferences"), _T("showToolTip"), m_showToolTip);
    theApp.WriteProfileInt(_T("Preferences"), _T("autoUpdate"), m_autoUpdate);
    theApp.WriteProfileInt(_T("Preferences"), _T("displayConsole"), IsWindowVisible());
    theApp.WriteProfileInt(_T("Preferences"), _T("displayConsoleAOT"), (GetWindowLong(m_hWnd, GWL_EXSTYLE) & WS_EX_TOPMOST) == WS_EX_TOPMOST);

    theApp.WriteProfileString(_T("MenuXP"), _T("GradientStart"), m_Helper.ConvertColorHexa(m_skin.startColor));
    theApp.WriteProfileString(_T("MenuXP"), _T("GradientEnd"), m_Helper.ConvertColorHexa(m_skin.endColor));
    theApp.WriteProfileString(_T("Preferences"), _T("border_color"), m_Helper.ConvertColorHexa(m_skin.border_color));
    theApp.WriteProfileString(_T("Preferences"), _T("end_bk"), m_Helper.ConvertColorHexa(m_skin.end_bk));
    theApp.WriteProfileString(_T("Preferences"), _T("mid_bk"), m_Helper.ConvertColorHexa(m_skin.mid_bk));
    theApp.WriteProfileString(_T("Preferences"), _T("start_bk"), m_Helper.ConvertColorHexa(m_skin.start_bk));

    theApp.WriteProfileString(_T("Preferences"), _T("ToolTipText"), m_skin.toolTipText);
    theApp.WriteProfileInt(_T("Preferences"), _T("Theme"), m_skin.theme);
    theApp.WriteProfileInt(_T("Preferences"), _T("effect_bk"), m_skin.effect_bk);
    theApp.WriteProfileInt(_T("Preferences"), _T("granularity"), m_skin.granularity);
    theApp.WriteProfileInt(_T("Preferences"), _T("border"), m_skin.border);
    theApp.WriteProfileInt(_T("Preferences"), _T("custom_border"), m_skin.custom_border);
    theApp.WriteProfileInt(_T("Preferences"), _T("border_width"), m_skin.border_width);
    theApp.WriteProfileInt(_T("Preferences"), _T("border_height"), m_skin.border_height);
    theApp.WriteProfileInt(_T("Preferences"), _T("transparency"), m_skin.transparency);

    theApp.WriteProfileInt(_T("Preferences"), _T("show_time"), m_show_time);
    theApp.WriteProfileInt(_T("Preferences"), _T("hide_time"), m_hide_time);
    theApp.WriteProfileInt(_T("Preferences"), _T("fade_in"), m_fade_in);
    theApp.WriteProfileInt(_T("Preferences"), _T("fade_out"), m_fade_out);
    theApp.WriteProfileInt(_T("Preferences"), _T("animation"), m_animation);

    theApp.WriteProfileInt(_T("Preferences"), _T("XPLookNFeel"), m_skin.xpLookNFeel);

    CString dllInKey = _T("");
    int ii = stdIn.GetSize();
    dllInKey.Format(_T("dllInName%d"), ii);
    AfxGetApp()->WriteProfileString(_T("Preferences"), dllInKey, _T("NONE"));
    do
    {
        CDllInput* currentDllInput = (CDllInput*)stdIn.getDllInput(ii - 1);
        dllInKey.Format(_T("dllInName%d"), ii - 1);
        AfxGetApp()->WriteProfileString(_T("Preferences"), dllInKey, currentDllInput->GetFilePath());
        ii--;
    }
    while (ii != 0);
    CString dllOutKey = _T("");
    ii = stdOut.GetSize();
    dllOutKey.Format(_T("dllOutName%d"), ii);
    AfxGetApp()->WriteProfileString(_T("Preferences"), dllOutKey, _T("NONE"));
    do
    {
        CDllOutput* currentDllOutput = (CDllOutput*)stdOut.getDllOutput(ii - 1);
        dllOutKey.Format(_T("dllOutName%d"), ii - 1);
        AfxGetApp()->WriteProfileString(_T("Preferences"), dllOutKey, currentDllOutput->GetFilePath());
        ii--;
    }
    while (ii != 0);
    CString dllGenKey = _T("");
    ii = stdGen.GetSize();
    dllGenKey.Format(_T("dllGenName%d"), ii);
    AfxGetApp()->WriteProfileString(_T("Preferences"), dllGenKey, _T("NONE"));
    if (ii != 0)
    {
        do
        {
            CDllGen* currentDllGen = (CDllGen*)stdGen.getDllGen(ii - 1);
            dllGenKey.Format(_T("dllGenName%d"), ii - 1);
            AfxGetApp()->WriteProfileString(_T("Preferences"), dllGenKey, currentDllGen->GetFilePath());
            ii--;
        }
        while (ii != 0);
    }

    theApp.WriteProfileInt(_T("Preferences"), _T("activateWindowsMessenger"), m_activateWindowsMessenger);
    theApp.WriteProfileString(_T("Preferences"), _T("wmTitle"), m_wmTitle);
    theApp.WriteProfileInt(_T("Preferences"), _T("wmIcon"), m_wmIcon);
    theApp.WriteProfileInt(_T("Preferences"), _T("wmSpeed"), m_wmSpeed);
    theApp.WriteProfileInt(_T("Preferences"), _T("scrollMode"), m_scrollMode);
}

void CMainWnd::SaveThePlaylist()
{
    TCHAR STPname[MAX_PATH + 1];
    GetModuleFileName(theApp.m_hInstance, STPname, MAX_PATH);
    TCHAR STPDrive[MAX_PATH];
    TCHAR STPDir[MAX_PATH];
    TCHAR STPFname[MAX_PATH];

    _tsplitpath(STPname, STPDrive, STPDir, STPFname, NULL);

    CString fname;
    fname.Format(_T("%s%s%s.m3u"), STPDrive, STPDir, STPFname);

    CStdioFile plfile;

    CStringArray prev;
    CString buf;

    if (plfile.Open(fname, CFile::modeRead | CFile::shareDenyNone))
    {
        while (plfile.ReadString(buf))
        {
            buf.TrimLeft();buf.TrimRight();
            prev.Add(buf);
        }
        plfile.Close();
    }

    if (plfile.Open(fname, CFile::modeCreate | CFile::modeWrite))
    {
        CString PLPath;
        TCHAR PLpath[MAX_PATH];
        TCHAR PLdrive[MAX_PATH];
        TCHAR PLdir[MAX_PATH];
        TCHAR PLfname[MAX_PATH];
        TCHAR PLext[MAX_PATH];
        _tcscpy(PLpath, (TCHAR *)fname.GetString());
        _tsplitpath(PLpath, PLdrive, PLdir, PLfname, PLext);

        PLPath.Format(_T("%s%s"), PLdrive, PLdir);

        TCHAR path[MAX_PATH];
        TCHAR drive[MAX_PATH];
        TCHAR dir[MAX_PATH];
        TCHAR fname[MAX_PATH];
        TCHAR ext[MAX_PATH];

        if (m_extPlaylistFormat)
        {
            plfile.WriteString(_T("#EXTM3U\n"));
        }
        UINT i;
        CString buf;
        for (i = 0; i < (UINT)s_playlistManager.GetSize(); i++)
        {
            CString tmp = s_playlistManager.GetPlaylist(i);

            _tcscpy(path, (TCHAR *)tmp.GetString());
            _tsplitpath(path, drive, dir, fname, ext);

            if (_tcsicmp(drive, PLdrive) == 0)
            {
                if (_tcsicmp(dir, PLdir) == 0)
                {
                    buf.Format(_T("%s%s"), fname, ext);
                }
                else
                {
                    if (_tcsstr(dir, PLdir) != NULL)
                    {
                        buf.Format(_T("%s%s%s"), dir + _tcslen(PLdir), fname, ext);
                    }
                    else
                    {
                        CString points = _T("");
                        TCHAR tmpPLdir[MAX_PATH];
                        _tcscpy(tmpPLdir, PLdir);
                        tmpPLdir[_tcslen(PLdir) - 1] = 0;
                        TCHAR* pEnd;
                        do
                        {
                            points += "..\\";
                            pEnd = _tcsrchr(tmpPLdir, '\\');
                            if (pEnd != NULL)
                            {
                                pEnd[0] = 0;
                                if (_tcsstr(dir, tmpPLdir) != NULL)
                                {
                                    break;
                                }
                            }
                        }
                        while (pEnd != NULL);
                        buf.Format(_T("%s%s%s%s"), points, dir + _tcslen(tmpPLdir) + 1, fname, ext);
                    }
                }
            }
            else
            {
                buf.Format(_T("%s%s%s%s"), drive, dir, fname, ext);
            }

            plfile.WriteString(buf + _T("\n"));
            if (m_extPlaylistFormat && s_playlistManager.GetRead(i))
            {
                CString tmp;
                tmp.Format(_T("#EXTINF:%d,%s\n"), s_playlistManager.GetDurationI(i), s_playlistManager.GetTag(i));
                plfile.WriteString(tmp);
            }
        }
        plfile.Close();
        theApp.WriteProfileInt(_T("Preferences"), _T("CurrentInPlaylist"), s_playlistManager.GetCurrent());
    }
}

void CMainWnd::ShowPopup(int MenuType)
{
    POINT point;
    switch (MenuType)
    {
        case 0:
            point = m_curMousePos; break;
        case 1:
            GetPosForMenu(&point); break;
        case 2:
            GetCursorPos(&point); break;
    }
    m_pPopup = m_mainMenu.GetSubMenu(0);
    m_Helper.translateMenu(m_pPopup, IDR_MENU);

    CMenu* pTempMenu;
    // Rcent
    pTempMenu = m_pPopup->GetSubMenu(6)->GetSubMenu(5);
    pTempMenu->DeleteMenu(0, MF_BYPOSITION);
    int i, j, k; CString rbuf;
    for (i = 0; i < 10; i++)
    {
        if (m_recent[i] != "")
        {
            rbuf = m_recent[i];
            if (rbuf.GetLength() > 40)
            {
                j = rbuf.ReverseFind('\\');
                k = j > 20 ? 18 : j - 3; if (k < 0)
                                            k = 0;
                rbuf = rbuf.Left(k) + _T(".....") + rbuf.Mid(j);
            }
            pTempMenu->AppendMenu(MF_STRING, IDM_RECENT_FILES + i, ReplaceAmpersand(rbuf));
        }
    }

    // Scan drive
    pTempMenu = m_pPopup->GetSubMenu(6)->GetSubMenu(6);
    pTempMenu->DeleteMenu(0, MF_BYPOSITION);
    CString CDLetter;
    UINT dt;
    for (TCHAR c = 'C'; c <= 'Z'; c++)
    {
        CDLetter.Format(_T("%c"), c);
        dt = ::GetDriveType(CDLetter + _T(":\\"));
        if (dt == DRIVE_REMOVABLE || dt == DRIVE_FIXED || dt == DRIVE_REMOTE || dt == DRIVE_CDROM)
            pTempMenu->AppendMenu(MF_STRING, IDM_DRIVES + (UINT)(c - 'C'), CDLetter);
    }

    // Menu prev next
    if (m_SMPrevNext && s_playlistManager.GetSize() > 0)
    {
        pTempMenu = m_pPopup->GetSubMenu(18);
        pTempMenu->DeleteMenu(0, MF_BYPOSITION);
        try
        {
            BuildPrevNextMenu(pTempMenu);
        }
        catch (...)
        {
            while (pTempMenu->GetMenuItemCount() > 0)
            {
                pTempMenu->DeleteMenu(0, MF_BYPOSITION);
            }
            pTempMenu->InsertMenu(0, MF_STRING, 0, _T("Erreur"));
        }
    }
    else
        m_pPopup->DeleteMenu(18, MF_BYPOSITION);

    if (s_playlistManager.GetSize() > 0 && s_playlistManager.GetSize() <= 50000)
    {
        if (m_SMAlbum)
        {
            pTempMenu = m_pPopup->GetSubMenu(8);
            pTempMenu->DeleteMenu(0, MF_BYPOSITION);
            try
            {
                BuildAlbumMenu(pTempMenu);
            }
            catch (...)
            {
                while (pTempMenu->GetMenuItemCount() > 0)
                {
                    pTempMenu->DeleteMenu(0, MF_BYPOSITION);
                }
                pTempMenu->InsertMenu(8, MF_STRING, 0, _T("Erreur"));
            }
        }
        else
            m_pPopup->DeleteMenu(8, MF_BYPOSITION);
        if (m_SMTracks)
        {
            pTempMenu = m_pPopup->GetSubMenu(7);
            pTempMenu->DeleteMenu(0, MF_BYPOSITION);
            try
            {
                BuildMenu(pTempMenu);
            }
            catch (...)
            {
                while (pTempMenu->GetMenuItemCount() > 0)
                {
                    pTempMenu->DeleteMenu(0, MF_BYPOSITION);
                }
                pTempMenu->InsertMenu(7, MF_STRING, 0, _T("Erreur"));
            }
        }
        else
            m_pPopup->DeleteMenu(7, MF_BYPOSITION);
    }
    else
    {
        m_pPopup->DeleteMenu(8, MF_BYPOSITION);
        m_pPopup->DeleteMenu(7, MF_BYPOSITION);
    }

    if (MenuType < 2)
    {
        if (m_graphicalButtons)
        {
            m_pPopup->ModifyMenu(ID_POPUPMENU_PLAY, MF_OWNERDRAW | MF_BYCOMMAND, ID_POPUPMENU_PLAY);
            m_pPopup->ModifyMenu(ID_POPUPMENU_PAUSE, MF_OWNERDRAW | MF_BYCOMMAND, ID_POPUPMENU_PAUSE);
            m_pPopup->ModifyMenu(ID_POPUPMENU_STOP, MF_OWNERDRAW | MF_BYCOMMAND, ID_POPUPMENU_STOP);
            m_pPopup->ModifyMenu(ID_POPUPMENU_PREVIOUS, MF_OWNERDRAW | MF_BYCOMMAND, ID_POPUPMENU_PREVIOUS);
            m_pPopup->ModifyMenu(ID_POPUPMENU_NEXT, MF_OWNERDRAW | MF_BYCOMMAND, ID_POPUPMENU_NEXT);
        }

        if (m_showGradientBar)
        {
            m_pPopup->InsertMenu(0, MF_OWNERDRAW | MF_BYPOSITION, ID_POPUPMENU_PIC);
            CString buf;
            m_pPopup->GetMenuString(ID_POPUPMENU_EXIT, buf, MF_BYCOMMAND);
            m_pPopup->ModifyMenu(ID_POPUPMENU_EXIT, MF_BYCOMMAND | MF_MENUBARBREAK | MF_STRING, ID_POPUPMENU_EXIT, buf);
        }
        SetForegroundWindow();
        m_pPopup->TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, this);
        if (m_showGradientBar)
        {
            m_pPopup->DeleteMenu(0, MF_BYPOSITION);
            CString buf;
            m_pPopup->GetMenuString(ID_POPUPMENU_EXIT, buf, MF_BYCOMMAND);
            m_pPopup->ModifyMenu(ID_POPUPMENU_EXIT, MF_BYCOMMAND | MF_STRING, ID_POPUPMENU_EXIT, buf);
        }
        if (m_graphicalButtons)
        {
            m_pPopup->ModifyMenu(ID_POPUPMENU_PLAY, MF_BYCOMMAND, ID_POPUPMENU_PLAY);
            m_pPopup->ModifyMenu(ID_POPUPMENU_PAUSE, MF_BYCOMMAND, ID_POPUPMENU_PAUSE);
            m_pPopup->ModifyMenu(ID_POPUPMENU_STOP, MF_BYCOMMAND, ID_POPUPMENU_STOP);
            m_pPopup->ModifyMenu(ID_POPUPMENU_PREVIOUS, MF_BYCOMMAND, ID_POPUPMENU_PREVIOUS);
            m_pPopup->ModifyMenu(ID_POPUPMENU_NEXT, MF_BYCOMMAND, ID_POPUPMENU_NEXT);
        }
    }
    else
    {
        m_pPopup->DeleteMenu(ID_POPUPMENU_PLAY, MF_BYCOMMAND);
        m_pPopup->DeleteMenu(ID_POPUPMENU_PAUSE, MF_BYCOMMAND);
        m_pPopup->DeleteMenu(ID_POPUPMENU_STOP, MF_BYCOMMAND);
        m_pPopup->DeleteMenu(ID_POPUPMENU_PREVIOUS, MF_BYCOMMAND);
        m_pPopup->DeleteMenu(ID_POPUPMENU_NEXT, MF_BYCOMMAND);
        m_pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, this);

        CString buf;
        m_Helper.translate(ID_POPUPMENU_PLAY, buf);
        m_pPopup->InsertMenu(9, MF_BYPOSITION, ID_POPUPMENU_PLAY, buf);
        m_Helper.translate(ID_POPUPMENU_PAUSE, buf);
        m_pPopup->InsertMenu(10, MF_BYPOSITION, ID_POPUPMENU_PAUSE, buf);
        m_Helper.translate(ID_POPUPMENU_STOP, buf);
        m_pPopup->InsertMenu(11, MF_BYPOSITION, ID_POPUPMENU_STOP, buf);
        m_Helper.translate(ID_POPUPMENU_PREVIOUS, buf);
        m_pPopup->InsertMenu(12, MF_BYPOSITION, ID_POPUPMENU_PREVIOUS, buf);
        m_Helper.translate(ID_POPUPMENU_NEXT, buf);
        m_pPopup->InsertMenu(13, MF_BYPOSITION, ID_POPUPMENU_NEXT, buf);
    }
    if (s_playlistManager.GetSize() > 0 && s_playlistManager.GetSize() <= 50000)
    {
        if (m_SMTracks)
        {
            pTempMenu = m_pPopup->GetSubMenu(7);
            while (pTempMenu->GetMenuItemCount() != 0)
            {
                pTempMenu->DeleteMenu(0, MF_BYPOSITION);
            }
            pTempMenu->AppendMenu(MF_STRING, ID_DUMMY, _T("Dummy"));
        }
        else
        {
            CMenu tmenu;
            tmenu.CreatePopupMenu();
            HMENU tmpHMenu = tmenu.Detach();
            CString buf;
            m_Helper.translate(IDR_MENU, buf, 7);
            m_pPopup->InsertMenu(7, MF_BYPOSITION | MF_POPUP, (UINT)tmpHMenu, buf);
        }
        if (m_SMAlbum)
        {
            pTempMenu = m_pPopup->GetSubMenu(8);
            while (pTempMenu->GetMenuItemCount() != 0)
            {
                pTempMenu->DeleteMenu(0, MF_BYPOSITION);
            }
            pTempMenu->AppendMenu(MF_STRING, ID_DUMMY, _T("Dummy"));
        }
        else
        {
            CMenu tmenu;
            tmenu.CreatePopupMenu();
            HMENU tmpHMenu = tmenu.Detach();
            CString buf;
            m_Helper.translate(IDR_MENU, buf, 8);
            m_pPopup->InsertMenu(8, MF_BYPOSITION | MF_POPUP, (UINT)tmpHMenu, buf);
        }
    }
    else
    {
        CMenu tmenu;
        tmenu.CreatePopupMenu();
        HMENU tmpHMenu = tmenu.Detach();
        CString buf = m_Helper.MyLoadString(ID_POPUPMENU_TRACKS);
        m_pPopup->InsertMenu(7, MF_BYPOSITION | MF_POPUP, (UINT)tmpHMenu, buf);
        CMenu tmenu2;
        tmenu2.CreatePopupMenu();
        HMENU tmpHMenu2 = tmenu2.Detach();
        buf = m_Helper.MyLoadString(ID_POPUPMENU_ALBUM);
        m_pPopup->InsertMenu(8, MF_BYPOSITION | MF_POPUP, (UINT)tmpHMenu2, buf);
    }

    // Menu prev next
    if (m_SMPrevNext && s_playlistManager.GetSize() > 0)
    {
        pTempMenu = m_pPopup->GetSubMenu(18);
        while (pTempMenu->GetMenuItemCount() != 0)
        {
            pTempMenu->DeleteMenu(0, MF_BYPOSITION);
        }
        pTempMenu->AppendMenu(MF_STRING, ID_DUMMY, _T("Dummy"));
    }
    else
    {
        CMenu tmenu;
        tmenu.CreatePopupMenu();
        HMENU tmpHMenu = tmenu.Detach();
        CString buf;
        buf = m_Helper.MyLoadString(ID_POPUPMENU_NEXTSONGS);
        m_pPopup->InsertMenu(18, MF_BYPOSITION | MF_POPUP, (UINT)tmpHMenu, buf);
    }
    // Scan drive
    pTempMenu = m_pPopup->GetSubMenu(6)->GetSubMenu(6);
    while (pTempMenu->GetMenuItemCount() != 0)
    {
        pTempMenu->DeleteMenu(0, MF_BYPOSITION);
    }
    pTempMenu->AppendMenu(MF_STRING, ID_DUMMY, _T("Dummy"));
    // Rcent
    pTempMenu = m_pPopup->GetSubMenu(6)->GetSubMenu(5);
    while (pTempMenu->GetMenuItemCount() != 0)
    {
        pTempMenu->DeleteMenu(0, MF_BYPOSITION);
    }
    pTempMenu->AppendMenu(MF_STRING, ID_DUMMY, _T("Dummy"));
}


void CMainWnd::ShowTracksMenu(int MenuType, bool CurAlbOnly)
{
    if (s_playlistManager.GetSize() > 0 && s_playlistManager.GetSize() <= 50000)
    {
        POINT point;
        switch (MenuType)
        {
            case 0:
                point = m_curMousePos; break;
            case 1:
                GetPosForMenu(&point); break;
            case 2:
                GetCursorPos(&point); break;
        }

        CMenu tmenu;
        tmenu.CreatePopupMenu();
        tmenu.DeleteMenu(0, MF_BYPOSITION);
        HMENU tmpHMenu = tmenu.Detach();
        try
        {
            if (CurAlbOnly)
                BuildAlbumMenu(CMenu::FromHandle(tmpHMenu));
            else
                BuildMenu(CMenu::FromHandle(tmpHMenu));
            tmenu.Attach(tmpHMenu);
        }
        catch (...)
        {
            while (CMenu::FromHandle(tmpHMenu)->GetMenuItemCount() > 0)
            {
                CMenu::FromHandle(tmpHMenu)->DeleteMenu(0, MF_BYPOSITION);
            }
            CMenu::FromHandle(tmpHMenu)->InsertMenu(7, MF_STRING, 0, _T("Erreur"));
            tmenu.Attach(tmpHMenu);
        }
        if (MenuType < 2)
        {
            SetForegroundWindow();
            tmenu.TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, this);
            PostMessage(WM_NULL, 0, 0);
        }
        else
            tmenu.TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, this);
        tmenu.DestroyMenu();
    }
}

extern void equInit(int wb);
extern void loadFrom(CStringArray* listString);
extern void SetBandsFromSlpos();

extern int lslpos[19], rslpos[19];
extern CStringArray m_eq;

void initEq()
{
    equInit(14);

    for (int i = 0; i <= 18; i++)
    {
        if (lslpos[i] < 0)
            lslpos[i] = 0;
        if (lslpos[i] > 96)
            lslpos[i] = 96;
        if (rslpos[i] < 0)
            rslpos[i] = 0;
        if (rslpos[i] > 96)
            rslpos[i] = 96;
    }

    loadFrom(&m_eq);
    SetBandsFromSlpos();
}

void CMainWnd::Start2()
{
    stdIn.LoadAll(WAEmuWnd.m_hWnd);
    initEq();
    stdOut.LoadAll(WAEmuWnd.m_hWnd);
    stdGen.LoadAll(WAEmuWnd.m_hWnd);

    stdIn.SetOutMod(stdOut.GetOut_Module());
    stdGen.Init();

    LoadThePlaylist();
    if (m_autOnStart)
        s_playlistManager.PerformAutomation();

    if (theApp.GetProfileInt(_T("Preferences"), _T("BarAtStartup"), 0) == 1)
    {
        InternalSeek();
    }
    if (theApp.GetProfileInt(_T("Preferences"), _T("PlaylistAtStartup"), 0) == 1)
    {
        s_playlistDlg.ShowWindow(SW_SHOW);
        s_playlistDlg.SendMessage(WM_COMMAND, ID_TRACKS_REFRESH);
    }
    if (theApp.GetProfileInt(_T("Preferences"), _T("EQAtStartup"), 0))
        ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_OPTIONS_EQ, 0);
    m_created = true;

    if (m_autoUpdate)
    {
        CAutoUpdater updater;
        CAutoUpdater::ErrorType err = updater.CheckForUpdate(_T("http://systrayplay.free.fr/"));
        switch (err)
        {
            case CAutoUpdater::Success:
                MessageBox(m_Helper.MyLoadString(IDS_UPDATEOK), _T("STP"), MB_ICONINFORMATION | MB_OK);
                ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_QUIT, 0);
                break;
            case CAutoUpdater::UpdateNotRequired:
                break;
            case CAutoUpdater::UpdateNotComplete:
                MessageBox(m_Helper.MyLoadString(IDS_UPDATEKO), _T("STP"), MB_ICONINFORMATION | MB_OK);
                break;
            case CAutoUpdater::NoExecutableVersion:
                MessageBox(m_Helper.MyLoadString(IDS_UPDATENOEXECUTABLEVERSION), _T("STP"), MB_ICONINFORMATION | MB_OK);
                break;
            default:
                MessageBox(m_Helper.MyLoadString(IDS_UPDATECONNECTFAILED), _T("STP"), MB_ICONINFORMATION | MB_OK);
                break;
        }
    }
    if (m_consoleRect.right != -1000 && m_consoleRect.bottom != -1000)
        SetWindowPos(NULL, m_consoleRect.left, m_consoleRect.top, m_consoleRect.Width(),m_consoleRect.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
    if (m_displayConsole)
    {
        ShowWindow(SW_SHOW);
        if(m_displayConsoleAOT)
            OnConsoleAot();
    }
    else
        ShowWindow(SW_HIDE);

    m_firstPass = true;
#ifdef _DEBUG
    //OnPopupMenuSettingsAdvanced();
#endif
}
void CMainWnd::Start()
{
    helperMod = theApp.m_hInstance;

    m_stpIcon = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_STP), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR);
    m_stpIconSm = (HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_STP), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
    m_imgList.Create(IDB_BITMAP1, 16, 0, RGB(192, 192, 192));

    m_skin.startColor = theApp.GetProfileInt(_T("MenuXP"), _T("GradientStart"), RGB(0xB4, 0xC4, 0xE4));
    m_skin.endColor = theApp.GetProfileInt(_T("MenuXP"), _T("GradientEnd"), RGB(0xFF, 0xFF, 0xFF));
    m_skin.border_color = theApp.GetProfileInt(_T("Preferences"), _T("border_color"), RGB(255, 255, 223));
    m_skin.end_bk = theApp.GetProfileInt(_T("Preferences"), _T("end_bk"), RGB(192, 192, 208));
    m_skin.mid_bk = theApp.GetProfileInt(_T("Preferences"), _T("mid_bk"), RGB(240, 247, 255));
    m_skin.start_bk = theApp.GetProfileInt(_T("Preferences"), _T("start_bk"), RGB(255, 255, 255));
    m_skin.toolTipText = theApp.GetProfileString(_T("Preferences"), _T("ToolTipText"), _T("<table>\\r\\n  <tr>\\r\\n    <td><icon idres=301></td>\\r\\n    <td><center><h2>%7</h2></center></td>\\r\\n    <td><right><a><icon idres=248 width=16 height=16 style=g hotstyle></a></right></td>\\r\\n  </tr>\\r\\n  <tr>\\r\\n    <td colspan=3><hr color=blue></td>\\r\\n  </tr>\\r\\n  <tr>\\r\\n    <td><bmp idres=138 mask style=d></td>\\r\\n    <td colspan=2>\\r\\n      <table>\\r\\n        <tr>\\r\\n          <td>Title :</td>\\r\\n          <td> %2</td>\\r\\n        </tr>\\r\\n        <tr>\\r\\n          <td>Artist :</td>\\r\\n          <td> %1</td>\\r\\n        </tr>\\r\\n        <tr><td>Album :</td>\\r\\n          <td> %3</td>\\r\\n        </tr>\\r\\n          <tr>\\r\\n          <td>Year :</td>\\r\\n          <td> %4</td>\\r\\n        </tr>\\r\\n        <tr>\\r\\n          <td>Comment :</td>\\r\\n          <td> %5</td>\\r\\n        </tr>\\r\\n        <tr>\\r\\n        <td>Length :</td>\\r\\n          <td> %6</td>\\r\\n        </tr>\\r\\n      </table>\\r\\n    </td>\\r\\n  </tr>\\r\\n</table>"));

    m_skin.theme = theApp.GetProfileInt(_T("Preferences"), _T("Theme"), 1);
    m_skin.effect_bk = theApp.GetProfileInt(_T("Preferences"), _T("effect_bk"), 13);
    m_skin.granularity = theApp.GetProfileInt(_T("Preferences"), _T("granularity"), 5);
    m_skin.border = theApp.GetProfileInt(_T("Preferences"), _T("border"), TRUE);
    m_skin.custom_border = theApp.GetProfileInt(_T("Preferences"), _T("custom_border"), 0);
    m_skin.border_width = theApp.GetProfileInt(_T("Preferences"), _T("border_width"), 1);
    m_skin.border_height = theApp.GetProfileInt(_T("Preferences"), _T("border_height"), 1);
    m_skin.transparency = theApp.GetProfileInt(_T("Preferences"), _T("transparency"), 0);

    m_currentSkinSel = theApp.GetProfileInt(_T("Preferences"), _T("CurrentSkinSel"), 0);
    m_currentSkin.Add(theApp.GetProfileString(_T("Preferences"), _T("CurrentSkin"), _T("")));

    m_changeSkinOnEachTrack = theApp.GetProfileInt(_T("Preferences"), _T("changeSkinOnEachTrack"), FALSE);
    m_randomSkin = theApp.GetProfileInt(_T("Preferences"), _T("randomSkin"), FALSE);

    int i = 1;
    CString tmp, tmp2;
    do
    {
        tmp.Format(_T("CurrentSkin%d"), i);
        tmp2 = theApp.GetProfileString(_T("Preferences"), tmp, _T("NONE"));
        if (tmp2.Find(_T("NONE")) == -1)
            m_currentSkin.Add(tmp2);
        i++;
    }
    while (tmp2.Find(_T("NONE")) == -1);
    m_currentSkinSel %= m_currentSkin.GetSize();
    LoadSkin(m_currentSkin[m_currentSkinSel], &m_skin);
    UseSkin(&m_skin);

    CMenuXP::SetMenuItemImage(ID_POPUPMENU_ABOUT, m_imgList, 0);
    CMenuXP::SetMenuItemImage(ID_POPUPMENU_OPEN_FILE, m_imgList, 1);
    CMenuXP::SetMenuItemImage(ID_PLAYLIST_SAVE, m_imgList, 2);
    CMenuXP::SetMenuItemImage(ID_POPUPMENU_OPENFOLDER, m_imgList, 4);

    // initiating random list
    rnd = GetTickCount();
    {
        int i, j, k, l;
        for (i = 0; i < 50000; i++)
            m_rndlst[i] = i;
        srand((unsigned)time(NULL));
        for (i = 0; i < 75000; i++)
        {
            j = rand() % 50000;
            k = rand() % 50000;

            l = m_rndlst[j]; 
            m_rndlst[j] = m_rndlst[k]; 
            m_rndlst[k] = l;
        }
        m_rndpntr = m_rndlst;
    }

    m_firstInMyRandom = 0xFFFFFFFF;

    m_trackDurI = 0;

    m_shutdownAfterEnd = 0;
    m_exitAfterEnd = 0;

    m_traySeeking = false;
    m_iconShown = true;

    m_lbd = m_rbd = false;
    m_lbs = m_rbs = 0;

    m_curMousePos.x = m_curMousePos.y = 0;

    m_W2Ffile = theApp.GetProfileString(_T("Preferences"), _T("W2Ffile"), _T(""));
    m_sortTemplate = theApp.GetProfileString(_T("Preferences"), _T("sortTemplate"), _T("%8%9%7"));
    m_W2Fplay = theApp.GetProfileString(_T("Preferences"), _T("W2Fplay"), _T("Now playing: %7"));
    m_W2Fpause = theApp.GetProfileString(_T("Preferences"), _T("W2Fpause"), _T("Now paused: %7"));
    m_W2Fstop = theApp.GetProfileString(_T("Preferences"), _T("W2Fstop"), _T("Now stopped: %7"));
    m_W2Fexit = theApp.GetProfileString(_T("Preferences"), _T("W2Fexit"), _T("STP is closed"));
    m_W2Foem = theApp.GetProfileInt(_T("Preferences"), _T("W2Foem"), FALSE);
    m_W2Fdel = theApp.GetProfileInt(_T("Preferences"), _T("W2Fdel"), FALSE);
    m_W2Fenabled = theApp.GetProfileInt(_T("Preferences"), _T("W2Fenabled"), FALSE);
    m_W2FFtp = theApp.GetProfileInt(_T("Preferences"), _T("W2FFtp"), FALSE);
    m_W2FSite = theApp.GetProfileString(_T("Preferences"), _T("W2FSite"), _T(""));
    m_W2FUser = theApp.GetProfileString(_T("Preferences"), _T("W2FUser"), _T(""));
    m_W2FPassword = theApp.GetProfileString(_T("Preferences"), _T("W2FPassword"), _T(""));

    m_autSort = theApp.GetProfileInt(_T("Preferences"), _T("AutSort"), 0);
    m_autRemove = theApp.GetProfileInt(_T("Preferences"), _T("AutRemove"), 0);
    m_autRemovedup = theApp.GetProfileInt(_T("Preferences"), _T("AutRemovedup"), 0);
    m_autRescan = theApp.GetProfileInt(_T("Preferences"), _T("AutRescan"), 0);
    m_autPeriod = (int)theApp.GetProfileInt(_T("Preferences"), _T("AutPeriod"), 5);
    m_autEvery = theApp.GetProfileInt(_T("Preferences"), _T("AutEvery"), 0);
    m_autOnStart = theApp.GetProfileInt(_T("Preferences"), _T("AutOnStart"), 0);
    m_autSaveset = theApp.GetProfileInt(_T("Preferences"), _T("AutSaveset"), 0);

    int AutDirsCnt = (int)theApp.GetProfileInt(_T("Preferences"), _T("AutDirsCnt"), 0);

    CString adtmp; int adc;
    for (adc = 0; adc < AutDirsCnt; adc++)
    {
        adtmp.Format(_T("AutDir%d"), adc + 1);
        adtmp = theApp.GetProfileString(_T("Preferences"), adtmp, _T(""));
        if (adtmp != "")
            m_autDirs.Add(adtmp);
    }

    m_currentVolume = 0;
    s_volume.Init();

    m_rNTemplate = theApp.GetProfileString(_T("Preferences"), _T("RNTemplate"), _T("%1 - %3"));

    m_SMTracks = theApp.GetProfileInt(_T("Preferences"), _T("SMTracks"), 1);
    m_SMAlbum = theApp.GetProfileInt(_T("Preferences"), _T("SMAlbum"), 1);
    m_SMPrevNext = theApp.GetProfileInt(_T("Preferences"), _T("SMPrevNext"), 1);
    m_wAEmu = theApp.GetProfileInt(_T("Preferences"), _T("WAEmu"), 0);

    m_dockSD = theApp.GetProfileInt(_T("Preferences"), _T("DockMinibar"), 0);

    m_language = theApp.GetProfileString(_T("Preferences"), _T("Language"), _T(""));
    m_pressAndHold = (int)theApp.GetProfileInt(_T("Preferences"), _T("PressAndHold"), 2);

    m_extPlaylistFormat = (int)theApp.GetProfileInt(_T("Preferences"), _T("ExtPlaylistFormat"), 0);

    m_albumStop = theApp.GetProfileInt(_T("Preferences"), _T("AlbumStop"), 0);

    m_showingMode = (int)theApp.GetProfileInt(_T("Preferences"), _T("ShowingMode"), 0);
    s_playlistManager.SetShowingMode(m_showingMode);

    m_showGradientBar = theApp.GetProfileInt(_T("Preferences"), _T("ShowGradientBar"), 0);
    m_graphicalButtons = theApp.GetProfileInt(_T("Preferences"), _T("GraphicalButtons"), 1);

    m_tpc = (int)theApp.GetProfileInt(_T("Preferences"), _T("TPC"), 10);

    m_showRemainingTime = (int)theApp.GetProfileInt(_T("Preferences"), _T("ShowRemainingTime"), 0);
    m_showTTT = theApp.GetProfileInt(_T("Preferences"), _T("ShowTTT"), 0);

    m_playlistOnTop = (int)theApp.GetProfileInt(_T("Preferences"), _T("PlaylistOnTop"), 0);
    m_eQOnTop = (int)theApp.GetProfileInt(_T("Preferences"), _T("EQOnTop"), 0);
    m_noClicks = (int)theApp.GetProfileInt(_T("Preferences"), _T("NoClicks"), 0);

    m_gapBtwTracks = (int)theApp.GetProfileInt(_T("Preferences"), _T("Gap"), 0);

    m_clicks[0] = theApp.GetProfileInt(_T("Preferences"), _T("Clicks1"), 1);
    m_clicks[1] = theApp.GetProfileInt(_T("Preferences"), _T("Clicks2"), 4);
    m_clicks[2] = theApp.GetProfileInt(_T("Preferences"), _T("Clicks3"), 3);
    m_clicks[3] = theApp.GetProfileInt(_T("Preferences"), _T("Clicks4"), 2);
    m_clicks[4] = theApp.GetProfileInt(_T("Preferences"), _T("RClicks1"), 10);
    m_clicks[5] = theApp.GetProfileInt(_T("Preferences"), _T("RClicks2"), 0);
    m_clicks[6] = theApp.GetProfileInt(_T("Preferences"), _T("RClicks3"), 0);
    m_clicks[7] = theApp.GetProfileInt(_T("Preferences"), _T("RClicks4"), 0);

    m_NPKey = theApp.GetProfileInt(_T("Preferences"), _T("NPKey"), 0);
    m_NPMod = theApp.GetProfileInt(_T("Preferences"), _T("NPMod"), 0);

    m_exitKey = theApp.GetProfileInt(_T("Preferences"), _T("ExitKey"), 0);
    m_exitMod = theApp.GetProfileInt(_T("Preferences"), _T("ExitMod"), 0);

    m_playKey = theApp.GetProfileInt(_T("Preferences"), _T("PlayKey"), 0);
    m_playMod = theApp.GetProfileInt(_T("Preferences"), _T("PlayMod"), 0);
    m_stopKey = theApp.GetProfileInt(_T("Preferences"), _T("StopKey"), 0);
    m_stopMod = theApp.GetProfileInt(_T("Preferences"), _T("StopMod"), 0);
    m_prevKey = theApp.GetProfileInt(_T("Preferences"), _T("PrevKey"), 0);
    m_prevMod = theApp.GetProfileInt(_T("Preferences"), _T("PrevMod"), 0);
    m_nextKey = theApp.GetProfileInt(_T("Preferences"), _T("NextKey"), 0);
    m_nextMod = theApp.GetProfileInt(_T("Preferences"), _T("NextMod"), 0);
    m_forwKey = theApp.GetProfileInt(_T("Preferences"), _T("ForwKey"), 0);
    m_forwMod = theApp.GetProfileInt(_T("Preferences"), _T("ForwMod"), 0);
    m_backKey = theApp.GetProfileInt(_T("Preferences"), _T("BackKey"), 0);
    m_backMod = theApp.GetProfileInt(_T("Preferences"), _T("BackMod"), 0);
    m_vUpKey = theApp.GetProfileInt(_T("Preferences"), _T("VUpKey"), 0);
    m_vUpMod = theApp.GetProfileInt(_T("Preferences"), _T("VUpMod"), 0);
    m_vDownKey = theApp.GetProfileInt(_T("Preferences"), _T("VDownKey"), 0);
    m_vDownMod = theApp.GetProfileInt(_T("Preferences"), _T("VDownMod"), 0);

    m_openKey1 = theApp.GetProfileInt(_T("Preferences"), _T("OpenKey1"), 0); 
    m_openMod1 = theApp.GetProfileInt(_T("Preferences"), _T("OpenMod1"), 0); 
    m_openKey2 = theApp.GetProfileInt(_T("Preferences"), _T("OpenKey2"), 0); 
    m_openMod2 = theApp.GetProfileInt(_T("Preferences"), _T("OpenMod2"), 0);
    m_openKey3 = theApp.GetProfileInt(_T("Preferences"), _T("OpenKey3"), 0); 
    m_openMod3 = theApp.GetProfileInt(_T("Preferences"), _T("OpenMod3"), 0);
    m_minibarKey = theApp.GetProfileInt(_T("Preferences"), _T("MinibarKey"), 0);
    m_minibarMod = theApp.GetProfileInt(_T("Preferences"), _T("MinibarMod"), 0);
    m_MP3InfoKey = theApp.GetProfileInt(_T("Preferences"), _T("MP3InfoKey"), 0);
    m_MP3InfoMod = theApp.GetProfileInt(_T("Preferences"), _T("MP3InfoMod"), 0);
    m_playlistKey = theApp.GetProfileInt(_T("Preferences"), _T("PlstKey"), 0);
    m_playlistMod = theApp.GetProfileInt(_T("Preferences"), _T("PlstMod"), 0);
    m_equalizerKey = theApp.GetProfileInt(_T("Preferences"), _T("EqualizerKey"), 0);
    m_equalizerMod = theApp.GetProfileInt(_T("Preferences"), _T("EqualizerMod"), 0);
    m_repeatKey = theApp.GetProfileInt(_T("Preferences"), _T("RptKey"), 0);
    m_repeatMod = theApp.GetProfileInt(_T("Preferences"), _T("RptMod"), 0);
    m_shuffleKey = theApp.GetProfileInt(_T("Preferences"), _T("ShflKey"), 0);
    m_shuffleMod = theApp.GetProfileInt(_T("Preferences"), _T("ShflMod"), 0);
    m_albumModeKey = theApp.GetProfileInt(_T("Preferences"), _T("AlbummodeKey"), 0);
    m_albumModeMod = theApp.GetProfileInt(_T("Preferences"), _T("AlbummodeMod"), 0);
    m_trayIconKey = theApp.GetProfileInt(_T("Preferences"), _T("TrayIconKey"), 0);
    m_trayIconMod = theApp.GetProfileInt(_T("Preferences"), _T("TrayIconMod"), 0);
    m_menuKey = theApp.GetProfileInt(_T("Preferences"), _T("MenuKey"), 0);
    m_menuMod = theApp.GetProfileInt(_T("Preferences"), _T("MenuMod"), 0);
    m_tracksKey = theApp.GetProfileInt(_T("Preferences"), _T("TracksKey"), 0);
    m_tracksMod = theApp.GetProfileInt(_T("Preferences"), _T("TracksMod"), 0);
    m_albumKey = theApp.GetProfileInt(_T("Preferences"), _T("AlbumKey"), 0);
    m_albumMod = theApp.GetProfileInt(_T("Preferences"), _T("AlbumMod"), 0);
    m_automationKey = theApp.GetProfileInt(_T("Preferences"), _T("AutomationKey"), 0);
    m_automationMod = theApp.GetProfileInt(_T("Preferences"), _T("AutomationMod"), 0);

    RegHotKeys();

    m_opening = false;

    s_playlistManager.SetCurrent(0);

    m_initDir = theApp.GetProfileString(_T("Preferences"), _T("InitDir"), _T("C:\\"));

    m_recent[0] = theApp.GetProfileString(_T("Preferences"), _T("Recent0"), _T(""));
    m_recent[1] = theApp.GetProfileString(_T("Preferences"), _T("Recent1"), _T(""));
    m_recent[2] = theApp.GetProfileString(_T("Preferences"), _T("Recent2"), _T(""));
    m_recent[3] = theApp.GetProfileString(_T("Preferences"), _T("Recent3"), _T(""));
    m_recent[4] = theApp.GetProfileString(_T("Preferences"), _T("Recent4"), _T(""));
    m_recent[5] = theApp.GetProfileString(_T("Preferences"), _T("Recent5"), _T(""));
    m_recent[6] = theApp.GetProfileString(_T("Preferences"), _T("Recent6"), _T(""));
    m_recent[7] = theApp.GetProfileString(_T("Preferences"), _T("Recent7"), _T(""));
    m_recent[8] = theApp.GetProfileString(_T("Preferences"), _T("Recent8"), _T(""));
    m_recent[9] = theApp.GetProfileString(_T("Preferences"), _T("Recent9"), _T(""));


    m_autoPlay = (int)theApp.GetProfileInt(_T("Preferences"), _T("AutoPlay"), 1);
    m_randomFirst = (int)theApp.GetProfileInt(_T("Preferences"), _T("RandomFirst"), 0);

    m_seekBarRect = GetRect(_T("Preferences"), _T("SeekBar"));
    m_equalizerRect = GetRect(_T("Preferences"), _T("Equalizer"));
    m_playlistRect = GetRect(_T("Preferences"), _T("Playlist"));
    m_videoRect = GetRect(_T("Preferences"), _T("Video"));
    m_consoleRect = GetRect(_T("Preferences"), _T("Console"));
    m_fullScreen = (BOOL)theApp.GetProfileInt(_T("Preferences"), _T("FullScreen"), 0);

    m_repeat = (int)theApp.GetProfileInt(_T("Preferences"), _T("Repeat"), 0);
    m_repeatTrack = (int)theApp.GetProfileInt(_T("Preferences"), _T("RepeatTrack"), 0);
    m_shuffleMode = (int)theApp.GetProfileInt(_T("Preferences"), _T("ShuffleMode"), 0);

    s_videoDialog.Create(CVideoDialog::IDD);

    extern int enable;

    enable = (int)theApp.GetProfileInt(_T("Preferences"), _T("EnableEQ"), 0);

    CString buf;

    i = 0; 
    do
    {
        buf.Format(_T("EQ%d"), i);
        buf = theApp.GetProfileString(_T("Preferences"), buf, _T(""));
        m_eq.Add(buf);
        i++;
    }
    while (buf != _T(""));

    m_showGradient = theApp.GetProfileInt(_T("MenuXP"), _T("ShowGradient"), 1);
    m_showGradientSel = theApp.GetProfileInt(_T("MenuXP"), _T("ShowGradientSel"), 1);
    m_showToolTip = theApp.GetProfileInt(_T("Preferences"), _T("showToolTip"), 1);
    m_autoUpdate = theApp.GetProfileInt(_T("Preferences"), _T("autoUpdate"), 0);
    m_displayConsole = theApp.GetProfileInt(_T("Preferences"), _T("displayConsole"), 0);
    m_displayConsoleAOT = theApp.GetProfileInt(_T("Preferences"), _T("displayConsoleAOT"), 0);

    m_show_time = theApp.GetProfileInt(_T("Preferences"), _T("show_time"), 500);
    m_hide_time = theApp.GetProfileInt(_T("Preferences"), _T("hide_time"), 1000);
    m_fade_in = theApp.GetProfileInt(_T("Preferences"), _T("fade_in"), 0);
    m_fade_out = theApp.GetProfileInt(_T("Preferences"), _T("fade_out"), 0);
    m_animation = theApp.GetProfileInt(_T("Preferences"), _T("animation"), 100);

    m_nid.cbSize = sizeof(m_nid);
    m_nid.hWnd = m_hWnd;
    m_nid.uID = 1;
    m_nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
    m_nid.uCallbackMessage = WM_ICON_NOTIFY;
    HICON m_hIcon = m_skin.stopIcon;
    m_nid.hIcon = m_hIcon;
    if (!m_showToolTip)
    {
        _tcscpy(m_nid.szTip, _T("STP"));
    }
    else
    {
        _tcscpy(m_nid.szTip, _T(""));
    }

    Shell_NotifyIcon(NIM_ADD, &m_nid);   
    m_skin.xpLookNFeel = theApp.GetProfileInt(_T("Preferences"), _T("XPLookNFeel"), 1);

    m_activateWindowsMessenger = theApp.GetProfileInt(_T("Preferences"), _T("activateWindowsMessenger"), 0);
    m_wmTitle = theApp.GetProfileString(_T("Preferences"), _T("wmTitle"), _T("%1"));
    m_wmIcon = theApp.GetProfileInt(_T("Preferences"), _T("wmIcon"), 0);
    m_wmSpeed = theApp.GetProfileInt(_T("Preferences"), _T("wmSpeed"), 1);
    m_scrollMode = theApp.GetProfileInt(_T("Preferences"), _T("scrollMode"), 0);

    SetTimer(REFRESH_WINDOW, 250, NULL);

    SetTimer(WM_DELAY, 1000, NULL);
    SetTimer(AUTOMATION_START, m_autPeriod * 60000, NULL);
    m_startToolTip = false;
}

bool CMainWnd::sup(CString n1, CString n2)
{
    CString r1, r2;

    r1 = n1.Left(1 + n1.ReverseFind('\\'));
    r2 = n2.Left(1 + n2.ReverseFind('\\'));
    if (r1.Find(r2) == 0)
    {
        if (r1.GetLength() != r2.GetLength())
            return false;
        else
            return (n1.CompareNoCase(n2) > 0);
    }
    else
    {
        if (r2.Find(r1) == 0 && r1.GetLength() != r2.GetLength())
            return true;
        else
            return (n1.CompareNoCase(n2) > 0);
    }
}

bool CMainWnd::TryToEnd()
{
    if (m_shutdownAfterEnd)
    {
        OSVERSIONINFO osinfo;
        osinfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
        ::GetVersionEx(&osinfo);
        if (osinfo.dwPlatformId == VER_PLATFORM_WIN32_NT)
        {
            HANDLE hToken;
            TOKEN_PRIVILEGES tkp; 

            if (OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
            {
                LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid); 
                tkp.PrivilegeCount = 1;
                tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED; 
                AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0); 
                if (GetLastError() == ERROR_SUCCESS)
                    ExitWindowsEx(EWX_POWEROFF | EWX_FORCE, 0);
            }
        }
    }
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_QUIT, 0);
    return true;
}

void CMainWnd::UnregHotKeys()
{
    UnregisterHotKey(m_hWnd, HOTKEY_PLAY);
    UnregisterHotKey(m_hWnd, HOTKEY_STOP);
    UnregisterHotKey(m_hWnd, HOTKEY_PREV);
    UnregisterHotKey(m_hWnd, HOTKEY_NEXT);
    UnregisterHotKey(m_hWnd, HOTKEY_VUP);
    UnregisterHotKey(m_hWnd, HOTKEY_VDOWN);
    UnregisterHotKey(m_hWnd, HOTKEY_OPEN1);
    UnregisterHotKey(m_hWnd, HOTKEY_OPEN2);
    UnregisterHotKey(m_hWnd, HOTKEY_OPEN3);
    UnregisterHotKey(m_hWnd, HOTKEY_SHUFFLE);
    UnregisterHotKey(m_hWnd, HOTKEY_MINIBAR);
    UnregisterHotKey(m_hWnd, HOTKEY_EQUALIZER);
    UnregisterHotKey(m_hWnd, HOTKEY_REPEAT);
    UnregisterHotKey(m_hWnd, HOTKEY_PLAYLIST);
    UnregisterHotKey(m_hWnd, HOTKEY_MP3INFO);
    UnregisterHotKey(m_hWnd, HOTKEY_EXIT);
    UnregisterHotKey(m_hWnd, HOTKEY_NP);
    UnregisterHotKey(m_hWnd, HOTKEY_FORW);
    UnregisterHotKey(m_hWnd, HOTKEY_BACK);
    UnregisterHotKey(m_hWnd, HOTKEY_TRAYICON);
    UnregisterHotKey(m_hWnd, HOTKEY_MENU);
    UnregisterHotKey(m_hWnd, HOTKEY_TRACKS);
    UnregisterHotKey(m_hWnd, HOTKEY_ALBUM);
    UnregisterHotKey(m_hWnd, HOTKEY_ALBUMMODE);
    UnregisterHotKey(m_hWnd, HOTKEY_AUTOMATION);
}

void CMainWnd::UpdMBTR()
{
    if (!m_created)
        return;
    if (s_playlistManager.GetSize() == 0)
    {
        m_nid.hIcon = m_skin.stopIcon;
        if (m_iconShown)
        {
            if (!m_showToolTip)
            {
                _tcscpy(m_nid.szTip, _T("STP MP3 Player"));
            }
            else
            {
                _tcscpy(m_nid.szTip, _T(""));
            }
            Shell_NotifyIcon(NIM_MODIFY, &(m_nid));
        }
        if (s_seekDialog.m_hWnd != NULL)
        {
            s_seekDialog.m_bar.SetCurrentSong(_T(""));
            s_seekDialog.m_bar.SetPos(0);
            s_seekDialog.m_bar.SetRange(0, 1);
        }
        return;
    }
    m_trackDurI = (int)(stdIn.GetLength() / 1000);

    if (m_trackDurI <= 0)
        m_trackDurI = 1;

    int p = 0;
    switch (stdIn.GetPlayerMode())
    {
        case PLAYER_MODE_PLAYING:
            m_nid.hIcon = m_skin.playIcon;
            break;
        case PLAYER_MODE_PAUSED:
            m_nid.hIcon = m_skin.pauseIcon;
            break;
        case PLAYER_MODE_CLOSE:
            m_nid.hIcon = m_skin.stopIcon;
            break;
    }
    p = stdIn.GetOutputTime() / 1000;

    if (p > m_trackDurI)
        p = m_trackDurI;
    if (s_seekDialog.m_hWnd != NULL)
    {
        if (!s_seekDialog.m_bar.isScrollFlag())
        {
            s_seekDialog.m_bar.SetCurrentTime(p, m_trackDurI);

            if (s_playlistManager.GetCurrent() < s_playlistManager.GetSize())
            {
                if (m_showingMode == 2)
                    s_seekDialog.m_bar.SetCurrentSong(s_playlistManager.GetCurrentTag().GetFilenameExt());
                else
                    s_seekDialog.m_bar.SetCurrentSong(s_playlistManager.GetCurrentTag().GetTag());
            }
        }
    }
    CString tag, time, title;
    if (m_showTTT)
        time.Format(_T("%02d:%02d/%02d:%02d"), m_showRemainingTime ? (int)((m_trackDurI - p) / 60) : p / 60, m_showRemainingTime ? ((m_trackDurI - p) % 60) : p % 60, m_trackDurI / 60, m_trackDurI % 60);
    else
        time.Format(_T("%02d:%02d"), m_showRemainingTime ? (int)((m_trackDurI - p) / 60) : p / 60, m_showRemainingTime ? ((m_trackDurI - p) % 60) : p % 60);

    tag = s_playlistManager.GetCurrentTag().GetTag();
    if (m_showingMode == 2)
        tag = s_playlistManager.GetCurrentTag().GetFilenameExt();
    if (!m_showToolTip)
    {
        _stprintf(m_nid.szTip, _T("%s - %s"), tag, time);
    }
    else
    {
        _tcscpy(m_nid.szTip, _T(""));
    }
    if (WAEmuWnd.m_hWnd != NULL)
    {
        title.Format(_T("%s %s"), tag, time);
        WAEmuWnd.SendMessage(WM_SETTEXT, 0, (LPARAM)title.GetString());
    }

    if (m_iconShown)
    {
        Shell_NotifyIcon(NIM_MODIFY, &(m_nid));
    }
}

LRESULT CMainWnd::OnPostPlayerOver(WPARAM wParam, LPARAM lParam)
{
    stdIn.SetPlayerMode(PLAYER_MODE_CLOSE);
    stdIn.Stop();
    GoNext();
    return TRUE;
}

void CMainWnd::DrawGradient(CDC* pDC, COLORREF clrStart, COLORREF clrEnd, LPCRECT pRect)
{
    CBufferDC memDC(pDC->GetSafeHdc());

    int r = GetRValue(clrEnd) - GetRValue(clrStart);
    int g = GetGValue(clrEnd) - GetGValue(clrStart);
    int b = GetBValue(clrEnd) - GetBValue(clrStart);

    if (!r && !g && !b)
    {
        memDC.FillSolidRect(pRect, clrStart);
        return;
    }

    int nSteps = max(abs(r), max(abs(g), abs(b)));  

    float fStep = (float)(pRect->right - pRect->left) / (float)nSteps;
    float rStep = r / (float)nSteps;
    float gStep = g / (float)nSteps;
    float bStep = b / (float)nSteps;

    r = GetRValue(clrStart);
    g = GetGValue(clrStart);
    b = GetBValue(clrStart);

    CRect rcFill;
    int iOnBand = 0;
    for (iOnBand = 0; iOnBand < nSteps; iOnBand++)
    {
        rcFill.SetRect(pRect->left + (int)(iOnBand * fStep), 0, pRect->left + (int)((iOnBand + 1) * fStep), pRect->bottom);
        if (!rcFill.Width())
            continue;

        memDC.FillSolidRect(&rcFill, RGB(r + rStep * iOnBand, g + gStep * iOnBand, b + bStep * iOnBand));
    }
    if (rcFill.right < pRect->right)
    {
        rcFill.right = pRect->right;

        memDC.FillSolidRect(&rcFill, RGB(r + rStep * iOnBand, g + gStep * iOnBand, b + bStep * iOnBand));
    }
}

LRESULT CMainWnd::QueryEndSession(WPARAM wParam, LPARAM lParam)
{
    TRACE(_T("Command WM_QUERYENDSESSION"));
    ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_QUIT, 0);
    return TRUE;
}

LRESULT CMainWnd::MixControlChange(WPARAM wParam, LPARAM lParam)
{
    if (s_volume.m_dwMixerHandle == wParam && s_volume.m_dwVolumeControlID == lParam)
    {
        DWORD currentVolume = s_volume.GetCurrentVolume();
        if (m_currentVolume != currentVolume)
        {
            m_currentVolume = currentVolume;
            stdIn.SetVolume(currentVolume);
            if (s_seekDialog.m_hWnd != NULL)
                 s_seekDialog.m_vol.SetPos(currentVolume);
        }
    }
    return TRUE;
}

LRESULT CMainWnd::OnHotKey(WPARAM wParam, LPARAM lParam)
{
    TRACE(_T("WM_HOTKEY %d"), wParam);
    switch ((int)wParam)
    {
        case HOTKEY_PLAY:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
            break;
        case HOTKEY_STOP:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
            break;
        case HOTKEY_PREV:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON1, 0);
            break;
        case HOTKEY_NEXT:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON5, 0);
            break;
        case HOTKEY_VUP:
            UnregisterHotKey(m_hWnd, HOTKEY_VUP);
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_VOLUMEUP, 0);
            RegisterHotKey(m_hWnd, HOTKEY_VUP, m_vUpMod, m_vUpKey);
            break;
        case HOTKEY_VDOWN:
            UnregisterHotKey(m_hWnd, HOTKEY_VDOWN);
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_VOLUMEDOWN, 0);
            RegisterHotKey(m_hWnd, HOTKEY_VDOWN, m_vDownMod, m_vDownKey);
            break;
        case HOTKEY_OPEN1:
            ::SetForegroundWindow(m_hWnd);
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_PLAY, 0);
            break;
        case HOTKEY_OPEN2:
            ::SetForegroundWindow(m_hWnd);
            OnPopupMenuOpenFolder();
            break;
        case HOTKEY_OPEN3:
            OnPopupMenuOpenUrl();
            break;
        case HOTKEY_SHUFFLE:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_SHUFFLE, 0);
            break;
        case HOTKEY_ALBUMMODE:
            OnPopupMenuSettingsStopAfterEachAlbum();
            break;
        case HOTKEY_MINIBAR:
            ::SetForegroundWindow(m_hWnd);
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_MAIN_WINDOW, 0);
            break;
        case HOTKEY_EQUALIZER:
            ::SetForegroundWindow(m_hWnd);
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_OPTIONS_EQ, 0);
            break;
        case HOTKEY_REPEAT:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_REPEAT, 0);
            break;
        case HOTKEY_PLAYLIST:
            ::SetForegroundWindow(m_hWnd);
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_OPTIONS_PLEDIT, 0);
            break;
        case HOTKEY_MP3INFO:
            if (s_playlistManager.GetSize() > 0)
            {
                ::SetForegroundWindow(m_hWnd);
                OnPopupMenuFileInfo();
            }
            break;
        case HOTKEY_EXIT:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_FILE_QUIT, 0);
            break;
        case HOTKEY_NP:
            if (OpenClipboard())
            {
                if (EmptyClipboard())
                {
                    HANDLE hData;
                    CString tmp;
                    GetWindowText(tmp);
                    tmp = tmp.Left(tmp.ReverseFind('-') - 1);
                    hData = GlobalAlloc(GMEM_DDESHARE, tmp.GetLength() + 5);
                    char* pData;
                    pData = (char*)GlobalLock(hData);
                    Strcpy((char*)pData, tmp.GetLength() + 5, tmp);
                    GlobalUnlock(hData);
                    if (::SetClipboardData(CF_TEXT, hData) == NULL)
                        GlobalFree(hData);
                }
                CloseClipboard();
            }
            break;
        case HOTKEY_FORW:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON5_SHIFT, 0);
            break;
        case HOTKEY_BACK:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_BUTTON1_SHIFT, 0);
            break;
        case HOTKEY_TRAYICON:
            if (m_iconShown)
            {
                Shell_NotifyIcon(NIM_DELETE, &m_nid);
                m_iconShown = false;
            }
            else
            {
                Shell_NotifyIcon(NIM_ADD, &m_nid);
                m_iconShown = true;
            }
            break;
        case HOTKEY_MENU:
            ::SendMessage(WAEmuWnd.m_hWnd, WM_COMMAND, WINAMP_MAINMENU, 0);
            break;
        case HOTKEY_TRACKS:
            ShowTracksMenu(1);
            break;
        case HOTKEY_ALBUM:
            ShowTracksMenu(1, true);
            break;
        case HOTKEY_AUTOMATION:
            s_playlistManager.PerformAutomation();
            if (m_autSaveset)
                SaveSettings();
            break;
    }
    return TRUE;
}

LRESULT CALLBACK CMainWnd::HookCallWndProc(int nCode, WPARAM wParam, LPARAM lParam)
{
    CWPSTRUCT cwps;
    static int x = 550;
    static int y = 550;
    static CRect subRect(0, 0, 0, 0);

    if (nCode == HC_ACTION)
    {
        CopyMemory(&cwps, (LPVOID)lParam, sizeof(CWPSTRUCT));
        TCHAR szClass[128];
        GetClassName(cwps.hwnd, szClass, 127);

        switch (cwps.message)
        {
            case 485:
            {
                if (_tcscmp(szClass, _T("#32768")) == 0)
                {
                    CRect rect;
                    //On rcuprer le menu que l'on est en train d'afficher
                    HMENU hMenu = (HMENU)::SendMessage(cwps.hwnd, MN_GETHMENU, 0, 0);
                    if (hMenu != NULL)
                    {
                        //TRACE(_T("%d %d\n"),CMenu::FromHandle(hMenu)->GetMenuItemCount(),CMenu::FromHandle(hMenu)->GetMenuItemID(cwps.wParam));
                        CString buf;
                        CMenu::FromHandle(hMenu)->GetMenuString(cwps.wParam, buf, MF_BYPOSITION);
                        //S'il a un sous menu on mmorise sa position pour pouvoir coller le sous menu
                        if (CMenu::FromHandle(hMenu)->GetSubMenu(cwps.wParam) != NULL)
                        {
                            ::GetMenuItemRect(cwps.hwnd, hMenu, cwps.wParam, &rect);
                            //TRACE(_T("Nom : %s \n"),buf);
                            //TRACE(_T("Dim %d %d %d %d\n"),rect.left,rect.top,rect.right, rect.bottom);
                            subRect = rect;
                        }
                        else
                        {
                            subRect = CRect(0, 0, 0, 0);
                        }
                    }
                    else
                    {
                        subRect = CRect(0, 0, 0, 0);
                    }
                }
                break;
            }
            case WM_WINDOWPOSCHANGED:
            {
                if (_tcscmp(szClass, _T("#32768")) == 0)
                {
                    //TRACE(_T("subRect %d %d %d %d\n"),subRect.left,subRect.top,subRect.right, subRect.bottom);
                    LPWINDOWPOS windowPos = (LPWINDOWPOS)cwps.lParam;
                    //TRACE(_T("%d %d %d %d\n"),windowPos->x, windowPos->y, windowPos->cx, windowPos->cy);
                    if (windowPos->x + windowPos->cx < subRect.left)
                        ::SetWindowPos(cwps.hwnd, NULL, subRect.left - windowPos->cx, windowPos->y, windowPos->cx, windowPos->cy, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
                }
                break;
            }
        }
    }

    return CallNextHookEx((HHOOK)WH_CALLWNDPROC, nCode, wParam, lParam);
}

void CMainWnd::PostNcDestroy()
{
    TRACE(_T("PostNcDestroy"));
}

void CMainWnd::OnClose()
{
    ShowWindow(SW_HIDE);
}

void CMainWnd::OnContextMenu(CWnd* pWnd, CPoint pos)
{
    m_pPopup = m_mainMenu.GetSubMenu(0);
    m_Helper.translateMenu(&m_consoleMenu, IDR_CONSOLE);
    m_consoleMenu.GetSubMenu(0)->CheckMenuItem(IDS_CONSOLE_AOT, MF_BYCOMMAND | ((GetWindowLong(m_hWnd, GWL_EXSTYLE) & WS_EX_TOPMOST) == WS_EX_TOPMOST)? MF_CHECKED : MF_UNCHECKED);
    m_consoleMenu.GetSubMenu(0)->TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON, pos.x, pos.y, this);
}
 
void CMainWnd::OnConsoleClear()
{
    while(SendMessage(LB_GETCOUNT, 0, 0) >0)
        SendMessage(LB_DELETESTRING, 0, 0);
}
 
void CMainWnd::OnConsoleAot()
{
    if ((GetWindowLong(m_hWnd, GWL_EXSTYLE) & WS_EX_TOPMOST) == WS_EX_TOPMOST)
        SetWindowPos(&CWnd::wndNoTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
    else
        SetWindowPos(&CWnd::wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
}

void CMainWnd::OnConsoleCopy()
{
    CString tmp2 = _T("");
    int maxTaille = 0, taille = SendMessage(LB_GETCOUNT, 0, 0);
    if (OpenClipboard())
    {
        if (EmptyClipboard())
        {
            CString paste = _T("");

            HANDLE hData;
            for (int i = 0; i < taille; i++)
            {
                SendMessage(LB_GETTEXT, i, (LPARAM)tmp2.GetBuffer(SendMessage(LB_GETTEXTLEN, i, 0)));
                tmp2.ReleaseBuffer();
                maxTaille += tmp2.GetLength();
                paste += tmp2;
            }

            hData = GlobalAlloc(GMEM_DDESHARE, maxTaille + 5);
            char* pData;
            pData = (char*)GlobalLock(hData);
            Strcpy(pData, maxTaille + 5, (TCHAR*)paste.GetString());
            GlobalUnlock(hData);
            
            if (::SetClipboardData(CF_TEXT, hData) == NULL)
                GlobalFree(hData);
        }
        CloseClipboard();
    }
}

LRESULT CMainWnd::OnAreYouMe(WPARAM, LPARAM)
{
    return STP_WND;
}
